INFORMATION = 0
TRACE = 1
WARNING = 2
ERROR = 3
FATAL = 4

SEVERITIES = {
    INFORMATION: "info",
    TRACE: "trace",
    WARNING: "warn",
    ERROR: "error",
    FATAL: "fatal"
}

MESSAGES = {

    'DM_ACL_F_TYPE_INIT': 'Failed to initialize type dm_acl.',
    'DM_ACL_F_BAD_VSTAMP': 'Type dm_acl has a bad vstamp {0}. The current vstamp for dm_acl is supposed to be {1}.',
    'DM_ACL_F_PUB_BIT_CHANGE_FAILED': 'Failure changing public bits when acl {0} (domain {1}) changed.',
    'DM_ACL_F_TYPE_CONVERSION': 'Failed to convert type dm_acl to version {0}.',
    'DM_ACL_F_REFRESH_SELECT_INSTANCE': 'Failure retrieving instances of template ACL. Select statement is {0}. DB error is {1}.',
    'DM_ACL_W_ACL_INSTANCES_NEED_CONVERSION': 'Server did not convert all ACL Instances to use r_template_id and r_alias_set_id as part of the upgrade because there are too many. Administrator should manually use the apply method DM_CONVERT_ACL_INSTANCES (i.e., apply,c,NULL,DM_CONVERT_ACL_INSTANCES) after upgrade completes.',
    'DM_ACL_W_RENAMED_ACCESSOR_EXISTS': 'Renaming accessor_name from \'{0}\' to \'{1}\' for ACL \'{2}\' caused the existing ACE with the same qualification being removed.',
    'DM_ACL_W_LENGTH_WIDEN_FAILED': 'The upgrade failed on widening acl\'s attribute ({0}) length from {1} to {2}.',
    'DM_ACL_W_': '',
    'DM_ACL_W_NOT_CASCADE_DELETED': 'Attempted to cascade destroy in-use ACL \'{0}\' in domain \'{1}\'.',
    'DM_ACL_E_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}',
    'DM_ACL_E_CANT_FETCH_ACL': 'Failed to fetch the ACL \'{0}\' in the domain \'{1}\'.',
    'DM_ACL_E_INVALID_PERMIT': 'Illegal permit ({0}) granted for user \'{1}\'.',
    'DM_ACL_E_NOMATCH': 'No ACEs matched for the name \'{0}\' in the ACL \'{1}\'.',
    'DM_ACL_E_BAD_STATE': 'The ACL \'{0}\' of domain \'{1}\' is in bad state.',
    'DM_ACL_E_CANT_FETCH_USER': 'The operation to the ACL object \'{0}\' failed due to failure to fetch dmUser \'{1}\' and failure to check permissions.',
    'DM_ACL_E_NEW_SYS_ACL': 'Failed to create an ACL \'{0}\' in the system domain, because the user \'{1}\' is neither SYSADMIN nor SUPERUSER.',
    'DM_ACL_E_USER_NOT_EXIST': 'The owner_name or accessor_name \'{0}\' given in the ACL \'{1}\' does not exist.',
    'DM_ACL_E_NOT_OWNER': 'The ACL \'{0}\' can only be modified by its owner \'{1}\' or superusers.',
    'DM_ACL_E_READONLY_ATTR': 'The attribute \'{0}\' of the ACL \'{1}\' is read-only and not changable.',
    'DM_ACL_E_OWNER_NOT_ALLOWED': 'Setting the owner_name of the ACL \'{0}\' to \'{1}\' is not allowed.',
    'DM_ACL_E_MOD_NAME_DOMAIN': 'Changing domain or name of the ACL \'{0}\' is not allowed, once the ACL is created.',
    'DM_ACL_E_DESTROY_REF_COUNT': 'Failed to destroy the ACL \'{0}\' in domain \'{1}\' because it is in use.',
    'DM_ACL_E_FETCH_NO_NAME': 'Failed to fetch the ACL with no name provided.',
    'DM_ACL_E_NEED_NAME': 'Need the user name for operation \'{0}\' to succeed, when setting the ACL \'{1}\'.',
    'DM_ACL_E_CORRUPTED': 'The ACL \'{0}\' in domain \'{1}\' is found corrupted.',
    'DM_ACL_E_DESTROY_IN_USE': 'Failed to destroy the ACL \'{0}\' in domain \'{1}\' because it is in use.',
    'DM_ACL_E_CURSOR': 'The cursor \'{0}\' failed. The error message from the database server is: {1}.',
    'DM_ACL_E_PARAMETER': 'The parameters provided for command \'{0}\' are not valid.',
    'DM_ACL_E_CHANGE_NAME_PRIV': 'Changeing ACL owner\'s name or object name requires SUPERUSER privilege.',
    'DM_ACL_E_DUMP_NO_USER': 'Although dump will continue, the missing user should be created in the docbase where load is to be performed.',
    'DM_ACL_E_CHANGE_OBJNAME_PRIV': 'Only SUPERUSER can change object_name.',
    'DM_ACL_E_UNIQUE_NAME': 'ACL name has to be unique in a given domain.',
    'DM_ACL_E_FORCE_DESTROY': 'The force flag in the destroy API command can be used only by superusers.',
    'DM_ACL_E_MOD_SYSACL': 'The ACL \'{0}\' can only be modified by its owner \'{1}\', system admins or superusers.',
    'DM_ACL_E_INVALID_XPERMIT': 'Illegal extended permit ({0}) granted for user \'{1}\'.',
    'DM_ACL_E_INVALID_XPERMIT_NAME': 'There exists at least one invalid extended permission name in {0} for operation {1}.',
    'DM_ACL_E_CANT_CHANGE_PERMITS': 'Only the {0} acl owner, superuser, or whoever has the change_permit extended permission can change permits.',
    'DM_ACL_E_CANT_CHANGE_INSTANCE': 'The ACL {0} is an instance of an ACL template.',
    'DM_ACL_E_ILLEGAL_ACL_CLASS': 'The acl_class ({0}) of ACL {1} is illegal.',
    'DM_ACL_E_CANT_CREATE_INSTANCE': 'Cannot create an instance {0} of template ACL {1} based on alias set {2}.',
    'DM_ACL_E_REFRESH_BAD_ALIAS_SET': 'The ACL instance object named {0} refers to a non-existent alias set object {1}.',
    'DM_ACL_E_REFRESH_BAD_ACL_TEMPLATE': 'The ACL instance object named {0} refers to a non-existent template ACL object {1}.',
    'DM_ACL_E_QUERY_EXECUTION_FAILURE': 'Error while trying to execute the following query: {0}. Database error is {1}.',
    'DM_ACL_E_CANT_UNREGISTER': 'Could not unregister the specified {0} event for {1} object.',
    'DM_ACL_E_FAILED_TO_UPGRADE_ACL_INSTANCE': 'Could not upgrade ACL Instance with ID \'{0}\' and object_name \'{1}\'. The ACL Instance to ACL Template/Alias Set mapping is not complete.',
    'DM_ACL_E_ACE_INVALID_PERMIT': 'The Accessor Control Entry (ACE) for accessor \'{0}\', permit_type \'{1}({2})\', has an invalid permit ({3})',
    'DM_ACL_E_ACE_INVALID_XPERMIT': 'The Accessor Control Entry (ACE) for accessor \'{0}\', permit_type \'{1}({2})\', has an illegal extended permit ({3}).',
    'DM_ACL_E_ACE_APPLICATION_PERMIT_NOT_ALLOWED': 'The Accessor Control Entry (ACE) for accessor \'{0}\', permit_type \'{1}({2})\', cannot have an application_permit value.',
    'DM_ACL_E_ACE_INTERNAL_INVALID_PERMIT_TYPE': 'The Accessor Control Entry (ACE) for accessor \'{0}\' has an invalid permit_type \'{1}({2})\'.',
    'DM_ACL_E_ACE_PERMIT_NOT_NULL': 'The Accessor Control Entry (ACE) for accessor \'{0}\', permit_type \'{1}({2})\' has a non-null permit of \'{3}\'.',
    'DM_ACL_E_ACE_XPERMIT_NOT_NULL': 'The Accessor Control Entry (ACE) for accessor \'{0}\', permit_type \'{1}({2})\' has a non-null xpermit of \'{3}\'.',
    'DM_ACL_E_ACE_APPLICATION_PERMIT_NOT_NULL': 'The Accessor Control Entry (ACE) for accessor \'{0}\', permit_type \'{1}({2})\' has a non-null application_permit of \'{3}\'.',
    'DM_ACL_E_ACE_NULL_APPLICATION_PERMIT': 'The Accessor Control Entry (ACE) for accessor \'{0}\', permit_type \'{1}({2})\' cannot have a NULL application_permit.',
    'DM_ACL_E_PERMIT_TYPE_REQUIRES_GROUP': 'The Accessor Control Entry (ACE) for accessor \'{0}\' is invalid. The accessor for permit_type value of \'{1}({2})\' must be a valid group.',
    'DM_ACL_E_INVALID_ACE_PERMIT_TYPE': 'The Accessor Control Entry (ACE) for accessor \'{0}\' has an invalid permit_type value of \'{1}\'.',
    'DM_ACL_E_CANNOT_UPDATE_ACE': 'The Accessor Control Entry (ACE) in ACL with Id \'{0}\' for accessor \'{1}\', permit_type \'{2}({3})\' cannot be updated.',
    'DM_ACL_E_MACL_NOT_SUPPORTED': 'The current docbase does not support MACL Security.',
    'DM_ACL_E_OLD_CLIENT_CANNOT_MODIFY_MACL_ACL': 'The ACL with ID \'{0}\' contains MACL (Mandatory Access Controls) rules and cannot be modified by an older client.',
    'DM_ACL_E_TRUSTED_CONTENT_SERVICES_NOT_ENABLED': 'Trusted Content Services (TCS) must be enabled to access Mandatory Access Control (MACL) functionality.',
    'DM_ACL_E_MISSING_ACCESSOR_LIST': 'The apply method DM_ACL_VALIDATE_REQUIRED_GROUPS requires an accessor list as in input parameter.',
    'DM_ACL_E_CANNOT_RESTRICT_MORE_THAN_GRANTED': 'The ACL with ID \'{0}\' can not restrict the permission of accessor \'{1}\' to ({2}) because an equal or lower permission ({3}) is granted.',
    'DM_ACL_E_INTERNAL_FETCH_TYPE_FAILED': 'Failed to fetch type \'{0}\' during the following operation: {1}',
    'DM_API_I_FACILITY_USAGE': 'You can turn on ({0}) trace facility by issueing an api command:trace,<session>,<severity_level>,apilogfile,{1}. You can turn off this facility by using the same api with severity_level set to 0.',
    'DM_API_I_FACILITY_NOT_AVAILABLE': 'Current facility ({0}) does not have trace',
    'DM_API_I_OPTION_USAGE': 'This option is currently ({0}). You need system administrator\'s privilege to turn on -o flags.  You can turn on[/off] this option by issueing an api command: apply,<session>,NULL,SET_OPTIONS,OPTION,S,{1}, VALUE,B,T[/F]',
    'DM_API_I_SQL_TRACE_USAGE': 'SQL Trace is currently ({0}). The api command to turn on[/off] SQL trace is: trace,<session>,1[/0],,SQL_TRACE',
    'DM_API_I_SPECIAL_FACILITY_USAGE': 'You can turn on/off ({0}) trace facility by issueing an api command:apply,c,NULL,MODIFY_TRACE,SYBSYSTEM,S,fulltext,VALUE,S,{all,document,verity,none} ',
    'DM_API_W_OLDTYPE': 'Type name \'{0}\' should no longer be used in the creation of objects.',
    'DM_API_W_CONTAINMENT_FEATURES_NOT_SUPPORTED': 'The docbase ({0}) has version ({1}) which does not support setting containment_type and containment_desc attributes in the operation ({2}).  These features require a server of at least version ({3})',
    'DM_API_W_NO_MATCH': 'There was no match in the docbase for the qualification: {0}',
    'DM_API_W_CACHE_FLUSH': 'Unable to flush query cache.',
    'DM_API_W_NO_VALUE': 'There are no values in the repeating attribute {0}.',
    'DM_API_W_EXTRA_PARAMETER': 'The extra parameter, {0}, is only allowed for date attribute.',
    'DM_API_W_SERVER_NEED_RESTART': 'Changes made by the apply method {0} will not take effect until Content Server is restarted.',
    'DM_API_E_ERROR': 'General internal error: API has failed.',
    'DM_API_E_BADATTRNAME': 'Bad attribute name \'{0}\' for document/object.',
    'DM_API_E_BADATTRINDX': 'Attribute name \'{0}\' for document/object has incorrect index \'{1}\'',
    'DM_API_E_BADCMD': 'Bad API command \'{0}\'',
    'DM_API_E_BADDATATYPE': 'Bad datatype or value conversion for attribute {0}.',
    'DM_API_E_BADOBJ': 'Command {0} returned an invalid document/object id.',
    'DM_API_E_BADQUERY': 'No query has been run for command {0}.',
    'DM_API_E_BADQUEUE': 'No queue name has been given.',
    'DM_API_E_BADSESS': 'Bad session specifier {0}, try using current.',
    'DM_API_E_BADSTAMP': 'Bad queue stamp specifier for queue {0}.',
    'DM_API_E_EXIST': 'Document/object specified by {0} does not exist.',
    'DM_API_E_NOCACHE': 'Internal error, cache is missing.',
    'DM_API_E_NODEVNAME': 'No device name was given for command {0}.',
    'DM_API_E_NOFOLDER': 'Folder with the path {0} does not exist.',
    'DM_API_E_NOFOLDID': 'No folder id given for a link/unlink command.',
    'DM_API_E_NOID': 'No id given for command {0}.',
    'DM_API_E_NO_FILE': 'No file name given for command {0}.',
    'DM_API_E_NOLABEL': 'No version label specified during appendcomp/insertcomp operations.',
    'DM_API_E_NOLAST': 'Cannot use last for document/object id. Must fetch or create document/object first.',
    'DM_API_E_NOQUERY': 'No query has been run. Cannot use a query collection id.',
    'DM_API_E_NOSESS': 'No session is currently active.',
    'DM_API_E_NOTYPE': 'Type name \'{0}\' is not a valid type.',
    'DM_API_E_NOTYPE2': 'No type was specified.',
    'DM_API_E_DEQUEUE_FAIL': 'Dequeue operation on queue item {0} failed',
    'DM_API_E_QUERY_FAIL': 'Query failed: {0}',
    'DM_API_E_BADFILE_FORMAT': 'File format for file {0} is either incorrect or missing.',
    'DM_API_E_NOTASKNUM': 'No task number specified during router operations.',
    'DM_API_E_NOEVENTNAME': 'No event name specified during register/unregister operations.',
    'DM_API_E_BADID': 'Bad ID given: {0}',
    'DM_API_E_NODOCBASE': 'No document base has been provided for a connection.',
    'DM_API_E_NOUSERNAME': 'No user name have been provided for a connection.',
    'DM_API_E_NOOSPASSWD': 'No operating system password has been provided for a connection.',
    'DM_API_E_NODBPASSWD': 'No database password provided for a connection.',
    'DM_API_E_BADDATE': 'You have specified an invalid date or an unrecognized date representation \'{0}\' based on format \'{1}\'',
    'DM_API_E_NO_MATCH': 'There was no match in the docbase for the qualification: {0}',
    'DM_API_E_ONELISTMSG': 'Cannot have multiple listmessage collections open simultaneously.',
    'DM_API_E_INVALID_TYPE_FOR_METHOD': 'Cannot perform {0} method on supplied object of id ({1}) since it is not of type ({2}).',
    'DM_API_E_POSITIONAL_PARAM_MISSING': 'The required positional parameter, {0}, was not supplied.  Please provide a value for {1}.',
    'DM_API_E_NO_COLLECTION': 'There are no more available collection object for the current session.',
    'DM_API_E_NO_SESSION': 'There are no more available sessions.',
    'DM_API_E_EXPECT_BOOL': 'A null or boolean value was expected for positional parameter {0}.  Bad value: {1}. This parameter specifies {2}.',
    'DM_API_E_OPERATION_UNSUPPORTED': 'This {0} operation cannot be performed because the server does not support the \'{1}\' method. There is an incompatibility between your client library (DMCL) and the current Documentum server.',
    'DM_API_E_DESCRIBE_TABOWNER': 'To execute this \'describe table\' operation against the current server you must supply the table owner name in the command (ie. \'describe table owner_name.table_name\').',
    'DM_API_E_COMMAND_OBSOLETE': 'The API command \'{0}\' is no longer supported.',
    'DM_API_E_BADSEVERITY': 'Bad severity level given: {0}',
    'DM_API_E_NONAME': 'The accessor name is missing.',
    'DM_API_E_NOPERMIT': 'The accessor permit is missing.',
    'DM_API_E_NO_ACL_SOURCE': 'The ACL inheritance source is missing.',
    'DM_API_E_DOWNREV_SERVER_VER': 'The docbase ({0}) has version ({1}) which does not support the operation ({2}).  This operation requires a server of at least version ({3})',
    'DM_API_E_NO_CACHE_NAME': 'The name of the global cache to be flushed is missing.',
    'DM_API_E_WRONG_CACHE_NAME': 'The global cache \'{0}\' is not supported in \'flushglobalcache\' method.',
    'DM_API_E_BOOLEAN_FLAG': 'The value \'{0}\' is not valid. The boolean flag is either \'T\' or \'F\'.',
    'DM_API_E_NOT_SELECT': 'You have specified an unsupported statement type in a cachequery.',
    'DM_API_E_FLUSH_NO_ARG': 'The flush method had a missing required cachename argument.',
    'DM_API_E_FLUSH_BAD_ARG': 'The flush method had an unsupported cache name argument:  {0}.',
    'DM_API_E_UPDATE_BAD_ATTR': 'The attribute \'{0}\' is not updateable.',
    'DM_API_E_BAD_DIRECTION': 'An improper direction ({0}) was specified in a seek.',
    'DM_API_E_NO_SERVERMAP': 'No server map information from docbroker.',
    'DM_API_E_NO_UL_SUPPORT': 'The server does not support NT Unified Logon.',
    'DM_API_E_BADATTRSTATE': 'Attribute name \'{0}\' for policy has incorrect value \'{1}\'.',
    'DM_API_E_FACILITY_UNKNOWN': 'The specified facility ({0}) is not a valid trace facility.',
    'DM_API_E_NOSCOPE': 'The required scope argument is missing.',
    'DM_API_E_BADSCOPE': 'Docbase scope identifier ({0}) is not valid.',
    'DM_API_E_DOCBASE_SCOPE': 'Could not connect to docbase.  Docbase {0} could not be found.',
    'DM_API_E_DOCBASE_SCOPE_ID': 'Could not connect to docbase.  Docbase id {0} could not be found.',
    'DM_API_E_ACCESS': 'Document/object specified by {0} cannot be accessed.',
    'DM_API_E_BAD_POSITION': 'Invalid position argument ({0}) to seek method',
    'DM_API_E_CANT_SEEK': 'Can\'t perform a seek operation for this content',
    'DM_API_E_NOPOLIID': 'you need to specify a valid policy object while doing an Attach.',
    'DM_API_E_NO_REMOTE_POLICY': 'You cannot attach to a non-local business policy object from docase id {0}.',
    'DM_API_E_MUSTBE_NEXT': 'You must specify \'next\' as the state name to promote to.',
    'DM_API_E_MUSTBE_BASE_PREV': 'You must specify \'base\' or \'previous\' as the state name to demote to.',
    'DM_API_E_CANT_WITH_OPEN_TRAN': 'You cannot perform \'{0}\' operation since there is an open transaction in this session \'{1}\'.',
    'DM_API_E_DISTTRANS_UNSUPPORTED': 'It is disallowed to update through a reference or a replica while a user transaction is open.',
    'DM_API_E_MISS_ACTIVITY_NAME': 'Missing parameter activity name.',
    'DM_API_E_MISS_ACTIVITY_DEF_ID': 'Missing parameter activity definition id.',
    'DM_API_E_MISS_LINK_NAME': 'Missing parameter link name.',
    'DM_API_E_MISS_SRC_ACTIVITY': 'Missing parameter source activity.',
    'DM_API_E_MISS_SRC_PORT': 'Missing parameter source port.',
    'DM_API_E_MISS_DEST_ACTIVITY': 'Missing parameter destination activity.',
    'DM_API_E_MISS_DEST_PORT': 'Missing parameter destination port.',
    'DM_API_E_CHECK_ACTIVITY': 'Paramter check activity is invalid.',
    'DM_API_E_METHOD_NOT_APPLICABLE': 'The method {0} is not applicable to type {1}.',
    'DM_API_E_ISCACHED_NO_CACHE_NAME': 'A cache name must be supplied to the iscached API call.',
    'DM_API_E_ISCACHED_BAD_CACHE_NAME': '{0} is not a valid cache name for the iscached API call.',
    'DM_API_E_ISCACHED_NO_CACHE_KEY': 'A cache key must be supplied to the iscached API call.',
    'DM_API_E_FLUSH_DD_CACHE_NO_KEY': 'A cache key must be supplied to the flush API call when ddcache is specified.',
    'DM_API_E_FLUSH_DD_CACHE_BAD_KEY': 'A cache key ({0}) was supplied to the flush ddcache API call that is not the name of a type.',
    'DM_API_E_NO_USER': 'Need to specifiy an user.',
    'DM_API_E_MISS_PACKAGE_NAME': 'Parameter, package name, is missing.',
    'DM_API_E_MISS_PACKAGE_TYPE': 'Parameter, package type, is missing.',
    'DM_API_E_MISS_ROUTE_ID': 'The parameter route case identifier is missing.',
    'DM_API_E_MISS_ROUTE_COND': 'The parameter route condition is missing.',
    'DM_API_E_STATE_WITH_NO_POLICY': 'The state name parameter ({0}) to the \'type\' api cannot be supplied without a business policy object id.',
    'DM_API_E_POLICY_WITH_NO_STATE': 'If a business policy id ({0}) is used in the \'type\' api, a valid state name must be supplied.',
    'DM_API_E_CANNOT_FETCH_POLICY': 'Cannot fetch a business policy with object id {0}.',
    'DM_API_E_POLICY_STATE_NOT_FOUND': 'The business policy with object id {0} does not have a state named {1}.',
    'DM_API_E_MISS_ACT_NAME': 'The parameter, activity name, is missing.',
    'DM_API_E_MISS_INPUT_PORT_NAME': 'The parameter, input port name, is missing.',
    'DM_API_E_BAD_TYPE': 'The object, {0}, is not type, {1}.',
    'DM_API_E_SAVE_TYPE': 'The internal type, {0}, can not be saved.',
    'DM_API_E_SCHD_POLICY_NO_STATE': 'A scheduled policy event requires a state name specified.',
    'DM_API_E_MISS_STATE_POS': 'The movestate API requires both old and new positions be specified.',
    'DM_API_E_NOPASSWORD': 'There is no password argument specified.',
    'DM_API_E_CANT_UPDATE': 'Cannot Save/Check-in object <{0}> because the object is marked invalid.  This is most likely due to an error from a prior operation performed on the object.',
    'DM_API_E_VDMPATH_SORTBY': '{0} is not a valid attribute to sort by',
    'DM_API_E_MISSING_CONTAINMENT_DESC': 'A containment type of {0} was supplied but its corresponding containment description is missing.',
    'DM_API_E_MISSING_CONTAINMENT_TYPE': 'A containment desc of {0} was supplied but its corresponding containment type is missing.',
    'DM_API_E_PUBLISH_DD_MISSING_PARAMETER': 'When calling the publish_dd api, the 1st parameter (locale) is optional. The 2nd parameter (type_name) is optional, but must be present if the 3rd parameter (attribute) is specified.',
    'DM_API_E_CANT_WITHOUT_OPEN_TRAN': 'You cannot perform \'{0}\' operation without an open transaction in this session.',
    'DM_API_E_NOT_IN_CACHE': 'Document/object specified by {0} does not exist in the cache.',
    'DM_API_E_NO_PAGE_MODIFIER_FOR_BATCH': 'The page_modifier, {0}, is not allowed for {1} in batch mode.',
    'DM_API_E_BAD_PAGE_MODIFIER': 'The page_modifier, {0}, is reserved for internal use.',
    'DM_API_E_BAD_EXTENSION_FOR_BATCH': 'The extension of the input file, {0}, is not allowed for {1} in batch mode.',
    'DM_API_E_UNKNOWN_SECURE_FLAG': 'Unknown secure connect flag \'{0}\' is specified.',
    'DM_API_E_NO_EVENT_NAME': 'No event name given for command {0}.',
    'DM_API_E_CANNOT_FETCH_REMOTE_POLICY': 'Cannot fetch a remote business policy with object id {0}.',
    'DM_API_E_CONFIGURATION': 'The value \'{0}\' is not a valid setting for {1} in the dmcl.ini initialization file.',
    'DM_API_E_FLUSH_REGISTRY_CACHE_NO_KEY': 'A cache key must be supplied to the flush API call when registrycache is specified.',
    'DM_API_E_DOCBASE_NOT_ALLOWED': 'You cannot specify a docbase name ({0}) if you use a session in authenticate API.',
    'DM_API_E_BAD_ARGS': 'Invalid or insufficient arguments for \'{0}\' for \'{1}\' API',
    'DM_API_E_EXCEPTION': 'An unexpected error has caused the current command to be aborted.  A detailed description of the error can be found in \'{0}\'.',
    'DM_API_E_EXCEPTION_ON_SESSION': 'An unexpected error has caused the command \'{0}\' to be aborted.  The session and all associated subconnections have been disabled.  A detailed description of the error can be found in \'{1}\'.',
    'DM_API_E_SESSION_DISABLED': 'The session was disabled on an exception, only getmessage and disconnect are allowed on a disabled session.',
    'DM_API_E_API_SHUTDOWN': 'The DMCL has been disabled due to an internal error, command \'{0}\' was not run.  The process needs to be restarted.',
    'DM_API_E_AUTH_CMD_NOT_SUPPORTED': 'The target server of version ({0}) does not support authenticate command.',
    'DM_API_E_COMMAND_NOT_SUPPORTED': 'Server version ({0}) does not support the method ({1}).',
    'DM_API_E_INVALID_TICKET_SCOPE': 'Invalid login ticket scope ({0}). It must be \'global\', \'docbase\', or \'server\'.',
    'DM_API_E_INVALID_TOKEN_SCOPE': 'Invalid token scope ({0}). It must be \'global\' or \'docbase\'.',
    'DM_API_E_MISSING_PASSWORD': 'A password must be provided.',
    'DM_API_E_NULL_TICKET': 'A login ticket must be provided.',
    'DM_API_E_OUT_OF_MEMORY': 'There is not enough memory for creating the object.',
    'DM_API_E_DECODING_FAILED': 'Decoding {0} ({1}) failed.',
    'DM_API_E_INVALID_INPUT': 'Input string ({0}) must have prefix \'DM_TICKET=\' or \'DM_TOKEN\'.',
    'DM_API_E_INVALID_SINGLE_USE': 'Invalid single_use parameter value ({0}). It must be \'T\', \'t\', \'F\', or \'f\'.',
    'DM_API_E_INVALID_TIMEOUT': 'Invalid timeout parameter value ({0}). It must be a valid integer.',
    'DM_API_E_INVALID_MACHINE_ONLY': 'Invalid machine_only parameter value ({0}). It must be \'T\' or \'t\'.',
    'DM_API_E_NO_PERMIT_TYPE': 'No value for permit_type was specified.',
    'DM_API_E_INVALID_PERMIT_TYPE': 'An unrecognized permit_type value of \'{0}\' was specified. Please check the value and try again.',
    'DM_API_E_UNRECOGNIZED_PARAMETER': 'An unrecongized parameter with value \'{0}\' was specified. Check the API syntax and the parameter and try again.',
    'DM_API_E_INVALID_PERMIT': 'An invalid accessor_permit value of \'{0}\' was specified.',
    'DM_API_E_NO_XPERMIT': 'The accessor_xpermit value was not specified.',
    'DM_API_E_NO_APPLICATION_PERMIT': 'The application_permit value was not specified.',
    'DM_API_E_DYNAMIC_GROUP_UPDATE': 'The dynamic_groups field can be updated only by append and remove operations.',
    'DM_API_E_INVALID_FORCE_AUTH': 'Invalid value ({0}) for connect argument \'force_authenticate\'. It must be \'T\', \'t\', \'F\', or \'f\'.',
    'DM_API_E_INVALID_ARG_APPLY': 'Invalid value ({0}) for the {1} argument of {2} apply method.',
    'DM_API_E_GETHOSTBYNAME_FAILED': 'OS Error has occurred in gethostbyname() or gethostbname_r(). Retry could resolve the issue.',
    'DM_API_F_INTERNAL': 'An unexpected internal inconsistency has caused your operation to fail ({0}).',
    'DM_API_F_BADRPCDLL': 'You have a mismatched rpcdll.dll and dmcl.dll. rpc version: {0}, rpc release: {1}. Expected version: {2}, expected release: {3}',
    'DM_API_F_CACHE_READ': 'An unexpected internal error has occurred while reading query results from the query cache for your query.',
    'DM_API_F_CACHE_OBJECT': 'An unexpected error has occurred while loading an object from the query cache for your query.',
    'DM_API_F_CACHE_CLOSE': 'An unexpected error has occurred while closing the query cache for your query.',
    'DM_API_F_CACHE_UNREADABLE': 'An unexpected internal error has occurred while reading query results from the query cache for your query.',
    'DM_API_F_CACHE_MAP': 'An unexpected internal error has occurred while processing a cached query.',
    'DM_ASSEMBLY_E_NEED_PRIV_FOR_CHANGE': 'The current user {0} has insufficient privileges to  save or destroy {1} assembly.',
    'DM_ASSEMBLY_E_NEED_PRIV2_FOR_CHANGE': 'The current user {0} has insufficient privileges to  save or destroy {1} assembly since {2} \'{3}\' is protected.',
    'DM_ASSEMBLY_E_INVALID_PARENT': 'Invalid parent id {0} specified.',
    'DM_ASSEMBLY_E_INVALID_COMPONENT': 'Invalid component id {0} specified.',
    'DM_ASSEMBLY_E_INVALID_COMP_CHRON': 'Invalid component chronicle id {0} specified.',
    'DM_ASSEMBLY_E_INVALID_COMP_MATCH': 'Specified chronicle id {0} does not match the chronicle id of {1}.',
    'DM_ASSEMBLY_E_CANT_FETCH_INVALID_ID': 'Cannot fetch an assembly - Invalid object ID {0}',
    'DM_ASSEMBLY_F_INIT1': 'The dmAssembly type was found in the database without a version stamp.',
    'DM_ASSEMBLY_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_ASSEMBLY_F_INIT3': 'The type manager returned an error storing the dmAssembly type.',
    'DM_ASSEMBLY_F_TYPE_CONVERSION': 'Failed to convert type dm_assembly to version {0}.',
    'DM_ASSEMBLY_F_LENGTH_WIDEN_FAILED': 'Failed to increase the length of the attribute ({0}) from {1} to {2}.',
    'DM_AUDITTRAIL_W_EXCEED_ROW_SIZE': 'The attribute_list_old property is created with a short lengh because the ability to audit old property values is not enabled due to a database page size limitation.',
    'DM_AUDITTRAIL_E_CANT_MODIFY': 'You can not modify any existing AuditTrail object {0}.',
    'DM_AUDITTRAIL_E_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_AUDITTRAIL_E_AUDIT_NO_EVENT': 'No Event Specified for audit.',
    'DM_AUDITTRAIL_E_AUDIT_INVALID_EVENT': 'Event {0} is not a valid system event.',
    'DM_AUDITTRAIL_E_AUDIT_ALREADY_AUDITED': 'Event {0} on object {1} is already being audited.',
    'DM_AUDITTRAIL_E_UNAUDIT_NO_EVENT': 'No Event Specified for unaudit.',
    'DM_AUDITTRAIL_E_UNAUDIT_INVALID_EVENT': 'Event {0} is not a valid system event.',
    'DM_AUDITTRAIL_E_DBERROR': 'AuditTrail was unable to perform \'{0}\' on {1} for event {2}.\nDatabase error:\n{3}',
    'DM_AUDITTRAIL_E_CANT_AUDIT': 'Could not audit the specified {0} event for {1} document/object.',
    'DM_AUDITTRAIL_E_CANT_UNAUDIT': 'Could not unaudit the specified {0} event for {1} document/object.',
    'DM_AUDITTRAIL_E_AUDIT_NEED_AT_LEAST_SYSADMIN': 'The current user ({0}) needs to have at least sysadmin privileges to audit the {1} event.',
    'DM_AUDITTRAIL_E_UNAUDIT_NEED_TO_BE_SUPERUSER': 'The current user ({0}) needs to have superuser privileges to unaudit the {1} event.',
    'DM_AUDITTRAIL_E_NOT_AUDITED': 'Event {0} is not audited for object {1}.',
    'DM_AUDITTRAIL_E_CANT_FIND_OBJ': 'Could not find the object, name or event \'{0}\' for id {1}.',
    'DM_AUDITTRAIL_E_NO_AUTH_DESTROY': 'The current user ({0}) must have \'purge audit\' privilege to destroy an audit trail.',
    'DM_AUDITTRAIL_E_INCREASE_LENGTH': 'Failed to increase the size of {0} from {1} to {2}.',
    'DM_AUDITTRAIL_E_AUDIT_NEED_CONFIG_AUDIT': 'The current user ({0}) needs to have \'config audit\' privilege to audit the {1} event.',
    'DM_AUDITTRAIL_E_UNAUDIT_NEED_CONFIG_AUDIT': 'The current user ({0}) needs to have \'config audit\' privilege to unaudit the {1} event.',
    'DM_AUDITTRAIL_E_AUDIT_ALL_NOT_ALLOW_EXTRA': 'You are not allowed to specify extra values, for example, \'{0}\', when auditing all events.',
    'DM_AUDITTRAIL_E_AUDIT_DEFAULT_NOT_ALLOWED': 'The keyword \'default\' for policy is only allowed when the event name is ({0}).',
    'DM_AUDITTRAIL_E_NO_DEFAULT_POLICY': '{0} failed because the type ({1}) does not have a default policy.',
    'DM_AUDITTRAIL_E_NO_BROWSE_ACCESS': 'The user ({0}) does not have browse access to the audittrail record with ID \'{1}\'.',
    'DM_AUDITTRAIL_E_EVENT_NAME_NOT_ALLOWED': 'Event {0} is not allowed in {1}.',
    'DM_AUDITTRAIL_E_OUT_OF_RANGE': 'The index ({0}) of the attribute {1} should be between {2} and {3}.',
    'DM_AUDITTRAIL_E_CURSOR_FAIL': 'The following query {0} generated the following database {1} error',
    'DM_AUDITTRAIL_E_AUDIT_OBJ_NOT_ALLOW_EXTRA': 'When auditing an object, no values can be provided for the following arguments: audit_subtypes ({0}), controlling_app ({1}), policy_id ({2}), and state_name ({3})',
    'DM_AUDITTRAIL_E_AUDIT_DOCBASE_WIDE_NOT_ALLOW_EXTRA': 'You are not allowed to specify extra values, \'{0}\', when docbase-wide event is audited.',
    'DM_AUDITTRAIL_E_AUDIT_ATTR_NOT_EXISTS': 'You try to audit event ({0}) with an non-existent attribute ({1}) in the list ({2}).',
    'DM_AUDITTRAIL_E_AUDIT_GROUP_NOT_ALLOW_EXTRA': 'No value is allowed to specify in controlling_app ({0}), policy_id ({1}), and state_name ({2}) for event ({3}).',
    'DM_AUDITTRAIL_E_AUDIT_NOT_ALLOW_STATE_NAME': 'It is not allowed to specify state_name ({0}) if lifecycle id is not specified.',
    'DM_AUDITTRAIL_E_INVALID_POLICY_ID': 'Lifecycle with ID \'{0}\' does not exist.',
    'DM_AUDITTRAIL_E_INVALID_STATE_NAME': 'There is no state named \'{0}\' in lifecycle with ID \'{1}\'.',
    'DM_AUDITTRAIL_E_EVENT_NOT_AUDITABLE_FOR_TYPE': 'The event \'{0}\' is not auditable for the type \'{1}\'.',
    'DM_AUDITTRAIL_E_MISSING_ARG': 'The method \'{0}\' is missing argument for \'{1}\'.',
    'DM_AUDITTRAIL_E_INVALID_ARG': 'The method \'{0}\' has invalid value ({1}) for argument \'{2}\'.',
    'DM_AUDITTRAIL_E_OBJ_NO_SIGNATURE': 'The Object ({0}) has not been digitally signed. No audit record is generated for the event \'{1}\'.',
    'DM_AUDITTRAIL_E_INSUFFICIENT_PRIV': 'The user ({0}) needs \'{1}\' privilege for the operation \'{2}\'.',
    'DM_AUDITTRAIL_E_SIGNATURE_TOO_LONG': 'The internal gernerated audit signature is too long ({0}). It cannot exceed the size of {1}.',
    'DM_AUDITTRAIL_E_SIGNATURE_CREATE_FAIL': 'Server failed to generate audit signature.',
    'DM_AUDITTRAIL_E_SIGNATURE_MISMATCH': 'Audit record ({0}) has failed the audit signature verification.',
    'DM_AUDITTRAIL_E_NO_SIGNATURE': 'Audit record ({0}) has not been signed.',
    'DM_AUDITTRAIL_E_CANT_AUDIT_UNLESS_MATERIALIZED': 'Could not audit the specified {0} event for {1} because it is an un-materialized lightweight object.',
    'DM_AUDITTRAIL_E_ONLY_INSTALL_OWNER': 'Only a docbase install owner can perform {0} operation on audit policy.',
    'DM_AUDITTRAIL_E_NO_PURGE_POLICY': 'The current user ({0}) does not have a purge policy to destroy an AuditTrail object ({1})',
    'DM_AUDITTRAIL_F_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_AUDITTRAIL_F_BAD_VSTAMP': 'Type dm_audittrail has a bad vstamp {0}. The current vstamp for dm_audittrail is supposed to be {1}.',
    'DM_AUDITTRAIL_F_TYPE_CONVERSION': 'Failed to convert type dm_audittrail to version {0}.',
    'DM_AUDITTRAIL_F_RPC_CALL': 'Failed to run the RPC call {0}.',
    'DM_DOCBROKER_I_REGISTERED': 'The Docbroker registered using service: ({0}) with port: ({1}).',
    'DM_DOCBROKER_I_SHUT_DOWN': 'The Docbroker is shutting down.',
    'DM_DOCBROKER_I_SECURITY_ENABLED': 'Shutdown security enabled via password.',
    'DM_DOCBROKER_I_START': 'Docbroker has started.  Process id: {0}',
    'DM_DOCBROKER_I_SHUTDOWN_REQUESTED': 'Shutdown has been requested from user: {0} on host: {1}.',
    'DM_DOCBROKER_I_LISTENING': 'The Docbroker is listening on network address: ({0})',
    'DM_DOCBROKER_I_DMCL_INI_WIN32_SEARCH1': '%%DMCL_CONFIG%%==({0}), current directory==({1}), %%DOCUMENTUM%%==({2}), Windows directory==({3})',
    'DM_DOCBROKER_I_PROJECTING': 'Sending information to Docbroker located on host ({0}) with port ({1}).  Information: ({2}).',
    'DM_DOCBROKER_I_REGISTERED_PORT': 'The Docbroker registered using port ({0}).',
    'DM_DOCBROKER_W_CONNECT_FAILED': 'Unable to make network connection to the DocBroker at network address ({0}).  Please check your dmcl.ini file for a correct host.',
    'DM_DOCBROKER_W_NO_OPEN_SERVERS': 'The DocBroker running on host ({0}) indicates the server map for docbase ({1}), does not contain any servers with status Open',
    'DM_DOCBROKER_W_NO_LOCAL_SERVERS': 'The DocBroker running on host ({0}) indicates the server map for docbase ({1}), does not contain any servers with local proximity',
    'DM_DOCBROKER_W_DBG_BYPASS_BY_SRV': 'Warning you are using a local override to specifiy the network address of your server for docbase ({0}).  Values used: host ({1}), service ({2}) and docbase ID ({3}).',
    'DM_DOCBROKER_W_DBG_BYPASS_BY_RAW': 'Warning you are using a local override to specifiy the network address of your server for docbase ({0}).  Values used: host ({1}), port ({2}) and docbase ID ({3}).',
    'DM_DOCBROKER_W_REQUEST_STATUS': 'The docbroker on host ({0}) returned a failed status for the request: ({1}).   Error message from docbroker: ({2}).',
    'DM_DOCBROKER_W_FILE_CHECK': 'The file containing your docbroker password, {0}, can be accessed by other users.  The operating system error was {1}.',
    'DM_DOCBROKER_W_FILE_PERMISSION': 'The security of file containing your docbroker password: {0} is readable by others.',
    'DM_DOCBROKER_W_SHUTDOWN_REQ_REJ': 'A shutdown request from user ({0}) on host ({1}) was rejected due to an invalid password.',
    'DM_DOCBROKER_W_UNKNOWN_REQUEST': 'Unknown request ordinal: {0}',
    'DM_DOCBROKER_W_EXEC_POOL_FULL': 'The execution context pool is full.',
    'DM_DOCBROKER_W_CHECKPOINT_RUNNING': 'Docbroker Checkpoint was not sent.  The previously launched Docbroker Checkpoint (pid = {0}) is still running.  Check your server log for additional messages.',
    'DM_DOCBROKER_W_SSL_HANDSHAKE_FAILED': 'Failed to establish a secure connection. Secure port: {0}. Client address: {1}. Check that clients and servers have the correct docbroker port configuration.',
    'DM_DOCBROKER_E_MEMORY_EXHAUSTED': 'Memory exhausted allocating {0} bytes',
    'DM_DOCBROKER_E_REQUEST_FAILED': 'The request to the Docbroker failed due to the following error: ({0}).',
    'DM_DOCBROKER_E_REQUEST_FAILED_E': 'The Docbroker request failed.',
    'DM_DOCBROKER_E_NO_SERVERS_QUALIFY': 'The DocBroker running on host ({0}) does not know of a local active server for the specified docbase ({1})',
    'DM_DOCBROKER_E_NO_SERVERS_FOR_DOCBASE': 'The DocBroker running on host ({0}) does not know of a server for the specified docbase ({1})',
    'DM_DOCBROKER_E_DOCBASE_NAME_LENGTH': 'The connect string ({0}) is too long at ({1}) characters.  Maximum length is restricted to ({2}) characters',
    'DM_DOCBROKER_E_DOCBASE_SYNTAX_ORDER': 'Invalid syntax for the docbase connect string ({0}).  The docbase/server name separator, \'.\' must preceed the server name/host name separator \'@\'.',
    'DM_DOCBROKER_E_DOCBASE_SYNTAX_MULTI': 'Invalid syntax for the docbase connect string ({0}).  The docbase/host name separator, @, and the docbase name/server name separator \'.\' can only appear once.',
    'DM_DOCBROKER_E_EMPTY_NAME': 'The docbase name is required and is not specified in the docbase connect string ({0})',
    'DM_DOCBROKER_E_NETWORK_ERROR': 'An error occured performing a network operation: ({0}).  Network specific error: ({1}).',
    'DM_DOCBROKER_E_CONNECT_FAILED': 'Unable to connect to DocBroker. Clients please check your dmcl.ini file for a correct host.  Server please check your server.ini or target attributes in server config.  Network address: ({0}).',
    'DM_DOCBROKER_E_NO_SERVERS_FOR_SPECIFIC': 'The DocBroker running on host ({0}) indicates the specific server for the docbase ({1}) you specified was not found.',
    'DM_DOCBROKER_E_NO_DOCBASES': 'There are not any Docbases registered with the DocBroker running on host ({0}).',
    'DM_DOCBROKER_E_DMCL_MISSING_HOST': 'Unable to connect to a DocBroker because your dmcl.ini file ({0}) does not specify a section DOCBROKER_PRIMARY with a value for host',
    'DM_DOCBROKER_E_DMCL_INI_NOT_FOUND': 'Unable to connect to a DocBroker because your dmcl.ini file cannot be found.  Please see your system administrator as this file is needed to specify the host name of your DocBroker.',
    'DM_DOCBROKER_E_DMCL_INI_UNIX_MISSING': 'Failure to connect to DocBroker (no dmcl.ini). The search rules are: 1) $DMCL_CONFIG specifies a file 2) current directory 3) $DOCUMENTUM specifies a directory with dmcl.ini.',
    'DM_DOCBROKER_E_DMCL_INI_WIN_MISSING': 'Failure to connect to a DocBroker (no dmcl.ini). The search rules are: 1) working directory 2) windows directory',
    'DM_DOCBROKER_E_DMCL_INI_MAC_MISSING': 'Failure to connect to a DocBroker (no dmcl.ini). The search rules are: 1) working path 2) preferences path 3) Documentum: 4) Documentum:config',
    'DM_DOCBROKER_E_NOT_IMPLEMENTED': 'The Docbroker request you generated is not implemented in this release.  ({0})',
    'DM_DOCBROKER_E_REPLY_STREAM': 'The reply stream from the DocBroker could not be loaded. First 80 bytes: ({0}).',
    'DM_DOCBROKER_E_REQUEST_STREAM': 'The request stream from the client could not be loaded. First 80 bytes: ({0}).',
    'DM_DOCBROKER_E_HOST_NAME': '{0}',
    'DM_DOCBROKER_E_BAD_PROTOCOL': 'The DocBroker protocol you specified is invalid',
    'DM_DOCBROKER_E_REQUEST_STATUS': 'The docbroker on host ({0}) returned a failed status for the request: ({1}).   Error message from docbroker: ({2}).',
    'DM_DOCBROKER_E_REGISTER_FAIL': 'Failure to register the docbroker process on socket port: ({0}).  Error: {1}',
    'DM_DOCBROKER_E_REGISTER_IN_USE': 'Failure to start the docbroker process.  Error indicates that there is already a docbroker process running on this host on port: ({0}).  Error Details: {1}',
    'DM_DOCBROKER_E_CONN_REJ_1': 'Docbroker: Refusing service to client on connection {0} -- too many clients',
    'DM_DOCBROKER_E_START_NETWISE': 'The docbroker failed to start due to an error returned by the Netwise networking subsystem.  Failed API: {0}.  Error specifics: {1}.',
    'DM_DOCBROKER_E_OPEN_IFILE': 'Error opening initialization file: {0}.  {1}.',
    'DM_DOCBROKER_E_BAD_NET_STREAM': 'Unable to process a request.  The stream image was unparsable.',
    'DM_DOCBROKER_E_LISTEN_FAIL': 'Failure to register the docbroker process on network address: ({0}).  Error: ({1})',
    'DM_DOCBROKER_E_SEND_LAUNCH': 'Unable to send checkpoint to docbroker due to an operating system error: {0}.',
    'DM_DOCBROKER_E_DMCL_INI_WIN32_MISSING': 'DocBroker connection failed (no dmcl.ini). Search rules: 1) %%DMCL_CONFIG%% specifies a file 2) current directory 3) %%DOCUMENTUM%% specifies a directory with dmcl.ini 4) Windows dir.',
    'DM_DOCBROKER_E_INVALID_PORT': 'Invalid port number ({0}).',
    'DM_DOCBROKER_E_INVALID_HOST': 'Invalid host name ({0}).',
    'DM_DOCBROKER_E_MAP_CACHE_OVERFLOW': '{0} map cache overflow.',
    'DM_DOCBROKER_E_UNKNOWN_DOCBROKER_MAP_NAME': 'Unknown docbroker map name: {0}',
    'DM_DOCBROKER_E_CHECKPOINT_NOT_SENT': 'The docbroker checkpoint was not sent for the following reason: {0}',
    'DM_DOCBROKER_E_CONNECT_FAILED_EX': 'Unable to connect to DocBroker. Clients please check your dfc.properties file for a correct host.  Server please check your server.ini or target attributes in server config.  Network address: ({0}).',
    'DM_DOCBROKER_E_OPEN_FAILED': 'nl_open failed, error code: {0}.',
    'DM_DOCBROKER_E_ACCEPT_FAILED': 'nl_accept failed, error code: {0}.',
    'DM_DOCBROKER_E_CLOSE_FAILED': 'nl_close failed, error code: {0}. The connection will be aborted.',
    'DM_DOCBROKER_F_ABORT_FAILED': 'nl_abort failed, error code: {0}. The connection was not closed.',
    'DM_CABINET_E_NEED_PRIV_FOR_CHANGE': 'The current user {0} has insufficient privileges to  save or destroy {1} cabinet.',
    'DM_CABINET_F_INIT1': 'The dmCabinet type was found in the database without a version stamp.',
    'DM_CABINET_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_CABINET_F_INIT3': 'The type manager returned an error storing the dmCabinet type.',
    'DM_CCONTENT_I_AUTO_PURGE': 'Local Content Area ({0}) was purged automatically as the Diskfull Warning threshold was exceeded during a getfile request.',
    'DM_CCONTENT_W_CLEANUP_ERROR': 'During session exit errors were encountered cleaning up the session content directory ({0}).  These files will be automatically cleaned up the next time you connect.',
    'DM_CCONTENT_W_PURGE_CONTENTS': 'Error occurred during purge operation on temporary content area ({0}).  Not all files could be removed.  Operating System error was ({1}).',
    'DM_CCONTENT_W_DISKFULL_WARN': 'Diskfull warning; threshold exceeded in content area {0}.  Free Bytes Remaining: {1}K. Current Disk Usage: {2} percent. Diskfull Limit: {3} percent.',
    'DM_CCONTENT_W_APICONFIG_PATH': 'The configuration setting for the local_path in the dmcl.ini file specifies a directory ({0}) that does not exist or cannot be accessed. Overriding this setting with its default local area.',
    'DM_CCONTENT_W_APICONFIG_VALUE': 'The Client configuration setting for {0} in the dmcl.ini file specifies an invalid value. Overriding this setting with its default value.',
    'DM_CCONTENT_E_CREATE_DIRECTORY': 'Creation of file system directory ({0}) for session content area failed.  Operating System error was ({1}).',
    'DM_CCONTENT_E_LOCK_FILECREATE': 'Error creating file ({0}) in order to lock the Session Temporary Content Directory for use on the first Getfile request. Operating System error was ({1}).',
    'DM_CCONTENT_E_LOCK_REQUEST': 'Error requesting file lock on filename ({0}) in order to lock the Session Temporary Content Directory for use on the first Getfile request. Lock_wait {1}. Operating System error was ({2}).',
    'DM_CCONTENT_E_LOCK_RELEASE': 'Error releasing file lock on filename ({0}) in order to unlock the Session Temporary Content Directory at session exit. Operating System error was ({1}).',
    'DM_CCONTENT_E_CHECK_DISKSPACE': 'Error attempting to check for available disk space in the Session Temporary Content Area during a Getfile operation. Space check on directory ({0}) failed with Operating System error ({1}).',
    'DM_CCONTENT_E_REMOVE_DIRECTORY': 'Error destroying a directory or its contents.  Error occurred on remove of directory ({0}) with Operating System error ({1}).',
    'DM_CCONTENT_E_REMOVE_FILE': 'Error destroying a file.  Error occurred on remove of file ({0}) with Operating System error ({1}).',
    'DM_CCONTENT_E_READ_DIRECTORY': 'Error reading directory contents of directory ({0}).  Operating System error ({1}).',
    'DM_CCONTENT_E_DISKFULL_LIMIT': 'Insufficient disk space exists to create a file of size {0} bytes in directory {1}.  Free Bytes Remaining: {2}K. Current Disk Usage: {3} percent. Diskfull Limit: {4} percent.',
    'DM_CCONTENT_E_DIRECTORY_ACCESS': 'Cannot use the Local Content Area due to the inability to access the session content directory ({0}). The Operating System error was ({1}).',
    'DM_CCONTENT_E_NO_LOCAL_AREA': 'The Local Content Area could not be initialized due to the inability to lookup a default Working Directory to use for Getfile requests.',
    'DM_CCONTENT_E_LOCAL_AREA_NOTFOUND': 'The Client configuration setting for the Local Location specifies a directory ({0}) that does not exist or cannot be accessed. Using the Default Local Content Area ({1}). The Operating System error was ({2}).',
    'DM_CCONTENT_E_LOCAL_AREA_DEFAULT': 'The default Local Location for this client ({0}) does not exist or cannot be accessed.  This prevents fetching document contents. The Operating System error was ({1}).',
    'DM_CCONTENT_E_BAD_CONFIG_VALUE': 'The setting for the configuration parameter ({0}) is not a legal value: {1}.  Using default value of {2}.',
    'DM_CCONTENT_E_NO_COMMON': 'A Nameless Getfile request was made to a server which does not have Common Area access.  The Client should be configured to use its Local Content Area.',
    'DM_CCONTENT_E_PERMS1': 'The Local Content Area cannot be initialized because the session does not have permission to make updates in the Root Local Area ({0}). The Local Area root and its immediate subdirectories should allow public write access.',
    'DM_CCONTENT_E_PERMS2': 'If the local root is shared by multiple users then in some cases the user environment can prevent the Local Area from being created with proper permissions (the user may use a umask which disallows creating public files).',
    'DM_CCONTENT_E_PERMS3': 'The Local Content Area root ({0}) and its docbase and hostname subdirectories should be made publicly updatable as well as the \'dir.lck\' files inside.',
    'DM_CCONTENT_E_LCOPY_NONFS': 'The use_local_on_copy option requires that the client be nfs enabled.  Since the nfs_enabled option for this client is not set to TRUE the local area protocols must default to use_local_always.',
    'DM_CCONTENT_E_LCOPY_AMBIGUOUS': 'Both the use_local_always and use_local_on_copy options were enabled for this client. These flags are mutually exclusive.  Use_local_on_copy cannot be specified unless use_local_always is unset.',
    'DM_CCONTENT_E_NO_UNIQUE': 'Unable to generate a unique file name.  While creating a file for the sysobject {0} with hint {1} the maximum number of collisions was exceeded. The file name generated was {2}',
    'DM_CCONTENT_E_CHECK_LONG': 'Error accessing directory {0}.  While determining file system support for long file names the following Operating System error occurred: {1}.',
    'DM_CCONTENT_E_PATH_TOO_LONG': 'Cannot create file in directory {0} as the resulting path/filename would exceed the system limitation of {1} bytes.',
    'DM_CHARTRANS_I_TRANSLATOR_OPENED': 'Translator in directory ({0}) was added succesfully initialized.  Translator specifics: ({1})',
    'DM_CHARTRANS_W_TRANSLATOR_SKIPPED': 'Translator in directory ({0}) was skipped because it failed initialization.  Translator specifics: ({1})',
    'DM_CHARTRANS_W_NLS_LOCACTION_ACCESS': 'The location specified by your server configuration for the NLS directory is ({0}) specifies a directory ({1}) which cannot be accessesed.  Operating system error was ({2}).',
    'DM_CHARTRANS_W_SERVER_CODEPAGE': 'The server is NOT certified with an internal codepage of {0}, only UTF-8!  Using the server with this codepage setting is likely to lead to corruption of data!',
    'DM_CHARTRANS_W_CHANGE_PASSWORD_TRANSLATION': 'User password was successfully changed but an internal error occurred in returning the user credentials.',
    'DM_CHARTRANS_E_MEMORY_EXHAUSTED': 'Memory exhausted allocating {0} bytes',
    'DM_CHARTRANS_E_SERVER_PLATFORM_MISMATCH': 'Library, {0}, does not provide translation for server host platform.  Server platform :({1}), Library translation server platform: ({2}).',
    'DM_CHARTRANS_E_SERVER_LOCALE': 'Error processing Library {0}: unable to create locale object',
    'DM_CHARTRANS_E_PROC_LOAD_FAIL': 'Error processing Library {0}: unable to load procedure: {1} due to: {2}',
    'DM_CHARTRANS_E_SCAN_OPEN': 'Error opening directory scan for directory: ({0}), {1}',
    'DM_CHARTRANS_E_INVALID_DIRECTORY': 'Unable to validate existence of directory for ({0})=({1}).  Operating System Error: ({2})',
    'DM_CHARTRANS_E_SCAN_ADVANCE': 'Error during scan of directory ({0}).  Operating System Error: ({1})',
    'DM_CHARTRANS_E_SHARED_LIB_OPEN': 'Unable to open character translator shared library: ({0}).  Operating System Error: ({1})',
    'DM_CHARTRANS_E_VERITY_TRANSLATION': 'Error translating \'{0}\' to Verity codepage.',
    'DM_CHARTRANS_E_VERITY_NO_TRANSLATOR': 'Unable to find character translator for Verity codepage {0}.',
    'DM_CHARTRANS_E_SERVER_TRANSLATION': '{0} function: {1} value: {2}.',
    'DM_CHARTRANS_E_NO_OS_TRANSLATOR': 'Unable to create character translator for Operating System codepage {0}.',
    'DM_CHARTRANS_E_SESSION_TRANSLATION': 'Error translating \'{0}\' to session codepage \'{1}\'.',
    'DM_CHARTRANS_E_DATABASE_CONFIGURATION': 'Unable to verify that database is compatible with UTF-8 codepage.',
    'DM_CHARTRANS_E_SERVER_TRANSLATION_TO_SERVER_CODEPAGE': 'Error in server translating \'{0}\' from client codepage \'{1}\' to server codepage \'{2}\'.',
    'DM_CHARTRANS_E_SERVER_TRANSLATION_FROM_SERVER_CODEPAGE': 'Error in server translating \'{0}\' from server codepage \'{1}\' to client codepage \'{2}\'.',
    'DM_CHARTRANS_E_CLIENT_TRANSLATION_FROM_CLIENT_CODEPAGE': 'Error in DMCL translating \'{0}\' from client codepage \'{1}\' to server codepage \'{2}\'.',
    'DM_CHARTRANS_E_CLIENT_TRANSLATION_TO_CLIENT_CODEPAGE': 'Error in DMCL translating \'{0}\' from server codepage \'{1}\' to client codepage \'{2}\'.',
    'DM_CHARTRANS_E_OS_TRANSLATION_FROM_OS_CODEPAGE': 'Error translating \'{0}\' from OS codepage \'{1}\' to codepage \'{2}\'.',
    'DM_CHARTRANS_E_OS_TRANSLATION_TO_OS_CODEPAGE': 'Error translating \'{0}\' to OS codepage \'{1}\' from codepage \'{2}\'.',
    'DM_CHARTRANS_F_NO_TRANSLATOR': 'Unable to instantiate any translators in directory ({0})',
    'DM_CONTAINMENT_E_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}',
    'DM_CONTAINMENT_E_NEED_PRIV_FOR_CHANGE': 'The current user {0} has insufficient privileges to  save or destroy {1} containment.',
    'DM_CONTAINMENT_E_BAD_PARAM': 'Invalid object id {0} specified.',
    'DM_CONTAINMENT_E_CURSOR_FAIL': 'The following query {0} generated the following database {1} error',
    'DM_CONTAINMENT_E_UPDATE_FAIL': 'Database update on the following table {0} generated the following database {1} error.',
    'DM_CONTAINMENT_E_FETCH_FAIL': 'Database fetching on the following table {0} generated the following database {1} error.',
    'DM_CONTAINMENT_E_INVALID_COMPONENT': 'Component object with id {0} does not exist.',
    'DM_CONTAINMENT_F_INIT1': 'The dmContainment type was found in the database without a version stamp.',
    'DM_CONTAINMENT_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_CONTAINMENT_F_INIT3': 'The type manager returned an error storing the dmContainment type.',
    'DM_CONTAINMENT_F_INT1': 'The following database query {0} could not be executed.',
    'DM_CONTAINMENT_F_INIT4': 'The type manager returned an error converting the dm_containment type.',
    'DM_CONTAINMENT_F_TYPE_CONVERSION': 'Failed to convert type dm_containment to version {0}.',
    'DM_COMPOSITE_E_ALREADY_LINKED': 'The {0} sysobject is already linked to the composite with ID {1}.',
    'DM_COMPOSITE_E_BAD_ORDER': 'Invalid order number {0} specified. Must be positive and non-zero.',
    'DM_COMPOSITE_E_CANT_ADD_LINK': 'Cannot add sysobject {0} to composite with path name {1}.',
    'DM_COMPOSITE_E_CANT_CHANGE_NAME': 'Cannot change a composite name.',
    'DM_COMPOSITE_E_CANT_DELETE_LINK': 'Cannot delete sysobject {0} from composite with path name {1}.',
    'DM_COMPOSITE_E_CANT_DROP_CHILDL': 'No link established between composite with path name {0} and ancestor composite with ID {1}.',
    'DM_COMPOSITE_E_CANT_DROP_LINK': 'No link exists between composite with path name {0} and sysobject with ID {1}.',
    'DM_COMPOSITE_E_CANT_DESTROY': 'Cannot destroy composite with path name {0} since it is not empty.',
    'DM_COMPOSITE_E_INVALID_PATH': 'Cannot fetch composite with path name {0}.',
    'DM_COMPOSITE_E_CANT_SAVE_NO_LINK': 'Cannot save composite with object_name {0} - composites must be linked.',
    'DM_COMPOSITE_E_CIRC_LINK': 'Cannot create circular links for composite with path name {0}.',
    'DM_COMPOSITE_E_COMPN_COMPS': 'The component with {0} id cannot be added since components of this composite must all be composites.',
    'DM_COMPOSITE_E_COMPN_DOC': 'The component with {0} id cannot be added since components of this composite must all be documents.',
    'DM_COMPOSITE_E_INVALID_COMP': 'The component identified by {0} is of invalid type.',
    'DM_COMPOSITE_E_INVALID_CHECKIN': 'Invalid version label {0} specified for composite {1} checkin.',
    'DM_COMPOSITE_E_INVALID_LABEL': 'Version label {0} must exist in {1} composite.',
    'DM_COMPOSITE_E_MUST_HAVE_NAME': 'A new composite must have an object_name.',
    'DM_COMPOSITE_E_PATH_EXISTS': 'Cannot save (or link) {0} composite with path name {1} because one already exists.',
    'DM_COMPOSITE_E_NO_COMPONENT': 'Cannot find the component at position {0} in composite {1}.',
    'DM_COMPOSITE_E_NONEXISTENT_COMPN': 'Nonexistent component {0} ID for {1} composite.',
    'DM_COMPOSITE_E_TOO_MANY_LEVELS': 'Cannot link {0} composite to {1} composite since the level of nesting is passed the limit ({2}).',
    'DM_COMPOSITE_E_INVALID_COMPL': 'Invalid component label {0} for {1} component.',
    'DM_COMPOSITE_E_CANT_COMPUTE_DESC': 'Cannot compute child composites for {0} composite.',
    'DM_COMPOSITE_F_INIT1': 'The dm_composite type was found in the database without a version stamp.',
    'DM_COMPOSITE_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_COMPOSITE_F_INIT3': 'The type manager returned an error storing the dm_composite type.',
    'DM_COMPOSITE_F_INT1': 'The following database query could not be executed: {0}.',
    'DM_CONTENT_T_COMPRESSION': 'Content was compressed from {0} to {1} bytes',
    'DM_CONTENT_T_DECOMPRESSION': 'Content was decompressed from {0} to {1} bytes',
    'DM_CONTENT_T_MERGE_1': 'Checking local renditions for content object ID={0}, parent ID={1}',
    'DM_CONTENT_T_MERGE_2': 'Deleting content object: {0}',
    'DM_CONTENT_T_MERGE_3': 'Unlinking content object: {0}',
    'DM_CONTENT_T_MIGRATE_CONTENT': '{0}',
    'DM_CONTENT_T_MIGRATE_CONTENT_ARGUMENTS_SPECIFIED': 'Arguments specified for MIGRATE_CONTENT: OBJECT_ID = {0}, TARGET_STORE = {1}, SOURCE_STORE = {2}, QUERY = {3}, MAX_MIGRATE_COUNT = {4}, BATCH_SIZE = {5}, LOG_FILE= {6}, REMOVE_ORIGINAL = {7}',
    'DM_CONTENT_T_MIGRATE_CONTENT_MIGRATION_SUCCESS': 'Successful migration of batch ({0} object(s)).',
    'DM_CONTENT_T_MIGRATE_CONTENT_OBJECTS_MIGRATED': '{0} object(s) successfully migrated.',
    'DM_CONTENT_T_MIGRATE_CONTENT_MIGRATING_OBJECT': 'Migrating content object {0}',
    'DM_CONTENT_T_MIGRATE_CONTENT_MIGRATED_OBJECT': 'Migrated content object {0}',
    'DM_CONTENT_T_MIGRATE_CONTENT_REACHED_MAX_COUNT': 'Migrated maximum objects specified {0}',
    'DM_CONTENT_T_MIGRATE_CONTENT_REMOVE_SKIPPED': 'Content file {0} for content object {1} is not removed. You should remove it manually.',
    'DM_CONTENT_T_MIGRATE_CONTENT_PERF_REC': '{0}',
    'DM_CONTENT_T_MIGRATE_CONTENT_PERF_FREC': '{0}',
    'DM_CONTENT_T_MIGRATE_CONTENT_PERF_FINAL': '{0}',
    'DM_CONTENT_T_MIGRATE_CONTENT_OBJECT_SKIPPED': 'Migration of content for object {0} skipped. Reason {1}',
    'DM_CONTENT_T_MIGRATE_CONTENT_TOTAL_SKIPPED': '{0} objects skipped during migration',
    'DM_CONTENT_T_MIGRATE_CONTENT_WORKER_LOGFILENAME': 'worker log filename: {0}',
    'DM_CONTENT_W_CONTENT_TRUNCATED': 'Content was truncated -- only {0}u bytes stored',
    'DM_CONTENT_W_SET_WORM_CONTENT_READ_ONLY_FAILED': 'Could not set read only attribute for content with path {0} on worm store, with error {1}',
    'DM_CONTENT_W_DUMP_NO_CONTENT': 'The content data for dmr_content object {0} could not be dumped. Reason: {1}.',
    'DM_CONTENT_W_LOAD_NO_CONTENT': 'No content data for dmr_content object {0} in dumpfile.  Document being added with no content.  Use RESTORE_CONTENT method to associate content data with this object.',
    'DM_CONTENT_W_LOAD_CONTENT_ERROR': 'Could not load content data for dmr_content object {0}.  Document being added with no content.  Use RESTORE_CONTENT method to associate content data with this object.',
    'DM_CONTENT_W_CREATE_MARK_ALL_TRACE_FAILED': 'Could not create trace file {0} when running the MARK_ALL method. The method will continue without tracing.',
    'DM_CONTENT_W_MIGRATE_CONTENT': '{0}',
    'DM_CONTENT_W_RMDIR_FAILED': 'Unable to destroy temp directory ({0}) created for content batch save. Content Id: {1}. Reason: {2}',
    'DM_CONTENT_W_UPDATE_OTHER_FILE_SIZE_INVALID_BATCH_SIZE': 'Batch size should be a positive integer. The default batch size {0} will be used.',
    'DM_CONTENT_W_UPDATE_OTHER_FILE_SIZE_INVALID_MAX_COUNT': 'Max count should be a positive integer. By default, it will be ignored.',
    'DM_CONTENT_W_UPDATE_OTHER_FILE_SIZE_MISSING_OTHER_FILE': 'There is no other file for the specified dmr_content object {0}.',
    'DM_CONTENT_W_UPDATE_OTHER_FILE_SIZE_ORPHANED_CONTENT': 'Content {0} is an orphaned content and is skipped to be updated.',
    'DM_CONTENT_W_UPDATE_OTHER_FILE_SIZE_FAIL_COMPUTE_OTHER_FILE_SIZE': 'Fail to compute other file size for content {0}. This content will be skipped to be updated.',
    'DM_CONTENT_W_PARALLEL_DEGREE': 'parallel_degree shouldn\'t be negative',
    'DM_CONTENT_W_RETRIEVE_CM_CONTEXT': 'Fail to retrieve content migration execution context and we will migrate contents sequentially',
    'DM_CONTENT_W_INIT_CM_CONTEXT': 'Failed to initialize the content migration execution context, content will be migrated sequentially',
    'DM_CONTENT_W_STOP_SEQUENTIAL_JOB': 'Unable to monitor this content migration job, it will proceed but cannot be stopped through the apply method control_migration',
    'DM_CONTENT_W_STOP_BY_USER': 'This content migration job was stopped by user request',
    'DM_CONTENT_E_NOT_STORE': 'Storage object with id {0} does not exist',
    'DM_CONTENT_E_NULL_STORE': 'Storage object for content with id {0} was null',
    'DM_CONTENT_E_WRONG_PROTOCOL': 'Server and client not using same Mac access protocol',
    'DM_CONTENT_E_NO_PARTITION': 'Content with id {0} marked for indexing; no partition for format {1} exists',
    'DM_CONTENT_E_NO_TEMP_FILE': 'Cannot create temporary file in directory {0}',
    'DM_CONTENT_E_MKDIR_FAILED': 'Cannot create temporary directory {0}',
    'DM_CONTENT_E_CANT_OPEN': 'Could not open file ({0}).',
    'DM_CONTENT_E_FILE_COPY_FAIL': 'File copy from {0} to {1} failed at position {2}.  Operating System error: ({3}).',
    'DM_CONTENT_E_STREAM_COPY_FAIL': 'Stream copy to file {0} failed at position {1}',
    'DM_CONTENT_E_BAD_FORMAT': 'Format {0} is invalid',
    'DM_CONTENT_E_CANT_START_COPY': 'Could not start content copy into file {0}',
    'DM_CONTENT_E_FILE_WRITE_FAILED': 'Attempt to write to file {0} failed',
    'DM_CONTENT_E_FILE_READ_FAILED': 'Attempt to read from file {0} failed',
    'DM_CONTENT_E_REMOVE_FAILED': 'Attempt to remove directory {0} failed; couldn\'t fork process',
    'DM_CONTENT_E_CANT_GET_COMMON_ROOT': 'Could not determine name of common directory',
    'DM_CONTENT_E_COPY_BAD_USER': 'Copy of {0} to {1} failed -- couldn\'t get info for user {2}',
    'DM_CONTENT_E_CONTENT_OFFLINE': 'Content object {0} is offline',
    'DM_CONTENT_E_CANT_FETCH': 'Content in storage area {0} is not available',
    'DM_CONTENT_E_OFFLINE_RESTORE': 'Content is being restored to storage area {0} -- try later',
    'DM_CONTENT_E_RESTORE_FAIL': 'Content could not be restored to storage area {0} -- method {1} failed',
    'DM_CONTENT_E_NO_RESTORE_METHOD': 'Attempt to restore content to storage area {0} failed -- no method with name {1}',
    'DM_CONTENT_E_PURGE_FAILED': 'Content purge failed because {0}',
    'DM_CONTENT_E_DESTROY_FAILED': 'Content destroy failed because {0}',
    'DM_CONTENT_E_NO_PATH_FOR_CONTENT': 'No file path exists for content {0}',
    'DM_CONTENT_E_CONTENT_WORM_UNLINK_FAILED': 'Unlink to content {0} failed',
    'DM_CONTENT_E_FORMAT_NOT_INDEXABLE': 'Content can\'t be indexed -- format was {0}',
    'DM_CONTENT_E_CONTENT_TOO_LONG': 'Content too long; limit is {0} bytes',
    'DM_CONTENT_E_TURBO_LOAD': 'Load of document content not completed due to inconsistencies in content object info. Storage ID is zero indicating turbo storage but non-turbo object content present. DataTicket {0} OtherTicket {1} content pos {2}.',
    'DM_CONTENT_E_OPEN_FAILURE': 'Error opening file ({0}). Operating System error: ({1}).',
    'DM_CONTENT_E_READ_FAILURE': 'Error reading content data from file or stream. Operating System error: ({0}).',
    'DM_CONTENT_E_WRITE_FAILURE': 'Error writing data to content file ({0}). Operating System error: ({1}).',
    'DM_CONTENT_E_STREAM_COPY_FAILURE': 'Stream copy to content file ({0}) failed at position {1}.',
    'DM_CONTENT_E_FILE_COPY_FAILURE': 'File copy from ({0}) to content file ({1}) failed at position {2}.',
    'DM_CONTENT_E_CLOSE_FAILURE': 'Error closing output file ({0}). Operating System error: ({1}).',
    'DM_CONTENT_E_TICKET_FINDINDEX': 'Error searching for existing indexes on the dmr_content type.',
    'DM_CONTENT_E_TICKET_DROPINDEX': 'Error dropping dmr_content index with dmi_index id {0}.',
    'DM_CONTENT_E_TICKET_INDEX': 'Error creating dmr_content index on attribute {0}.',
    'DM_CONTENT_E_INVALID_CONTENT': '{0} is not the object id of a valid content object',
    'DM_CONTENT_E_SECUREWRITE_POPEN': 'Error executing the Secure Writer: {0}. The popen() operation failed with status ({1}).',
    'DM_CONTENT_E_SECUREWRITE_PCLOSE': 'Error executing the Secure Writer: {0}. The pclose() operation failed with status ({1}).',
    'DM_CONTENT_E_SECUREWRITE_ERROR': 'Failure to create content file copy ({0}) due to an error returned by the Secure Writer program ({1}).  Check the server error log for additional information logged by the Secure Writer.',
    'DM_CONTENT_E_NO_OTHER': 'Other-file content requested for document which has no other-file.',
    'DM_CONTENT_E_TRANSFER_ABORTED': 'The content transfer {0} the server was aborted by the user',
    'DM_CONTENT_E_STORAGE_UNKNOWN': 'This problem may be caused by a dumpfile inconsistency.  The load process was likely unable to locate the object which describes the storage area for content object {0} in the dumpfile.',
    'DM_CONTENT_E_FLUSH_FAILURE': 'Error flushing output stream to content file ({0}). Operating System error: ({1}).',
    'DM_CONTENT_E_SYNC_FAILURE': 'Error forcing new content data to physical storage for file ({0}). Operating System error: ({1}).',
    'DM_CONTENT_E_STREAM_NO_FD': 'Error: Could not get file descriptor from open fstream on file ({0}).',
    'DM_CONTENT_E_SOURCE_NOT_OPEN': 'Error: input source is not open.',
    'DM_CONTENT_E_SOURCE_READ_ERROR': 'Error: input source could not be read.',
    'DM_CONTENT_E_SECUREWRITE_PERM': 'Error: failed to set proper file permission for content file ({0}). Operating System error: ({1}).',
    'DM_CONTENT_E_STREAM_COPY_SOURCE': 'Error creating internal Source wrapper for input stream.',
    'DM_CONTENT_E_FILE_COPY_SOURCE': 'Error creating internal Source wrapper for input file ({0}).',
    'DM_CONTENT_E_CANT_OPEN_OTHER': 'Error opening resource fork for file ({0}).',
    'DM_CONTENT_E_FILE_COPY_OTHER': 'File copy from ({0}) to content file ({1}) failed at position {2} during the copy of the Macintosh Resource Fork data.',
    'DM_CONTENT_E_RESOURCE_OPEN': 'Error opening Macintosh Fork for file ({0}). Operating System error: ({1}).',
    'DM_CONTENT_E_RESOURCE_READ': 'Error reading content data from Macintosh Fork for file ({0}). Operating System error: ({1}).',
    'DM_CONTENT_E_MAC_GET_TC': 'Error reading Type/Creator information from a Macintosh file ({0}). Operating System error: ({1}).',
    'DM_CONTENT_E_MAC_SET_TC': 'Error setting Type/Creator information on a Macintosh file ({0}). Operating System error: ({1}).',
    'DM_CONTENT_E_INDEX_PARENT_NOT_A_PARENT': 'Content can\'t be indexed because specified index parent {0} not a parent',
    'DM_CONTENT_E_NEW_CONTENT': 'Can\'t perform getcontent on a new content object',
    'DM_CONTENT_E_TURBO_LOAD2': 'Load of document content not completed due to inconsistencies in content object info. Storage ID is zero indicating turbo storage but non-turbo object content present. DataTicket {0} OtherTicket {1} content pos {2}.',
    'DM_CONTENT_E_CANT_OPEN_SESSION': 'Could not establish session to content server for docbase {0}.',
    'DM_CONTENT_E_CANT_START_PULL': 'Could not begin content transfer for content object {0}.',
    'DM_CONTENT_E_CANT_START_PUSH': 'Could not begin content transfer for content object {0}.',
    'DM_CONTENT_E_NOT_ORPHAN': '{0} is not an orphan subcontent object. Parent is {1}',
    'DM_CONTENT_E_INVALID_SUBCONTENT': '{0} is not a valid subcontent object',
    'DM_CONTENT_E_REMOVE_LOCAL_REND': 'Failed to delete local rendition for {0} of page number {1} with format {2}. Error is: {3}',
    'DM_CONTENT_E_UNLINK_FROM_PARENT': 'Failed to remove rendition object {0} from its parent object {1}',
    'DM_CONTENT_E_XFER_NULL_HANDLE': 'Server content transfer method {0} was called by client with a null handle.',
    'DM_CONTENT_E_REPDT_FIX': 'Error in startup consistency check for replica data_tickets.  Query check: {0}.',
    'DM_CONTENT_E_NO_FORMAT': 'Content object ({0}) does not have a format associated with it.',
    'DM_CONTENT_E_NOT_SYS_ADMIN': 'User {0} does not have sufficient permission to run {1}. User must have at least system administrator permissions.',
    'DM_CONTENT_E_NO_DATABASE_CONNECTION': 'Mark all could not establish a database connection to perform necessary operations.',
    'DM_CONTENT_E_MISSING_PROPERTY': 'The property file ({0}) is missing some required property.',
    'DM_CONTENT_E_BAD_PAGE_NO': 'Page number {0} is invalid',
    'DM_CONTENT_E_CONTENT_TOO_LONG2': 'Content ({0} bytes) in turbo_store exceeds limit ({1} bytes) and cannot be opened',
    'DM_CONTENT_E_MIGRATE_CONTENT': '{0}',
    'DM_CONTENT_E_MIGRATE_CONTENT_INVALID_USER': 'User {0} does not have super user permission',
    'DM_CONTENT_E_MIGRATE_CONTENT_SAME_STORE': 'Incorrect argument: SOURCE_STORE {0} is same as TARGET_STORE {1}',
    'DM_CONTENT_E_MIGRATE_CONTENT_INVALID_CONTENT': '{0} is an invalid content object',
    'DM_CONTENT_E_MIGRATE_CONTENT_INVALID_CURRENT_STORE': 'Current storage for {0} is not a dm_filestore',
    'DM_CONTENT_E_MIGRATE_CONTENT_MIGRATION_FAILED': 'Migration of content {0} failed.',
    'DM_CONTENT_E_MIGRATE_CONTENT_ROLLBACK': 'Migration rolled back due to errors.',
    'DM_CONTENT_E_MIGRATE_CONTENT_INVALID_STORE': 'Storage object {0} is invalid for {1}',
    'DM_CONTENT_E_MIGRATE_CONTENT_CURRENT_STORE_IS_A_COMPONENT': 'Current store {0} of content {1} is a component of a distributed store',
    'DM_CONTENT_E_MIGRATE_CONTENT_SOURCE_STORE_NOT_READONLY': 'Source store object {0} is not READONLY',
    'DM_CONTENT_E_MIGRATE_CONTENT_INCOMPATIBLE_STORES_FOR_FULLTEXT_INDEX': 'Source store {0}as a dm_fulltext_index object. But the target store {1} does not.',
    'DM_CONTENT_E_MIGRATE_CONTENT_UNABLE_TO_UPDATE_PARENT': 'Unable to update the a_storage_type attribute of parent object {0} for content object {1} to {2}',
    'DM_CONTENT_E_MIGRATE_CONTENT_UNABLE_TO_SAVE_PARENT': 'Unable to save parent object {0} of content object {1}',
    'DM_CONTENT_E_MIGRATE_CONTENT_UNABLE_TO_SAVE_CONTENT_OBJECT': 'Unable to save content object {0} after migration.',
    'DM_CONTENT_E_MIGRATE_CONTENT_COMMIT_FAILED': 'A database error occured while committing transaction.',
    'DM_CONTENT_E_MIGRATE_CONTENT_NOT_A_FILESTORE': '{0} is not a dm_filestore object',
    'DM_CONTENT_E_MIGRATE_CONTENT_TARGET_STORE_NOT_ONLINE': 'Target store {0} is not ONLINE',
    'DM_CONTENT_E_MIGRATE_CONTENT_UNABLE_TO_FETCH_STORAGE_OBJECT': 'Unable to fetch storage object {0}',
    'DM_CONTENT_E_MIGRATE_CONTENT_STORAGE_IS_A_COMPONENT': 'Storage object {0} is a component of a distributed store. Migration disallowed.',
    'DM_CONTENT_E_MIGRATE_CONTENT_INVALID_TARGET_STORE': 'No or invalid target store specified.',
    'DM_CONTENT_E_MIGRATE_CONTENT_CANT_SPECIFY_SOURCE_STORE_AND_QUERY': 'Invalid arguments. Cannot specify both SOURCE_STORE and QUERY arguments.',
    'DM_CONTENT_E_MIGRATE_CONTENT_INSUFFICIENT_ARGUMENTS': 'Insufficient arguments specified for content migration.',
    'DM_CONTENT_E_MIGRATE_CONTENT_MISSING_LOG_FILE': 'If REMOVE_ORIGINAL argument is set to F (OR) SOURCE_STORE and TARGET_STORE specified (OR) QUERY is specified, you must specify LOG_FILE argument.',
    'DM_CONTENT_E_MIGRATE_CONTENT_DATABASE_ERROR': 'A database error occured during content migration: {0}',
    'DM_CONTENT_E_MIGRATE_CONTENT_UNABLE_TO_OPEN_LOGFILE': 'Unable to open log file {0}',
    'DM_CONTENT_E_MIGRATE_CONTENT_INVALID_CONTENT_FILE': 'The content file for dmr_content object {0} is invalid or not found or inaccessible.',
    'DM_CONTENT_E_MIGRATE_CONTENT_INCOMPATIBLE_STORES_FOR_FULLTEXT_INDEX2': 'Current store {0} of page {1} of parent object {2} of content object {3} is not compatible with the target store {4}. Content object for page 0 is {5}. Store {6} has a dm_fulltext_index object whereas {7} does not have one.',
    'DM_CONTENT_E_FILE_INFO_FAILURE': 'Error: failed to obtain file information for file ({0}). Operating System error: ({1}).',
    'DM_CONTENT_E_MIGRATE_CONTENT_CHECKEDOUT_OBJECTS_PRESENT': 'Parent(s) of content object(s) has been checked out, preventing storage migration. Run the following DQL query to find the checked out objects: {0}',
    'DM_CONTENT_E_CANNOT_INDEX_CA_STORE_WITH_NULL_IP': 'Content in the content addressable store {0} cannot be indexed, since it contains a NULL ip address.',
    'DM_CONTENT_E_HASH_UNSUPPORTED_ALGORITHM': 'The hashing algorithm \'{0}\' is not supported.',
    'DM_CONTENT_E_HASH_CANT_CREATE_DATA_SOURCE': 'Failed to read the data in content object \'{0}\'.',
    'DM_CONTENT_E_HASH_CANT_CREATE_CRYPTO_DIGEST': 'Failed to successfully initialize the cryptographic hashing function for algorithm \'{0}\'.',
    'DM_CONTENT_E_HASH_UPDATE_DIGEST_FAILED': 'Failed to hash a block of data. The cryptographic library error code is \'{0}\'.',
    'DM_CONTENT_E_HASH_FINALIZE_DIGEST_FAILED': 'Failed to complete a cryptographic hashing operation. The cryptographic library error code is \'{0}\'.',
    'DM_CONTENT_E_HASH_INVALID_DIGEST_LENGTH': 'Failed to create a hash string of the required length. Actual Length: {0}  Expected Length: {1}',
    'DM_CONTENT_E_CONTENT_SAVE_FAILURE': 'Save of content object {0} failed. Reason: {1}',
    'DM_CONTENT_E_MIGRATE_CONTENT_CANNOT_MIGRATE_RESOURCE_FORK_TO_CA_STORE': 'Cannot migrate content object {0} to Content Addressable store \'{1}\' since dm_ca_store does not support storing Mac Resource fork',
    'DM_CONTENT_E_MIGRATE_CONTENT_UNABLE_TO_GET_RETENTION_PERIOD': 'Unable to get retention period for content object \'{0}\' in storage \'{1}\'',
    'DM_CONTENT_E_MIGRATE_CONTENT_CANNOT_MIGRATE_CONTENT_WITH_UNEXPIRED_RETENTION': 'Cannot migrate content object \'{0}\' from \'{1}\' to \'{2}\' because of unexpired retention',
    'DM_CONTENT_E_MIGRATE_CONTENT_INVALID_CURRENT_STORE2': 'Current storage for {0} is not a dm_filestore or a dm_ca_store',
    'DM_CONTENT_E_MIGRATE_CONTENT_INVALID_TARGET_STORE2': 'The target store specified {0} is neither a dm_filestore nor a dm_ca_store',
    'DM_CONTENT_E_MIGRATE_CONTENT_INVALID_SYSOBJECT': 'The sysobject specified {0} is not a valid sysobject',
    'DM_CONTENT_E_MIGRATE_CONTENT_INSUFFICIENT_SYSOBJECT_PERMIT': 'User {0} does not have enough privileges to migrate the content of sysobject {1}',
    'DM_CONTENT_E_MIGRATE_CONTENT_UNABLE_TO_UPDATE_RETAIN_UNTIL_DATE': 'Error updating i_retain_until attribute of \'{0}\' while migrating content object \'{1}\', that represents page {2} of \'{3}',
    'DM_CONTENT_E_MIGRATE_CONTENT_CANT_MIGRATE_CASTORE_PLUGIN_OBJECTS_TO_CASTORE': 'The arguments specified for MIGRATE_CONTENT apply method is attempting to migrate a dm_plugin object used in a dm_ca_store object to a CA store. This is not allowed. To see which CA store plugin object is about to be migrated execute the following DQL statement as Administrator: {0}',
    'DM_CONTENT_E_UNABLE_TO_CREATE_INDEX_ON_CONTENT_HASH': 'Index creation on dmr_content.r_content_hash failed. See other error messages for the session',
    'DM_CONTENT_E_MIGRATE_CONTENT_INVALID_TARGET_STORE3': 'The target store specified {0} is not a supported target storage type',
    'DM_CONTENT_E_GDCM_NO_CONTENT_EXISTS': 'There is no content for sysobject {0}, page number {1}, page modifier {2}, and format {3}',
    'DM_CONTENT_E_GDCM_CONTENT_NOT_ACCESSIBLE': 'Content is available for this object but it is not accessible via HTTP',
    'DM_CONTENT_E_GDCM_NO_READ_ACCESS': 'Read Access is not permited to this user for sysobject {0}',
    'DM_CONTENT_E_GDCDS_NOT_VERIFIED': 'Cannot make Digital Signature, the hash key digest did not verify',
    'DM_CONTENT_E_GDCDS_NO_HASHKEY_GENERATED': 'Cannot generate the Crypto HashKey for Distributed Content. Distributed ACS Access will be disabled. Status = {0}',
    'DM_CONTENT_E_GDCDS_NO_ACS_CRYPTO_KEY': 'Cannot get the ACS Cryptographic key for Distributed Content. This is expected during docbase creation and the ACS Cryptographic system will be initialized by each session as needed. This error is unexpected once docbase creation is complete. Status = {0}',
    'DM_CONTENT_E_GDCDS_ACS_CRYPTO_KEY_NOT_VALID': 'The ACS Cryptographic key is not valid. Status = {0}',
    'DM_CONTENT_E_GDCM_MISSING_PARAMETERS': 'Required Parameters are missing from GET_DIST_CONTENT_MAP',
    'DM_CONTENT_E_GDCDS_MISSING_PARAMETERS': 'Required Parameters are missing from GET_DISTCONT_DIGSIG',
    'DM_CONTENT_E_NEXTBLOCK_READ': 'Error reading NextBlock data. Netwise error code = {0}.',
    'DM_CONTENT_E_WRITE_FAILURE_READBLOCK': 'Error writing data to content file ({0}) due to a ReadBlock error.',
    'DM_CONTENT_E_MIGRATE_CONTENT_UNABLE_TO_VERIFY_RETENTION_BY_RETAINERS': 'Unable to verify whether i_retain_until was set by retainers for content id ({0})',
    'DM_CONTENT_E_MIGRATE_CONTENT_DB_ERROR': 'A database error occured during migrate content, Operation is {0}, Query is {1}, Error from database is {2}',
    'DM_CONTENT_E_GDWM_NO_WRITE_LOCATIONS': 'No write locations found for storage {0}',
    'DM_CONTENT_E_GDWM_NO_WRITE_ACCESS': 'Write Access is not permited to user {0} for storage {1}',
    'DM_CONTENT_E_GDWM_MISSING_PARAMETERS': 'Required parameter(s) {0} missing or invalid from GET_DIST_WRITE_MAP',
    'DM_CONTENT_E_GDWM_FAILED': 'GET_DIST_WRITE_MAP failed to complete',
    'DM_CONTENT_E_ENCODED_CONTENT_ATTRS': 'Failed to process encoded content attributes {0}',
    'DM_CONTENT_E_UNABLE_TO_MIGRATE_DUE_TO_EBR': 'The content object id {0} with conditional retention cannot be migrated to another CA Store.',
    'DM_CONTENT_E_PUSH_CONTENT_DB_ERROR': 'A database error occured during push content, Operation is {0}, Query is {1}, Error from database is {2}',
    'DM_CONTENT_E_PUSH_CONTENT_RETENTION_TOO_LARGE': 'The retention interval {0} is to large.',
    'DM_CONTENT_E_UNABLE_TO_MIGRATE_TARGET_STORE_NOT_RETENTION_AWARE': ' The content object {0} cannot be migrated to the target_store',
    'DM_CONTENT_E_UPDATE_OTHER_FILE_SIZE_INVALID_CONTENT_ID': '{0} is not a valid content id.',
    'DM_CONTENT_E_UPDATE_OTHER_FILE_SIZE_WRONG_ARGUMENTS': 'Wrong arguments are specified for updating other file size. {0} is not allowed when {1} is specified.',
    'DM_CONTENT_E_UPDATE_OTHER_FILE_SIZE_INVALID_STORAGE_NAME': 'Storage name {0} is invalid.',
    'DM_CONTENT_E_UPDATE_OTHER_FILE_SIZE_FILE_ACCESS_ERROR': 'The other file {0} is unaccessible. The reason is: {1}.',
    'DM_CONTENT_E_CREATE_CM_WORKER_SESSION': 'Creating content migration worker session fails.',
    'DM_CONTENT_E_MIGRATE_CONTENT_MASTER_TIMEOUT': 'master session timeout, forcely terminate failed worker sessions',
    'DM_CONTENT_E_ACS_CONFIGURATION': 'ACS object named {0} contains an invalid id {1} on svr_config_id',
    'DM_CONTENT_E_REPLACE_FAILED_WORKER': 'A parallel content migration had to be restarted due to an internal error.  Some content may have failed to be migrated',
    'DM_CONTENT_E_NAME_CONFLICT': 'Name conflict with an existing migration job',
    'DM_CONTENT_E_JOBNAME_REQUIRED': 'you must specify the name of the job which you want to stop',
    'DM_CONTENT_E_JMS_CONFIGURATION': 'JMS object named {0} contains an invalid id {1} on svr_config_id',
    'DM_CONTENT_E_BATCH_RENDITION_MISSING_PROPERTY_TXT': 'property.txt not found in tar file for batch rendition',
    'DM_CONTENT_E_TARGET_STORE_TYPE_ERROR_FOR_EXTERNALSTORE_NONDIRECT': 'The target store must be a file store, a CA store, or a writable external store like an XML store when migrating from an external store using  a  plugin.',
    'DM_CONTENT_E_DIRECT_COPY_OR_MOVE_FOR_EXTERNALSTORE': 'DIRECT_COPY and DIRECT_MOVE are mutually exclusive when migrating from an external store.',
    'DM_CONTENT_E_UPDATE_ONLY_SHOULD_BE_WITH_DIRECT_COPY_OR_MOVE_AND_COMMAND_FILE_NAME': 'You specified the flag, UPDATE_ONLY when migrating from an external store. You should also specify one of the following flags, DIRECT_COPY or DIRECT_MOVE, and specify a command file name.',
    'DM_CONTENT_E_SOURCE_STORE_NEED_AUTHENTICATION': 'Authentication is required to access contents from the source store.',
    'DM_CONTENT_E_DIRECT_OPERATION_FAIL_DUE_TO_OS': 'An operating system error occurred during direct move or copy: {0}, error code: {1}.',
    'DM_CONTENT_E_DIRECT_MOVE_TO_FILESTORE_ONLY': 'The target store should be a dm_filestore when DIRECT_MOVE is specified.',
    'DM_CONTENT_E_CANNOT_UPDATE_CASTORE_BY_CMD': 'The target store cannot be a CA store when UPDATE_ONLY is specified.',
    'DM_CONTENT_E_INVALID_SOURCE_STORE_FOR_DIRECT_OPERATION': 'The source store should be either dm_extern_file or dm_extern_free when DIRECT_COPY or DIRECT_MOVE is sepcified.',
    'DM_CONTENT_E_INVALID_TARGET_STORE_FOR_DIRECT_OPERATION': 'The target store should be either dm_filestore or dm_ca_store when DIRECT_COPY or DIRECT_MOVE is specified.',
    'DM_CONTENT_E_INVALID_TARGET_STORE_CONFIGURATION_FOR_DIRECT_OPERATION': 'The target store cannot be configured for compression, encryption, or de-duplication when migrating contents and you have specified SOURCE_DIRECT_ACCESS_OK.',
    'DM_CONTENT_E_INVALID_ARGUMENTS': 'If you specify the argument COMMAND_FILE_NAME, you should also specify UPDATE_ONLY when migrating contents from an external store.',
    'DM_CONTENT_E_OUT_OF_MEMORY': 'Could not allocate space for object.',
    'DM_CONTENT_E_ATTR_TYPE_MISMATCH': 'For Object {0} Attribute {1}, expected type {2}, found type {3}.',
    'DM_CONTENT_E_CANT_ACCESS_DATA_TICKET': 'Cannot access data ticket {0}.',
    'DM_CONTENT_F_COMMIT_PROBLEM_MARK_ALL_FAILED': 'RDBMS transaction commit failed during MARK_ALL.',
    'DM_CONTENT_F_TRANS_CREATE_PROBLEM_MARK_ALL_FAILED': 'Can\'t start RDBMS transaction during MARK_ALL.',
    'DM_CONTENT_F_SAVE_PROBLEM_MARK_ALL_SKIPPING': 'Mark all can\'t save content object {0}.  Skipping.',
    'DM_CONTENT_F_SUBCONTENT_TYPE_CONVERSION': 'Failed to convert type dmi_subcontent to version {0}.',
    'DM_CONTENT_F_SUBCONTENT_INIT': 'Version stamp {0} was expected to be {1}.',
    'DM_CONTENT_F_MARK_ALL_DBERROR': 'Mark all failed with the database error: {0}',
    'DM_CRYPTO_F_KEYSTORE_LOCATION': 'Failed to find key store location. Internal error - {0}',
    'DM_CRYPTO_F_KEYSTORE_INIT': 'Failed to initialize keystore at {0}. Internal error - {1}',
    'DM_CRYPTO_W_SCAN_DIR_NO_MORE_FILES': 'No more files were found while  scanning directory - {0}',
    'DM_CRYPTO_W_DATA_ALREADY_ENCRYPTED': 'Encrypted data cannot be encrypted again.',
    'DM_CRYPTO_W_KEYSTORE_ALREADY_INITIALIZED': 'Key store has already been initialized. Key store location - {0}',
    'DM_CRYPTO_W_RKM_KEY_NOT_ACTIVATED': 'RKM key of class {0} is not an activated key.',
    'DM_CRYPTO_W_FILE_OPEN': 'Unable to open file {0} ',
    'DM_CRYPTO_E_KEYSTORE_ALREADY_INITIALIZED_WITH_DIFFERENT_LOCATION': 'Key store at location {0} has already been initialized.',
    'DM_CRYPTO_E_NULL_LOCATION': 'NULL AEK file name encountered ',
    'DM_CRYPTO_E_NO_MORE_MEMORY': 'Not enough memory to allocate object.',
    'DM_CRYPTO_E_TRUSTED_CONTENT_SERVICES_NOT_ENABLED': 'Trusted content services must be enabled to perform the operation.',
    'DM_CRYPTO_E_NULL_DATA': 'NULL data passed to a function performing cryptographic operation.',
    'DM_CRYPTO_E_SP_ENCRYPTED_DATA_INVALID': 'Invalid encrypted data.',
    'DM_CRYPTO_E_OLD_AND_NEW_PASSWORD_NULL': 'Both old and new password cannot be passed as NULL.',
    'DM_CRYPTO_E_INVALID_KEY_TYPE': 'An invalid key type was specified.',
    'DM_CRYPTO_E_INVALID_ARGUMENT': 'Invalid arguments. Check Usage',
    'DM_CRYPTO_E_DIRECTORY_READ_ERROR': 'Could not read directory - {0}',
    'DM_CRYPTO_E_DIRECTORY_REMOVAL_FAILED': 'Could not remove key store directory.',
    'DM_CRYPTO_E_DIRECTORY_CREATION_FAILED': 'Could not create key store directory.',
    'DM_CRYPTO_E_DIRECTORY_CHANGE_PERMISSION_FAILED': 'Failed to change key store directory permission to 0755.',
    'DM_CRYPTO_E_NULL_KEY_FILE_LOCATION': 'NULL key file location encountered.',
    'DM_CRYPTO_E_KEY_STORE_ALREADY_EXISTS': 'A key store already exists.',
    'DM_CRYPTO_E_PASSWORDS_DO_NOT_MATCH': 'Passwords do not match.',
    'DM_CRYPTO_E_BOOT_PROCESS_CREATION_FAILED': 'Could not create boot process.',
    'DM_CRYPTO_E_INVALID_FILE_NAME': 'A valid file name must be passed.',
    'DM_CRYPTO_E_FILE_OPEN_FOR_READ_FAILED': 'The file {0} could not opened for read.',
    'DM_CRYPTO_E_FILE_OPEN_FOR_WRITE_FAILED': 'The file {0} could not opened for write.',
    'DM_CRYPTO_E_FILE_RENAME_FAILED': 'The file {0} could not be renamed to {1}.',
    'DM_CRYPTO_E_NO_PASSWORD_PRESENT_IN_FILE_TO_ENCRYPT': 'A password was not found in file {0} to encrypt.',
    'DM_CRYPTO_E_ENCRYPTION_ALREADY_FINALIZED': 'Encryption has already been finalized.',
    'DM_CRYPTO_E_DECRYPTION_ALREADY_FINALIZED': 'Decryption has already been finalized.',
    'DM_CRYPTO_E_BUFFER_SIZE_EXCEEDS_MAX_SHM_SIZE': 'Buffer size exceeds maximum allowable shared memory segment size.',
    'DM_CRYPTO_E_SHM_ACCESS_DENIED': 'Access to a shared memory segment is denied.',
    'DM_CRYPTO_E_SHM_CREATE_FAILED': 'Creation of a shared memory segment failed.',
    'DM_CRYPTO_E_SHM_REMOVE_FAILED': 'Removal of a shared memory segment failed.',
    'DM_CRYPTO_E_SHM_WRITE_FAILED': 'Write to a shared memory segment failed.',
    'DM_CRYPTO_E_SHM_ATTACH_FAILED': 'Attaching to a shared memory segment failed.',
    'DM_CRYPTO_E_SHM_READ_FAILED': 'Read from a shared memory segment failed.',
    'DM_CRYPTO_E_SHM_DOES_NOT_EXIST': 'The shared memory segment keyed by a specific ID does not exists',
    'DM_CRYPTO_E_NULL_BUFFER_DURING_CONTENT_DECRYPTION': 'NULL buffer was encountered during content decryption.',
    'DM_CRYPTO_E_CONTENT_DECRYPTION_FAILED': 'Content decryption failed. Internal error - {0}',
    'DM_CRYPTO_E_CONTENT_ENCRYPTION_FAILED': 'Content encryption failed. Internal error - {0}',
    'DM_CRYPTO_E_NULL_BUFFER_RECEIVED_FROM_SOURCE': 'NULL buffer received from underlying source.',
    'DM_CRYPTO_E_NO_PASSWORD_ENTERED': 'No password was entered.',
    'DM_CRYPTO_E_STORAGE_AREA_CANNOT_BE_ENCRYPTED_STORAGE_TYPE': 'Only file stores can be encrypted.',
    'DM_CRYPTO_E_LOCATION_NOT_FOUND': 'Location not found to open/create key store. Make sure that you have passed in a valid location or the docbase name or specify environment variable DM_CRYPTO_HOME.',
    'DM_CRYPTO_E_DOCBASE_NAME_MISSING': 'Docbase name missing while trying to open/create a key store.',
    'DM_CRYPTO_E_DOCUMENTUM_ENV_MISSING': 'Environment variable DOCUMENTUM is not available.',
    'DM_CRYPTO_E_INVALID_PASSWORD_FOR_DECRYPTION': 'The password to be decrypted is invalid.',
    'DM_CRYPTO_E_INVALID_TEXT_FOR_DECRYPTION': 'The string to be decrypted is invalid.',
    'DM_CRYPTO_E_NULL_PASSWORD': 'A NULL password was passed to function expecting a valid one.',
    'DM_CRYPTO_E_NULL_TEXT': 'A NULL string was passed to function expecting a valid one.',
    'DM_CRYPTO_E_PASSWORD_DECRYPTION_FAILED': 'Decryption of password present in file {0} failed, status - {1}',
    'DM_CRYPTO_E_INVALID_FEDERATION_PASSWORD_FILE': 'An invalid federation.cnt file was found for docbase {0}',
    'DM_CRYPTO_E_MAKE_SOURCE_FAILED': 'A failure occurred while performing an operation on file \'{0}\' belonging to storage area \'{1}\'',
    'DM_CRYPTO_E_CANT_WRITE': 'Unable to write to file: ({0}).  Operating System Error: ({1})',
    'DM_CRYPTO_E_INVALID_HEX_NUMBER': 'An invalid hex number was passed to a function.',
    'DM_CRYPTO_E_DMCL_INIT_FAILED': 'Failed to initialize DMCL',
    'DM_CRYPTO_E_CONNECT_FAILED': 'Failed to connect to server',
    'DM_CRYPTO_E_NO_LOCAL_CONTENT_REPL_JOB': 'Failed to find local dm_ContentReplication job',
    'DM_CRYPTO_E_REMOTE_SERVERS_FAILED': 'Failed to retrieve list of remote servers',
    'DM_CRYPTO_E_NO_LOCAL_COMPONENT_STORE': 'No local component store for server',
    'DM_CRYPTO_E_INITCRYPTODB_FAILED': 'Failed to initialize crypto database',
    'DM_CRYPTO_E_CREATE_CONTENTREPL_FILE_FAILED': 'Failed to create content replication file',
    'DM_CRYPTO_E_ENCRYPTPASS_FAILED': 'Failed to encrypt password with error code {0}.',
    'DM_CRYPTO_E_ENCRYPTTEXT_FAILED': 'Failed to encrypt string with error code {0}.',
    'DM_CRYPTO_E_DECRYPTPASS_FAILED': 'Failed to decrypt password with error code {0}.',
    'DM_CRYPTO_E_DECRYPTTEXT_FAILED': 'Failed to decrypt string with error code {0}.',
    'DM_CRYPTO_E_KEYSTORE_NOT_INITIALIZED': 'A key store has not been initialized yet.',
    'DM_CRYPTO_E_UPDATE_CONTENT_REPL_JOB_FAILED': 'Failed to update local dm_ContentReplication job',
    'DM_CRYPTO_E_CIPHER_ALREADY_INITIALIZED': 'A cipher has already been initialized',
    'DM_CRYPTO_E_PARAMS_ALREADY_INITIALIZED': 'Crypto parameters have already been initialized',
    'DM_CRYPTO_E_NULL_PARAMS_OBJECT': 'During a parameter object initialization, a NULL parameter object was found',
    'DM_CRYPTO_E_PBE_STREAM_ALREADY_INITIALIZED': 'Password Based Encryption stream has already been initialized',
    'DM_CRYPTO_E_NULL_CIPHER_OBJECT': 'Null cipher object encountered while performing a cryptographic operation',
    'DM_CRYPTO_E_NULL_ALGORITHM_OBJECT': 'Null algorithm object encountered while performing a cryptographic operation',
    'DM_CRYPTO_E_NULL_OBJECT_TO_ENCRYPT_TEXT': 'NULL crypto objects were encountered while encrypting text',
    'DM_CRYPTO_E_INVALID_CIPHER_MODE': 'Invalid cipher object was encountered while performing a cryptographic operation',
    'DM_CRYPTO_E_NOT_INITIALIZED': 'A cryptographic object has not been initialized yet.',
    'DM_CRYPTO_E_ALREADY_INITIALIZED': 'A Crypto object has already been initialized',
    'DM_CRYPTO_E_DM_AEKSTORE_INSTANCE_EXISTS': 'The Documentum AEK store object already exists',
    'DM_CRYPTO_E_DM_SYSPASSSTORE_INSTANCE_EXISTS': 'The Documentum system password store object already exists',
    'DM_CRYPTO_E_INVALID_AEK_IN_AEKSTORE_DM': 'Invalid AEK present in the Documentum AEK store.',
    'DM_CRYPTO_E_INVALID_PASSPHRASE_IN_STORE': 'Invalid passphrase is present in the store.',
    'DM_CRYPTO_E_INVALID_KEY_FOR_SHM': 'Invalid key for shared memory segment',
    'DM_CRYPTO_E_INVALID_AEK_IN_AEKSTORE_SHM': 'Invalid AEK in the Documentum AEK shared memory segment.',
    'DM_CRYPTO_E_NULL_KEY_DATA': 'NULL key data found during key generation process',
    'DM_CRYPTO_E_NULL_PREFIX': 'NULL prefix passed.',
    'DM_CRYPTO_E_NULL_AEK': 'NULL AEK passed.',
    'DM_CRYPTO_E_NULL_DBK': 'NULL Docbase Key (DBK) passed.',
    'DM_CRYPTO_E_NULL_FSK': 'NULL Filestore KEY (FSK) passed.',
    'DM_CRYPTO_E_NULL_FEK': 'NULL File Encryption Key (FEK) passed.',
    'DM_CRYPTO_E_NULL_CODING_OBJECT': 'NULL encoding object found',
    'DM_CRYPTO_E_CORRUPT_AEK_OR_PASSPHRASE_MISMATCH': 'AEK could not be read from the file',
    'DM_CRYPTO_E_INVALID_OBJECT_FROM_SERIALIZED_DATA': 'The serialized data could not be converted into a valid object',
    'DM_CRYPTO_E_INVALID_KEY_FOR_STORE': 'Invalid cyrptographic key associated with the storage area',
    'DM_CRYPTO_E_ILL_FORMED': 'An object is not completely formed.',
    'DM_CRYPTO_E_STRING_NOT_ENCRYPTED_USING_THIS_METHOD': 'The string was not encrypted using the complementary method with which it is being decrypted',
    'DM_CRYPTO_E_PASSWORD_NOT_ENCRYPTED_USING_THIS_METHOD': 'The password was not encrypted using the complementary method with which it is being decrypted',
    'DM_CRYPTO_E_NULL_GLOBAL_CONTEXT_OBJECT': 'NULL global context object found.',
    'DM_CRYPTO_E_CANT_FETCH_CRYPTO_OBJECTS': 'The Filestore Key associated with the storage area {0} could not be retrieved. Internal error - {1}.',
    'DM_CRYPTO_E_CANT_CREATE_CRYPTO_OBJECTS': 'File store key creation for storage area {0} failed. Internal error - {1}.',
    'DM_CRYPTO_E_PASSPHRASE_DOES_NOT_MATCH': 'Entered passphrase does not match the one in the shared memory segment.',
    'DM_CRYPTO_E_CREATE_EVENT_FAILED': 'Creation of an event object on windows failed',
    'DM_CRYPTO_E_INVALID_DIGEST_LENGTH': 'Length of data to be digested is not valid.',
    'DM_CRYPTO_E_MISMATCHED_DIGEST_ALGORITHM': 'Digest algorithm does not match.',
    'DM_CRYPTO_E_DEFAULT_PASSPHRASE_CREATION_FAILED': 'Creation of default passphrase failed',
    'DM_CRYPTO_E_PASSWORD_LENGTH_IN_FILE_EXCEEDS_MAX_SIZE': 'Password length in file exceeds maximum allowed size of 128 bytes.',
    'DM_CRYPTO_E_MULTIPLE_LINES_IN_PASSWORD_FILE': 'The password in file cannot be encrypted. Only single line password files can be encrypted using this utility.',
    'DM_CRYPTO_E_INVALID_SIGNATURE_DATA': 'The signature data could not be converted into a valid object',
    'DM_CRYPTO_E_NULL_ORGANIZATION': 'A null pointer to an organization string was passed to a function performing cryptographic operation.',
    'DM_CRYPTO_E_NULL_ORGANIZATION_UNIT': 'A null pointer to an organization unit string was passed to a function performing cryptographic operation.',
    'DM_CRYPTO_E_START_VALIDITY_GREATER_THAN_END_VALIDITY': 'The start validity date is after the end validity date for a public key certificate.',
    'DM_CRYPTO_E_CERT_FIELDS_NOT_NULL_DURING_CERT_CREATION': 'The public key certificate fields were found to be non null when expected to be null.',
    'DM_CRYPTO_E_CERTIFICATE_OBJECT_NULL': 'A null pointer to a public key certificate object was found in a function performing cryptographic operation.',
    'DM_CRYPTO_E_KEY_PAIR_NOT_NULL_DURING_CERT_CREATION': 'A key pair was found to be non null when expected to be null.',
    'DM_CRYPTO_E_HASH_KEY_INVALID': 'A hash key was found to be null or invalid.',
    'DM_CRYPTO_E_INVALID_OPERATION': 'This is not a valid operation for this cipher type',
    'DM_CRYPTO_E_CERT_PRIVATE_KEY_COUNT_MISMATCH': 'The number of certificates and private keys do not match',
    'DM_CRYPTO_E_NULL_SERIAL_NUMBER': 'A null serial number was detected when creating a certificate',
    'DM_CRYPTO_E_NULL_CN': 'A null common name was detected when creating a certificate',
    'DM_CRYPTO_E_NULL_KEYSTORE_PASSWORD': 'A null keystore password was passed when creating a key store',
    'DM_CRYPTO_E_NULL_KEYSTORE_NAME': 'A null key store name was passed when creating a key store',
    'DM_CRYPTO_E_PASSWORD_MISMATCH': 'There was a mismatch with the current key store password',
    'DM_CRYPTO_E_TEMPORARY_FILE_DELETE_FAILED': 'A temporary file cound not be deleted',
    'DM_CRYPTO_E_LIST_COUNT_MISMATCH': 'The number of certificates in a list does not match the number of entries in the list',
    'DM_CRYPTO_E_INSERT_CERT_IN_LIST_FAILED': 'The number of certificates/keys in a list does not match the number inserted into a key store',
    'DM_CRYPTO_E_DELETE_CERT_IN_LIST_FAILED': 'The number of certificates/keys in a list does not match the number deleted from a key store',
    'DM_CRYPTO_E_DUPLICATE_CERTS': 'Multiple certificates present for same serial number.',
    'DM_CRYPTO_E_FETCH_CERT_FAILED': 'Error while fetching a certificate.',
    'DM_CRYPTO_E_NOT_ALL_OBJECTS_DELETED': 'Not all objects deleted based on input.',
    'DM_CRYPTO_E_OBJECT_NOT_FOUND': 'Expected cryptographic object not found in key store.',
    'DM_CRYPTO_E_NULL_KEY_LIST': 'A NULL key list was passed while deleting private keys from key store.',
    'DM_CRYPTO_E_NULL_CERT_FIELD': 'A NULL certificate fields object was detected',
    'DM_CRYPTO_E_INVALID_CERTIFICATE': 'An invalid certificate was detected',
    'DM_CRYPTO_E_INVALID_KEYPAIR': 'A NULL ',
    'DM_CRYPTO_E_INVALID_PRIVATE_KEY': 'An invalid private key of an asymmetric key pair was detected',
    'DM_CRYPTO_E_KEY_IDENTIFIER_MISMATCH': 'The key identifier associated with a cryptographic key is incorrect',
    'DM_CRYPTO_E_KEYSTORE_PUT_ERROR': 'An error was encountered when writing to the database used to store cryptographic keys',
    'DM_CRYPTO_E_NO_SYSTEM_CRYPTO_KEYS_FOLDER': 'The /System/Cryptographic/Keys folder does not exist',
    'DM_CRYPTO_E_INIT_CERT_OBJECT_FAILED': 'The RSA function C_InitializeCertC failed to initialize the certificate object.',
    'DM_CRYPTO_E_NOT_RKM_GENERATED_KEY': 'The key was not created in the RSA Key Manager.',
    'DM_CRYPTO_E_CANNOT_CREATE_RKM_CLIENT_CONTEXT': 'Unable to intialize the RKM client context from configuration files.',
    'DM_CRYPTO_E_RKM_ERROR': 'Unable to successfully complete call to RKM.',
    'DM_CRYPTO_E_CRYPTO_OBJECT_CREATION_FAILED': '{0} key creation failed. Internal error - {1}.',
    'DM_CRYPTO_E_RKM_REQUEST_FAILED': '{0} failed with error {1}',
    'DM_CRYPTO_E_RKM_ENCRYPTED_FILESTORE_KEY_ERROR': 'Attempt to create or retrieve a key for encrypting content failed',
    'DM_CRYPTO_E_RKM_CONTENT_DECRYPTION_KEY_ERROR': 'Attempt to retrieve a key for decrypting content failed',
    'DM_CRYPTO_E_RKM_INVALID_KEY_TYPE_ERROR': 'Invalid {0} key type, expecting {1} of size {2} {3}',
    'DM_CRYPTO_E_FILE_READ_FAILED': 'Unable to read from file: ({0})',
    'DM_CRYPTO_E_INVALID_LOCKBOX_FILE_EXTENSION': '{0} Invalid lockbox filename',
    'DM_CRYPTO_I_RKM_RETRYING_KEY_MANAGER_CONNECTION': 'The following error was encountered trying to verify availability of RKM:  {0} \nThe server will retry {1} more time(s) (every {2} seconds).',
    'DM_DATA_DICT_I_PUBLISH': 'The Data Dictionary is publishing information for \'{0}\', in locale \'{1}.',
    'DM_DATA_DICT_I_AGGR_DOMAIN_FIXUP': 'The Data Dictionary is fixing up the aggrdomain object with id \'{0}\'',
    'DM_DATA_DICT_I_CLEANUP_TRACE_GENERIC': 'Type: {0}. Message: {1}.',
    'DM_DATA_DICT_I_CLEANUP_TRACE_PROBLEM': 'Object {0} of type {1} refers to non-existent object {2} in field {3}. Reference will be removed.',
    'DM_DATA_DICT_W_EXPUNGE_KEY_CANT_FETCH': 'Could not fetch the dm_key object with ID {0} during an expunge operation.',
    'DM_DATA_DICT_W_EXPUNGE_UNIQUE_KEY_CANT_FETCH': 'Could not fetch the dm_key object with ID {0} during an expunge operation.',
    'DM_DATA_DICT_W_EXPUNGE_FOREIGN_KEY_CANT_FETCH': 'Could not fetch the dm_foreign_key object with ID {0} during an expunge operation.',
    'DM_DATA_DICT_W_EXPUNGE_AGGR_DOMAIN_CANT_FETCH': 'Could not fetch the dm_aggr_domain object with ID {0} during an expunge operation.',
    'DM_DATA_DICT_W_EXPUNGE_DD_INFO_CANT_FETCH': 'Could not fetch the dm_dd_info object with ID {0} during an expunge operation.',
    'DM_DATA_DICT_W_EXPUNGE_DOMAIN_CANT_FETCH': 'Could not fetch the dm_domain object with ID {0} during an expunge operation.',
    'DM_DATA_DICT_W_EXPUNGE_NLS_DD_INFO_CANT_FETCH': 'Could not fetch the dm_nls_dd_info object with ID {0} during an expunge operation.',
    'DM_DATA_DICT_W_EXPUNGE_VALUE_ASSIST_CANT_FETCH': 'Could not fetch the dm_value_assist object with ID {0} during an expunge operation.',
    'DM_DATA_DICT_W_EXPUNGE_VALUE_LIST_CANT_FETCH': 'Could not fetch the dm_value_list object with ID {0} during an expunge operation.',
    'DM_DATA_DICT_W_EXPUNGE_VALUE_QUERY_CANT_FETCH': 'Could not fetch the dm_value_query object with ID {0} during an expunge operation.',
    'DM_DATA_DICT_W_EXPUNGE_VALUE_FUNC_CANT_FETCH': 'Could not fetch the dm_value_func object with ID {0} during an expunge operation.',
    'DM_DATA_DICT_W_EXPUNGE_EXPR_CODE_CANT_FETCH': 'Could not fetch the dmi_expr_code object with ID {0} during an expunge operation.',
    'DM_DATA_DICT_W_REPLICA_REFERENCES_NONEXISTENT_ATTRIBUTE': 'The Replicated Data Dictionary information for \'{0}\' references a non-existent attribute \'{1}.',
    'DM_DATA_DICT_W_REPLICA_DEFAULT_VALUE_INCONSISTENCY': 'The Replicated Data Dictionary information for \'{0}\' has a default value with id \'{1}\' that references one or more invalid attributes.',
    'DM_DATA_DICT_W_REPLICA_VALUE_ASSISTANCE_INCONSISTENCY': 'The Replicated Data Dictionary information for \'{0}\' has a conditional value assistance with id \'{1}\' that references one or more invalid attributes.',
    'DM_DATA_DICT_W_REPLICA_COND_COMPUTED_EXPR_INCONSISTENCY': 'The Replicated Data Dictionary information for \'{0}\' has a conditional computed expression with id \'{1}\' that references one or more invalid attributes.',
    'DM_DATA_DICT_W_REPLICA_VAL_CONSTRAINT_INCONSISTENCY': 'The Replicated Data Dictionary information for \'{0}\' has a value constraint with id \'{1}\' that references one or more invalid attributes.',
    'DM_DATA_DICT_W_REPLICA_UNIQUE_KEY_INCONSISTENCY': 'The Replicated Data Dictionary information for \'{0}\' has a unique key constraint with id \'{1}\' that references one or more invalid attributes.',
    'DM_DATA_DICT_W_REPLICA_FOREIGN_KEY_INCONSISTENCY': 'The Replicated Data Dictionary information for \'{0}\' has a foreign key constraint with id \'{1}\' that references one or more invalid attributes.',
    'DM_DATA_DICT_W_REPLICA_PRIMARY_KEY_INCONSISTENCY': 'The Replicated Data Dictionary information for \'{0}\' has a primary key constraint with id \'{1}\' that references one or more invalid attributes.',
    'DM_DATA_DICT_W_REPLICA_DISPLAY_CONFIG_NONEXISTENT_ATTRIBUTE': 'The Replica dm_display_config object with ID \'{0}\', attribute_source \'{1}\', reference a non-existent attribute \'{2}\'.',
    'DM_DATA_DICT_W_EXPUNGE_CANT_FETCH': 'Could not fetch the \'{0}\' object with ID {1} during an expunge operation.',
    'DM_DATA_DICT_E_KEY_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_FOREIGN_KEY_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_UNIQUE_KEY_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_AGGR_DOMAIN_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_DD_INFO_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_DOMAIN_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_NLS_DD_INFO_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_VALUE_ASSIST_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_VALUE_LIST_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_VALUE_QUERY_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_VALUE_FUNC_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_OVERRIDE_UNKNOWN_ATTR': 'The attribute {0} does not exist in the Data Dictionary.',
    'DM_DATA_DICT_E_NAMED_DOMAIN_NOT_SUPPORTED': 'Named domain objects are not supported.  The name of the domain is {0}.',
    'DM_DATA_DICT_E_NAMED_SUPER_DOMAIN_NOT_SUPPORTED': 'Named super domain objects are not supported.  The name of the super domain is {0}.',
    'DM_DATA_DICT_E_AGGR_DOMAIN_BAD_ATTR_NAME': 'Attribute \'{0}\' does not exist for type \'{1}\'.',
    'DM_DATA_DICT_E_DD_HANDLE_WRONG_FIRST_CHAR': 'The Data Dictionary handle \'{0}\' is invalid because it does not begin with \'t\'.',
    'DM_DATA_DICT_E_DD_HANDLE_TYPE_NAME_MISSING': 'The type name portion of the Data Dictionary handle \'{0}\' is missing.',
    'DM_DATA_DICT_E_DD_HANDLE_TYPE_NAME_TOO_LONG': 'The type name portion of the Data Dictionary handle \'{0}\' is too long.',
    'DM_DATA_DICT_E_DD_HANDLE_POLICY_ID_MISSING': 'The policy id portion of the Data Dictionary handle \'{0}\' is missing.',
    'DM_DATA_DICT_E_DD_HANDLE_POLICY_ID_TOO_LONG': 'The policy id portion of the Data Dictionary handle \'{0}\' is too long.',
    'DM_DATA_DICT_E_DD_HANDLE_BAD_POLICY_ID': 'The policy id portion of the Data Dictionary handle \'{0}\' is not a valid object id.',
    'DM_DATA_DICT_E_DD_HANDLE_TYPE_NOT_FOUND': 'The type \'{0}\' named in the Data Dictionary handle \'{1}\' does not exist.',
    'DM_DATA_DICT_E_DD_HANDLE_POLICY_NOT_FOUND': 'The policy with object id \'{0}\' named in the Data Dictionary handle \'{1}\' does not exist.',
    'DM_DATA_DICT_E_DD_HANDLE_STATE_NAME_MISSING': 'The business policy state name portion of the Data Dictionary handle \'{0}\' is missing.',
    'DM_DATA_DICT_E_DD_HANDLE_STATE_NAME_TOO_LONG': 'The business policy state name portion of the Data Dictionary handle \'{0}\' is too long.',
    'DM_DATA_DICT_E_DD_HANDLE_ATTR_NAME_MISSING': 'The attribute name portion of the Data Dictionary handle \'{0}\' is missing.',
    'DM_DATA_DICT_E_DD_HANDLE_ATTR_NAME_TOO_LONG': 'The attribute name portion of the Data Dictionary handle \'{0}\' is too long.',
    'DM_DATA_DICT_E_DD_HANDLE_ATTR_NOT_FOUND': 'The attribute \'{0}\' named in the Data Dictionary handle \'{1}\' does not exist in type \'{2}\'.',
    'DM_DATA_DICT_E_DD_HANDLE_EXTRA_CHARACTERS': 'The Data Dictionary handle \'{0}\' contains extra characters at the end.',
    'DM_DATA_DICT_E_BAD_REPEATING_PSEUDO_BOOLEAN_VALUE': 'The value of attribute {0}[{1}] should be in the range {2} to {3}, but was {4}.',
    'DM_DATA_DICT_E_BAD_PSEUDO_BOOLEAN_VALUE': 'The value of attribute {0} should be in the range {1} to {2}, but was {3}.',
    'DM_DATA_DICT_E_BAD_REPEATING_LIFECYCLE_VALUE': 'The value of attribute {0}[{1}] should be in the range {2} to {3}, but was {4}.',
    'DM_DATA_DICT_E_BAD_LIFECYCLE_VALUE': 'The value of attribute {0} should be in the range {1} to {2}, but was {3}.',
    'DM_DATA_DICT_E_BAD_REPEATING_ENFORCEMENT_VALUE': 'The value of attribute {0}[{1}] should be in the range {2} to {3}, but was {4}.',
    'DM_DATA_DICT_E_BAD_ENFORCEMENT_VALUE': 'The value of attribute {0} should be in the range {1} to {2}, but was {3}.',
    'DM_DATA_DICT_E_BAD_REPEATING_CONSTRAINT_CHECKER_VALUE': 'The value of attribute {0}[{1}] should be in the range {2} to {3}, but was {4}.',
    'DM_DATA_DICT_E_BAD_CONSTRAINT_CHECKER_VALUE': 'The value of attribute {0} should be in the range {1} to {2}, but was {3}.',
    'DM_DATA_DICT_E_BAD_SEARCH_OP_VALUE': 'The value of attribute {0} should be in the range {1} to {2}, but was {3}.',
    'DM_DATA_DICT_E_DUPLICATE_SEARCH_OP_VALUE': 'The search operator attribute {0} contains the value {1} at position {2} and at position {3}.',
    'DM_DATA_DICT_E_BAD_DEFAULT_SEARCH_OP': 'The default search operator attribute {0} contains the value {1} which is not in the list of allowed search operators ({2}).',
    'DM_DATA_DICT_E_NULL_REPEATING_EXPRESSION_VALUE': 'The value of expression attribute {0}[{1}] is the NULL object id.',
    'DM_DATA_DICT_E_CANNOT_FETCH_EXPRESSION_OBJECT_FOR_ATTRIBUTE': 'Cannot fetch the expression with object id {0} for attribute {1}.',
    'DM_DATA_DICT_E_ERROR_GENERATING_EXPRESSION_SOURCE': 'An error was encountered generating the source code for expression object {0} for Data Dictionary attribute {1}.',
    'DM_DATA_DICT_E_MISSING_FORMAT_TAG': 'A format pattern ({0}) was supplied without a format tag.',
    'DM_DATA_DICT_E_MISSING_FORMAT_PATTERN': 'A format tag ({0}) was supplied without a format pattern.',
    'DM_DATA_DICT_E_BAD_DEF_VALUE_LENGTH': 'The value of the def_value_length attribute ({0}) must be >= 0.',
    'DM_DATA_DICT_E_DUPLICATE_VALUE_LIST_ENTRY': 'The list value assistance contains the value \'{0}\' at position {1} and at position {2}.',
    'DM_DATA_DICT_E_NAMED_VALUE_ASSISTANCE_NOT_SUPPORTED': 'A value assistance object with an object name of {0} was found.  Named value assistance objects are not supported.',
    'DM_DATA_DICT_E_CANNOT_FETCH_OBJECT_FOR_DEFAULT_ID': 'Cannot fetch the object with object id {0} for the default_id attribute.',
    'DM_DATA_DICT_E_BAD_ATTR_FOR_TYPE': 'The attribute \'{0}\' can only be supplied for an attribute, not for a type.',
    'DM_DATA_DICT_E_BAD_ATTR_FOR_ATTRIBUTE': 'The attribute \'{0}\' can only be supplied for a type, not for an attribute of a type.',
    'DM_DATA_DICT_E_EXPR_CODE_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_EXPR_CODE_TEMP_FILE_WRITE_ERROR': 'The following error occurred while writing to a temporary file for expression code:  {0}.',
    'DM_DATA_DICT_E_CANT_CREATE_EXPR_CODE_TEMP_FILE': 'The following error occurred trying to create a temporary file for expression code:  {0}.',
    'DM_DATA_DICT_E_CANT_DESTROY_EXPR_CODE_TEMP_FILE': 'The following error occurred trying to destroy a temporary file for expression code:  {0}.',
    'DM_DATA_DICT_E_SET_UPDATE_FAILED': 'Could not SET attribute {0} at position {1}.',
    'DM_DATA_DICT_E_APPEND_UPDATE_FAILED': 'Could not APPEND to attribute {0}.',
    'DM_DATA_DICT_E_INSERT_UPDATE_FAILED': 'Could not INSERT into attribute {0} at position {1}.',
    'DM_DATA_DICT_E_REMOVE_UPDATE_FAILED': 'Could not REMOVE from attribute {0} at position {1}.',
    'DM_DATA_DICT_E_TRUNCATE_UPDATE_FAILED': 'Could not TRUNCATE attribute {0} at position {1}.',
    'DM_DATA_DICT_E_BAD_INTEGER_VALUE': 'The value \'{0}\' is not a valid INTEGER value.',
    'DM_DATA_DICT_E_BAD_BOOLEAN_VALUE': 'The value \'{0}\' is not a valid BOOLEAN value (must be TRUE (1) or FALSE (0)).',
    'DM_DATA_DICT_E_BAD_ID_VALUE': 'The value \'{0}\' is not a valid ID value.',
    'DM_DATA_DICT_E_BAD_DOUBLE_VALUE': 'The value \'{0}\' is not a valid DOUBLE value.',
    'DM_DATA_DICT_E_BAD_DATE_VALUE': 'The value \'{0}\' is not a valid DATE/TIME value using the format {1}.',
    'DM_DATA_DICT_E_BAD_POLICY_ID_TAG': 'The object id specifed for the default business policy \'{0}\' is not the id of a dm_policy object.',
    'DM_DATA_DICT_E_DEFAULT_SEARCH_OP_NULL': 'The default search op attribute {0} cannot be NULL if the allowed_search_ops attribute {1} is set.',
    'DM_DATA_DICT_E_CANNOT_FETCH_POLICY': 'The business policy specified with object id \'{0}\' does not exist.',
    'DM_DATA_DICT_E_BAD_POLICY_LABEL': 'The business policy specified with object id \'{0}\' does not have a version with the label \'{1}\'.',
    'DM_DATA_DICT_E_DUPLICATE_COMPONENT_CLASSIFIER': 'The component classifier \'{0}\' is duplicated at position {1} and position {2}.',
    'DM_DATA_DICT_E_CANNOT_MODIFY_THIS_ATTR': 'The attribute \'{0}\' cannot be modified.',
    'DM_DATA_DICT_E_DUPLICATE_MAP_DATA_STRING': 'The mapping table data string \'{0}\' is duplicated at position {1} and position {2}.',
    'DM_DATA_DICT_E_UPDATE_TYPE_MISMATCH': 'An attempt was made to update attribute \'{0}\' (of type {1}) with a value of type {2}.',
    'DM_DATA_DICT_E_UPDATE_STRING_NULL': 'An attempt was made to update the STRING attribute \'{0}\' with the value \'{1}\' (currently used as a NULL marker) which will cause the parent\'s value to be inherited.  If this is desired use the keyword NULL.',
    'DM_DATA_DICT_E_UPDATE_INTEGER_NULL': 'An attempt was made to update the INTEGER attribute \'{0}\' with the value {1} (currently used as a NULL marker) which will cause the parent\'s value to be inherited.  If this is desired use the keyword NULL.',
    'DM_DATA_DICT_E_UPDATE_BOOLEAN_NULL': 'An attempt was made to update the BOOLEAN attribute \'{0}\' with the value {1} (currently used as a NULL marker) which will cause the parent\'s value to be inherited.  If this is desired use the keyword NULL.',
    'DM_DATA_DICT_E_UPDATE_ID_NULL': 'An attempt was made to update the ID attribute \'{0}\' with the value \'{1}\' (currently used as a NULL marker) which will cause the parent\'s value to be inherited.  If this is desired use the keyword NULL.',
    'DM_DATA_DICT_E_BAD_VALUE_ESTIMATE': 'Value estimate ({0}) for value assistance cannot be negative.',
    'DM_DATA_DICT_E_TYPE_MISSING': 'The type {0} referred by the aggregate domain was not found.',
    'DM_DATA_DICT_E_BAD_TYPE_FOR_KEY': 'The type_name ({0}) specified for key {1} is not a valid type name.',
    'DM_DATA_DICT_E_NO_ATTRS_FOR_KEY': 'The key ({0}) for type {1} has no attributes.',
    'DM_DATA_DICT_E_DUP_ATTR_FOR_KEY': 'The key ({0}) for type {1} duplicates the attribute {2}.',
    'DM_DATA_DICT_E_BAD_ATTR_FOR_KEY': 'The key ({0}) for type {1} references a non-existent attribute {2}.',
    'DM_DATA_DICT_E_MIXED_ATTR_LEVELS_FOR_KEY': 'The key ({0}) for type {1} references some attributes defined in type {2} and some attributes defined in type {3}.',
    'DM_DATA_DICT_E_FKEY_ATTR_LISTS_DIFFERENT_LENGTHS': 'In the foreign key ({0}) for type {1} the child attribute list contains {2} attributes, but the parent type {3} attribute list contains {4} attributes.',
    'DM_DATA_DICT_E_FKEY_ATTR_TYPE_MISMATCH': 'In the foreign key ({0}) for type {1} the child attribute {2} is of type {3}, but the parent type {4} attribute {5} is of type {6}.',
    'DM_DATA_DICT_E_DD_HANDLE_POLICY_STATE_NOT_FOUND': 'The policy with object id \'{0}\' named in the Data Dictionary handle \'{1}\' does not have a state named \'{2}\'.',
    'DM_DATA_DICT_E_COMMIT_EXTERNAL_TRANSACTION': 'Committing the Data Dictionary changes for type {0} would commit an explicit open transaction.',
    'DM_DATA_DICT_E_CODE_GENERATION_FAILURE': 'Could not generate source or code for the dm_aggr_domain with object id \'{0}\'.',
    'DM_DATA_DICT_E_BAD_ATTR_NAME_IN_MESSAGE': 'A parameterized error message referenced the value of an attribute $value({0}) that does not exist in type {1}.',
    'DM_DATA_DICT_E_PARAM_NOT_TERMINATED': 'A substitution parameter was not terminated correctly with {0} in error message:  {1}.',
    'DM_DATA_DICT_E_BAD_ESCAPE_CHARACTER_IN_MESSAGE': 'The substitution parameter escape character ({0}) was not used correctly in error message:  {1}.',
    'DM_DATA_DICT_E_BAD_STRING_VALUE': 'The value \'{0}\' is not a valid STRING value.',
    'DM_DATA_DICT_E_DEPENDENCY_ATTR_NOT_FOUND': 'Attribute {0} was specified in a DEPENDENCY LIST clause for type {1} but does not exist in the type.',
    'DM_DATA_DICT_E_DUPLICATE_DEPENDENCY_ATTR': 'Attribute {0} was specified more than once in a DEPENDENCY LIST clause for type {1}.',
    'DM_DATA_DICT_E_ATTR_NAME_TOO_LONG': 'Attribute name {0} is too long.  Maximum length is {1}.',
    'DM_DATA_DICT_E_INVALID_ATTR_FOR_ATTR_CONSTRAINT_EXPRESSION': 'A constraint expression for attribute {0} references another attribute ({1}).  Only type level constraints can reference multiple attributes.',
    'DM_DATA_DICT_E_TYPE_CANNOT_HAVE_DEFAULT_VALUE': 'You cannot specify a DEFAULT value for any attribute of the system type {0}.',
    'DM_DATA_DICT_E_TYPE_CANNOT_HAVE_EXPRESSION': 'You cannot specify an expression for the system type {0}.',
    'DM_DATA_DICT_E_DEFAULT_FOR_SYSTEM_INTERNAL_ATTRIBUTE': 'You cannot specify a DEFAULT value for attribute {0} in type {1} because it is a system internal attribute.',
    'DM_DATA_DICT_E_DEFAULT_FOR_SYSTEM_READ_ONLY_ATTRIBUTE': 'You cannot specify a DEFAULT value for attribute {0} in type {1} because it is a system read only attribute.',
    'DM_DATA_DICT_E_DEFAULT_FOR_BUSINESS_POLICY_STATE': 'You cannot specify a DEFAULT value for attribute {0} in type {1} that is specific to a particular Business Policy state.',
    'DM_DATA_DICT_E_EXPRESSION_IS_WRONG_TYPE': 'Expression or literal is wrong type.  Expected {0}, found {1}.',
    'DM_DATA_DICT_E_CANNOT_SET_IGNORE_IMMUTABLE_FALSE': 'You cannot set ignore_immutable to FALSE for {0} attribute {1}.  It is required by the system to be TRUE.',
    'DM_DATA_DICT_E_SINGLE_AND_REPEATING_IN_KEY': 'The key with object id {0} for type {1} contains at least one single-valued attribute ({2}) and at least one repeating attribute ({3}).',
    'DM_DATA_DICT_E_ILLEGAL_REPEATING_IN_KEY': 'The key with object id {0} for type {1} contains at least one repeating attribute ({2}).  Neither a primary key, nor the parent key in a foreign key can contain repeating attributes.',
    'DM_DATA_DICT_E_DUPLICATE_PRIMARY_KEY': 'Type {0} has more than one primary key.',
    'DM_DATA_DICT_E_DUPLICATE_UNIQUE_KEY': 'Type {0} has multiple unique keys consisting of just the attribute {1}.  One at the type level, and one at the attribute level.',
    'DM_DATA_DICT_E_DUPLICATE_FOREIGN_KEY': 'Type {0} has multiple foreign keys based on just the attribute {1}.  One at the type level, and one at the attribute level.',
    'DM_DATA_DICT_E_ALLOWED_SEARCH_OPS_NULL': 'The allowed search operators attribute {0} cannot be NULL if the default search op attribute {1} is set.',
    'DM_DATA_DICT_E_CURSOR_ERROR': 'A database error has occurred during the creation of a cursor (\'{0}\').',
    'DM_DATA_DICT_E_INVALID_TYPE_NAME': 'An invalid type_name {0} was specified.',
    'DM_DATA_DICT_E_INVALID_DD_BUILTIN_VALUE_SPECIFICATION': 'An invalid builtin function {0} was specified for attribute {1}.',
    'DM_DATA_DICT_E_INVALID_ATTRIBUTE_NAME': 'An invalid attribute {0} for type_name {1} was specified.',
    'DM_DATA_DICT_E_POLICY_STATE_NOT_FOUND': 'The policy with object id \'{0}\' does not have a state named \'{1}\'.',
    'DM_DATA_DICT_E_DD_HANDLE_TYPE_NOT_VALID_FOR_POLICY': 'The type \'{0}\' named in the Data Dictionary handle \'{1}\' is not a valid type for the policy with object id \'{2}\'.',
    'DM_DATA_DICT_E_TYPE_NOT_VALID_FOR_POLICY': 'The type \'{0}\' is not a valid type for the policy with object id \'{1}\'.',
    'DM_DATA_DICT_E_DD_COMMON_INFO_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_DD_ATTR_INFO_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_DD_TYPE_INFO_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_DATA_DICT_E_QUERY_EXECUTION_FAILURE': 'The Data Dictionary encountered an error while trying to execute the following query: {0}. Database error was {1}.',
    'DM_DATA_DICT_E_FIND_DATA_DICTIONARY_OBJECT_IN_DB': 'While trying to retrieve data dictionary information about {0} with locale {1}, the following database cursor error was returned: {2}',
    'DM_DATA_DICT_E_COULD_NOT_DROP_PUBLISHED_DATA_DICTIONARY_INFO': 'Unable to remove Data dictionary information about {0} with locale {1}.',
    'DM_DATA_DICT_E_COULD_NOT_PUBLISH_DATA_DICTIONARY_INFORMATION': 'The Data Dictionary was unable to publish information for {0}, locale {1}, an error occured.',
    'DM_DATA_DICT_E_DATA_DICTIONARY_OBJECT_ERROR': 'The data dictionary information for the type {0}, locale {1} and r_object_id ({2}) was not retrieved correctly.',
    'DM_DATA_DICT_E_NO_DB_CONNECTION': 'There was no database connection passed {0}',
    'DM_DATA_DICT_E_COULD_NOT_SAVE_DATA_DICTIONARY_CHANGES': 'The server could not save changes to the database tables in a transaction. The data dictionary information being changed was for {0}, locale {1}',
    'DM_DATA_DICT_E_COULD_NOT_LOG_DATA_DICTIONARY_CHANGES': 'An error was encountered while trying to log changes to data dictionary information for {0}, locale {1}.',
    'DM_DATA_DICT_E_COMPUTING_DEPENDENCIES_IN_DATA_DICTIONARY_LOG': 'An error occured while adding entries to the data dictionary log table named dd_publish_log. Information was being added relating to {0} with locale {1}',
    'DM_DATA_DICT_E_COULD_NOT_EXPUNGE_PUBLISHED_DATA_DICTIONARY_OBJECT': 'An error occured while attemping to remove an object of type dmi_dd_type_info or dmi_dd_attr_info from the docbase. The object referred to {0} with locale {1}. The r_object_id was {2}',
    'DM_DATA_DICT_E_UNABLE_TO_REMOVE_DATA_DICTIONARY_LOG_ENTRY': 'An error occured while removing log entry about {0} and locale: {1} from the data dictionary log (dd_publish_log)',
    'DM_DATA_DICT_E_PUBLISHING_FROM_DD_PUBLISH_LOG': 'An error occured while trying to update Data Dictionary information from the dd_publish_log',
    'DM_DATA_DICT_E_MARK_PUBLISH_IN_PROGRESS': 'The server was trying to update the publish_in_progress flag for an entry of {0} with locale {1} in the dd_publish_log and failed.',
    'DM_DATA_DICT_E_UNABLE_TO_PUBLISH_INFO': 'An error occured while trying to publish data dictionary information for handle {0}, locale {1}',
    'DM_DATA_DICT_E_REMOVING_DATA_DICTIONARY_OBJECTS_FOR_TYPE': 'An error occured while trying to remove published data dictionary information for type {0}, locale {1}',
    'DM_DATA_DICT_E_RESYNC_NEEDED': 'The server is dealing with an out of sync data dictionary object.',
    'DM_DATA_DICT_E_REMOVING_DATA_DICTIONARY_OBJECTS_FOR_ATTRIBUTE': 'An error occured while trying to remove published data dictionary information for type {0}, attribute {1}, and locale {2}',
    'DM_DATA_DICT_E_UNABLE_TO_ADD_EXTENDED_ATTRIBUTES_TO_DMI_DD_TYPE_INFO': 'The Data Dictionary was unable to add extended attributes to the dmi_dd_type_info object with handle {0}',
    'DM_DATA_DICT_E_DOMAIN_UNABLE_TO_NAME_DEFAULT_LOCALE': 'The Data Dictionary encountered an error while trying to name the default locale (nls_key) in the dm_domain objects. The error from the database is \'{0}\'',
    'DM_DATA_DICT_E_STATE_NAME_TOO_LONG': 'Business Policy state_name {0} is too long.  Maximum length is {1}.',
    'DM_DATA_DICT_E_POLICY_STATE_FOR_OVERRIDE_NOT_FOUND': 'The business policy state was not found for the data dictionary override was not found. The dm_aggr_domain id is {0} and the dm_policy id is {1}.',
    'DM_DATA_DICT_E_INSUFFICIENT_PRIVILEGES': 'The docbase user {0} has insufficient privileges for the desired operation. The user must be a super user.',
    'DM_DATA_DICT_E_NOT_A_VALID_DATA_DICTIONARY_LOCALE': 'The locale {0} is not a valid Data Dictionary Locale.',
    'DM_DATA_DICT_E_MAX_RETRY_COUNT_EXCEEDED': 'The Data Dictionary operation has exceeded the max retry count of {0}. The operation has aborted due to too many errors.',
    'DM_DATA_DICT_E_UPDATE_STATEMENT': 'The Data Dictionary encountered an error while trying to execute the following query: {0}. Database error was {1}.',
    'DM_DATA_DICT_E_REPLICA_VALIDATION_FAILURE': 'The Data Dictionary encountered an error during the validation of Data Dictionary replica objects',
    'DM_DATA_DICT_E_REPLICA_LOAD_FAILURE': 'The Data Dictionary encountered an error during the load of Data Dictionary replica objects',
    'DM_DATA_DICT_E_REPLICA_VALIDATION_FAILED': 'The replica \'{0}\' object with ID \'{1}\' could not be validated against one or more types in the target docbase.',
    'DM_DATA_DICT_E_DUPLICATE_CATEGORY_LIST_ENTRY': 'The category_list entry \'{0}\' is duplicated at position {1} and position {2}.',
    'DM_DATA_DICT_E_SCOPE_CONFIG_CANT_FETCH': 'Cannot fetch - Invalid object ID \'{0}\'.',
    'DM_DATA_DICT_E_DISPLAY_CONFIG_CANT_FETCH': 'Cannot fetch - Invalid object ID \'{0}\'.',
    'DM_DATA_DICT_E_SCOPE_CONFIG_NOT_VALID_FOR_TYPE': 'The dm_scope_config object with ID \'{0}\' is not valid for type \'{1}\'. See additional messages for more detail.',
    'DM_DATA_DICT_E_DISPLAY_CONFIG_NOT_VALID_FOR_TYPE': 'The dm_display_config object with ID \'{0}\' is not valid for type \'{1}\' The dm_display_config object can only be associated with \'{2}\' type or one of its subtypes.',
    'DM_DATA_DICT_E_INVALID_SCOPE_CONFIG': 'The dm_scope_config object with ID \'{0}\' is invalid. See additional error messages for details.',
    'DM_DATA_DICT_E_DISPLAY_CONFIG_INVALID_ATTRIBUTE_NAME': 'The dm_display_config object with ID \'{0}\' has an \'attribute_name\' entry \'{1}\' that does not exist in the \'attribute_source\' type \'{2}\'',
    'DM_DATA_DICT_E_MISMATCHED_ATTRIBUTE_VALUES': 'The \'{0}\' object with ID \'{1}\' has mismatched attribute value counts for related attributes \'{2}\' and \'{3}\'.',
    'DM_DATA_DICT_E_DUPLICATE_VALUE': 'The \'{0}\' object with ID \'{1}\' has a duplicate values for attribute \'{2}\' of \'{3}\' at positions {4} and {5}.',
    'DM_DATA_DICT_E_TYPE_NOT_FOUND': 'The type \'{0}\' referenced in object with ID \'{1}\', attribute \'{2}\' was not found.',
    'DM_DATA_DICT_E_REQUIRED_ATTRIBUTE': 'The \'{0}\' object with ID \'{1}\' must have an value for attribute \'{2}\'.',
    'DM_DATA_DICT_E_SYNCHRONIZE_WITH_TYPE_FAILED': 'The server was unable to synchronize the \'{0}\' object with ID \'{1}\' with the type \'{2}\'.',
    'DM_DATA_DICT_E_CANNOT_EXPUNGE_REFERENCED_OBJECT': 'The \'{0}\' object with ID \'{1}\' cannot be expunged because it is referenced by object with ID \'{2}\'.',
    'DM_DATA_DICT_E_CLEANUP_ERROR': 'An error occurred while running the data dictionary cleanup method. Operation: {0}. Details: {1}.',
    'DM_DATA_DICT_E_CLEANUP_OBJECT_ERROR': 'An error occurred while running the data dictionary cleanup method. Operation: {0}. Object ID: {1}. Details: {2}.',
    'DM_DATA_DICT_F_KEY_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_KEY_BAD_VSTAMP': 'Type dm_key has a bad vstamp {0}. The current vstamp for dm_key is supposed to be {1}.',
    'DM_DATA_DICT_F_FOREIGN_KEY_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_FOREIGN_KEY_BAD_VSTAMP': 'Type dm_foreign_key has a bad vstamp {0}. The current vstamp for dm_foreign_key is supposed to be {1}.',
    'DM_DATA_DICT_F_UNIQUE_KEY_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_UNIQUE_KEY_BAD_VSTAMP': 'Type dm_unique_key has a bad vstamp {0}. The current vstamp for dm_unique_key is supposed to be {1}.',
    'DM_DATA_DICT_F_AGGR_DOMAIN_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_AGGR_DOMAIN_BAD_VSTAMP': 'Type dm_aggr_domain has a bad vstamp {0}. The current vstamp for dm_aggr_domain is supposed to be {1}.',
    'DM_DATA_DICT_F_DD_INFO_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_DD_INFO_BAD_VSTAMP': 'Type dm_dd_info has a bad vstamp {0}. The current vstamp for dm_dd_info is supposed to be {1}.',
    'DM_DATA_DICT_F_DOMAIN_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_DOMAIN_BAD_VSTAMP': 'Type dm_domain has a bad vstamp {0}. The current vstamp for dm_domain is supposed to be {1}.',
    'DM_DATA_DICT_F_NLS_DD_INFO_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_NLS_DD_INFO_BAD_VSTAMP': 'Type dm_nls_dd_info has a bad vstamp {0}. The current vstamp for dm_nls_dd_info is supposed to be {1}.',
    'DM_DATA_DICT_F_VALUE_ASSIST_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_VALUE_ASSIST_BAD_VSTAMP': 'Type dm_value_assist has a bad vstamp {0}. The current vstamp for dm_value_assist is supposed to be {1}.',
    'DM_DATA_DICT_F_VALUE_LIST_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_VALUE_LIST_BAD_VSTAMP': 'Type dm_value_list has a bad vstamp {0}. The current vstamp for dm_value_list is supposed to be {1}.',
    'DM_DATA_DICT_F_VALUE_QUERY_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_VALUE_QUERY_BAD_VSTAMP': 'Type dm_value_query has a bad vstamp {0}. The current vstamp for dm_value_query is supposed to be {1}.',
    'DM_DATA_DICT_F_VALUE_FUNC_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_VALUE_FUNC_BAD_VSTAMP': 'Type dm_value_func has a bad vstamp {0}. The current vstamp for dm_value_func is supposed to be {1}.',
    'DM_DATA_DICT_F_CANNOT_GET_GLOBAL_CONTEXT': 'Could not get Global Context Object.',
    'DM_DATA_DICT_F_CANNOT_GET_DOCBASE_DATA': 'Could not get Docbase Data Object.',
    'DM_DATA_DICT_F_CANNOT_GET_OBJECT_MANAGER': 'Could not get Persistent Object Manager.',
    'DM_DATA_DICT_F_CANNOT_GET_DD_INFO_TYPE': 'Could not get the dm_dd_info type.',
    'DM_DATA_DICT_F_CANNOT_GET_NLS_DD_INFO_TYPE': 'Could not get the dm_nls_dd_info type.',
    'DM_DATA_DICT_F_CANNOT_FETCH_DD_INFO': 'Could not fetch a dm_dd_info object.',
    'DM_DATA_DICT_F_CANNOT_FETCH_NLS_DD_INFO': 'Could not fetch a dm_nls_dd_info object.',
    'DM_DATA_DICT_F_INTERNAL_ERROR': 'A Data Dictionary internal error occurred:  ({0}).',
    'DM_DATA_DICT_F_AGGR_DOMAIN_NO_TYPE': 'There is no edit_type for the aggregate domain with object id {0}.',
    'DM_DATA_DICT_F_AGGR_DOMAIN_NO_TYPE_INFO': 'Could not fetch the type info object with object id {0} for the aggregate domain with object id {1}.',
    'DM_DATA_DICT_F_AGGR_DOMAIN_WRONG_NUMBER_CODE_OBJECTS': 'There should be {0} code object(s) for this aggregate domain, found {1}.',
    'DM_DATA_DICT_F_AGGR_DOMAIN_BAD_ATTR_LISTS': 'The attribute lists lengths for the aggregate domain are corrupted.  Attr_name has {0} values, attr_domain_name has {1} values, and attr_domain_id has {2} values.',
    'DM_DATA_DICT_F_CANT_FETCH_DOMAIN': 'Cannot fetch the domain object with object id {0} for attribute {1}',
    'DM_DATA_DICT_F_AGGR_DOMAIN_BAD_ATTR_TYPE': 'Cannot get attribute type for attribute \'{0}\' of type \'{1}\'.',
    'DM_DATA_DICT_F_AGGR_DOMAIN_BAD_ATTR_LENGTH': 'String attribute \'{0}\' has an invalid length ({1}) in type \'{2}\'.',
    'DM_DATA_DICT_F_AGGR_DOMAIN_CANNOT_FETCH_CODE_OBJECT': 'Cannot fetch the expression code SysObject with object id {0}.',
    'DM_DATA_DICT_F_CANNOT_GET_TYPE_INFO_FOR_TYPE': 'Cannot get the type info object for type {0}.',
    'DM_DATA_DICT_F_NO_ATTRIBUTE_INFO_FOR_NAME': 'The Data Dictionary has no information for attribute {0} of Data Dictionary type {1}.',
    'DM_DATA_DICT_F_CANNOT_FETCH_AGGR_DOMAIN_FOR_TYPE': 'Cannot fetch the aggregate domain with object id {0} for type {1}.',
    'DM_DATA_DICT_F_CANNOT_FETCH_DD_INFO_FOR_TYPE': 'Cannot fetch the dm_dd_info object with id {0} for type {1}.',
    'DM_DATA_DICT_F_CANNOT_FETCH_NLS_DD_INFO_FOR_TYPE': 'Cannot fetch the dm_nls_dd_info object with id {0} for type {1}.',
    'DM_DATA_DICT_F_UNEXPECTED_ATTRIBUTE_TYPE': 'Attribute {0} has an unexpected data type ({1}).',
    'DM_DATA_DICT_F_NULL_DOMAIN_ID_FOR_ATTRIBUTE': 'The domain id for attribute {0} of type {1} is NULL.',
    'DM_DATA_DICT_F_CANNOT_FETCH_DOMAIN_FOR_ATTRIBUTE': 'Cannot fetch the dm_domain object with object id {0} for attribute {1} of type {2}.',
    'DM_DATA_DICT_F_CANNOT_FETCH_DD_INFO_FOR_ATTRIBUTE': 'Cannot fetch the dm_dd_info object with id {0} for attribute {1} of type {2}.',
    'DM_DATA_DICT_F_CANNOT_FETCH_NLS_DD_INFO_FOR_ATTRIBUTE': 'Cannot fetch the dm_nls_dd_info object with id {0} for attribute {1} of type {2}.',
    'DM_DATA_DICT_F_AGGR_DOMAIN_NULL_CODE_OBJECT_ID': 'The object id of the code object is NULL.',
    'DM_DATA_DICT_F_ROUTINE_ID_MISMATCH': 'Two different routine_id objects were specified for generated expression source code:  {0} and {1}.',
    'DM_DATA_DICT_F_NULL_DEFAULT_ID': 'The default_id attribute is NULL for this dm_cond_id_expr object.',
    'DM_DATA_DICT_F_BAD_DD_ATTRIBUTE_TREATMENT': 'The Data Dictionary attribute {0} has a bad attribute treatment value ({1}).',
    'DM_DATA_DICT_F_BAD_DD_DEFAULT_VALUE_TYPE': 'The Data Dictionary attribute {0} is of the wrong type ({1}) to have a default value.',
    'DM_DATA_DICT_F_CANNOT_FIND_ATTRIBUTE_FOR_TYPE': 'Attribute {0} does not exist in type {1}.',
    'DM_DATA_DICT_F_EXPR_CODE_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_EXPR_CODE_BAD_VSTAMP': 'Type dmi_expr_code has a bad vstamp {0}. The current vstamp for dmi_expr_code is supposed to be {1}.',
    'DM_DATA_DICT_F_CANNOT_FIND_DD_FOLDER': 'Cannot find the Data Dictionary system folder \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_FETCH_DD_FOLDER': 'Cannot fetch the Data Dictionary system folder \'{0}\' with ID \'{1}\'.',
    'DM_DATA_DICT_F_NULL_DOMAIN_POINTER': 'The domain pointer for a dm_dd_info object is NULL.',
    'DM_DATA_DICT_F_NULL_AGGR_DOMAIN_POINTER': 'The aggr_domain pointer for a domain object is NULL.',
    'DM_DATA_DICT_F_NULL_GENERATED_SOURCE_FILE': 'The generated_source_file pointer for an aggr domain object is NULL.',
    'DM_DATA_DICT_F_AGGR_DOMAIN_EDIT_TYPE_NOT_SET': 'The internal pointer to the type being edited is not set in dm_aggr_domain \'{0}\'.',
    'DM_DATA_DICT_F_BAD_PRIMITIVE_TYPE_CODE': 'Unknown primitive type code:  ({0}).',
    'DM_DATA_DICT_F_BAD_POLICY_ID_AND_VERSION': 'Bad default policy id ({0}) and version label (\'{1}\') combination.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_DOMAIN_FOR_ATTR': 'Cannot expunge the domain object for attribute {0}.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_CODE_OBJECT_FOR_ATTR_DOMAIN': 'Cannot expunge the dmi_expr_code object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_NLS_DD_INFO': 'Cannot expunge the dm_nls_dd_info object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_DD_INFO': 'Cannot expunge the dm_dd_info object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_DEFAULT_VALUE': 'Cannot expunge the default value expression with object id \'{0}\' at position {1}.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_COND_VALUE_ASSIST': 'Cannot expunge the cond value assist expression with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_COND_COMPUTED_EXPR': 'Cannot expunge the cond computed expr expression with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_VAL_CONSTRAINT': 'Cannot expunge the val_constraint expression with object id \'{0}\' at position {1}.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_UNIQUE_KEY': 'Cannot expunge the unique key with object id \'{0}\' at position {1}.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_FOREIGN_KEY': 'Cannot expunge the foreign key with object id \'{0}\' at position {1}.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_PRIMARY_KEY': 'Cannot expunge the primary key with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_DEFAULT_VALUE_ASSIST': 'Cannot expunge the default value assistance with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_VALUE_ASSIST': 'Cannot expunge the value assistance with object id \'{0}\' at position {1}.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_DEFAULT_COMPUTED_EXPRESSION': 'Cannot expunge the default computed expression with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_COMPUTED_EXPRESSION': 'Cannot expunge the computed expression with object id \'{0}\' at position {1}.',
    'DM_DATA_DICT_F_CANNOT_FETCH_DD_OBJECT_FOR_OVERRIDE': 'Cannot fetch the object with id \'{0}\' during an override operation.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_DD_OBJECT_FOR_OVERRIDE': 'Cannot expunge the object with id \'{0}\' during an override operation.',
    'DM_DATA_DICT_F_SET_NULL_UPDATE_BAD_TYPE': 'Update NULL for attribute {0} using unknown primitive type code ({1}).',
    'DM_DATA_DICT_F_MISSING_VALUE_ASSIST_PARENT_ID': 'Value assistance object \'{0}\' has no parent_id set.',
    'DM_DATA_DICT_F_CANNOT_FETCH_KEY': 'The key specified with object id \'{0}\' does not exist.',
    'DM_DATA_DICT_F_CANNOT_FETCH_FOREIGN_KEY': 'The foreign key specified with object id \'{0}\' does not exist.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_AGGR_DOMAIN': 'Cannot expunge the dm_aggr_domain object with object id \'{0}\'.',
    'DM_DATA_DICT_F_STORE_OVERRIDE_FAILED': 'Could not set the override_id while updating type {0}.',
    'DM_DATA_DICT_F_STORE_STATE_OVERRIDE_FAILED': 'Could not set the override_id while updating the type for business policy id {0}, state {1}.',
    'DM_DATA_DICT_F_ABORT_FAILURE': 'Could not set the transaction state to ABORT while updating type {0}.',
    'DM_DATA_DICT_F_TYPE_UNDO_FAILURE': 'Could not undo type updates for type {0}.',
    'DM_DATA_DICT_F_COMMIT_FAILURE': 'Could not commit Data Dictionary updates for type {0}.',
    'DM_DATA_DICT_F_CANNOT_SAVE_POLICY': 'Could not save changes to business policy {0} for state {1}.',
    'DM_DATA_DICT_F_INCONSISTENT_CODE_OBJECT': 'The code object pointer for dm_aggr_domain {0} is inconsistent.',
    'DM_DATA_DICT_F_CANNOT_CLONE_DD_INFO': 'Cannot clone the dm_dd_info object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_CLONE_DEFAULT_VALUE': 'Cannot clone the default value dm_expresion object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_CLONE_COND_VALUE_ASSIST': 'Cannot clone the cond value assistance dm_expresion object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_CLONE_DEFAULT_VALUE_ASSIST': 'Cannot clone the default dm_value_assist object with object_id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_CLONE_VALUE_ASSIST': 'Cannot clone the dm_value_assist object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_CLONE_COND_COMPUTED_EXPR': 'Cannot clone the cond computed dm_expression object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_CLONE_DEFAULT_COMPUTED_EXPRESSION': 'Cannot clone the default computed dm_expression object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_CLONE_COMPUTED_EXPRESSION': 'Cannot clone the computed dm_expression object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_CLONE_VAL_CONSTRAINT': 'Cannot clone the validation constraint dm_expression object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CLONE_UNIQUE_KEY': 'Attempt to clone a unique key for the dm_dd_info object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CLONE_FOREIGN_KEY': 'Attempt to clone a foreign key for the dm_dd_info object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CLONE_PRIMARY_KEY': 'Attempt to clone a primary key for the dm_dd_info object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_CLONE_DOMAIN': 'Cannot clone the dm_domain object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_CLONE_NLS_DD_INFO': 'Cannot clone the dm_nls_dd_info object with object id \'{0}\'.',
    'DM_DATA_DICT_F_CANNOT_CLONE_DOMAIN_FOR_ATTR': 'Cannot clone the domain object for attribute {0}.',
    'DM_DATA_DICT_F_UNEXPECTED_DOMAIN_ID_IN_ATTR_DOMAIN_ID_LIST': 'For aggr domain {0}, the attr_domain_id for attribute {1} was found to be {2}.',
    'DM_DATA_DICT_F_GET_ATTR_TYPE_FAILURE': 'Cannot get attribute type for type {0} attribute {1}.',
    'DM_DATA_DICT_F_SYNCHRONIZE_WITH_TYPE_FAILED': 'Failure synchronizing dm_aggr_domain \'{0}\' with type {1}.',
    'DM_DATA_DICT_F_SAVE_FAILED_AFTER_SYNCHRONIZE': 'Failure saving after synchronizing dm_aggr_domain \'{0}\' with type {1}.',
    'DM_DATA_DICT_F_DD_COMMON_INFO_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_DD_COMMON_INFO_BAD_VSTAMP': 'Type dmi_dd_common_info has a bad vstamp {0}. The current vstamp for dmi_dd_common_info is supposed to be {1}.',
    'DM_DATA_DICT_F_DD_ATTR_INFO_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_DD_ATTR_INFO_BAD_VSTAMP': 'Type dmi_dd_attr_info has a bad vstamp {0}. The current vstamp for dmi_dd_attr_info is supposed to be {1}.',
    'DM_DATA_DICT_F_DD_TYPE_INFO_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_DD_TYPE_INFO_BAD_VSTAMP': 'Type dmi_dd_type_info has a bad vstamp {0}. The current vstamp for dmi_dd_type_info is supposed to be {1}.',
    'DM_DATA_DICT_F_SCOPE_CONFIG_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_SCOPE_CONFIG_BAD_VSTAMP': 'Type dm_scope_config has a bad vstamp {0}. The current vstamp for dm_scope_config is supposed to be {1}.',
    'DM_DATA_DICT_F_DISPLAY_CONFIG_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_DATA_DICT_F_DISPLAY_CONFIG_BAD_VSTAMP': 'Type dm_display_config has a bad vstamp {0}. The current vstamp for dm_display_config is supposed to be {1}.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_SCOPE_CONFIG': 'Cannot expunge the dm_scope_config object with object id \'{0}\' at position {1}.',
    'DM_DATA_DICT_F_CANNOT_EXPUNGE_DISPLAY_CONFIG': 'Cannot expunge the dm_display_config object with object id \'{0}\' at position {1}.',
    'DM_DIRECTORY_E_MEMORY_EXHAUSTED': 'Memory exhausted allocating {0} bytes',
    'DM_DIRECTORY_E_BROWSE_INSUFF_PRIVS': 'Must be have Administrator privilege.',
    'DM_DIRECTORY_E_BROWSE_INSUFF_FS_PRIVS': 'The current user does not sufficient privilege to access this directory: ({0}i)',
    'DM_DIRECTORY_E_BROWSE_CANT_RETRIEVE_DIRECTORY': 'Failed to retrieve directory listing \'{0}\'',
    'DM_DIRECTORY_E_BROWSE_NOT_DIRECTORY': 'The path provided ({0}) is not a directory.',
    'DM_DIRECTORY_E_BROWSE_NO_DIRECTORY_SUPPLIED': 'Must provide a directory with argument DIRECTORY.',
    'DM_DOCUMENT_E_NO_STAGE': 'Staging location named \'{0}\' is not defined for \'{1}\' document.',
    'DM_DOCUMENT_E_STG_DESTROY': 'Non-zero status returned from stage destroyer: {0}.  Command line was: {1}.',
    'DM_DOCUMENT_E_NO_STG_LOC_PATH': 'Unable to retrieve the file_system_path attribute of the dm_location named {0}',
    'DM_DOCUMENT_E_NO_DESTROYER_PATH': 'Unable to retrieve the file_system_path attribute of the dm_location named {0}',
    'DM_DOCUMENT_F_INIT1': 'The dmDocument type was found in the database without a version stamp.',
    'DM_DOCUMENT_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_DOCUMENT_F_INIT3': 'The type manager returned an error storing the dmDocument type.',
    'DM_DOCUMENT_F_TYPE_CONVERSION': 'Failed to convert type dm_document from version {0} to version {1}.',
    'DM_DCNFG_W_INVALID_MIN_OWNER_PERMIT': 'An invalid value for minimum owner permit ({0}) was found when loading the docbase config. The server default value was used instead.',
    'DM_DCNFG_W_INVALID_MIN_OWNER_XPERMIT': 'An invalid value for minimum owner extended permit (\'{0}\') was found when loading the docbase config. The server default value was used instead.',
    'DM_DCNFG_W_CLIENTRIGHTSDOMAIN_PROPAGATE': 'Failed to create {0} object for dm_client_rights_domain propagation',
    'DM_DCNFG_E_CANT_FIND': 'Cannot find {0} docbase_config.',
    'DM_DCNFG_E_CANT_FETCH_INVALID_ID': 'Cannot fetch a docbase_config - Invalid object ID {0}',
    'DM_DCNFG_E_CANT_SAVE': 'Cannot save {0} docbase_config.',
    'DM_DCNFG_E_CANT_CHANGE_NAME': 'Cannot change {0} name of docbase_config object',
    'DM_DCNFG_E_INVALID_SECURITY': 'Invalid security mode \'{0}\' found in dm_docbase_config.',
    'DM_DCNFG_E_INVALID_MACP': 'Invalid mac access protocol {0}.',
    'DM_DCNFG_E_CANT_CHANGE_MACP': 'Can not change mac access protocol from {0} to {1}.',
    'DM_DCNFG_E_NEED_PRIV_FOR_CHANGE': 'The current user ({0}) needs to have superuser or sysadmin privilege to save or destroy {1} docbase_config object.',
    'DM_DCNFG_E_CANT_CHANGE_ACL': 'Can not change security mode from ACL to {0}.',
    'DM_DCNFG_E_CANT_CHANGE_TO_ACL': 'Can not change security mode from {0} to ACL since ACL conversion has not been performed. Execute dm_convertto_acl to do the conversion.',
    'DM_DCNFG_E_CANT_CHANGE_AUTH_PROTOCOL': 'Can not change auth_protocol mode from \'domain_required\' to {0}.',
    'DM_DCNFG_E_NEED_SU_FOR_FED_CHANGE': 'The current user ({0}) needs to have superuser privilege to save or destroy {1} dm_federation object.',
    'DM_DCNFG_E_BAD_FEDERATION_MEMBER_ATTRC': 'In dm_federation named \'{0}\', count of {1}: {2} does not match the count of r_member_docbases: {3}.',
    'DM_DCNFG_E_CANT_DESTROY_FEDERATION': 'Cannot destroy dm_federation identified by \'{0}\' because the federation is active.',
    'DM_DCNFG_E_DUPLICATE_DD_LOCALE': 'The docbase config object has duplicate dd_locales value \'{0}\'. dd_locales must be unique.',
    'DM_DCNFG_E_INVALID_DD_LOCALE': 'The docbase config object has an unrecognized dd_locales value \'{0}\'.',
    'DM_DCNFG_E_INVALID_DEFAULT_APP_PERMIT_VALUE': 'The docbase_config object has an invalid default_app_permit value of {0}. Valid values must be between 2 (BROWSE) and 7 (DELETE).',
    'DM_DCNFG_E_CANT_CHANGE_CRYPTO_KEY': 'The i_crypto_key attribute cannot be changed/updated.',
    'DM_DCNFG_E_INVALID_VALUE_FOR_MAX_AUTH_ATTEMPT': 'The docbase_config object has an invalid max_auth_attempt value of {0}. It must be an integer greater than or equal to zero.',
    'DM_DCNFG_E_MACL_REQUIRES_TRUSTED_CONTENT_SERVICES': 'In order to turn on Mandatory Access Control (MACL) functionality, you must have a Trusted Content Services (TCS) license.',
    'DM_DCNFG_E_INVALID_MODULE_NAME': 'The number of values for module_name does not match the number of values for module_mode. These two attributes are one to one mappings and must have the same number of values.',
    'DM_DCNFG_E_SET_OLDEST_CLIENT_VERSION_FIRST': 'The docbase_config object attribute oldest_client_version has to be set before setting attribute check_client_version to T.',
    'DM_DCNFG_E_INVALID_CLIENT_VERSION': 'The value ({0}) specified for docbase_config object attribute oldest_client_version is invalid.',
    'DM_DCNFG_E_CANT_CHANGE_AUDIT_OLD_VALUES': 'Cannot change audit_old_values to T because auditing old values of audited properties is not enabled due to a database page size limitation.',
    'DM_DCNFG_E_CLIENTREG_ILLEGAL_VALUE': 'The value \'{0}\' is not legal for field \'{1}\' of dm_client_registration.',
    'DM_DCNFG_E_CLIENTREG_NO_PRIV': 'User \'{0}\' does not have permission to create this dm_client_registration entry.',
    'DM_DCNFG_E_CLIENTREG_NOT_UNIQUE': 'Object value (\'{0}\') not unique in field \'{1}\'.  Conflicts with existing object.',
    'DM_DCNFG_E_CLIENTRIGHTS_ILLEGAL_VALUE': 'The value \'{0}\' is not legal for field \'{1}\' of dm_client_rights.',
    'DM_DCNFG_E_CLIENTRIGHTS_NO_PRIV': 'User \'{0}\' does not have permission to create this dm_client_rights object.',
    'DM_DCNFG_E_CLIENTRIGHTS_NOT_UNIQUE': 'Object value (\'{0}\') not unique in field \'{1}\'.  Conflicts with existing object.',
    'DM_DCNFG_E_PKCERT_ILLEGAL_VALUE': 'The value \'{0}\' is not legal for field \'{1}\' of dm_public_key_certificate.',
    'DM_DCNFG_E_PKCERT_NO_PRIV': 'User \'{0}\' does not have permission to create this dm_public_key_certificate object.',
    'DM_DCNFG_E_PKCERT_NOT_UNIQUE': 'Object value (\'{0}\') not unique in field \'{1}\'.  Conflicts with existing object.',
    'DM_DCNFG_E_PKCERT_FORMAT': 'The certificate value is not of a format understood by the server.  Error code: {0}.',
    'DM_DCNFG_E_PKCERT_PUBLICKEY': 'Error getting public key from certificate value.  Error code: {0}.',
    'DM_DCNFG_E_PKCERT_KEYID': 'Error building key identifier for certificate value.  Error code: {0}.',
    'DM_DCNFG_E_RIGHTS_NOT_AUTHENTICATED': 'Client \'{0}\' was not authenticated and cannot host privileged roles.',
    'DM_DCNFG_E_RIGHTS_NOT_AUTHORIZED': 'Client \'{0}\' is not authorized to use role \'{1}\'.',
    'DM_DCNFG_E_RIGHTS_NOT_EXIST': 'Could not find entry for client \'{0}\' in the rights database.',
    'DM_DCNFG_E_CANNOT_UPDATE_PARTITION_STATUS': 'Direct update on r_partition_status attribute in dm_docbase_config object is not allowed.',
    'DM_DCNFG_E_UPDATE_MIN_OWNER_PERMIT': 'You have specified an invalid value ({0}) for the minimum owner permit.',
    'DM_DCNFG_E_UPDATE_MIN_OWNER_XPERMIT': 'You have specified an invalid value (\'{0}\') for the minimum owner extended permit.',
    'DM_DCNFG_E_BOUNDARY_ERROR': 'You have specified a value \'{0}\' for {1} which is invalid. Please specify a value within {2} to {3}.',
    'DM_DCNFG_E_NOT_GLOBAL_REGISTRY': 'The docbase is not a global register. The opration you requested, {0}, can only be executed in a global registry',
    'DM_DCNFG_E_CLIENTRIGHTSDOMAIN_NO_PRIV': 'User \'{0}\' does not have permission to operate on dm_client_rights_domain object or mark a dm_client_rights object as is_globally_managed.',
    'DM_DCNFG_E_CLIENTRIGHTSDOMAIN_EXIST': 'dm_client_rights_domain object already exists. Only one instance of dm_client_rights_domain object can be created in a docbase',
    'DM_DCNFG_E_CLIENTRIGHTSDOMAIN_ADD_MEMBER': 'Please use register_privileged_dfc method to add docbase to client right domain',
    'DM_DCNFG_E_CLIENTRIGHTSDOMAIN_VALUE_MISMATCH': 'The value counts of repeating attributes, member_docbase, login, and last_refresh, are different',
    'DM_DCNFG_E_CLIENTRIGHTSDOMAIN_MEMBER': 'Docbase {0} is a member of a client right domain already.',
    'DM_DCNFG_E_CLIENTRIGHTSDOMAIN_GR_MEMBER': 'Global Registry docbase cannot be a regular member of client rights domain.',
    'DM_DCNFG_E_CLIENTRIGHTSDOMAIN_NOT_EXIST': 'No dm_client_rights_domain object found in docbase {0}.',
    'DM_DCNFG_E_CLIENTRIGHTSDOMAIN_VERSION': 'Member docbase {0} has to be 6.7 or later.',
    'DM_DCNFG_E_CANT_UPDATE_CRYPTO_MODE_OR_KEYSTORE': 'crypto_mode and crypto_keystore attributes cannot be updated, once the docbase is created/upgraded',
    'DM_DCNFG_E_MISSING_CRYPTO_MODE_OR_KEYSTORE': 'crypto_mode or crypto_keystore values are missing from server.ini. These values are required during new docbase creation or upgrade in server.ini',
    'DM_DCNFG_E_RKM_REQUIRES_TRUSTED_CONTENT_SERVICES': 'In order to use RSA Key Manager to create and store cryptographic keys, you must have a Trusted Content Services (TCS) license.',
    'DM_DCNFG_F_INIT1': 'The docbase_config type was found in the database without a version stamp.',
    'DM_DCNFG_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_DCNFG_F_INIT3': 'The type manager returned an error storing the docbase_config type.',
    'DM_DCNFG_F_INT1': 'The following database query {0} could not be executed.',
    'DM_DCNFG_F_INIT4': 'The type manager returned an error converting the dm_docbase_config type.',
    'DM_DCNFG_F_FEDERATION_STORE_TYPE': 'The type manager returned an error storing the dm_federation type.',
    'DM_DCNFG_F_FEDERATION_BAD_VSTAMP': 'Version stamp {0} was expected to be {1}.',
    'DM_DCNFG_F_CLIENTREG_STORE_TYPE': 'Error creating dm_client_registration type.',
    'DM_DCNFG_F_CLIENTRIGHTS_STORE_TYPE': 'Error creating dm_client_rights type.',
    'DM_DCNFG_F_CLIENTREG_BAD_VSTAMP': 'Version stamp {0} was expected to be {1}.',
    'DM_DCNFG_F_CLIENTRIGHTS_BAD_VSTAMP': 'Version stamp {0} was expected to be {1}.',
    'DM_DCNFG_F_UPGRADE65': 'Type manager is unable to upgrade dm_docbase_config type to version 6.5.',
    'DM_DCNFG_F_CLIENTRIGHTS_UPGRADE70': 'Type manager is unable to upgrade dm_client_rights type to version 7.0.',
    'DM_DUMP_T_REPL_1': 'Number of objects looked up={0}d, total lookup time={1}f ms, avg time={2}f ms',
    'DM_DUMP_T_REPL_2': 'Number of objects inserted={0}d, total insert time={1}f ms, avg time={2}f ms',
    'DM_DUMP_T_REPL_3': 'Executing SQL stmt: {0}',
    'DM_DUMP_T_REPL_4': 'Skipping object ID={0}, i_vstamp={1}d',
    'DM_DUMP_T_REPL_5': 'Starting dump: mode={0}, object count={1}',
    'DM_DUMP_T_QUERY': 'Executing query statement: {0}',
    'DM_DUMP_T_OBJ_ID': 'Dumping object, id = {0}',
    'DM_DUMP_T_TYPE_NAME': 'Dumping type, name = {0}',
    'DM_DUMP_T_RELATE': 'Dumping the objects referenced by the following object: {0}',
    'DM_DUMP_T_LOG_TYPE': 'Writing type information into the dump file.',
    'DM_DUMP_T_DUMPMAP': 'Starting GetDumpMap operation on object {0}. Option parameters ({1}).',
    'DM_DUMP_T_DUMPMAP_ADD': 'Add object {0}.',
    'DM_DUMP_T_DUMPMAP_ADDPEER': 'Add {0}, peer of object {1}.',
    'DM_DUMP_T_DUMPMAP_ADDBEFORE': 'Add {0}, before object {1}.',
    'DM_DUMP_T_DUMPMAP_ADDAFTER': 'Add {0}, after object {1}.',
    'DM_DUMP_T_DUMPMAP_ADDPRIMARY': 'Add {0} as a primary object for object {1}.',
    'DM_DUMP_T_DUMPMAP_ADDEXCEPTION': 'Add {0} as an exception object for object {1}.',
    'DM_DUMP_T_DUMPMAP_DUPLICATE': 'Object {0} already exists in map.',
    'DM_DUMP_T_DUMPMAP_PROCESS': 'Processing Object {0}.',
    'DM_DUMP_T_OBJECT_START': 'Start object dump, id = {0}#[[[',
    'DM_DUMP_T_OBJECT_END': 'End object dump, id = {0}#]]]',
    'DM_DUMP_T_TYPE_START': 'Start type dump, name = {0}#[[[',
    'DM_DUMP_T_TYPE_END': 'End type dump, name = {0}#]]]',
    'DM_DUMP_W_UNFORCEPLAN_FAILED': 'Could not turn off FORCEPLAN. {0}',
    'DM_DUMP_W_FORCEPLAN_FAILED': 'Could not turn on FORCEPLAN. {0}',
    'DM_DUMP_W_OBJ_NOT_EXIST': 'Skipping reference to object {0}. Object does not exist.',
    'DM_DUMP_W_UNABLE_TO_FETCH_TYPE': 'Could not fetch type {0}',
    'DM_DUMP_E_RECORD_SAVE_FAILED': 'Save of dump record for object {0} failed -- dump terminated',
    'DM_DUMP_E_OBJECT_UPDATE_FAILED': 'Update of dump object {0} failed -- dump terminated',
    'DM_DUMP_E_CANT_COUNT_ROOT_SET': 'Query to count objects to be dumped failed. \nQuery was: {0}',
    'DM_DUMP_E_CANT_OPEN_NEW_FILE': 'Could not open new output dumpfile {0}',
    'DM_DUMP_E_CANT_OPEN_OLD_FILE': 'Could not open old output dumpfile {0}',
    'DM_DUMP_E_OBJECT_SAVE_FAILED': 'Save of dump object {0} failed -- dump terminated',
    'DM_DUMP_E_CANT_CONTINUE': 'Can\'t continue dump -- count of root sets has changed',
    'DM_DUMP_E_TYPE_NOT_FOUND': 'Dump request error: type {0} does not exist in this docbase.',
    'DM_DUMP_E_NOT_SUPERUSER': 'The dump operation cannot be executed because the requesting user ({0}) does not have superuser privilege.  Superuser privilege is required to dump objects from a docbase.',
    'DM_DUMP_E_FILE_EXISTS': 'Could not open new output dumpfile. File {0} already exists. Dump will not overwrite an existing file.',
    'DM_DUMP_E_NO_FILENAME': 'No file_name value given for the Dump Operation.',
    'DM_DUMP_E_PARAM': 'Bad parameter for internal Dump Operation: {0}',
    'DM_DUMP_E_REPLICA_CATALOG': 'Database error in accessing replica catalog: {0}',
    'DM_DUMP_E_DESTROY_DUMP_RECORD': 'An error occurred during cleanup from a Dump as part of a destroy request on the dm_dump_record object.  The dump operation bookkeeping records (dmi_dump_object_record) have not been fully cleaned up.',
    'DM_DUMP_E_OPEN_TRANSACTION': 'The destroy Dump operation cannot be executed while inside of a user transaction.',
    'DM_DUMP_E_CANNOT_CREATE': 'Cannot create dump file with the specified file name: {0}',
    'DM_DUMP_E_BAD_STREAM': 'A system error has occurred during a data stream formating operation.',
    'DM_DUMP_E_FILE_IO': 'File Input / Output error. Operating System Error :  {0}',
    'DM_DUMP_E_RECORDED_SIZE': 'The recorded size of {0} in file ({1}) is corrupted.',
    'DM_DUMP_E_INIT_DUMP': 'Version stamp {0} was expected to be {1}',
    'DM_DUMP_E_MAP_BUILD': 'Error building map records in GetDumpMap operation for object {0}.',
    'DM_DUMP_E_MAP_ARGS': 'Error in dmGetDumpMap call, bad parameters to operation.  Handle: {0}, argument ptr: {1}.',
    'DM_DUMP_E_INVALID_TYPE': 'The type {0} supplied by user is invalid.',
    'DM_DUMP_E_NON_RESTART': 'Dump operation is not restartable because user has set the restart flag to false.',
    'DM_DUMP_E_CANT_FETCH_OBJ': 'Error fetching object to dump.  Object id: {0}.',
    'DM_DUMP_E_CANT_PROBE_OBJ': 'Error checking existence of object to dump.  Object id: {0}.',
    'DM_DUMP_E_CANT_READ_DUMP_RECS': 'Error reading dump records from dmi_dump_object_record.',
    'DM_DUMP_E_DUMP_OBJECT': 'An Error occurred dumping object with id: {0}.',
    'DM_DUMP_E_ROOTSET_COLL': 'Error dumping result collection.',
    'DM_DUMP_E_NOT_SYS_ADMIN': 'You must have sys admin privileges to perform a {0} operation.',
    'DM_DUMP_E_FILL_DUMPLOAD': 'Error in FILL_DUMPLOAD_TABLES operation.',
    'DM_DUMP_E_DUMP_RELATED_OBJECT': 'Error dumping objects related to {0}.',
    'DM_DUMP_F_INIT_FAILURE': 'Initialization failure for {0}.',
    'DM_SIGN_W_PASSWORD_STALE': 'The password for user ({0}) is stale',
    'DM_SIGN_E_PASSWORD_EXPIRED': 'The Operating System password for user ({0}) has expired.',
    'DM_SIGN_E_INVALID_USER': 'User ({0}), has failed to pass the signature validation check.',
    'DM_SIGN_E_ACCOUNT_EXPIRED': 'The Operating System account for user ({0}) has expired.',
    'DM_SIGN_E_ACCOUNT_DROPPED': 'The Operating System account for user ({0}) has been dropped.',
    'DM_SIGN_E_ACCOUNT_LOCKED': 'The Operating System account for user ({0}) has been locked.',
    'DM_SIGN_E_UNEXPECTED_CHK_RES': 'The return value from the external signature validation program ({0}) returned an unexpected value: ({1})',
    'DM_SIGN_E_PASSWORD_CHECK_GETPWNAM': 'Operating System Failure during user {0} validation. (User OS name = {1}, Domain = {2}, and session id = {3})',
    'DM_SIGN_E_CHK_PASS_OS_ERROR': 'There was an unexpected error during validation of your electronic signature.  Please see your system administrator or check the server log',
    'DM_SIGN_E_NON_EXIST_OBJ': 'The object identified by {0} does not exist.',
    'DM_SIGN_E_DOMAIN_IS_NOT_ACCEPTABLE': 'The passed in domain \'{0}\' is not an acceptable domain to perform sign-off.',
    'DM_SIGN_E_MUST_MATCH_OS_NAME_ATTR': 'The OS name \'{0}\' passed in is not the current user\'s OS name \'{1}\'.',
    'DM_SIGN_E_VERSION_MISMATCH': 'Signoff on the document ({0}) failed because of version mismatch: old version was {1}.',
    'DM_SIGN_E_MUST_MATCH_LOGIN_NAME': 'The login name (\'{0}\') passed in does not match with user\'s user_login_name (\'{1}\').',
    'DM_EVENT_W_INIT10': 'Error dropping the table {0}',
    'DM_EVENT_W_SEND_LAUNCH': 'Please contact your system administrator.  Unable to send mail during processing of your event.  The dm_method named \'{0}\' could not be launched.',
    'DM_EVENT_W_SEND_RUN': 'Please contact your system administrator.  Unable to send mail during processing of your event.  The dm_method named \'{0}\' reported a non-zero status from the program: ({1}) with arguments: ({2}).',
    'DM_EVENT_W_MAIL_METHOD': 'The method \'{0}\' specified in the mail_method attribute of the server config object is not a valid method. The server will use the dm_event_sender method to send mail.',
    'DM_EVENT_W_SEND_MSG_TURNCATED': 'Message is too long and so turncated after {0} characters before sending it out.',
    'DM_EVENT_W_LENGTH_WIDEN_FAILED': 'The upgrade failed on widening registry\'s attribute ({0}) length from {1} to {2}.',
    'DM_EVENT_W_': '',
    'DM_EVENT_E_NOT_REGISTERED': 'User {0} has not registered event {1} for sysobject named \'{2}\'.',
    'DM_EVENT_E_INVALID_EVENT': 'Invalid system event {0}.',
    'DM_EVENT_E_DBERROR': 'Event manager was unable to perform \'{0}\' on {1} for event {2}.\nDatabase error:\n{3}',
    'DM_EVENT_E_CANT_NOTIFY': 'Could not send notification for event {0} for {1} document/object.',
    'DM_EVENT_E_CANT_REGISTER': 'Could not register the specified {0} event for {1} document/object.',
    'DM_EVENT_E_CANT_UNREGISTER': 'User {0} could not unregister the specified {1} event for {2} document/object.',
    'DM_EVENT_E_CANT_FIND_OBJ': 'Could not find the object, name or event \'{0}\' for id {1}',
    'DM_EVENT_E_DIRECTORY_ACCESS_S': 'Error accessing your event directory.  The dm_location object named {0} that defines your event directory ({1}) is in error.  Operating System error was: {2}',
    'DM_EVENT_E_DIRECTORY_ACCESS_M': 'Error accessing your event directory.  The dm_location object named {0} and/or the dm_mount_point object named {1} that defines your event directory ({2}) is in error.  Operating System error was: {3}',
    'DM_EVENT_E_MAIL_LAUNCH': 'Please contact your system administrator.  Unable to send mail during processing of your event.  The dm_method named \'{0}\' could not be launched.',
    'DM_EVENT_E_MAIL_RUN': 'Please contact your system administrator.  Unable to send mail during processing of your event.  The dm_method named \'{0}\' reported a non-zero status from the program: ({1}) with arguments: ({2}).',
    'DM_EVENT_E_SEND_LAUNCH': 'Please contact your system administrator.  Unable to send mail during processing of your event.  The dm_method named \'{0}\' could not be launched.',
    'DM_EVENT_E_SEND_RUN': 'Please contact your system administrator.  Unable to send mail during processing of your event.  The dm_method named \'{0}\' reported a non-zero status from the program: ({1}) with arguments: ({2}).',
    'DM_EVENT_E_NEED_SU_OR_SYS_TO_UNREG': 'The current user ({0}) needs to have superuser or sysadmin privilege to unregister  {1} user event.',
    'DM_EVENT_E_INVALID_ID': 'Invalid handle ({0}) for system event {1}.',
    'DM_EVENT_E_EVENT_ALREADY_REGISTERED': 'Event {0} on object {1} is already registered for user {2}.',
    'DM_EVENT_E_NEED_SYS_TO_REG_TYPE': 'The current user ({0}) needs to have superuser or sysadmin privilege to register event {1} on type {2}.',
    'DM_EVENT_E_CANT_REGISTER_TYPE_EVENT': 'It is not permitted to register for event {0} on type {1}.',
    'DM_EVENT_E_FLUSH_REGISTRY_CACHE_BAD_KEY': 'A cache key ({0}) was supplied to the flush registrycache API call that is not a legal type name.',
    'DM_EVENT_E_CURSOR_FAIL': 'The following query {0} generated the following database {1} error',
    'DM_EVENT_E_CANT_REGISTER_UNLESS_MATERIALIZED': 'Could not register the specified {0} event for {1} because it is an un-materialized lightweight object.',
    'DM_EVENT_F_INIT1': 'The dmEvent type was found in the database without a version stamp.',
    'DM_EVENT_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_EVENT_F_INIT3': 'The type manager returned an error storing the dmEvent type.',
    'DM_EVENT_F_INIT4': 'Could not remove the registry type',
    'DM_EVENT_F_INIT5': 'Could not create the new registry type',
    'DM_EVENT_F_INIT6': 'Could not access the registry data',
    'DM_EVENT_F_INIT7': 'Could not save the new registry entry',
    'DM_EVENT_F_INIT8': 'Error creating the temporary registry table',
    'DM_EVENT_F_INIT9': 'Error renaming the table {0} to {1}',
    'DM_EXCEPTION_W_SHUTDOWN_SERVER': 'A server showdown exception has occurred.',
    'DM_EXCEPTION_W_SHUTDOWN_SESSION': 'A session showdown exception has occurred. Shutdown type: ({0})',
    'DM_EXCEPTION_E_DOCU_FATAL': 'A Documentum exception ({0}) occurred.',
    'DM_EXCEPTION_E_SYS_FATAL': 'A system exception ({0}) occurred.  Instruction: ({1})',
    'DM_EXCEPTION_E_SYS_FATAL_ACCESS': 'A system exception ({0}) occurred.  Code address: ({1}). Attempt to {2} data at address {3}.',
    'DM_EXCEPTION_E_MEMORY_EXHAUSTED': 'Unable to allocate {0} bytes.  Maximum heap capacity {1} bytes',
    'DM_EXCEPTION_E_HEAP_TAG': 'Error during heap validation.  Thread id: {0}.  Error: {1}.',
    'DM_EXCEPTION_E_WIN_INVALID_CRUNTIME_PARAMETER': 'Invalid runtime parameter {0}',
    'DM_EXPRESSION_W_EXPUNGE_EXPRESSION_CANT_FETCH': 'Could not fetch the expression object with ID {0} during an expunge operation.',
    'DM_EXPRESSION_W_EXPUNGE_COND_ID_EXPR_CANT_FETCH': 'Could not fetch the dm_cond_id_expr object with ID {0} during an expunge operation.',
    'DM_EXPRESSION_W_EXECUTION_PCODE_MISSING': 'Expression Manager could not find the pcode for expression with ID {0}. The pcode should be stored in the sysobject with ID {1} at page {2}',
    'DM_EXPRESSION_W_COMPILATION_UNABLE_TO_REMOVE_TEMP_FILE': 'The Expression Manager was unable to remove a temporary file used during the compilation of expression with id {0}. Removal of the temporary file {1} failed due to IO Error: {2}.',
    'DM_EXPRESSION_W_GENERATION_UNABLE_TO_REMOVE_TEMP_FILE': 'The Expression Manager was unable to remove a temporary file used during source code generation of expression with id {0}. Removal of the temporary file {1} failed due to IO Error: {2}.',
    'DM_EXPRESSION_W_': '',
    'DM_EXPRESSION_W_UNABLE_TO_REMOVE_PCODE_FILE': 'The Docbasic Engine was unable to remove the pcode file for expression with id {0} after generating new source code. The pcode is stored in sysobject {1} at page {2}. It should be removed prior to evaluating the expression.',
    'DM_EXPRESSION_E_EXPRESSION_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_EXPRESSION_E_LITERAL_EXPR_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_EXPRESSION_E_BUILTIN_EXPR_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_EXPRESSION_E_FUNC_EXPR_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_EXPRESSION_E_COND_EXPR_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_EXPRESSION_E_COND_ID_EXPR_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}.',
    'DM_EXPRESSION_E_NULL_TEXT': 'The expression_text for a dm_expression cannot be empty.',
    'DM_EXPRESSION_E_INVALID_EXPRESSION_TYPE': 'The expression_type for a dm_expression is invalid.',
    'DM_EXPRESSION_E_FUNC_EXPR_INVALID_EXPRESSION_LANG': 'The expression_lang for a dm_func_expr must be DM_EXPR_LANG_DOCBASIC.',
    'DM_EXPRESSION_E_FUNC_EXPR_INVALID_EXPRESSION_KIND': 'The expression_kind for a dm_func_expr must be DM_EXPR_NORMAL or DM_EXPR_USER_ROUTINE.',
    'DM_EXPRESSION_E_FUNC_EXPR_INVALID_ALIAS_INFO': 'The object_alias information is not complete.',
    'DM_EXPRESSION_E_FUNC_EXPR_MISSING_TYPE_NAME_INFO': 'The type_name attribute must have at least one type specified.',
    'DM_EXPRESSION_E_FUNC_EXPR_INVALID_ATTRIBUTE_INFO': 'The attribute information could not be validated.',
    'DM_EXPRESSION_E_FUNC_EXPR_INVALID_ROUTINE_ID': 'The attribute routine_id is not a valid object id.',
    'DM_EXPRESSION_E_FUNC_EXPR_INVALID_SOURCE_PAGE': 'The attribute source_page must be 0.',
    'DM_EXPRESSION_E_FUNC_EXPR_INVALID_CODE_PAGE': 'The attribute code_page must be 1.',
    'DM_EXPRESSION_E_COND_EXPR_INVALID_SUBEXPR_ID': 'Invalid Subexpression id {0} in expression_list.',
    'DM_EXPRESSION_E_COND_EXPR_INVALID_SUBEXPR_KIND': 'Subexpressions cannot be User Routines.',
    'DM_EXPRESSION_E_COND_ID_EXPR_INVALID_ID_LIST': 'The expression_list and id_list attributes are not in synch.',
    'DM_EXPRESSION_E_COND_ID_EXPR_MISSING_DEFAULT_ID': 'The default_id attribute must be set.',
    'DM_EXPRESSION_E_COND_EXPR_LANGUAGE_MISMATCH': 'The cond_expr contains a subexpression that is in a different expression language.',
    'DM_EXPRESSION_E_CANNOT_GENERATE_USER_ROUTINES': 'Cannot generate a User Routine.',
    'DM_EXPRESSION_E_COND_EXPR_INVALID_SUBEXPRESSION': 'The subexpression of the conditional expression object is invalid.',
    'DM_EXPRESSION_E_INVALID_EXPRESSION_SYNTAX': 'The syntax of the expression_text attribute is invalid.',
    'DM_EXPRESSION_E_GENERATED_SOURCE_FILE_IO': 'The following IO Error occurred while accessing the source code for expression {0}: {1}.',
    'DM_EXPRESSION_E_INVALID_TYPE': 'The type {0} is an invalid type.',
    'DM_EXPRESSION_E_INVALID_ATTRIBUTE': 'The attribute {0} of type {1} at index {2} is invalid.',
    'DM_EXPRESSION_E_INVALID_ATTRIBUTE_INDEX': 'The attribute {0} of type {1} references an invalid index {2}.',
    'DM_EXPRESSION_E_INVALID_EXPRESSION_OBJECT': 'An invalid operation on an expression object was attempted.',
    'DM_EXPRESSION_E_INVALID_DATA_TYPE': 'An invalid data type {0} has been specified.',
    'DM_EXPRESSION_E_UNKNOWN_ERROR': 'An unknown error with code {0} has occurred within the expression manager.',
    'DM_EXPRESSION_E_DOCBASIC_ENGINE': 'An error has occurred in the docbasic engine in mode {0} of type {1}.',
    'DM_EXPRESSION_E_UNABLE_TO_FETCH_ATTRIBUTE_VALUE': 'The Expression Handler was unable to fetch attribute {0} of type {1} at index {2} for object {3}.',
    'DM_EXPRESSION_E_DOCBASIC_UNEXPECTED_RETURN_TYPE': 'The Docbasic Engine has reported a return type of {0} that is different than what is expected for the expression.',
    'DM_EXPRESSION_E_PARSER_UNEXPECTED_CHAR_AT': 'Unexpected character ({0}) at line {1}, column {2} of expression.',
    'DM_EXPRESSION_E_PARSER_TOKEN_TOO_LONG_AT': 'The token at line {0}, column {1} exceeds the maximum token length of {2}.',
    'DM_EXPRESSION_E_PARSER_SYNTAX_EXPECTED_AT': 'Expected \'{0}\', found \'{1}\' at line {2}, column {3}.',
    'DM_EXPRESSION_E_PARSER_MALFORMED_NUMBER_AT': 'Malformed numeric literal at line {0}, column {1}.',
    'DM_EXPRESSION_E_PARSER_MALFORMED_STRING_AT': 'Malformed string literal at line {0}, column {1}.',
    'DM_EXPRESSION_E_PARSER_MALFORMED_DATE_AT': 'Malformed date literal at line {0}, column {1}.',
    'DM_EXPRESSION_E_PARSER_ILLEGAL_SUBSCRIPT_AT': 'The array subscript operation at line {0}, column {1} is illegal.',
    'DM_EXPRESSION_E_SUBSCRIPT_BAD_OPERATOR_AT': 'The array subscript operation {0} at line {1}, column {2} is illegal.',
    'DM_EXPRESSION_E_ROUTINE_ID_MISMATCH': 'Expression objects must have the same routine_id\'s in order for source code to be stored together. The expression objects with object ids {0} and {1} have different routine_id\'s.',
    'DM_EXPRESSION_E_SOURCE_PAGE_MISMATCH': 'Expression objects must have the same source_page\'s in order for source code to be stored together. The expression object with object ids {0} and {1} have different source_page\'s.',
    'DM_EXPRESSION_E_CODE_PAGE_MISMATCH': 'Expression objects must have the same code_page\'s in order for source code to be stored together. The expression object with object ids {0} and {1} have different code_page\'s.',
    'DM_EXPRESSION_E_EXECUTION_INVALID_OBJECT_ID': 'The Expression Manager found an invalid object_id of {0} of type {1} at position {2}.',
    'DM_EXPRESSION_E_EXECUTION_OBJECT_ID_MISMATCH': 'The Expression Manager expected {0} object ids but was given {1} object_ids.',
    'DM_EXPRESSION_E_COMPILATION_UNABLE_TO_RETRIEVE_SOURCE_CODE': 'The Expression Manager was unable to retrieve the source code for expression {0} from sysobject {1}.',
    'DM_EXPRESSION_E_COMPILATION_UNABLE_TO_STORE_PCODE': 'The Expression Manager was unable to store the pcode for expression object {0} in sysobject with id {1}.',
    'DM_EXPRESSION_E_EXECUTION_UNABLE_TO_RETRIEVE_PCODE': 'The Expression Manager was unable to retrieve pcode for expression with id {0} which is stored in sysobject with it {1}.',
    'DM_EXPRESSION_E_EXECUTION_UNABLE_TO_RETRIEVE_STORE_INFO': 'The Expression Manager was unable to retrieve store information for store {0} with name {1}.',
    'DM_EXPRESSION_E_COMPILATION': 'The expression compilation attempt failed. Error Number is {0}, Error Line is {1} and Error Text is \'{2}.\'',
    'DM_EXPRESSION_E_RUNTIME': 'The expression execution attempt failed. Error Number is {0}, Error Line is {1} and Error Text is \'{2}.\'',
    'DM_EXPRESSION_E_UNABLE_TO_COMPILE': 'The Expression Manager encountered a compilation error for expression with id {0}. Check the source code stored in routine id {1}, page {2}.',
    'DM_EXPRESSION_E_UNABLE_TO_EXECUTE': 'The Expression Manager encountered an execution error for expression with id {0}. Check the source code stored in routine id {1}, page {2}.',
    'DM_EXPRESSION_E_FUNC_EXPR_USER_FUNCTION_NULL_ROUTINE_NAME': 'The routine name for a user function must be set.',
    'DM_EXPRESSION_E_PARSER_UNKNOWN_IDENTIFIER_AT': 'The parser encountered an unknown identifier {0} at line {1}, column {2} is illegal.',
    'DM_EXPRESSION_E_INCREASE_LENGTH': 'Failed to increase the size of {0} from {1} to {2}.',
    'DM_EXPRESSION_E_DOCBASIC_INVALID_INTEGER': 'The value {0} is out of the docbasic supported integer range of -32768 to 32767.',
    'DM_EXPRESSION_F_EXPRESSION_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_EXPRESSION_F_LITERAL_EXPR_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_EXPRESSION_F_BUILTIN_EXPR_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_EXPRESSION_F_FUNC_EXPR_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_EXPRESSION_F_COND_EXPR_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_EXPRESSION_F_COND_ID_EXPR_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_EXPRESSION_F_EXPRESSION_BAD_VSTAMP': 'Type dm_expression has a bad vstamp {0}. The current vstamp for dm_expression is supposed to be {1}.',
    'DM_EXPRESSION_F_LITERAL_EXPR_BAD_VSTAMP': 'Type dm_literal_expr has a bad vstamp {0}. The current vstamp for dm_literal_expr is supposed to be {1}.',
    'DM_EXPRESSION_F_BUILTIN_EXPR_BAD_VSTAMP': 'Type dm_builtin_expr has a bad vstamp {0}. The current vstamp for dm_builtin_expr is supposed to be {1}.',
    'DM_EXPRESSION_F_FUNC_EXPR_BAD_VSTAMP': 'Type dm_func_expr has a bad vstamp {0}. The current vstamp for dm_func_expr is supposed to be {1}.',
    'DM_EXPRESSION_F_COND_EXPR_BAD_VSTAMP': 'Type dm_cond_expr has a bad vstamp {0}. The current vstamp for dm_cond_expr is supposed to be {1}.',
    'DM_EXPRESSION_F_COND_ID_EXPR_BAD_VSTAMP': 'Type dm_cond_id_expr has a bad vstamp {0}. The current vstamp for dm_cond_id_expr is supposed to be {1}.',
    'DM_EXPRESSION_F_EXPRESSION_CANT_EXPUNGE': 'Cannot expunge expression object with ID \'{0}\'.',
    'DM_EXPRESSION_F_PARSER_INTERNAL_AT': 'Internal error ({0}) at line {1}, column {2} of expression.',
    'DM_EXPRESSION_F_EXPRESSION_MANAGER_INTERNAL': 'Internal error ({0}) in the Expression Manager.',
    'DM_EXPRESSION_F_CANNOT_CLONE_EXPRESSION': 'Cannot clone expression object with ID \'{0}\'.',
    'DM_EXPRESSION_F_NULL_CODE_OBJECT_ID_FOR_FUNC_EXPR': 'A NULL object id was given for the code object for the dm_expression object with id \'{0}\'.',
    'DM_FILTER_I_STARTUP': 'Starting program {0} on dumpfile {1}.  Output to {2}.',
    'DM_FILTER_I_COMPLETE': 'Program completed with status {0}.\n  {1} objects processed from input file.\n  {2} objects written to output file.\n  {3} types written to output file.',
    'DM_FILTER_E_NO_DUMP_INPUT': 'Cannot locate dump input file: {0}.  Operating System Status {1}.',
    'DM_FILTER_E_DUMPOUT_EXISTS': 'Cannot remove existing dump output file: {0}.  Operating System Status {1}.',
    'DM_FILTER_E_DUMPIN_INIT': 'Error opening/initializing dump input file: {0}.',
    'DM_FILTER_E_DUMPIN_HEADER': 'Error reading header information in the dump input file: {0}.  Cannot build list of type version stamps.',
    'DM_FILTER_E_DUMMY1_MESSAGE': 'This is here to keep the error numbers from shifting.',
    'DM_FILTER_E_DUMPOUT_INIT': 'Error opening/initializing the dump output file: {0}.',
    'DM_FILTER_E_DUMPOUT_TYPE': 'Error writing type description for {0} to the dump output file.',
    'DM_FILTER_E_OBJECT_FILTER': 'Error processing object {0} (type {1}) in filter program.',
    'DM_FILTER_E_DUMPOUT_OBJECT': 'Error writing description for object {0} (type {1}) to the dump output file.',
    'DM_FILTER_E_DUMPOUT_CONTENT': 'Error writing content data for object {0} (type {1}) to the dump output file.',
    'DM_FILTER_E_SYNTAX_NEWVALUE': 'Error in argument syntax for -new_value flag.  Parameter value {0} is incorrect.  The correct format is \'-new_value type.attribute value\'.',
    'DM_FILTER_E_SYNTAX_NOOPT': 'The required parameter \'{0}\' was not specified.',
    'DM_FILTER_E_SYNTAX_BADPARM': 'The parameter \'{0}\' is not a valid filter option.',
    'DM_FILTER_E_SYNTAX_ARGCOUNT': 'Insufficient number of arguments for parameter \'{0}\'.',
    'DM_FILTER_E_STATE_ERROR': 'An internal error was detected in the filter program.  The program arguments were not correctly processed.',
    'DM_FILTER_E_TYPE_UNKNOWN': 'An internal error was detected in the filter program.  An attribute contained an unknown or unsupported type. Attribute: {0}.{1}',
    'DM_FILTER_E_API_ERROR': 'An error was returned from an API call in an attempt to execute the command: <{0}>.  The error reason was: <{1}>.',
    'DM_FILTER_E_API_ERROR0': 'An error was returned from an API call in an attempt to execute the command: <{0}>.',
    'DM_FILTER_E_FOLDER_ARG': 'Argument Error: the folder specified in the {0} argument does not exist.  Folder name: <{1}>.',
    'DM_FILTER_E_USER_ARG': 'Argument Error: the user specified in the {0} argument does not exist.  User name: <{1}>.',
    'DM_FILTER_E_ACL_ARG': 'Argument Error: the acl specified in the {0} argument does not exist.  Acl name: <{1}.{2}>.',
    'DM_FILTER_E_STORAGE_ARG': 'Argument Error: the storage area specified in the {0} argument does not exist.  Storage Area name: <{1}>.',
    'DM_FILTER_E_BOOLEAN_VAL': 'Argument Error: the value ({0}) for argument ({1}) is not a legal boolean value.  The value must be \'T(rue)\' or \'F(alse)\'',
    'DM_FILTER_E_ARG_MISSING': 'Argument Error: missing required argument {0}.',
    'DM_FILTER_E_STORE_NOT_INDEXABLE': 'Warning: the storage area specified has no fulltext index defined on it, but the filter arguments do not disable fulltext indexing.  Objects filtered will have their fulltext index attributes set to False.',
    'DM_FOLDER_T_MERGE_CHECK_OLD': 'Checking local folder path for folder {0}, folder_path={1}, tgt_path={2}.',
    'DM_FOLDER_T_MERGE_CHECK_NEW': 'Checking local folder path for folder {0}, folder_path={1}.',
    'DM_FOLDER_T_MERGE_DELETE': 'Removing folder path {0} from folder object {1}.',
    'DM_FOLDER_T_MERGE_ADD': 'Adding folder path {0} to folder object {1}.',
    'DM_FOLDER_T_MERGE_PROP1': 'Propagating folder path changes to subfolders of {0}.',
    'DM_FOLDER_T_MERGE_PROP2': 'Propagating folder path changes: subfolder {0} skipped.',
    'DM_FOLDER_T_MERGE_PROP3': 'Propagating folder path changes: checking subfolder {0}.',
    'DM_FOLDER_T_MERGE_PROP4': 'Propagating folder path changes: checking deleted path: {0}.',
    'DM_FOLDER_T_MERGE_PROP5': 'Propagating folder path changes: deleting path {0} at index {1}.',
    'DM_FOLDER_T_MERGE_PROP6': 'Propagating folder path changes: checking added path: {0}.',
    'DM_FOLDER_T_MERGE_PROP7': 'Propagating folder path changes: appending path {0}.',
    'DM_FOLDER_T_MERGE_PROP9': 'Completed folder path changes to subfolders of {0}.',
    'DM_FOLDER_W_MERGE_ANCESTOR_ID': 'Unable to resolve local id for folder link {0} in folder {1}.  Parent links in folder {2} may not have been properly loaded.',
    'DM_FOLDER_W_MERGE_ANCESTR_FETCH': 'Unable to fetch parent link {0} for folder {1} ({2}).  Parent folder object may not exist.  This inconsistent link should be resolved later in the load process.',
    'DM_FOLDER_E_ALREADY_LINKED': 'The {0} sysobject is already linked to folder with ID {1}.',
    'DM_FOLDER_E_CANT_ADD_LINK': 'Cannot add sysobject named \'{0}\' to folder with path name {1}.',
    'DM_FOLDER_E_CANT_CHANGE_NAME': 'Cannot change a folder name.',
    'DM_FOLDER_E_CANT_DELETE_LINK': 'Cannot delete sysobject named \'{0}\' from folder with path name {1}.',
    'DM_FOLDER_E_CANT_DROP_LINK': 'No link established between folder with path name {0} and sysobject with ID {1}.',
    'DM_FOLDER_E_CANT_DESTROY': 'Cannot destroy folder with path name {0} since it is not empty.',
    'DM_FOLDER_E_CANT_FETCH_BY_PATH': 'Cannot fetch folder with path name {0}.',
    'DM_FOLDER_E_CANT_SAVE_NO_LINK': 'Cannot save folder with object_name {0} - folders must be linked.',
    'DM_FOLDER_E_CIRC_LINK': 'Cannot create circular links for folder with path name {0}.',
    'DM_FOLDER_E_MUST_HAVE_NAME': 'A new folder/cabinet must have an object_name.',
    'DM_FOLDER_E_PATH_EXISTS': 'Cannot save (or link) \'{0}\' folder with path name \'{1}\' because one already exists.',
    'DM_FOLDER_E_CANT_ADD_LINK1': 'Cannot add sysobject named \'{0}\' to folder with ID {1}.',
    'DM_FOLDER_E_CANT_COMPUTE_DESC': 'Cannot compute child folders for {0} folder.',
    'DM_FOLDER_E_CANT_CHANGED': 'Cannot change name of folder \'{0}\' name since could not modify descendant named \'{1}\'.',
    'DM_FOLDER_E_INVALID_PATH': 'An Invalid path \'{0}\' is encountered in folder named \'{1}\'.',
    'DM_FOLDER_E_LONG_PATH': 'Folder path \'{0}\' in folder named \'{1}\' is too long ({2}d).',
    'DM_FOLDER_E_LONG_PATH1': 'Folder path  for folder named \'{0}\' is too long ({1}d).',
    'DM_FOLDER_E_ILLEGAL_NAME': 'The folder name \'{0}\' is illegal due to the character \'{1}\'.',
    'DM_FOLDER_E_CANT_ADD_LINK2': 'Failed to recompute the folder paths of the folder \'{0}\', which is a descendent of the folder \'{1}\'.',
    'DM_FOLDER_E_NAME_MAPPING': 'Failed to map the given folder path \'{0}\' to the folder\'s handle due to database errors. The message from the database is: {1}',
    'DM_FOLDER_E_PATH_WIDEN_FAILED': 'The type manager returned an error when widening the r_folder_path attribute from {0} to {1}.',
    'DM_FOLDER_E_MERGE_FOLDER_IDS': 'Error in load of folder object {0}.  Error processing i_folder_id values.',
    'DM_FOLDER_E_MERGE_ANCESTORS': 'Error in load of folder object {0}.  Error processing i_ancestor_id values.',
    'DM_FOLDER_E_MERGE_PROPAGATE': 'Error in load of folder object {0}.  Error propagating folder link changes to subfolders.',
    'DM_FOLDER_E_MERGE_PROPQUERY': 'Error in folder load merging.  Error querying for subfolders of the folder object {0}.',
    'DM_FOLDER_E_MERGE_PROPSAVE': 'Error in folder load merging.  Error saving the folder object {0}.',
    'DM_FOLDER_E_MERGE_PROPRECURS': 'Error in folder load merging.  Error propagating folder link changes to subfolder {0}.',
    'DM_FOLDER_E_MERGE_FOLDER_FETCH': 'Error in load folder merging.  Could not fetch folder object {0}.',
    'DM_FOLDER_E_NOT_A_FOLDER_ID': 'You have specified an ID ({0}) in the {1} command that is not a valid ID value for a folder or cabinet.',
    'DM_FOLDER_E_TRAILING_SPACE_IN_NAME': 'The folder name \'{0}\' contains trailing space(s), which is not allowed.',
    'DM_FOLDER_E_RENAMED_FOLDER_INTERNALLY': 'Multiple sessions tried to save a folder with name ( {0} ) simultaneously.Folder({1}) with path ({2}) was renamed to ({3}) at the same location',
    'DM_FOLDER_E_UNIQUENESS_CHECK_FAILED': '{0}',
    'DM_FOLDER_E_R_FOLDER_PATH_LOCK_ERROR': 'Failed to apply lock on the database table due to db error : ({0})',
    'DM_FOLDER_E_CONCUR_LINK_OPERATION_FAILURE': 'Cannot perfrom the link operation on folder ({0}), as some concurrent operation is being performed on the folder or decendant folder or ancesstor folder with folder id {1}.',
    'DM_FOLDER_E_CONCUR_UNLINK_OPERATION_FAILURE': 'Cannot perfrom the unlink operation on folder ({0}), as some concurrent operation is being performed on the folder or decendant folder or ancesstor folder with folder id {1}.',
    'DM_FOLDER_E_CONCUR_RENAME_OPERATION_FAILURE': 'Cannot rename folder ({0}), as some concurrent operation is being performed on the folder or decendant folder or ancesstor folder with folder id {1}.',
    'DM_FOLDER_F_INIT1': 'The dm_folder type was found in the database without a version stamp.',
    'DM_FOLDER_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_FOLDER_F_INIT3': 'The type manager returned an error storing the dm_folder type.',
    'DM_FOREIGN_T_FOLDERMERGE_CHECK': 'Checking Folder {0} as part of distributed operation.',
    'DM_FOREIGN_W_LOAD_NO_IDMAP': 'Cannot lookup object_id mapping for foreign object because the server has not initialized its object_id map cache.',
    'DM_FOREIGN_W_TOO_MANY_MAPS': 'Cannot add new replica objects from docbase id {0} because the limit has already been reached of {1} docbases participating in a replicated enterprise.',
    'DM_FOREIGN_W_SOURCE_REFRESH': 'After a successful refresh of a replica or reference object, could not update the source object ({0}) to show the refresh completion. This may cause the source to later needlessly re-execute the refresh.',
    'DM_FOREIGN_W_MAPINCOMPLETE': 'Object could not be refreshed due to a problem computing the set of related objects needed in the refresh action.  The state of object {0} was unexpectedly unknown.',
    'DM_FOREIGN_W_MULTI_SOURCE': 'Not Yet Supported: Refresh operation encountered a replica object ({0}) from a docbase different than the original object being refreshed ({1}). This multi-docbase replica relationship must be refreshed via the Replication Job.',
    'DM_FOREIGN_W_UPDATE_NOREFRESH': 'An update to a {0} object was performed successfully, but the local information could not be properly refreshed to reflect the new object state.  Local {1} object {2} is likely not up-to-date.',
    'DM_FOREIGN_E_MAP_UPDATE_PRIV': 'No privilege to {0} dm_docbaseid_map object.  You must have at least SYSADMIN privilege.',
    'DM_FOREIGN_E_MAP_CANT_CHANGE': 'Cannot change r_docbase_id or r_id_offset fields of an existing dm_docbaseid_map.',
    'DM_FOREIGN_E_MAP_COLLECTION': 'Error building collection of existing dm_docbaseid_map objects.',
    'DM_FOREIGN_E_MAP_CREATE': 'Error creating server dm_docbaseid_map cache.',
    'DM_FOREIGN_E_LOAD_NEW_MAP': 'Error creating new dm_docbaseid_map object for docbase {0}.',
    'DM_FOREIGN_E_REPLICA_UPDATE': 'Attempt to update a foreign object.  The object {0} of type {1} cannot be updated because it is a replica.',
    'DM_FOREIGN_E_NOT_SYSADMIN': 'Cannot update foreign objects without at least System Admin privilege.',
    'DM_FOREIGN_E_OBJECT_VSTAMP': 'Cannot load object {0} because its version stamp value (i_vstamp = {1}) exceeds the maximum allowable distributed version stamp of {2}.',
    'DM_FOREIGN_E_REF_IMMUTABLE': 'Attempt to modify an immutable field ({0}) of a dm_reference object.',
    'DM_FOREIGN_E_REF_UPDATE_PRIV': 'You do not have privilege to {0} this object.',
    'DM_FOREIGN_E_REF_DIRECT_DELETE': 'You cannot delete this dm_reference object directly.  To properly remove a reference link delete the mirror object, which will cause the associated dm_reference object to be deleted as well.',
    'DM_FOREIGN_E_INDEX_CREATE': 'Error during type initialization.  Could not create index on {0}.{1}.',
    'DM_FOREIGN_E_DEREFERENCE_ERROR': 'Error referencing through object ({0}).',
    'DM_FOREIGN_E_DMREF_LOOKUP': 'Error fetching dm_reference object for ({0}).',
    'DM_FOREIGN_E_DMREF_MISSING': 'Error: no dm_reference record found for object ({0}).',
    'DM_FOREIGN_E_REF_INCOMPATIBLE': 'The local object ({0}) references an object in an incompatible docbase ({1}).  This object cannot be dereferenced until the remote docbase is upgraded.  The remote docbase version is currently {2}.',
    'DM_FOREIGN_E_REF_FETCH_INFO': 'Error fetching information for the object referenced by local object ({0}).  Remote docbase is {1} and remote object id is ({2}).',
    'DM_FOREIGN_E_REFERENCE_NONE': 'Error dereferencing the object ({0}) - the referenced object was not found in docbase {1}.  Remote object id was ({2}) and version label requested was \'{3}\'.',
    'DM_FOREIGN_E_REPLICA_GLOBAL': 'Attempt to locally modify a global attribute of a foreign object.  Attribute {0}.{1} cannot be updated on replica object {2}.',
    'DM_FOREIGN_E_REFERENCE_GLOBAL': 'Attempt to locally modify a global attribute of a reference object.  Attribute {0} cannot be updated on reference object {1}.',
    'DM_FOREIGN_E_NO_DOCBASE_NAME': 'The reference cannot be created because no docbase name was specified.  The reference_docbase_name attribute must be set.',
    'DM_FOREIGN_E_NO_OBJECT_GIVEN': 'The reference cannot be created because no object to reference was specified.  Either the reference_by_id or the reference_by_name attribute must be set.',
    'DM_FOREIGN_E_AMBIGUOUS_REQUEST': 'The reference cannot be created because both the object to reference was specified both by name and by id.  Only one of the reference_by_id and reference_by_name fields can be set.',
    'DM_FOREIGN_E_INVALID_VALUE': 'The reference cannot be created because an invalid value was specified for the attribute: {0}.',
    'DM_FOREIGN_E_EXACT_ID_NAME': 'The reference cannot be created because an invalid binding condition was specified.  When referencing a document by Name, VERSION_LABEL binding must be used.',
    'DM_FOREIGN_E_BAD_FOLDER_LINK': 'The reference cannot be created because \'{0}\' is not valid for {1}. You must specify an existing folder or cabinet of the local docbase, either by ID (eg. 0b0015b480001b4f) or by Name (eg. /cabinet/subfolder).',
    'DM_FOREIGN_E_SERVER_VERSION': 'Distributed Features are not accessible on docbase {0} because it is of an incompatible version (server version {1}).  Docbases must be at least version {2} to participate in distributed operations.',
    'DM_FOREIGN_E_SERVER_SECURITY': 'Distributed Features are not accessible on docbase {0} because it uses an incompatible security mode.  Docbases must use ACL mode security to participate in distributed operations.',
    'DM_FOREIGN_E_SOURCE_NOTFOUND': 'The requested source object was not found.  No object matching the {0} ({1}) with version label ({2}) was found in docbase {3}.',
    'DM_FOREIGN_E_SOURCE_CANT_FETCH': 'The requested source object was not found.  Could not fetch object ({0}) from docbase {1}.',
    'DM_FOREIGN_E_SOURCE_NOT_SYSOBJ': 'The reference cannot be created because object \'{0}\' is not a dm_sysobject or dm_sysobject subtype.  Only dm_sysobject based objects can be referenced.',
    'DM_FOREIGN_E_TYPE_INCOMPATIBLE': 'The reference cannot be created because the {0} type from docbase {1} is not compatible with the local docbase.',
    'DM_FOREIGN_E_NEW_SYSOBJECT': 'Error creating a new object of type {0} during the creation of a reference link.',
    'DM_FOREIGN_E_REF_MIRROR_CREATE': 'Error creating reference to object {0}.  Could not save the local mirror object ({1}).',
    'DM_FOREIGN_E_REF_CREATE': 'Error creating reference to object {0}.  Could not save the local dm_reference object ({1}).',
    'DM_FOREIGN_E_REF_MIRROR_UPDATE': 'Error updating reference object {0}.  Could not save the local mirror object.',
    'DM_FOREIGN_E_REF_UPDATE': 'Error updating reference object {0}.  Could not save the local dm_reference object ({1}).',
    'DM_FOREIGN_E_INTERNAL_ERROR': 'Internal error ({0}) in Reference Object operation.',
    'DM_FOREIGN_E_CURSOR_FAIL': 'In operation {0} an attempt to execute cursor failed; query was: \'{1}\'; error from database system was: {2}',
    'DM_FOREIGN_E_REFINFO_NOT_SYSOBJ': 'ReferenceFetchInfo Operation failed because caller requested acl information on a non-sysobject ({0}).',
    'DM_FOREIGN_E_REFINFO_NO_ACL': 'ReferenceFetchInfo Operation could not find requested ACL information for object ({0}).',
    'DM_FOREIGN_E_COULD_NOT_REFRESH': 'Unable to dynamically refresh {0} object ({1}) from it\'s source object.  The local object may not be an up-to-date copy.  Master docbase is {2}. Master object is ({3}).',
    'DM_FOREIGN_E_UPDATE_NULL_REF': 'Unable to update reference/replica ({0}) to show that the object it points to does not exist.  Could not update i_null_ref_flag in object {1}.',
    'DM_FOREIGN_E_ACL_NOT_FOUND': 'Error processing reference object - could not find acl {0}.{1} in docbase {2} for sysobject ({3}).',
    'DM_FOREIGN_E_REF_NOT_ALLOWED': 'Illegal operation invoked on a reference object.  This operation ({0}) should be directed to the source object rather than the reference.',
    'DM_FOREIGN_E_NOT_IMPLEMENTED': 'Distributed operation ({0}) not supported.',
    'DM_FOREIGN_E_DESTROY_REPLICA': 'Cannot destroy the replica object ({0}) because {1}.',
    'DM_FOREIGN_E_DIST_REFRESH': 'Error in refresh operation for object ({0}).',
    'DM_FOREIGN_E_NOT_DISTRIBUTED': 'Distributed operation requested on an object which is neither a replica nor a reference link.',
    'DM_FOREIGN_E_REFRESH_MISMATCH': 'Refresh operation on object ({0}) failed because the object fetched from the master docbase was inconsistent with the local object. Global vstamp: {1}, Refresh vstamp: {2}; Master id: {3}, Refresh id: {4}.',
    'DM_FOREIGN_E_REFRESH_SAVE': 'The server ReferenceRefresh operation failed.',
    'DM_FOREIGN_E_REFRESHACL_SAVE': 'The server ReferenceRefreshAcl operation failed.',
    'DM_FOREIGN_E_DIST_REFRESHACL': 'Error in refresh security operation for object ({0}).',
    'DM_FOREIGN_E_REFRESH_WRONGACL': 'Reference security refresh failed: ACL object passed by dmcl did not match the reference mirror object.  Reference id {0}.  ACL object name: {1}, domain: {2}.  Mirror object name: {3}, domain: {4}.',
    'DM_FOREIGN_E_PURGE_MIRROR': 'Cannot purge the replica objects for the job ({0}) because {1}.',
    'DM_FOREIGN_E_PURGE_DANG_REF': 'Cannot purge the dangling reference objects for the job ({0}) because {1}.',
    'DM_FOREIGN_E_PURGE_REF_OBJ': 'Cannot purge the replica objects because {0}.',
    'DM_FOREIGN_E_CHECKPOINT_ERROR': 'An error occurred attempting to commit the work completed so far during a set of reference objects operation.  Either the outstanding transaction could not be committed or a new transaction could not be started.',
    'DM_FOREIGN_E_OPEN_TRANSACTION': 'The reference object operation cannot be executed while inside of a user transaction.',
    'DM_FOREIGN_E_SOURCE_AMBIGUOUS': 'The requested source object ({0}) does not specify a unique object in docbase {1}.',
    'DM_FOREIGN_E_COULD_NOT_CONNECT': 'Distributed Operation failed because a connection could not be established to docbase {0}.',
    'DM_FOREIGN_E_REF_TRAN': 'Error creating reference to object {0}.  Could not {1} transaction to create the local reference object.',
    'DM_FOREIGN_E_REFRESH_TRAN': 'Error refreshing reference object {0}.  Could not {1} transaction to update the local reference object.',
    'DM_FOREIGN_E_REFERENCE_TYPE': 'Cannot create a reference to an object of type {0}.',
    'DM_FOREIGN_E_REF_CLIENT_VERSION': 'DMCL version must be 4.0 or higher to create a distributed reference.',
    'DM_FOREIGN_E_REFRESH_DEEP': 'A simple refresh operation on object {0} could not be done because the object had relationships which were changed and also needed refreshing. A deep refresh is required on this object.',
    'DM_FOREIGN_E_REFRESH_SECURITY': 'The user ({0}) does not have permission to refresh object {1}.',
    'DM_FOREIGN_E_DUMPMAP_ALLOC': 'The {0} could not allocate a new entry for the refresh map.  Current map size is {1}d.',
    'DM_FOREIGN_E_ALLOC_ID': 'Could not allocate new object id for tag {0} in replication of object {1}.',
    'DM_FOREIGN_E_DUMPMAP_SRV': 'The source server was unable to properly determine the replication data for object {0}.',
    'DM_FOREIGN_E_REFRESH_NOJOB': 'Could not fetch the dm_job object which defines the replication parameters for replica {0}.  Job id from dm_reference: {1}.',
    'DM_FOREIGN_E_OBJECT_COPY': 'Error creating copy of object {0} in order to save to local server in a refresh operation. The remote object type is {1}. Check that the type definitions in the local and remote docbases are consistent.',
    'DM_FOREIGN_E_OBJECT_REFRESH': 'Error returned from server ReplicaRefresh call on attempt to save local replica of object {0}.  Local object id is {1}.',
    'DM_FOREIGN_E_REPLICA_DELETE': 'Error returned from server DESTROY_REPLICA call to destroy local replica of object {0}.  Local object id is {1}.',
    'DM_FOREIGN_E_RENDITION_DELETE': 'Error returned from server DESTROY_CONTENT call to destroy local rendition of object {0}.  Local object id is {1}.',
    'DM_FOREIGN_E_BUILDREPMAP': 'Error building map of related object in replica refresh operation.',
    'DM_FOREIGN_E_MERGEREPMAP': 'Error building map of related object in replica refresh operation.',
    'DM_FOREIGN_E_PROCESSREPLICA': 'Error processing replica object {0}. Global object id: {1}. Source id: {2}.',
    'DM_FOREIGN_E_OBJECT_IDMAP': 'Error in Distributed Id Mapping during object replication action.',
    'DM_FOREIGN_E_REPLICA_FETCH': 'Error in Distributed Operation due to the inibility to fetch/create the replica object with id {0}.  Type Name: {1}.  Create Flag: {2}.',
    'DM_FOREIGN_E_DMREF_ALLOC': 'Error creating new dm_reference object.',
    'DM_FOREIGN_E_PARM': 'Error in distributed operation.  Bad parameter: {0} = {1}.',
    'DM_FOREIGN_E_FOLDER_MERGE': 'A Replication error during computation of the new folders links for replica object {0} in its target docbase.',
    'DM_FOREIGN_E_NOMAP': 'No mapping found for object id {0} in {1} object {2}.',
    'DM_FOREIGN_E_PRESAVE': 'Error preparing object {0} for Distributed Save operation.',
    'DM_FOREIGN_E_SRC_FOR_UPDATE': 'Could not fetch master object {0} from docbase {1}. Unable to update replica object {2}.',
    'DM_FOREIGN_E_MODIFIED_MASTER': 'Could not update replica {0} because its master object {1} is already modified in the user\'s cache.  Either save or revert the changes to the master object first.',
    'DM_FOREIGN_E_VERSION_MISMATCH': 'Replica object {0} is out of date with its master object {1}.  Master Vstamp: {2}, Replica Vstamp: {3}.  You must refresh the local replica before applying updates to it.',
    'DM_FOREIGN_E_REP_BADCOPY': 'Error during Distributed Update operation.  The attributes of replica object {0} could not be copied to master object {1}.',
    'DM_FOREIGN_E_REP_BADCOPY2': 'Error during Distributed Update operation.  The modified attributes of replica object {0} could not be copied to temporary object prior to save to source docbase.',
    'DM_FOREIGN_E_REP_BADCOPY3': 'Error during Distributed Update operation.  The local changes to replica object {0} could not be reapplied following the distributed save and refresh of the local object.',
    'DM_FOREIGN_E_NEW_REPLICA': 'Error during Distributed Update operation.  The local changes to replica object {0} could not be applied due to the inability to refetch the replica object following the remote update.',
    'DM_FOREIGN_E_UPDATE_NOLOCALUPD': 'A distributed update to object {0} was partially completed. The updates to the master object were saved correctly but an error prevented the saving of local attribute changes.',
    'DM_FOREIGN_E_REFERENCE_CANT_FETCH': 'Cannot fetch - Invalid object ID \'{0}\'.',
    'DM_FOREIGN_F_MAP_INIT1': 'Could not create dm_docbaseid_map type.  The type manager returned an error from the Store operation.',
    'DM_FOREIGN_F_MAP_INIT2': 'The version stamp for the dm_docbaseid_map type was {0} but was  expected to be {1}.',
    'DM_FOREIGN_F_TYPE_INIT': 'Could not create dm_reference type.  The type manager returned an error from the Store operation.',
    'DM_FOREIGN_F_BAD_VSTAMP': 'The version stamp for the dm_reference type was {0} but was expected to be {1}.  You may be running a version of the Documentum server which is incompatible with the Docbase.',
    'DM_FOREIGN_F_TYPE_CONVERSION': 'Failed to convert type dm_reference to version {0}.',
    'DM_FORMAT_E_BAD_ATTR_SPEC': 'Format string has illegal specification for attribute {0}',
    'DM_FORMAT_E_NOT_ATTR': 'Format string has specification for non-existent attribute {0}',
    'DM_FORMAT_E_DUPLICATE_NAME': 'Failed to save format object -- format with name {0} already exists',
    'DM_FORMAT_E_NO_NAME': 'Failed to save format object -- no name was supplied',
    'DM_FORMAT_E_CANT_UPDATE_FTINDICES': 'Failed to save format objects -- could not update',
    'DM_FORMAT_E_FORMAT_IN_USE': 'Can\'t expunge format {0} -- {1} content objects exist with this format',
    'DM_FORMAT_E_BAD_TOPIC_FORMAT': 'Topic format {0} either doesn\'t exist or is not indexable',
    'DM_FORMAT_E_NOT_SYSADMIN': 'Can\'t perform {0} operation -- user does not have sysadmin privileges',
    'DM_FORMAT_E_ILLEGAL_NAME': 'The format name {0} is invalid',
    'DM_FORMAT_E_INCR_LENGTH_NONEXISTANT_ATTR': 'The attribute {0} increase length failed for version {1} because the attribute did not exist',
    'DM_FORMAT_E_INCR_LENGTH_TOO_LONG': 'The attribute {0} increase length failed for version {1} because the attribute was too long',
    'DM_FORMAT_E_INCR_LENGTH_FAILED': 'The attribute {0} increase length failed for version {1}. The database could not widen the attribute',
    'DM_FORMAT_F_TYPE_CONVERSION': 'Failed to convert type dm_format to version {0}.',
    'DM_FT_INDEX_T_UPGRADE_SYSOBJECT_400_PART1_DONE': 'Part 1 of fulltext index sysobject upgrade succeeded',
    'DM_FT_INDEX_T_UPGRADE_SYSOBJECT_400_PART2_DONE': 'Part 2 of fulltext index sysobject upgrade succeeded',
    'DM_FT_INDEX_T_UPGRADE_SYSOBJECT_400_DONE': 'Fulltext index sysobject upgrade succeeded',
    'DM_FT_INDEX_T_UPGRADE_TOPIC_400D_DONE': 'Fulltext index topic to tdk upgrade succeeded',
    'DM_FT_INDEX_T_UPGRADE53_REMOVE_INDEX_IMPLEMENTATION_OBJECT': 'Removal of  dmi_tdk_index object with id {0} {1}',
    'DM_FT_INDEX_T_UPGRADE53_REMOVE_COLLECTION_OBJECT': 'Removal of dmi_tdk_collect object with id {0} {1}',
    'DM_FT_INDEX_T_UPGRADE53_OBSOLETE_INDEX_LOCATION': 'The Verity sub-directory under the directory indicated by the file_system_path attribute of the following dm_location objects are not used for fulltext indexing: {0}',
    'DM_FT_INDEX_T_UPGRADE53_REMOVE_INDEX_OBJECT': 'The dm_fulltext_index object with {0} is removed successfully',
    'DM_FT_INDEX_T_UPGRADE53_OBSOLETE_ATTRIBUTE_DROPPED': 'Attribute {0} dropped from dm_fulltext_index successfully.',
    'DM_FT_INDEX_T_UPGRADE53_ATTRIBUTE_ADDED': 'Added attribute {0} to the dm_fulltext_index type',
    'DM_FT_INDEX_T_FTMETHOD_TIMEOUT': 'Timing out of {0} method',
    'DM_FT_INDEX_T_INIT_INDEX_AGENT_INVALID_FTINDEX': 'dm_fulltext_index ({0}) is invalid',
    'DM_FT_INDEX_T_INIT_INDEX_AGENT_NO_FTINDEX_AGENT_FOUND': 'There were no dm_ftindex_agent_config object(s) found for dm_fulltext_index object with name {0}',
    'DM_FT_INDEX_T_INIT_INDEX_AGENT_INVALID_FTINDEX_AGENT_CONFIG': 'dm_ftindex_agent_config object {0} is invalid.',
    'DM_FT_INDEX_T_INIT_INDEX_AGENT_STARTED': 'Index Agent {0} started.',
    'DM_FT_INDEX_T_INIT_INDEX_AGENT_UNABLE_TO_START': 'Unable to start Index Agent {0}',
    'DM_FT_INDEX_T_INIT_INDEX_AGENT_MSG': '{0}',
    'DM_FT_INDEX_I_IN_PROGRESS': 'Cannot perform operation {0} -- Fulltext index {1} is currently in progress.',
    'DM_FT_INDEX_W_DOCUMENTS_NOT_INDEXED': '{0} documents were not indexed in this update -- their update_count attributes were set to {1}',
    'DM_FT_INDEX_W_STYLE_FILE_NOT_FOUND': 'The {0} was not found',
    'DM_FT_INDEX_W_UPGRADE_400_TCOLL_TYPE_NOT_FOUND': 'The dmi_topic_collection type was not found during upgrade.  Skipping.',
    'DM_FT_INDEX_W_UPGRADE_400_TCOLL_NOT_FOUND': 'The dmi_topic_collection at \'{0}\' for object {1} was not found.',
    'DM_FT_INDEX_W_UPGRADE_400_TPART_TYPE_NOT_FOUND': 'The dmi_topic_partition type was not found during upgrade.  Skipping.',
    'DM_FT_INDEX_W_NO_FULLTEXT_IMPLEMENTATION_LOADED': 'A fulltext library was not identified in the server config object. Please identify a valid fulltext installation in the verity_location attribute of the server config object.',
    'DM_FT_INDEX_W_FULLTEXT_IMPLEMENTATION_NOT_LOADED': 'A fulltext library is currently loaded. Changes made to load a new fulltext library cannot take effect until Content Server is restarted.',
    'DM_FT_INDEX_W_NO_FULLTEXT_LOCS_DEFINED': 'No fulltext install locations are defined in the fulltext_install_locs attribute of the docbase config. This is expected on the first startup of a upgraded or new docbase. If this warning occurs on subsequent startups, follow the instructions in ACTION.',
    'DM_FT_INDEX_W_NO_VERITY_CODEPAGE_SPECIFIED': 'The verity_default_codepage flag was not specified in the server.ini for the {0} locale. The server will set {1} as the codepage for all existing dm_fulltext_index objects.',
    'DM_FT_INDEX_W_VERITY_LOCATION_NOT_DEFINED': 'No fulltext install location was specified in the verity location. No fulltext library will be loaded when the Content Server is rebooted.',
    'DM_FT_INDEX_W_FULLTEXT_LOCATION_NOT_DEFINED': 'No fulltext install location was specified in the fulltext location. No fulltext library will be loaded when the Content Server is rebooted.',
    'DM_FT_INDEX_W_FULLTEXT_SERVER_METHOD_DEPRECATED': 'The Fulltext subsystem related Server method {0} has been deprecated.',
    'DM_FT_INDEX_W_FULLTEXT_IMPLEMENTATION_NOT_LOADED_AIX': 'A fulltext library is not loaded. Changes made to load a new fulltext library cannot take effect until Content Server is restarted.',
    'DM_FT_INDEX_W_NO_FULLTEXT_LOC_DEFINED': 'No fulltext install location is defined in the install_location attribute of the server config. This is expected on the first startup of an upgraded or new docbase. If this warning occurs on subsequent startups, please ensure that a location is defined correctly.',
    'DM_FT_INDEX_W_UNSUPPORTED_FULLTEXT_LOC': 'Fulltext install location {0} is unsupported',
    'DM_FT_INDEX_E_DUPLICATE_FOR_STORE': 'Attempt to create new fulltext index with name {0} duplicates an existing index on the same store (storage name is {1})',
    'DM_FT_INDEX_E_DUPLICATE_NAME': 'Attempt to create new fulltext index failed -- index {0} already has name {1}',
    'DM_FT_INDEX_E_NO_STORE': 'Attempt to create new fulltext index with name {0} failed -- no store with name {1} exists',
    'DM_FT_INDEX_E_CANT_MODIFY': 'Cannot modify existing fulltext index {0}',
    'DM_FT_INDEX_E_CANT_MAKE': 'Can\'t make index with name {0} for storage of type {1}',
    'DM_FT_INDEX_E_CANT_BEGIN_TRANSACTION': 'Could not start transaction for {0} operation on fulltext index {1}',
    'DM_FT_INDEX_E_CANT_COMMIT_TRANSACTION': 'Could not commit transaction for {0} operation on fulltext index {1}',
    'DM_FT_INDEX_E_NOT_SYS_ADMIN': 'Can\'t perform operation {0} on fulltext indices -- not sys admin',
    'DM_FT_INDEX_E_NO_INDEX': 'Can\'t perform operation {0} -- fulltext index not found',
    'DM_FT_INDEX_E_NO_LOCATION': 'Attempt to create new fulltext index with name {0} failed -- no location with name {1} exists',
    'DM_FT_INDEX_E_BAD_CONFIG': 'Attempt to update fulltext index object failed -- invalid server config name {0}',
    'DM_FT_INDEX_E_FAR_STORE': 'Attempt to update fulltext index for far storage {0}',
    'DM_FT_INDEX_E_NO_NAME': 'Attempt to create new fulltext index without supplying a name',
    'DM_FT_INDEX_E_NO_FILE': 'No file was specified for {0} operation',
    'DM_FT_INDEX_E_CANT_UPDATE_SHADOW': 'Cannot perform index update on shadow index {0}',
    'DM_FT_INDEX_E_CLOSE_FAILED': 'Attempt to close fulltext index {0} failed',
    'DM_FT_INDEX_E_INDEX_CLOSED': 'Can\'t rollover index {0} -- it\'s already closed',
    'DM_FT_INDEX_E_CANT_OPEN_NON_TDK_INDEX': 'The index, {0}, you tried to open is with a wrong type {1}.',
    'DM_FT_INDEX_E_API_BAD_ARGS': 'The {0} method failed because of bad arguments: {1}',
    'DM_FT_INDEX_E_CANT_SAVE_TDK_INDEX': 'There was a failure trying to save a fulltext index object.',
    'DM_FT_INDEX_E_STYLE_FILE_NOT_FOUND': 'The internal copy of the {0} was not found',
    'DM_FT_INDEX_E_CANT_RENAME_FILE': 'Unable to rename the {0}.',
    'DM_FT_INDEX_E_CANT_DESTROY_FILE': 'Unable to destroy the {0}.',
    'DM_FT_INDEX_E_USER_STYLE_FILE_NOT_FOUND': 'The user\'s {0} was not found at server path {1}',
    'DM_FT_INDEX_E_CANT_COPY_FILE': 'Couldn\'t copy the {0} at server path {1}.',
    'DM_FT_INDEX_E_STYLE_BACKUP_NOT_FOUND': 'Couldn\'t find the backup for the {0}.',
    'DM_FT_INDEX_E_COLLECTION_NOT_FOUND': 'Couldn\'t find the collection for the sample object specified.',
    'DM_FT_INDEX_E_SAMPLE_OBJ_NO_GOOD': 'The sample object {0} specified must be unique and indexed.',
    'DM_FT_INDEX_E_CANT_MODIFY_TDK_INDEX': 'There was a failure trying to modify a fulltext index object.',
    'DM_FT_INDEX_E_ILLEGAL_TIME_OUT': 'The specified time-out interval ({0}) does not make sense.',
    'DM_FT_INDEX_E_SERVER_PATH_NOT_DIRECTORY': 'The specified server_path ({0}) is not a directory.',
    'DM_FT_INDEX_E_SAMPLE_OBJ_NOT_FOUND': 'The sample object {0} was not found in the docbase.',
    'DM_FT_INDEX_E_SAMPLE_OBJ_BAD_ID': 'The sample object {0} has a bad id.',
    'DM_FT_INDEX_E_STYLE_TYPE_NOT_ALLOWED': 'The {0} is not allowed',
    'DM_FT_INDEX_E_API_ARG_MISSING': 'The {0} method failed because of the argument {1} was missing',
    'DM_FT_INDEX_E_UPGRADE_400_TCOLL_DESTROY_FAILED': 'The dmi_topic_collection at \'{0}\' could not be destroyed.',
    'DM_FT_INDEX_E_INDEX_NAME_TOO_LONG': 'Cant create index with name {0} ({1} chars is max).',
    'DM_FT_INDEX_E_INVALID_DATE_CUTOFF': 'The specified cutoff date format is not valid or is later than the current time.',
    'DM_FT_INDEX_E_CANNOT_USE_MAX_DOCS': 'Cannot run update_ftindex with date_cutoff and max_docs both specified.',
    'DM_FT_INDEX_E_NO_STORAGE': 'Cannot perform operation {0} -- No storage is defined for fulltext index {1}.',
    'DM_FT_INDEX_E_NO_FULLTEXT_INDEX': 'Cannot perform operation {0} -- fulltext index {1} is not defined.',
    'DM_FT_INDEX_E_RESULTS_NOT_FILTERED': 'Cannot perform operation {0} -- The matching results were not filtered to the specified type on fulltext index {1}.',
    'DM_FT_INDEX_E_NO_INDEX_SPECIFIED': 'Cannot perform operation {0} -- No index specified to search.',
    'DM_FT_INDEX_E_METHOD_NOT_ENABLED': 'Cannot perform operation {0} -- The method is not enabled for usage. Contact your superuser for information.',
    'DM_FT_INDEX_E_QUERY_EXECUTION_FAILURE': 'An error occured while trying to execute the following query: {0}. Database error was {1}.',
    'DM_FT_INDEX_E_ILLEGAL_ARG_VALUE': 'The {0} argument was specified with an invalid value. Value was {1}.',
    'DM_FT_INDEX_E_FULLTEXT_CONFIG_NOT_LOADED': 'A fulltext configuration was not found in the file_system_path defined by the fulltext install location {0} object. Please check that the location object exists, that its file system_path points to a valid fulltext installation, and that the fulltext installation contains a valid dmfulltext.ini file.',
    'DM_FT_INDEX_E_NO_FULLTEXT_IMPLEMENTATION_LOADED': 'Could not {0} the fulltext index because a fulltext library is not loaded. A library was not loaded because verity_location in the server config object is not set or the fulltext plugin failed to load.',
    'DM_FT_INDEX_E_NO_LOCALE_SPECIFIED': 'Could not create the fulltext index because a locale was not specified. A locale must be specified.',
    'DM_FT_INDEX_E_BAD_FULLTEXT_INSTALL_LOCATION': 'The {0} fulltext install location is not valid or not found in the fulltext install locations identified in the docbase config object.',
    'DM_FT_INDEX_E_INSTALL_LOC_NOT_VERITY_LOC': 'The {0} fulltext install location specified does not match the verity_location of the server config: {1} for a non-standby index. Non-standby indexes must use the verity_location of the server config.',
    'DM_FT_INDEX_E_NO_FULLTEXT_CONFIG_FOUND': 'A fulltext configuration was not found for the specified {0} install location. Please specify a valid fulltext install location. (Valid install locations are defined in the fulltext_install_locs attribute of the docbase config object.)',
    'DM_FT_INDEX_E_BAD_LOCALE_SPECIFIED': 'The {0} locale specified was not found in the fulltext configuration pointed by the {1} fulltext install location. Please specify a valid locale. (Valid locales are identified in the dmfulltext.ini file, located $DOCUMENTUM/verity/<fulltext install location name> directory.',
    'DM_FT_INDEX_E_BAD_CODEPAGE_SPECIFIED': 'The {0} codepage specified is not valid for the {1} locale. Please specify codepage {2} for this locale.',
    'DM_FT_INDEX_E_BAD_INDEX_TYPE_SPECIFIED': 'The specified index_type {0} does not match the index_type of the fulltext configuration used by this index. Set the index_type to {1} to match the fulltext configuration used.',
    'DM_FT_INDEX_E_INTERNAL_DATABASE_ERROR': 'A database error occured during the following operation: {0}. Database error was {1}.',
    'DM_FT_INDEX_E_INTERNAL_LOGIC_ERROR': 'An internal error occured during the following operation: {0}.',
    'DM_FT_INDEX_E_NOT_STANDBY': 'Operation {0} requires a standby index.  Index {1} is not standby',
    'DM_FT_INDEX_E_VERITY_LOC_CHANGED': 'Not able to {0} the fulltext index. The verity_location value of the server config ({1}) does not match the install location of the fulltext library currently loaded ({2}) in the server.',
    'DM_FT_INDEX_E_NO_FULLTEXT_CONFIG_FOR_INDEX': 'Not able to {0} the fulltext index. There is no fulltext configuration loaded for this fulltext index\'s {1} install_loc.',
    'DM_FT_INDEX_E_INVALID_OPTIMIZATION_FLAG': 'The {0} optimization flag is not valid.',
    'DM_FT_INDEX_E_CANT_CREATE_FTINDEX_OBJECT_IN_NONSTANDBY_MODE': 'Cannot create \'{0}\' dm_fulltext_object with is_standby set to FALSE, because dm_fulltext_index object with is_standby set to FALSE already exists.',
    'DM_FT_INDEX_E_INVALID_FULLTEXT_ENGINE_ID': '\'{0}\' is not a valid dm_ftengine_config object id',
    'DM_FT_INDEX_E_NO_FULLTEXT_IMPLEMENTATION_LOADED2': 'A fulltext library was not identified in the server config object. Please identify a valid fulltext installation in the fulltext_location attribute of the server config object.',
    'DM_FT_INDEX_E_UNABLE_TO_FETCH_FTENGINE_CONFIG_TYPE': 'Unable to fetch \'{0}\' type',
    'DM_FT_INDEX_E_UNABLE_TO_GET_ATTR_POSITION': 'Unable to find \'{0}\' attribute in type \'{1}\'',
    'DM_FT_INDEX_E_UNABLE_TO_GENERATE_LOGIN_TICKET': 'Unable to generate a login ticket to start Index Agent {0}',
    'DM_FT_INDEX_E_UNABLE_TO_FETCH_FTINDEX_AGENT_CONFIG_TYPE': 'Unable to fetch \'{0}\' type',
    'DM_FT_INDEX_E_CANT_UPDATE_ATTRIBUTE': 'Attribute {0} cannot be changed for dm_fulltext_index object {1}',
    'DM_FT_INDEX_E_NO_FTINDEX_AGENT_CONFIG_OBJECTS_FOUND': 'There were no dm_ftindex_agent_config object(s) found for the specified arguments',
    'DM_FT_INDEX_E_NO_FULLTEXT_PLUGIN_LOADED': 'The fulltext query plugin did not initialize with the fulltext search engine \'{0}\' specified in the server config object. Please ensure that the search engine is functioning and is configured correctly.',
    'DM_FT_INDEX_E_NO_FTINDEX_PLUGIN': 'Cannot find fulltext index plugin library.',
    'DM_FT_INDEX_F_UPGRADE_SYSOBJECT_400_PART1_FAILED': 'Fulltext index sysobject upgrade failed on the type {0}.',
    'DM_FT_INDEX_F_UPGRADE_SYSOBJECT_400_PART2_FAILED': 'Part 2 of fulltext index sysobject upgrade failed',
    'DM_FT_INDEX_F_UPGRADE_400_TYPE_DESTROY_FAILED': 'The {0} type could not be destroyed during upgrade.',
    'DM_FT_INDEX_F_UPDATE_R_IS_PUBLIC_FAILED': 'Fulltext index sysobject upgrade failed on the type {0} when updating r_is_public field.',
    'DM_FT_INDEX_F_UPGRADE53_REMOVE_INDEX_OBJECT_FAILED': 'Unable to expunge dm_fulltext_index object with id {0}',
    'DM_FT_INDEX_F_UPGRADE53_BEGIN_TRANS_FAILED': 'Unable to begin transaction for upgrading fulltext types',
    'DM_FT_INDEX_F_UPGRADE53_COMMIT_TRANS_FAILED': 'Unable to commit the operations for fulltext upgrade',
    'DM_FT_INDEX_F_UPGRADE53_UNABLE_TO_DROP_OBSOLETE_ATTRIBUTE': 'Unable to drop attribute {0} from dm_fulltext_index type',
    'DM_FT_INDEX_F_UPGRADE53_UNABLE_TO_ADD_ATTRIBUTE': 'Unable to add attribute {0} to the dm_fulltext_index type',
    'DM_FT_INDEX_F_UPGRADE53_UNABLE_TO_GET_TEMP_CONNECTION': 'Unable to get temporary connection to the database to perform upgrade operations',
    'DM_FT_INDEX_F_FULLTEXT_ENGINE_INIT_ERROR': 'Query Plugin failed to successfully initialize: {0}',
    'DM_FULLTEXT_T_FULLTEXT_QUERY': 'Fulltext Query: {0}.',
    'DM_FULLTEXT_T_NUM_CHILDREN': 'GetFTResults:  Number of children of the rootnode of the docview: {0}.',
    'DM_FULLTEXT_T_NUM_MATCHES': 'RunFTQuery:  Number of documents matched by the fulltext query was {0}.',
    'DM_FULLTEXT_T_NUM_POSITIONS': 'GetFTResults:  Number of positions (hits within a document): {0}.',
    'DM_FULLTEXT_T_BEGIN_VERITY_RETRIEVAL': 'Verity retrieval is beginning.',
    'DM_FULLTEXT_T_VERITY_RETRIEVAL_COMPLETE': 'Verity retrieval has completed.',
    'DM_FULLTEXT_T_FTDQL_DATA': 'FTDQL Execution. ft_convertible = {0}, converted_ft_query = {1}, search phrase = {2}, ft_search_type = {3}',
    'DM_FULLTEXT_T_QUERY_PLUGIN_VERSION': 'Loaded FT Query Plugin: {0}',
    'DM_FULLTEXT_W_BAD_CONTENT_ID': 'Bad content id ({0}) at child node {1}.',
    'DM_FULLTEXT_W_IGNORED': 'Could not read {0} files during hit processing -- content ignored',
    'DM_FULLTEXT_W_INDEX_IGNORED': 'Fulltext index {0} not accessible -- index ignored',
    'DM_FULLTEXT_W_VERITY_WARN': 'A message is generated from Verity: ({0}) code = {1}, text = {2}',
    'DM_FULLTEXT_W_BAD_SYSOBJ_ID': 'Bad sysobj id ({0}) at child node {1}.',
    'DM_FULLTEXT_E_VERITY_RETRIEVE': 'An error has occurred during the processing of the Verity query: {0}',
    'DM_FULLTEXT_E_VERITY_NOT_AVAILABLE': 'You have specified a SEARCH clause in your query, but no fulltext system is available.',
    'DM_FULLTEXT_E_CANT_MAKE_TOPIC_INDEX': 'You have tried to create a Topic index on location {0}.',
    'DM_FULLTEXT_E_MAKE_UNKNOWN_INDEX_TYPE': 'You tried to create an unknown fulltext type, {0}, object on location {1}.',
    'DM_FULLTEXT_E_CANT_FETCH_TOPIC_INDEX': 'You have tried to fetch a Topic index with ID {0}.',
    'DM_FULLTEXT_E_FETCH_UNKNOWN_INDEX_TYPE': 'You tried to fetch an unknown fulltext type, {0}, object with ID {1}.',
    'DM_FULLTEXT_E_STRING_MALFORMED': 'Attempt to assign malformed value of encoding {0} to attribute {1}.',
    'DM_FULLTEXT_E_COULD_NOT_OPEN_FILE_FOR_WRITE': ' The file- {0} could not be opened for writing',
    'DM_FULLTEXT_E_INCORRECT_STORE_TYPE_FOR_RENDITION': 'Primary Content object \'{0}\' uses a CA Store but the indexable rendition object \'{1}\' uses a non-CA storage type.',
    'DM_FULLTEXT_E_INCORRECT_STORE_TYPE_FOR_RENDITION2': 'Primary Content Object \'{0}\' uses CA Store \'{1}\', whereas the indexable rendition \'{2}\' uses CA Store \'{3}\'',
    'DM_FULLTEXT_E_FTDQL_UNABLE_TO_EXECUTE_FULLTEXT_QUERY': 'Unable to execute the full text query in FTDQL Mode.',
    'DM_FULLTEXT_E_FTDQL_PERMIT_CHECK_FAIL': 'Unable to run the permit check on a result set.',
    'DM_FULLTEXT_E_FTDQL_UNABLE_TO_EXECUTE_QUERY_FOR_SELECT_LIST': 'Unable to execute a database query to fetch data for select list for a FTDQL compliant query',
    'DM_FULLTEXT_E_FTDQL_OBJECT_MERGE_FAIL': 'Unable to process fulltext results for a FTDQL compliant query.',
    'DM_FULLTEXT_E_FTDQL_UNABLE_TO_FETCH_SELECT_LIST_DATA': 'A database error occured while processing the select list for a FTDQL compliant query',
    'DM_FULLTEXT_E_FTDQL_UNABLE_TO_FETCH_USER_GROUP_LIST': 'Unable to obtain user group list',
    'DM_FULLTEXT_E_FTDQL_UNABLE_TO_BUILD_ACL_LIST': 'Unable to build ACL list',
    'DM_FULLTEXT_E_FTDQL_UNABLE_TO_EXECUTE_SQL_FOR_ACL_CHECK': 'Unable to execute SQL to perform ACL check. SQL Statement was: {0}, Error from database: {1}',
    'DM_FULLTEXT_E_FTDQL_DUPLICATE_ITEM_IN_ACL_CACHE': 'Unable to add an duplicate item to ACL cache',
    'DM_FULLTEXT_E_CANT_OPEN_SESSION': 'Unable to open a session with fulltext engine: {0}, Error Code: {1}',
    'DM_FULLTEXT_E_SEARCH_NEW_FAIL': 'dmFTSearchNew failed with error: {0}, error code: {1}',
    'DM_FULLTEXT_E_SEARCH_STATUS_FAIL': 'dmFTSearchStatus failed with error: {0}, error code: {1}',
    'DM_FULLTEXT_E_HIGHLIGHT_READ_FAIL': 'dmFTHighlightRead failed with error: {0}, error code: {1}',
    'DM_FULLTEXT_E_SEARCH_GET_ROW_FAIL': 'dmFTSearchGetRow failed with error: {0}, error code: {1}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_GENERAL_ERROR': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_QUERY_PARSE_ERROR': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_SEARCH_PARTITIONS_UNAVAILABLE': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_INTERNAL_ERROR': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_SYSTEM_OVERLOAD': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_FEATURE_NOT_IMPLEMENTED': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_QUERY_NOT_ALLOWED': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_NO_QUERY_STATE': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_NO_SEARCH_CHANNEL': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_INVALID_QUERY_STATE': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_UNABLE_TO_SEND_QUERY': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_QUERY_TIMEOUT': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_INVALID_QUERY_RESPONSE': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_CONNECTION_FAILURE_DURING_SEARCH': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_UNABLE_TO_SEND_DOC_SUMMARY_REQUEST': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_FETCH_DOC_SUMMARY_TIMEOUT': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_CONNECTION_ERROR_DURING_DOC_SUMMARY_FETCH': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_INVALID_RESPONSE_FOR_DOC_SUMMARY': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_UNABLE_TO_STORE_DOC_SUMMARY': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_MEMORY_ALLOCATION_FAILURE': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_PARTIAL_SEARCH_RESULT': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_QUERY_RESOURCE_LIMIT_EXCEEDED': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_QUERY_WILDCARD_TERM_COUNT_THRESHOLD_EXCEEDED': '{0}',
    'DM_FULLTEXT_E_SEARCH_FT_ENGINE_QUERY_SERVER_GENERIC_ERROR_CODE': '{0}',
    'DM_FULLTEXT_E_BAD_SDC_PHRASE': '{0}',
    'DM_FULLTEXT_E_EXEC_XQUERY_FAIL': 'EXEC_XQUERY failed with error: {0}, error code: {1}',
    'DM_FULLTEXT_E_FEATURE_NOT_AVAILABLE': 'Feature {0} is not available.',
    'DM_FULLTEXT_E_BAD_PULLER_HANDLE': 'Cannot find puller with handle: {0}d.',
    'DM_FULLTEXT_E_BAD_XQUERY_STREAM': 'Invalid xquery result stream: 0{0}p.',
    'DM_FULLTEXT_E_FTDQL_INVALID_SECURITY_MODE': 'Invalid value for security_mode in dm_ftengine_config object. The valid options are BROWSE,READ or SUMMARY_BASED',
    'DM_FULLTEXT_F_BAD_CONTENT': 'The content id retrieved from Verity is an invalid Documentum dmID value: {0}.',
    'DM_FULLTEXT_F_DATABASE_ERROR': 'An unexpected database error has occurred (\'{0}\'), causing your statement to fail.',
    'DM_FULLTEXT_F_VERITY_ENV': 'Unable to initialize the Verity API environment.',
    'DM_FULLTEXT_F_VERITY_DOCV': 'Unable to create a Verity document view.',
    'DM_FULLTEXT_F_VERITY_FATAL': 'A fatal error has been encountered in Verity: ({0}) code = {1}, text = {2}',
    'DM_FULLTEXT_F_VERITY_UNEXPECTED': 'An unexpected Verity error, error code = {0}, has been encountered during:  {1}, {2}',
    'DM_FULLTEXT_F_ZERO_CHILDREN': 'An internal inconsistency has been encountered.',
    'DM_FULLTEXT_F_NO_DBCONN': 'Unable to establish a database connection.',
    'DM_FULLTEXT_F_NO_FULLTEXT': 'Unable to create a fulltext object.',
    'DM_FULLTEXT_F_FTDQL_INIT_QUERY_DATA_FAIL': 'Failed to initialize the data structures for FTDQL. Reason: {0}',
    'DM_FULLTEXT_F_FTDQL_OBJECT_MERGE_FAIL': 'Unable to perform object merge',
    'DM_GROUP_W_UPGRADE_I_POSITION': 'Could not upgrade the i_position attribute.  Database error was: {0}',
    'DM_GROUP_W_LENGTH_WIDEN_FAILED': 'The upgrade failed on widening group\'s attribute ({0}) length from {1} to {2}.',
    'DM_GROUP_W_': '',
    'DM_GROUP_W_NO_CYCLES_IN_GROUPS': 'Two groups cannot be contained in each other: Group {0} forms a cycle with group {1}.',
    'DM_GROUP_E_ADD_AS_GROUP': ' Group {0} cannot be added as users.',
    'DM_GROUP_E_CANT_ADD_GROUP_TWICE': 'Cannot add group {0} to the {1} group more than once.',
    'DM_GROUP_E_CANT_ADD_USER_TWICE': 'Cannot add user {0} to the {1} group more than once.',
    'DM_GROUP_E_CANT_FETCH_INVALID_ID': 'Cannot fetch a group - Invalid object ID {0}.',
    'DM_GROUP_E_CANT_FIND_GROUP': 'Cannot find {0} group.',
    'DM_GROUP_E_CANT_FIND_USER': 'Cannot find user {0}.',
    'DM_GROUP_E_CANT_CREATE_EXISTING_GROUP': 'Cannot create the {0} group since it already exists.',
    'DM_GROUP_E_DROP_NONMEMBER_USER': 'Cannot drop a non-member user {0} from the {1} group.',
    'DM_GROUP_E_DROP_NONMEMBER_GROUP': 'Cannot drop non-member {0} group from the {1} group.',
    'DM_GROUP_E_INSUFFICIENT_PRIVILEGE': 'The current user ({0}) has insufficient privileges to save or destroy the {1} group object.',
    'DM_GROUP_E_NEED_NAME_OR_EMAIL': 'Need to specify name and eMail for a group before save.',
    'DM_GROUP_E_NO_CYCLES_IN_GROUPS': 'Two groups cannot be contained in each other: Group {0} forms a cycle with group {1}.',
    'DM_GROUP_E_CANT_SAVE': 'Cannot save {0} group',
    'DM_GROUP_E_CANT_DESTROY': 'Cannot destroy the {0} group',
    'DM_GROUP_E_CANT_CHANGE_NAME': 'Cannot change name of the {0} group.',
    'DM_GROUP_E_INSUFFICIENT_PRIV_OWNER': 'Cannot change the owner name of the {0} group.',
    'DM_GROUP_E_UNABLE_TO_SAVE': 'An error occurred during a save operation on the {0} group.',
    'DM_GROUP_E_CANT_ADD_GROUP_TO_USER': 'Cannot add group \'{0}\' to the users_names of \'{1}\' group.',
    'DM_GROUP_E_ATTR_PRIV': 'Insufficient privilege to set the {0} attribute of group {1}.',
    'DM_GROUP_E_INSUFFICIENT_PRIV_ADMIN': 'Cannot change the group administrator of the {0} group.',
    'DM_GROUP_E_MISSING_PARAMETERS': 'You must supply parameters to the apply method ({0})',
    'DM_GROUP_E_CANT_GET_ROLES': 'The ROLES_FOR_USER method failed because of the following: \'{0}\'.',
    'DM_GROUP_E_UNABLE_TO_SAVE_EXISTING': 'Cannot save group {0} because a user already exists with the same name',
    'DM_GROUP_E_CANT_UNREGISTER': 'Could not unregister the specified {0} event for {1} object.',
    'DM_GROUP_E_DUPLICATE_DISPLAY_NAME': 'Cannot save group {0} because its display name (\'{1}\') and native room id (\'{2}\') together is not unique',
    'DM_GROUP_E_DIR_MAPPED_ATTR_CHANGED': 'Cannot save the directory group {0} because at least one directory-mapped attribute (\'{1}\') has been changed',
    'DM_GROUP_E_ILLEGAL_DIR_ID': 'Cannot save a directory group {0} because its group_directory_id (\'{1}\') is illegal',
    'DM_GROUP_E_NEED_SU_OR_SYS_PRIV': 'The current user ({0}) needs to have superuser or sysadmin privilege.',
    'DM_GROUP_E_NEED_SUPER_USER_PRIV': 'The current user ({0}) needs to have superuser privilege to save the group object.',
    'DM_GROUP_E_GETINFO': 'Error getting information for group {0}.',
    'DM_GROUP_E_GETINFO_DB': 'Error processing database cursor for group {0}. ({1})',
    'DM_GROUP_E_DYNAMIC_SUBGROUP': 'Cannot add dynamic group {0} as a subgroup of a regular group.',
    'DM_GROUP_E_CANT_CHANGE_DYNAMIC': 'Cannot change group {0} to be a dynamic group while it is contained in other groups.',
    'DM_GROUP_E_PROCESS_GROUP_QUERY': 'Error executing query to discover group membership for user {0}.',
    'DM_GROUP_E_NOT_DYNAMIC_MEMBER': 'User is not a potential dynamic member of group {0}.',
    'DM_GROUP_E_DEFAULT_DYNAMIC_SETTING': 'Default dynamic group \'{0}\' can not be protected nor module only.',
    'DM_GROUP_E_DEFAULT_NONDYNAMIC': 'Non-dynamic group \'{0}\' can not be set to default dynamic mode.',
    'DM_GROUP_E_INTERNAL_DEFAULT_DYNAMIC': 'Default dynamic group \'{0}\' can not be added to the session dynamic group list.',
    'DM_GROUP_E_MODULE_ROLE_STATEFUL_REQUEST': 'Module Role cannot be added through AddDynamicGroup interface.  A call was made to add a role ({0}) to the session in a stateful mode. This is not allowed when the is_module_only attribute is set.',
    'DM_GROUP_E_PROTECTED_ROLE_UNKNOWN_CLIENT': 'The requested role ({0}) is marked protected and the requesting application was either not known in this docbase\'s dm_client_rights table or its credentials did not match those in the dm_client_rights table.',
    'DM_GROUP_E_PROTECTED_ROLE_PRIV': 'The requesting application is not privileged to use role ({0}).',
    'DM_GROUP_E_ERROR_UPDATING_SUBGROUPS': 'Error updating subgroups of group {0} to reflect changes in the group heirarchy.',
    'DM_GROUP_E_NONDYN_SUPERGROUP_QUERY': 'Error querying for nondynamic_supergroups of the parent groups of the group named {0}. Query: {1}',
    'DM_GROUP_E_GROUP_YET_TO_BE_RENAMED': 'A job request to rename group (\'{0}\') is in progress or in pipeline to be processed.',
    'DM_GROUP_E_CANT_ADD_INACTIVE_USER_TO_GROUP': 'The inactive user \'{0}\' can not be added to group \'{1}\' unless the session user \'{2}\' is the owner of the group or sysadmin',
    'DM_GROUP_F_INIT1': 'The dm_group type was found in the database without a version stamp.',
    'DM_GROUP_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_GROUP_F_INIT3': 'The type manager returned an error storing the dm_group type.',
    'DM_GROUP_F_INT1': 'The following database query {0} could not be executed.',
    'DM_GROUP_F_INIT4': 'The dm_group type could not be converted {0}.',
    'DM_GROUP_F_UPGRADE_NONDYN': 'Unable to upgrade the i_nondyn_supergroups_names attributes.',
    'DM_IDITR_T_SQL_ITER_PROGRESS': 'Large database update {0} percent done.',
    'DM_IDITR_T_SQL_ITER_DONE': 'Large database update complete.',
    'DM_IDITR_E_CURSOR': 'The cursor \'{0}\' fails. The error message from the database server is',
    'DM_IDITR_E_': '',
    'DM_IDITR_F_SQL_ITER_FETCH_FAILED': 'Fetch failed during large database update; database error message was \'{0}\'.',
    'DM_IDITR_F_SQL_ITER_ACCESS_FAILED': 'Cursor access failed during large database update; database error message was \'{0}\'.',
    'DM_IDITR_F_SQL_ITER_UPDATE_FAILED': 'Update failed during large database update; database error message was \'{0}\'.',
    'DM_INBOX_W_NO_ROWS': 'No results were returned from the GetEvents statement.',
    'DM_INBOX_W_EVENT_LOC': 'Unable to validate or create the event log location as specified using directory ({0}).  Operating System Error: ({1})',
    'DM_INBOX_W_PINIT10': 'Error dropping the table {0}',
    'DM_INBOX_W_EVENT_NOLOC': 'The server events location is currently undefined.  There is no location object for the events area ({0}).',
    'DM_INBOX_W_LENGTH_WIDEN_FAILED': 'The upgrade failed on widening inbox\'s attribute ({0}) length from {1} to {2}.',
    'DM_INBOX_W_': '',
    'DM_INBOX_E_CANT_GETEVENTS1': 'GetEvents failed because of the following: \'{0}\'.',
    'DM_INBOX_E_CANT_FIND_OBJ': 'Could not find the object to queue the event \'{0}\' for id {1}',
    'DM_INBOX_E_ONLY_SYSADMIN_SU': 'Only a sysadmin or super user can perform {0} operation on {1} inbox item.',
    'DM_INBOX_E_INIT4': 'Unable to validate or create the event log location as specified using directory ({0}).  Operating System Error: ({1})',
    'DM_INBOX_E_NOEVENTS': 'An error was encountered initializing the server shared Events area which prevents registering inbox events to any session clients.',
    'DM_INBOX_E_EVENT_FILE_CREATE': 'Error creating the event notification file ({0}) used to indicate to a session that an inbox event has occurred.  Operating system error ({1}).',
    'DM_INBOX_E_CANT_GETINBOX': 'GET_INBOX failed because of the following: \'{0}\'.',
    'DM_INBOX_E_QUERY_EXECUTION_FAILURE': 'The dmi_queue_item object upgrade encountered an error while trying to execute the following query: {0}. Database error was {1}.',
    'DM_INBOX_E_FAILED_TO_GENERATE_RANDOM_BYTES': 'Failed to generated random bytes.',
    'DM_INBOX_F_INIT1': 'The dmi_queue_item type was found in the database without a version stamp.',
    'DM_INBOX_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_INBOX_F_INIT3': 'The type manager returned an error storing the dmi_queue_item type.',
    'DM_INBOX_F_INIT4': 'Unable to validate or create the event log location as specified using directory ({0}). This error message is obsolete (see TroyO)',
    'DM_INBOX_F_INIT5': 'Failure to create view {0}: database error was: {1}',
    'DM_INBOX_F_INIT6': 'The dmi_queue_item type could not be converted {0}.',
    'DM_INBOX_F_INIT7': 'The dmi_queue_item type could not be altered.',
    'DM_INBOX_F_INIT8': 'The dmi_queue_item type could not be converted to version {0}.',
    'DM_INBOX_F_INT1': 'The following database query {0} could not be executed.',
    'DM_INBOX_F_PINIT4': 'Could not remove the registry type',
    'DM_INBOX_F_PINIT5': 'Could not create the new registry type',
    'DM_INBOX_F_PINIT6': 'Could not access the registry data',
    'DM_INBOX_F_PINIT7': 'Could not save the new registry entry',
    'DM_INBOX_F_PINIT8': 'Error creating the temporary registry table',
    'DM_INBOX_F_PINIT9': 'Error renaming the table {0} to {1}',
    'DM_INFO_W_OWNED': 'Database password file {0} should be owned by the dmdba user not {1}.',
    'DM_INFO_W_READIT': 'Database file {0} is readable by others.',
    'DM_INFO_E_NOFMT': 'Cannot find format {0}.',
    'DM_INFO_E_BADPATH': 'The path, {0} (for {1}), is not a valid pathname.',
    'DM_INFO_E_NOPATH': 'There is no pathname defined for location {0}.',
    'DM_INFO_E_INVALID_PATH': 'The path, {0} (for {1}), is not a valid pathname: Operating System Error: ({2}).',
    'DM_INFO_F_NODB': 'Cannot find docbase {0}.',
    'DM_INFO_F_NODBUSER': 'Cannot find database user for your docbase.',
    'DM_INFO_F_DBFILE': 'Could not find database file for database user {0}.',
    'DM_INFO_F_OWNERSHIP': 'Database password file {0} should be owned by the dmdba user not {1}.',
    'DM_INFO_F_READABLE': 'Database file {0} is readable by others.',
    'DM_INFO_F_OPENDBFILE': 'Cannot open database file {0}.',
    'DM_INFO_F_OPENINFO': 'Cannot open system information file {0}.',
    'DM_INFO_F_OPENERM': 'Cannot open error message file {0}. Terminating...',
    'DM_INTERNAL_I_ERROR_LIST_OVERFLOW': 'Error list has overflowed: beyond {0} messages. See server log for remaining messages.',
    'DM_INTERNAL_E_INVALID_FACILITY': 'Invalid Facility from error ({0})\n',
    'DM_INTERNAL_E_INVALID_ERROR_NO': 'Invalid Error no from error ({0})\n',
    'DM_LICENSE_E_SQL_EXEC': 'Execution of the SQL failed with error: {0}.',
    'DM_LICENSE_E_NOT_GLOBAL_REGISTRY': 'Operation only allowed in Global Registry',
    'DM_LICENSE_E_INVALID_ARGUMENT': 'One of the arguments to the CHECKOUT_LICENSE call is NULL or an empty string.',
    'DM_LOAD_I_PROGRESS': 'For load object {0} in phase {1}, processed {2} of {3} objects; last object processed was {4}',
    'DM_LOAD_I_PHASE_1_COMPLETE': 'Phase 1 of loading finished for load object {0}',
    'DM_LOAD_I_PHASE_2_COMPLETE': 'Phase 2 of loading finished for load object {0}',
    'DM_LOAD_I_MERGE_1': 'Number of objects merged={0}d, total time={1}f ms, avg time={2}f ms',
    'DM_LOAD_I_MERGE_2': 'Merging object ID={0}',
    'DM_LOAD_I_LOAD_TYPE': 'Loading type: {0}',
    'DM_LOAD_I_LOAD_OBJ': 'Loading object: {0}, old object id: {1}',
    'DM_LOAD_I_SYNONYM': 'Synonym {0} found.',
    'DM_LOAD_I_BUILD_OBJ': 'Object being loaded -- version in dumpfile ({0}d) is current or later than version in docbase ({1}d).',
    'DM_LOAD_I_SKIP_OBJ': 'Object skipped -- version in dumpfile ({0}d) older than version in docbase ({1}d).',
    'DM_LOAD_I_TYPE_CREATE': 'Creating type {0}.',
    'DM_LOAD_I_TYPE_MATCH': 'Type {0} matches definition in docbase.',
    'DM_LOAD_I_TYPE_SKIP': 'Type {0} mismatches definition in docbase. Skipping type.',
    'DM_LOAD_I_SKIP_LOCAL': 'Object skipped -- object in dumpfile is replica of a local object ({0}).',
    'DM_LOAD_I_UNMAPPED_OBJ': 'Local object {0} contains a foreign id pointer ({1}).  Object being refreshed from the dumpfile copy to ensure consistency.',
    'DM_LOAD_W_UPDATE_STATISTICS': 'Failed to update statistics. {0}',
    'DM_LOAD_W_UNFORCEPLAN_FAILED': 'Could not turn off FORCEPLAN. {0}',
    'DM_LOAD_W_FORCEPLAN_FAILED': 'Could not turn on FORCEPLAN. {0}',
    'DM_LOAD_W_INCOMPLETE_LOAD': 'Loading of object {0} failed to finish properly -- some attributes may be incorrect',
    'DM_LOAD_W_FOREIGN_ID': 'The load operation specifies a dumpfile that contains objects ({0}) foreign to the source docbase ({1}). The object will be ignored.',
    'DM_LOAD_W_OBJECT_NOT_LOADED': 'Object {0} could not be loaded.  The load operation is proceeding without loading it.',
    'DM_LOAD_W_GROUP_NOT_LOADED': 'The load operation could not load group object with name ({0}) as a user with same name exist. Skiping this object. This may cause inconsistencies in group references.',
    'DM_LOAD_E_RECORD_SAVE_FAILED': 'Save of load record for object {0} failed -- load terminated',
    'DM_LOAD_E_OBJECT_UPDATE_FAILED': 'Update of dump object {0} failed -- load terminated',
    'DM_LOAD_E_OLDER_VERSION': 'Object with {0} not updated -- version in dumpfile older than version in docbase',
    'DM_LOAD_E_CANT_OPEN_FILE': 'Could not open input dumpfile {0}',
    'DM_LOAD_E_IDS_OUT_OF_RANGE': 'Ids in dumpfile extend beyond docbase range for tag {0}',
    'DM_LOAD_E_VERSION_TOO_OLD': 'Version stamp for type {0} in dumpfile is too old -- \n is {1}; should be at least {2}',
    'DM_LOAD_E_TYPE_CREATION_FAILED': 'Could not create type {0} in docbase',
    'DM_LOAD_E_STORE_NOT_FOUND': 'Could not find storage object with name {0} in docbase.  The docbase being loaded must have a synonym for each storage object referenced in the load file.',
    'DM_LOAD_E_OBJECT_SAVE_FAILED': 'Save of object {0} failed -- load terminated',
    'DM_LOAD_E_TYPE_DEF_NOTFOUND': 'Error during Load operation - definition for type {0} not found in the loadfile type cache.',
    'DM_LOAD_E_RELOCATE_PREDICATE': 'Request error.  The \'type\' and \'predicate\' fields which subset the load operation may only be used on a non-relocate load (the \'relocate\' field must be False).',
    'DM_LOAD_E_DESTROY_LOAD_RECORD': 'An error occurred during cleanup from a Load as part of a destroy request on the dm_load_record object.  The load operation bookkeeping records (dmi_load_object_record) have not been fully cleaned up.',
    'DM_LOAD_E_REVERT_ERROR': 'An error occurred during the rollback of a load operation.  The loaded objects were not all successfully removed.  Please remedy the indicated problem and restart the REVERT operation.',
    'DM_LOAD_E_CHECKPOINT_ERROR': 'An error occurred attempting to commit the work completed so far during a load operation.  Either the outstanding transaction could not be committed or a new transaction could not be started.',
    'DM_LOAD_E_OPEN_TRANSACTION': 'The Load operation cannot be executed while inside of a user transaction.',
    'DM_LOAD_E_PHASE2_INCOMPLETE': 'Error in Phase 2. No rows returned from dmi_load_object_record indicating no work to do to complete the load, but the load object count ({0}) indicates that there should have been. Check database temp table space.',
    'DM_LOAD_E_OBJECT_DBID_MISMATCH': 'Error executing non-relocate Load operation.  Cannot load object with id ({0}) because it was dumped from a different docbase than the one being loaded.  The docbase id in the object_id does not match.',
    'DM_LOAD_E_NOT_SUPERUSER': 'The load operation cannot be executed because the requesting user ({0}) does not have superuser privilege.  Superuser privilege is required to load objects into a docbase.',
    'DM_LOAD_E_CANT_REPLICATE': 'The load operation specifies a dumpfile that was created on a foreign docbase (docbase id {0}).  Use of the non-relocate flag with foreign dumpfiles should be used in the context of Replication operations only.',
    'DM_LOAD_E_MISSING_PARAMETER': 'The load_parameter ({0}) is missing',
    'DM_LOAD_E_CANT_CREATE_REF': 'Failed to create a dm_reference object during load operation. The id of the object from the dump file is ({0}).',
    'DM_LOAD_E_BAD_STREAM': 'An error occur during formating of information.',
    'DM_LOAD_E_FILE_IO': 'File Input / Output error. Operating System Error: {0}',
    'DM_LOAD_E_FILE_SIZE_MISMATCH': 'The actual file size {0} does not match the size recorded {1} .',
    'DM_LOAD_E_CORRUPTION': 'Unreasonable Object / Type size: {0} (bytes).  Possible corruption of dump file.',
    'DM_LOAD_E_INIT_LOAD': 'Version stamp {0} was expected to be {1}',
    'DM_LOAD_E_LOAD_RECORD_LOOKUP': 'Error looking up dmi_load_object_record for id {0}.',
    'DM_LOAD_E_NO_DMREF_OBJ': 'Object {0} fetched during load operation indicates it is a {1} but the server could find not corresponding dm_reference object.',
    'DM_LOAD_E_PHASE2_INCOMPLETE2': 'Error in Phase 2.An error occurred during processing of this object. Load Order No ({0}), Old Id ({1}), New Id ({2}), old_exists ({3}), update_done ({4}).',
    'DM_LOAD_E_IGNORE_CHECK_ERROR': 'Error checking if object {0} should be loaded or skipped.',
    'DM_LOCALE_W_DEFAULT_DATE_WIN': 'Unable to get local date format from Windows environment. Reason code {0}.',
    'DM_LOCALE_W_DEFAULT_DATE_MAC': 'Unable to get local date format from Macintosh environment. Reason code {0}.',
    'DM_LOCALE_W_DEFAULT_DATE_SYSV': 'Unable to get local date format from your Unix environment. Reason code {0}.',
    'DM_LOCALE_W_ILLEGAL_DATE_FORMAT': 'Illegal syntax found in the date format \'{0}\'. The default localized short date format will be used.',
    'DM_LOCALE_E_MEMORY_EXHAUSTED': 'Memory exhausted allocating {0} bytes.',
    'DM_LOCALE_E_UNKNOWN_CHAR_SET': 'Unknown character set, ordinal ={0}.',
    'DM_LOCALE_E_UNABLE_TO_MODIFY_OS_LOCAL': 'Unable to modify the locale using the following API call: ({0}).',
    'DM_LOCALE_E_SERVER_FAILURE': 'An failed status was returned by the server during processing of your client locale.  Please check the server log for details.',
    'DM_LOCALE_E_UNKNOWN_CODEPAGE_NAME': 'Unknown codepage \'{0}\'',
    'DM_LOCALE_E_UNKNOWN_LOCALE_NAME': 'Unknown locale name \'{0}\'',
    'DM_LOCALE_F_UNEXPECTED_OS_FAILURE': 'An error was returned from the Operating System API ({0}) and was unexpected.  Operating System Error: ({1}).',
    'DM_LOCATION_W_RENAME_CURRENTLY_IN_USED': 'The dm_location object {0} ({1}) to be renamed to ({2}) is currently being used by a dm_filestore object.  Please make sure the root attribute value of the affected dm_filestore object is also renamed accordingly.',
    'DM_LOCATION_E_CANT_FETCH': 'Can\'t fetch, object identified by id ({0}). Invalid id.',
    'DM_LOCATION_E_MEMORY_EXHAUSTED': 'Memory exhausted allocating {0} bytes',
    'DM_LOCATION_E_CANT_DESTROY': 'Cannot destroy',
    'DM_LOCATION_E_SAVE_REQUIRES_ATTRIBUTE': 'Cannot save object due to empty attribute ({0})',
    'DM_LOCATION_E_NOT_A_LOCATION': 'The object identified by ({0}) is not a dm_location.',
    'DM_LOCATION_E_INVALID_DESTROY_OPTION': 'The destroy option ({0}) is not a valid option.',
    'DM_LOCATION_E_VALIDATE': 'Validation of DM_LOCATION ({0}) failed.  Operating System failed to validate directory ({1}).  Operating System error was ({2})',
    'DM_LOCATION_E_FILE_EXISTENCE': 'File System file specified in DM_LOCATION ({0}) does not exist.  Operating System failed to validate existence of the file ({1}).  Operating System error was ({2})',
    'DM_LOCATION_E_DIRECTORY_EXISTENCE': 'File System directory specified in DM_LOCATION ({0}) is does not exist.  Operating System failed to validate existence of the directory ({1}).  Operating System error was ({2})',
    'DM_LOCATION_E_CREATE_DIRECTORY': 'Creation of file system directory for DM_LOCATION ({0}) failed.  Operating System failed to create directory ({1}).  Operating System error was ({2})',
    'DM_LOCATION_E_DESTROY': 'Destroy with delete option of DM_LOCATION ({0}) failed.  Operating System failed to delete directory ({1}).  Operating System error was ({2})',
    'DM_LOCATION_E_SAVE': 'Save of DM_LOCATION ({0}) failed.',
    'DM_LOCATION_E_INVALID_MOUNT_POINT': 'Unable to get file system path for location ({0})\n, because of failure accessing associated\ndm_mount_point ({1}).',
    'DM_LOCATION_E_ATTRIBUTE_UNKNOWN': 'Save of DM_LOCATION ({0}) failed due to unrecognized value in attribute ({1}).  Value is ({2})',
    'DM_LOCATION_E_NAMED_LOOKUP': 'Unable to fetch the dmLocation named ({0}) by name.',
    'DM_LOCATION_E_NEED_PRIV_FOR_CHANGE': 'The current user ({0}) needs to have superuser or sysadmin privilege to save or destroy {1} location object.',
    'DM_LOCATION_E_FULL_PATH_REQUIRED': 'The attribute, file_system_path, must be a full path name when the attribute mount_point_name is not specifie.  file_system_path is currently: {0}.',
    'DM_LOCATION_E_NON_UNIQUE_PATH': 'The attribute, file_system_path, must be unique among all existing dm_location objects.  Path = ({0}).  Matching dm_location id = ({1}).',
    'DM_LOCATION_E_UNIQUE_CHECK': 'An error occurred attempting to validate the file_system_path attribute of a dm_location object.',
    'DM_LOCATION_E_WALK_DIRECTORY': 'Failed to access directory {0}, OS error: {1}',
    'DM_LOCATION_E_RESETPERM_MAXERR': 'Failed to reset permission on path {0} of location {1}',
    'DM_LOCATION_E_NON_UNIQUE_PATH_AND_MOUNT_POINT': 'The attributes, mount_point and file_system_path must be unique among all existing dm_location objects.{0} is using same mount point and file_system_path.',
    'DM_LOCATION_E_CANNOT_DESTROY_CURRENTLY_IN_USED': 'The dm_location object {0} ({1}) can not be destroyed because it is currently being used by a dm_filestore object',
    'DM_LOCATION_F_INIT1': 'The dm_location object subsystem failed initialization.  The version stamp for the dm_location object exists, but the corresponding type could not be fetched.',
    'DM_LOCATION_F_INIT2': 'The dm_location object subsystem could not be initialized.  The version stamp for the dm_location type ({0}) does not match the expected stamp ({1}).',
    'DM_LOCATION_F_INIT3': 'The dm_location object subsystem could not be initialized.  A failure was detected attempting to store the dm_location type.',
    'DM_LOCATION_F_COPY_DIRECTORY': 'Sorry, the save operator is not implemented at this time',
    'DM_LOCATION_F_MOVE_DIRECTORY': 'Sorry, the save operator is not implemented at this time',
    'DM_METHOD_I_JMS_DISABLED': 'Connect to the Java Method Server ({0}) failed, therefore it is marked DEAD.',
    'DM_METHOD_I_NO_JMS_AVAILABLE': 'No Java Method Server available to serve the request.',
    'DM_METHOD_W_ASSUME_USER_LOCATION': 'The method named ({0}) was executed on the server\'s behalf even though run_as_server was set to FALSE.   The dm_server_config attribute assume_user_location has not been defined.',
    'DM_METHOD_W_RETURNTO_START_DIR': 'Prior to launch of method named ({0}) the attempt to change directory to start-up directory ({1}) failed.  Operating System error: {2}.',
    'DM_METHOD_W_WEBCACHE_WARN': 'The webcache publish operation completed with warnings.',
    'DM_METHOD_E_CANT_FETCH_INVALID_ID': 'Cannot fetch a dm_method - Invalid object ID {0}',
    'DM_METHOD_E_CANT_SAVE': 'Cannot save {0} dm_method object.',
    'DM_METHOD_E_NEED_VERB': 'The verb for {0} dm_method object must be specified.',
    'DM_METHOD_E_INVALID_TIMEOUTR': 'The {0} = {1} must be less than or equal to the {2} = {3} for {4} dm_method object.',
    'DM_METHOD_E_INVALID_TIMEOUTP': 'The {0} value is = {1}, must be a positive number for {2} dm_method object.',
    'DM_METHOD_E_NEED_PRIV_FOR_CHANGE': 'The current user ({0}) needs to have superuser or sysadmin privilege to save or destroy {1} dm_method object.',
    'DM_METHOD_E_INCOMPAT_OPTIONS_1': 'The dm_method apply option RUN_AS_SERVER = F is only allowed if LAUNCH_DIRECT equals F.',
    'DM_METHOD_E_UNKNOWN_METHOD': 'The dm_method named ({0}) is not defined.  Please check the name of the method.',
    'DM_METHOD_E_VERB_NOT_DEFINED': 'The dm_method named ({0}) does not have a verb defined',
    'DM_METHOD_E_NO_FOLDER': 'Unable to find the default folder named ({0}) to store your resulting document.  This error occurred while processing the dm_method named ({1}).',
    'DM_METHOD_E_TEMP_CREATE': 'Failure attempting to create document to store save results during the processing of the dm_method ({0}).',
    'DM_METHOD_E_FILE_ACCESS': 'Unable to access file ({0}) used to save results.  Operating System Error: ({1}).  This occurred during the processing of the dm_method ({2}).',
    'DM_METHOD_E_SEND_PARAM': 'Error message not implemented',
    'DM_METHOD_E_ASSUME_USER_FILE': 'Unable to verify existence of program file for assume_user during processing of the dm_method named ({0}).  Program file : ({1}).  Operating System Error : ({2}).',
    'DM_METHOD_E_ASSUME_USER_FAIL': 'Your method failed to run due to an error during communication with the assume_user process.  Error: ({0}).',
    'DM_METHOD_E_ASSUME_USER_UV': 'Your method named ({0}) failed to execute because the assume user process could not validation your user credentials.  Assume User Process returned ({1}={2}).',
    'DM_METHOD_E_ASSUME_USER_UE': 'Your method named ({0}) failed to execute because the assume user process was unable to satisfy the request.  Assume User Process returned ({1}={2}).',
    'DM_METHOD_E_ASSUME_USER_SE': 'Your method named ({0}) failed to execute because the assume user process encountered an error processing the method.  Assume User Process returned ({1}={2}).',
    'DM_METHOD_E_NO_CONTENT': 'Your method name ({0}) has no content to launch.',
    'DM_METHOD_E_BAD_CONTENT': 'Your method name ({0})  content could not be fetched.',
    'DM_METHOD_E_BAD_CONTENT1': 'Your method name ({0})  content could not be fetched.',
    'DM_METHOD_E_ASSUME_USER_LE': 'Your method named ({0}) failed to execute because the assume user process was unable to launch.',
    'DM_METHOD_E_ASSUME_USER_OS': 'Your method named ({0}) could not be executed because the assume user feature is not supported in the current OS platform.',
    'DM_METHOD_E_NEED_PRIV_TO_RUN': 'The current user ({0}) does not have enough privilege to run {1} dm_method object.',
    'DM_METHOD_E_WEBCACHE_NOTFOUND': 'The requested dm_webc_config object ({0}) does not exist or is not accessible by the current user.',
    'DM_METHOD_E_WEBCACHE_ILLEGAL': 'Invalid argument to webcache publish method: {0}.',
    'DM_METHOD_E_WEBCACHE_CNF_OWNER': 'The webcache publish method must specify a superuser-owned dm_webc_config object.',
    'DM_METHOD_E_WEBCACHE_FAILED': 'The requested webcache publish operation was not successful.',
    'DM_METHOD_E_WEBCACHE_UNKNOWN': 'The requested webcache publish returned an unknown status.',
    'DM_METHOD_E_CHECK_SECURITY_INVALID_ARGUMENT': 'Invalid value for argument: {0}.',
    'DM_METHOD_E_CHECK_SECURITY_ILLEGAL_USER': 'The session user does not have super user privileges: {0}.',
    'DM_METHOD_E_HTTP_POST_APP_SERVER_NAME_NOTFOUND': 'The app_server_name was not specified.',
    'DM_METHOD_E_HTTP_POST_APP_SERVER_NAME_INVALID': 'The app_server_name \'{0}\' was not specified in dm_server_config.',
    'DM_METHOD_E_HTTP_POST_APP_SERVER_URI_INVALID': 'The app_server_uri used was not a valid uri: {0}.',
    'DM_METHOD_E_HTTP_POST_INVALID_SAVE_RESPONSE': 'The save_response field must be 0, 1, or -1 instead of: {0}.',
    'DM_METHOD_E_HTTP_POST_NO_FOLDER': 'Unable to find the default folder named ({0}) to store the HTTP response.',
    'DM_METHOD_E_HTTP_POST_TEMP_CREATE': 'Failure attempting to create document to store saved HTTP response.',
    'DM_METHOD_E_HTTP_POST_FILE_ACCESS': 'Unable to access file ({0}) used to save response. Operating system error ({1}).',
    'DM_METHOD_E_HTTP_COMMUNICATION': '{0}',
    'DM_METHOD_E_HTTP_POST_FAILED': 'Failed to send HTTP Post to app_server_uri:{0} Error:{1}',
    'DM_METHOD_E_HTTP_POST_ILLEGAL_APP_SERVER_NAME': 'The app_server_name \'{0}\' is reserved for DO_METHOD.',
    'DM_METHOD_E_RUN_AS_SERVER': 'The dm_method must have RUN_AS_SERVER set to TRUE.',
    'DM_METHOD_E_APP_SERVER_NAME_NOTFOUND': 'The app_server_name \'{0}\' is not specified in dm_server_config.',
    'DM_METHOD_E_INVALID_MTHD_VERB': 'The dm_method named ({0}) of type dmbasic has invalid method_verb ({1}).',
    'DM_METHOD_E_CACHECONFIG_NOMATCH': 'No dm_cache_config object exists with the name {0}.',
    'DM_METHOD_E_CACHECONFIG_CHECK': 'The CHECK_CACHE_CONFIG call for the config object {0} ({1}) failed.',
    'DM_METHOD_E_CACHECONFIG_PRIV': 'The user {0} does not have privilege to force a recheck of the cache config object {1}.  Execute privilege is required for this operation.',
    'DM_METHOD_E_CACHECONFIG_MTHD': 'Failure to execute the server method {0}.',
    'DM_METHOD_E_CACHECONFIG_REFRESH': 'Failure to refresh the cache config object {0}.',
    'DM_METHOD_E_MISSING_ARG': 'The method \'{0}\' is missing argument for \'{1}\'.',
    'DM_METHOD_E_CACHECONFIG_OWNER': 'Cache config object {0} is owned by a non-superuser: {1}.  Config objects must be owned by a valid superuser.',
    'DM_METHOD_E_HTTP_POST_INSUFFICIENT_PRIVILEGES': 'The user {0} must have at least sysadmin privileges to execute HTTP_POST.',
    'DM_METHOD_E_JMS_APP_SERVER_NAME_NOTFOUND': 'The app_server_name/servlet_name \'{0}\' is not specified in dm_server_config/dm_jms_config.',
    'DM_METHOD_E_NO_JMS_AVAILABLE2': 'No Java Method Server available to serve the request.',
    'DM_METHOD_E_METHOD_ARGS_TOO_LONG': 'The arguments being passed to the method \'{0}\' are too long to fit in the internal server buffer.',
    'DM_METHOD_E_METHOD_ARGS_INVALID': 'The arguments being passed to the method \'{0}\' are invalid: {1}.',
    'DM_METHOD_F_INIT1': 'The dmMethod type was found in the database without a version stamp.',
    'DM_METHOD_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_METHOD_F_INIT3': 'The type manager returned an error storing the dmMethod type.',
    'DM_MIGRATE_LIGHT_W_ADD_FT_ATTR': 'Could not add fulltext index support to type {0}.',
    'DM_MIGRATE_LIGHT_E_SHARED_PARENT_REQUIRED': 'SHARED_PARENT_TYPE is a required parameter.',
    'DM_MIGRATE_LIGHT_E_NO_INSTRINSIC': 'SHARED_PARENT_TYPE {0} cannot be an intrinsic type.',
    'DM_MIGRATE_LIGHT_E_NOT_SYSOBJ': 'SHARED_PARENT_TYPE {0} is not a subtype of dm_sysobject.',
    'DM_MIGRATE_LIGHT_E_LIGHTWEIGHT_REQUIRED': 'LIGHTWEIGHT_TYPE is required when SHARED_PARENT_TYPE is a sharable type.',
    'DM_MIGRATE_LIGHT_E_ALREADY_LIGHTWEIGHT': 'Migration type ({0}) is already a lightweight type.',
    'DM_MIGRATE_LIGHT_E_SHAREABLE': 'LIGHTWEIGHT_TYPE ({0}) cannot be a shareable type.',
    'DM_MIGRATE_LIGHT_E_DIRECT_SUBTYPE': 'Type {0} is not a direct subtype of {1}.',
    'DM_MIGRATE_LIGHT_E_SQL_HEADER': 'Failed to generate SQL header for migration.',
    'DM_MIGRATE_LIGHT_E_SQL_TRAILER': 'Failed to generate SQL trailer for migration.',
    'DM_MIGRATE_LIGHT_E_SQL_CANCEL': 'Failed to generate SQL to cancel migration.',
    'DM_MIGRATE_LIGHT_E_CANCEL': 'Execution of SQL to cancel migration failed with error: {0}.',
    'DM_MIGRATE_LIGHT_E_SQL_SHARED': 'Failed to generate SQL to create interim shared parent type {0}',
    'DM_MIGRATE_LIGHT_E_SQL_LIGHT': 'Failed to generate SQL to create interim lightweight child type {0}',
    'DM_MIGRATE_LIGHT_E_DQL_EXEC': 'Execution of DQL to create {0} failed.',
    'DM_MIGRATE_LIGHT_E_SQL_EXEC': 'Execution of the SQL failed with error: {0}.',
    'DM_MIGRATE_LIGHT_E_SQL_FINALIZE': 'Failed to generate the SQL to finalize the type {0}.',
    'DM_MIGRATE_LIGHT_E_NOT_LIGHT': 'Interim type {0} is not lightweight.',
    'DM_MIGRATE_LIGHT_E_BAD_DEFAULT_ID': 'DEFAULT_PARENT_ID {0} is invalid.',
    'DM_MIGRATE_LIGHT_E_BAD_PARENT_ID': 'object {0} is already sharing type {1}.',
    'DM_MIGRATE_LIGHT_E_BAD_PARENT_CHILD': 'object {0} is materialized object of type {1}.',
    'DM_MIGRATE_LIGHT_E_NO_PARENT_ID': '{0} is not an object of type {1}.',
    'DM_MIGRATE_LIGHT_E_TYPES_REQUIRED': 'the specified rpc requires SHARED_PARENT_TYPE and LIGHTWEIGHT_TYPE to be specified',
    'DM_MIGRATE_LIGHT_E_PARAMETER_REQUIRED_WHEN_SPLIT': 'The parameter ({0}) is a required parameter when the execution_mode is either \'Split and Finalize\' or \'Split without Finalize\'.',
    'DM_MIGRATE_LIGHT_E_NO_SYSOBJECT': 'SOURCE_TYPE {0} cannot be \'dm_sysobject\'.',
    'DM_MIGRATE_LIGHT_E_SHARED_PARENT_CANNOT_EXIST': 'The type ({0}) specified in SHARED_PARENT_TYPE can not be an existent type when splitting a type.',
    'DM_MIGRATE_LIGHT_E_WRONG_SHARED_PARENT_IN_RECOVERY_MODE': 'The type ({0}) specified in SHARED_PARENT_TYPE is not the right shareable parent type of type ({1}).',
    'DM_MIGRATE_LIGHT_E_INTERIM_TYPE_CANNOT_EXIST': 'The interim type ({0}) can not be an existent type before migration unless under recovery mode.',
    'DM_MIGRATE_LIGHT_E_ILLEGAL_ATTRIBUTE': 'You have specified an invalid attribute name ({0}) for type ({1}).',
    'DM_MIGRATE_LIGHT_E_NOT_PARENT_TYPE': 'object {0} is not of type {1}',
    'DM_MIGRATE_LIGHT_E_CANNOT_FINALIZE': 'Cannot Finalize type {0}. Try EXECUTION_MODE of \'Run without Finalize\' or \'Split without Finalize\' first',
    'DM_MIGRATE_LIGHT_E_REP_CHILD_ATTRS_WRONG_CNT': 'Either the number of values in parameter REPLACE_ORIG_CHILD_ATTRS ({0}) is different than that in REPLACE_WITH_CHILD_ATTRS ({1}) or they exceed the limit ({2}).',
    'DM_MIGRATE_LIGHT_E_REP_CHILD_ATTRS_WRONG_ORIG_ATTR': 'The attribute {0} specified in REPLACE_ORIG_CHILD_ATTRS is not allowed.',
    'DM_MIGRATE_LIGHT_E_REP_CHILD_ATTRS_WRONG_WITH_ATTR': 'The attribute {0} specified in REPLACE_WITH_CHILD_ATTRS needs to be a direct attribute of type {1}.',
    'DM_MQ_I_DAEMON_START': 'Message queue daemon ({0} : {1}, session {2}) is started sucessfully.',
    'DM_MQ_W_EXEC_POOL_FULL': 'Failed to launch {0} because the execution context pool is full.',
    'DM_MQ_E_SQL_EXEC': 'Execution of SQL statement({0}) in function {1} failed with error: {2}.',
    'DM_MQ_E_SQL_FETCH': 'Fetch failed during executing SQL statement({0}) in function {1} with error: {2}.',
    'DM_MQ_E_CONFIG_NOT_EXIST': 'Message queue configuration object ({0}) does not exist.',
    'DM_MQ_E_CONFIG_NOT_VALID': 'Message config object ({0}) is invalid.',
    'DM_MQ_E_MAKE_TYPE': 'Creating type in function ({0}) failed with error: {1}.',
    'DM_MQ_E_MESSAGE_NOT_EXIST': 'Message object ({0}) does not exist.',
    'DM_MQ_E_MESSAGE_NOT_VALID': 'Message object ({0}) is invalid.',
    'DM_MQ_E_MESSAGE_NOT_ACQUIRED': 'Attempt to acknowledge message object ({0}) that is not not in acquired state.',
    'DM_MQ_E_MESSAGE_ACK_USER': 'User ({0}) attempt to acknowledge message object ({1}) that was acquied by user ({2}).',
    'DM_MQ_E_MESSAGE_DELETE': 'Delete message object ({0}) failed in function ({1}).',
    'DM_MQ_E_MESSAGE_SAVE': 'Save message object ({0}) failed in function ({1}).',
    'DM_MQ_E_CANNOT_BROWSE': 'User ({0}) has no permission to browse messages in queue ({1}).',
    'DM_MQ_E_CANNOT_CONSUME': 'User ({0}) has no permission to consume messages from queue ({1}).',
    'DM_MQ_E_CANNOT_PURGE': 'User ({0}) has no permission to purge messages from queue ({1}). Only the queue owner, sysadmin, or superuser can purge messages from the queue.',
    'DM_MQ_E_CREATE_DAEMON_CONTEXT': 'Creating execution context for message queue daemon failed.',
    'DM_MQ_E_DAEMON_LAUNCH': 'Failed to launch {0} due to operating system error: {1}.',
    'DM_MTPT_E_CANT_FETCH': 'Can\'t fetch, object identified by id ({0}). Invalid id.',
    'DM_MTPT_E_CANT_DESTROY': 'Cannot destroy',
    'DM_MTPT_E_SAVE_REQUIRES_ATTRIBUTE': 'Cannot save object due to empty attribute ({0})',
    'DM_MTPT_E_NOT_A_MOUNTPOINT': 'The object identified by ({0}) is not a dm_mount_point.',
    'DM_MTPT_E_INVALID_DESTROY_OPTION': 'The destroy option ({0}) is not a valid option.',
    'DM_MTPT_E_VALIDATE': 'Validation of DM_MOUNT_POINT ({0}) failed.  Operating System failed to validate directory ({1}).  Operating System error was ({2})',
    'DM_MTPT_E_FILE_EXISTENCE': 'File System file specified in DM_MOUNT_POINT ({0}) is does not exist.  Operating System failed to validate existence of the file ({1}).  Operating System error was ({2})',
    'DM_MTPT_E_DIRECTORY_EXISTENCE': 'File System directory specified in DM_MOUNT_POINT ({0}) is does not exist.  Operating System failed to validate existence of the directory ({1}).  Operating System error was ({2})',
    'DM_MTPT_E_CREATE_DIRECTORY': 'Creation of file system directory for DM_MOUNT_POINT ({0}) failed.  Operating System failed to create directory ({1}).  Operating System error was ({2})',
    'DM_MTPT_E_DESTROY': 'Destroy with delete option of DM_MOUNT_POINT ({0}) failed.  Operating System failed to delete directory ({1}).  Operating System error was ({2})',
    'DM_MTPT_E_SAVE': 'Save of DM_MOUNT_POINT ({0}) failed.',
    'DM_MTPT_E_ATTRIBUTE_UNKNOWN': 'Save of DM_MOUNT_POINT ({0}) failed due to unrecognized value in attribute ({1}).  Value is ({2})',
    'DM_MTPT_E_NAMED_LOOKUP': 'Unable to fetch the dm_mount_point named ({0}) by name.',
    'DM_MTPT_E_NEED_PRIV_FOR_CHANGE': 'The current user ({0}) needs to have superuser or sysadmin privilege to save or destroy {1} dm_mount_point object.',
    'DM_MTPT_E_NO_ALIAS_FOR_WINDOWS': 'The dm_mount_point object named ({0}) does not have a alias for the Windows platform',
    'DM_MTPT_E_NO_ALIAS_FOR_UNIX': 'The dm_mount_point object named ({0}) does not have a alias for the UNIX platform',
    'DM_MTPT_E_NO_ALIAS_FOR_MAC': 'The dm_mount_point object named ({0}) does not have a alias for the Macintosh platform',
    'DM_MTPT_E_REFERENCES_EXIST': 'The dm_mount_point object named ({0}) can not be destroyed because there are ({1}) dm_location objects referencing it',
    'DM_MTPT_E_NON_UNIQUE_HOST_NAME_AND_MOUNT_POINT': 'The dm_mount_point object named({0}) has non unique combination of host name ({1}) and file_system_path ({2}). {3} is using same host_name and file_system_path',
    'DM_MTPT_F_INIT1': 'The dm_mount_point object subsystem failed initialization.  The version stamp for the dm_mount_point object exists, but the corresponding type could not be fetched.',
    'DM_MTPT_F_INIT2': 'The dm_mount_point object subsystem could not be initialized.  The version stamp for the dm_mount_point type ({0}) does not match the expected stamp ({1}).',
    'DM_MTPT_F_INIT3': 'The dm_mount_point object subsystem could not be initialized.  A failure was detected attempting to store the dm_mount_point type.',
    'DM_NOTE_E_CANT_FETCH_INVALID_ID': 'Cannot fetch a note - Invalid object ID {0}',
    'DM_NOTE_E_CANT_SAVE': 'Cannot save {0} sysobject.',
    'DM_NOTE_E_NO_ANNOTATION': 'No annotation relationship exists between {0} note and {1} sysobject.',
    'DM_NOTE_E_ALREADY_ANNOTATED': 'The {0} Sysobject is already annotated by {1} note object.',
    'DM_NOTE_E_CANT_ADDNOTE1': 'Can not relate {0} sysobject to {1} note object.',
    'DM_NOTE_E_CANT_ADDNOTE2': 'Can not relate {0} sysobject to {1} note object.',
    'DM_NOTE_E_CANT_CLEAN_UNUSED': 'Could not complete the cleanup of unused note objects for {0} docbase.',
    'DM_NOTE_F_INIT1': 'The dmNote type was found in the database without a version stamp.',
    'DM_NOTE_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_NOTE_F_INIT3': 'The type manager returned an error storing the dmNote type.',
    'DM_OBJECT_W_SET_ATTR_TYPE_MISMATCH': 'attempt to assign value of wrong type to attribute {0}',
    'DM_OBJECT_W_SET_ATTR_KIND_MISMATCH': 'attempt to set to non-zero position in single-valued attribute {0}',
    'DM_OBJECT_W_SET_ATTR_LENGTH_MISMATCH': 'attempt to set attribute {0} beyond current length',
    'DM_OBJECT_W_SET_ATTR_STRING_LENGTH': 'attempt to assign string of excessive length to attribute {0}',
    'DM_OBJECT_W_APPEND_ATTR_TYPE_MISMATCH': 'attempt to append value of wrong type to attribute {0}',
    'DM_OBJECT_W_INSERT_ATTR_TYPE_MISMATCH': 'attempt to insert value of wrong type in attribute {0}',
    'DM_OBJECT_W_INSERT_ATTR_LEN_MISMATCH': 'attempt to insert value beyond current length of attribute {0}',
    'DM_OBJECT_W_INSERT_ATTR_NAME_ERROR': 'attempt to insert into non-existent attribute {0}',
    'DM_OBJECT_W_DELETE_ATTR_LEN_MISMATCH': 'attempt to delete non-existing item in attribute {0}',
    'DM_OBJECT_W_GET_ATTR_TYPE_MISMATCH': 'attempt to read value of wrong type from attribute {0}',
    'DM_OBJECT_W_GET_ATTR_NAME_ERROR': 'attempt to get non-existent attribute {0}',
    'DM_OBJECT_W_GET_ATTR_KIND_ERROR': 'attempt to fetch from non-zero position in single-valued attribute {0}',
    'DM_OBJECT_W_SET_ATTR_POSITION_ERROR': 'attempt to set non-existent attribute {0}',
    'DM_OBJECT_W_SET_ATTR_TYPE_ERROR': 'attempt to assign value of wrong type to attribute {0}',
    'DM_OBJECT_W_SET_ATTR_LENGTH_ERROR': 'attempt to set non-existent attribute value of attribute {0}',
    'DM_OBJECT_W_SET_ATTR_STRING_TOO_LONG': 'attempt to assign string of excessive length to attribute {0}',
    'DM_OBJECT_W_APPEND_ATTR_POSITION_ERROR': 'attempt to append to non-existent attribute {0}',
    'DM_OBJECT_W_APPEND_ATTR_TYPE_ERROR': 'attempt to append value of wrong type to attribute {0}',
    'DM_OBJECT_W_APPEND_ATTR_KIND_ERROR': 'attempt to append to non-repeating attribute {0}',
    'DM_OBJECT_W_APPEND_ATTR_STRING_LENGTH_ERROR': 'attempt to append string of excessive length to attribute {0}',
    'DM_OBJECT_W_INSERT_ATTR_POSITION_ERROR': 'attempt to insert in non-existent attribute {0}',
    'DM_OBJECT_W_INSERT_ATTR_KIND_ERROR': 'attempt to insert into non-repeating attribute {0}',
    'DM_OBJECT_W_INSERT_ATTR_LEN_ERROR': 'attempt to insert at invalid position {0} in attribute {1}',
    'DM_OBJECT_W_ADD_ATTR_DUPLICATE_ERROR': 'attempt to add duplicate attribute {0}',
    'DM_OBJECT_W_DELETE_ATTR_POSITION_ERROR': 'attempt to delete non-existent attribute {0}',
    'DM_OBJECT_W_DELETE_ATTR_LEN_ERROR': 'attempt to delete at non-existent position {0} in attribute {1}',
    'DM_OBJECT_W_DELETE_ATTR_NAME_ERROR': 'attempt to delete non-existent attribute {0}',
    'DM_OBJECT_W_DROP_ATTR_POSITION_ERROR': 'attempt to drop value from non-existent attribute {0}',
    'DM_OBJECT_W_DROP_ATTR_LENGTH_ERROR': 'attempt to drop non-existent value from attribute {0}',
    'DM_OBJECT_W_DROP_ATTR_NAME_ERROR': 'attempt to drop value from non-existent attribute {0}',
    'DM_OBJECT_W_GET_ATTR_POSITION_ERROR': 'attempt to fetch non-existent attribute {0}',
    'DM_OBJECT_W_GET_ATTR_TYPE_ERROR': 'attempt to read value of wrong type from attribute {0}',
    'DM_OBJECT_W_GET_ATTR_LENGTH_ERROR': 'attempt to read from non-existent position {0} in attribute {1}, type {2}',
    'DM_OBJECT_W_SET_TYPE_WITH_NULL_TYPE': 'attempt to set type of persistent object with NULL type',
    'DM_OBJECT_W_FIND_ATTR_NAME_ERROR': 'attempt to find value in non-existent attribute {0}',
    'DM_OBJECT_W_SET_ATTR_BY_NAME_LENGTH_MISMATCH': 'attempt to set attribute {0} beyond current length',
    'DM_OBJECT_W_SET_ATTR_TYPE_ERROR_NAME': 'attempt to assign value of wrong type to attribute {0} (name {1})',
    'DM_OBJECT_W_APPEND_ATTR_TYPE_ERROR_NAME': 'attempt to append value of wrong type to attribute {0} (name {1})',
    'DM_OBJECT_W_GET_ATTR_TYPE_ERROR_NAME': 'attempt to read value of wrong type from attribute {0} (name {1})',
    'DM_OBJECT_W_SET_ATTR_STRING_MALFORMED_NAME': 'attempt to assign malformed value of encoding {0} to attribute {1} (name {2}).  Value:{3}',
    'DM_OBJECT_W_TYPE_VERSION_MISMATCH': 'wrong type version for object of type {0}; object has version {1}, but server type has version {2}',
    'DM_OBJECT_E_LOAD_KEYWORD_ERROR': 'error loading object -- stream should begin with OBJ',
    'DM_OBJECT_E_LOAD_TYPE_ERROR': 'error loading object -- can\'t find type {0}',
    'DM_OBJECT_E_LOAD_COUNT_ERROR': 'error loading object -- wrong object count for object of type {0}; found {1} attributes, but type says there should be {2}',
    'DM_OBJECT_E_FETCH_FAILURE': 'error fetching object attributes',
    'DM_OBJECT_E_OBJECT_TOO_BIG': 'attempt to return object that exceeds the network buffer size',
    'DM_OBJECT_E_BAD_DD_HANDLE': 'Could not parse Data Dictionary handle for type {0}.  Error code = {1}.',
    'DM_OBJECT_E_COULD_NOT_FETCH_DD_OBJECT': 'Could not fetch the Data Dictionary object for type {0}.',
    'DM_OBJECT_E_BAD_DD_ATTR_HANDLE': 'Could not parse Data Dictionary handle for type {0}, attribute {1}.  Error code = {2}.',
    'DM_OBJECT_E_COULD_NOT_FETCH_DD_ATTR_OBJECT': 'Could not fetch the Data Dictionary object for type {0}, attribute {1}.',
    'DM_OBJECT_E_LOAD_TYPE_VERSION_ERROR': 'error loading object -- wrong type version for object of type {0}; loaded object has version {1}, but current type has version {2}',
    'DM_OBJECT_E_OBJECT_ID_LOOKUP': 'Error looking up object \'{0}\'.',
    'DM_OBJECT_E_INVALID_TYPE': 'Invalid type \'{0}\' for object \'{1}\'.',
    'DM_OBJECT_E_LOAD_INVALID_STRING_LEN': 'Error loading object: invalid string length {0} found in input stream',
    'DM_OBJECT_E_LOAD_MEMORY_EXHAUSTED': 'Error loading object: failed to allocate {0} bytes',
    'DM_OUTPUTDEVICE_W_SUB1': 'An error occurred attempting to transform and save the content rendition in postscript.',
    'DM_OUTPUTDEVICE_W_ACTION_UNSUPPORTED': 'The specified action \'{0}\' is not supported on this platform \'{1}\'.',
    'DM_OUTPUTDEVICE_E_UNEXPECTEDERROR': 'Unexpected Error.',
    'DM_OUTPUTDEVICE_E_SAVE1': 'This Output Device\'s operating system device name has not been set.',
    'DM_OUTPUTDEVICE_E_APPLY1': 'ApplyForInt unexpectedly returned invalid.',
    'DM_OUTPUTDEVICE_E_APPLY2': 'ApplyForString unexpectedly returned invalid.',
    'DM_OUTPUTDEVICE_E_APPLY3': 'Apply(SEARCH) unexpectedly returned NULL.',
    'DM_OUTPUTDEVICE_E_INIT1': 'The dmOutputDevice type was found in the database without a version stamp.',
    'DM_OUTPUTDEVICE_E_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_OUTPUTDEVICE_E_INIT3': 'The type manager returned an error storing the dmOutputDevice type.',
    'DM_OUTPUTDEVICE_E_INIT4': 'The dm_outputdevice type cannot be stored because the dm_sysobject type could not be fetched from the database.',
    'DM_OUTPUTDEVICE_E_PCLOSE': 'An unexpected system error {0} occurred during pclose.',
    'DM_OUTPUTDEVICE_E_SCANF1': 'Internal error.  The lp subsystem returned a string that sscanf was not expecting. String:{0}',
    'DM_OUTPUTDEVICE_E_NOOSNAME': 'The output device {0} was not found in the system.',
    'DM_OUTPUTDEVICE_E_REMOVE': 'A system error {0} was encountered while attempting to remove the temporary print file {1}.',
    'DM_OUTPUTDEVICE_E_NEED_PRIV_FOR_CHANGE': 'The current user ({0}) needs to have superuser or sysadmin privilege to save or destroy {1} server_config object.',
    'DM_OUTPUTDEVICE_E_NONEXISTENT': 'Outputdevice with {0} object_name does not exist.',
    'DM_OUTPUTDEVICE_E_OS_ERROR': 'An error was returned by the operating system during the processing of the request.  OS API: {0} returned error: {1}',
    'DM_OUTPUTDEVICE_E_OPEN_PRINTER': 'Unable to open the output device due to error: {0}.  The command used was: ({1})',
    'DM_OUTPUTDEVICE_E_ASSUME_USER_PF': 'Unable to access the assume user program file.  Error returned from Operating System: ({0}).  Program file: ({1}).',
    'DM_OUTPUTDEVICE_E_COPY_TO_COMMON': 'Unable to complete the print request due to an error during the file copy to the common area',
    'DM_OUTPUTDEVICE_E_FETCH_FAILED': 'Unable to complete the print request due to an error fetching the content',
    'DM_OUTPUTDEVICE_E_ASSUME_USR_RET': 'Unable to complete the print request; an error was returned from the assume user process: {0}',
    'DM_OUTPUTDEVICE_E_CANT_FIND_METHOD': 'Can not find the method named : \'{0}\'.',
    'DM_OUTPUTDEVICE_E_TICKET_FAILED': 'Ticket generation failed for user \'{0}\'.',
    'DM_OUTPUTDEVICE_E_CANT_RUN_METHOD': 'The server was unable to run method \'{0}\', error return was {1}.',
    'DM_OUTPUTDEVICE_E_FORMAT_NOT_SUPPORTED': 'The document format \'{0}\' is not support.',
    'DM_VERITY_COLL_T_UPDATE_PHASEII_START': 'Begin phase 2 fulltext index update.',
    'DM_VERITY_COLL_T_UPDATE_PHASEII_END': 'End phase 2 fulltext index update.  Total successful docs: {0}, total failed: {1}.',
    'DM_VERITY_COLL_T_UPDATE_CRASH_RECOVERY_START': 'Begin update crash recovery phase.',
    'DM_VERITY_COLL_T_UPDATE_CRASH_RECOVERY_END': 'End update crash recovery phase.',
    'DM_VERITY_COLL_T_UPDATE_CRASH_RECOVERY_NORMAL': 'No evidence of previous crash found.',
    'DM_VERITY_COLL_T_UPDATE_DIR_SEARCH_START': 'Searching work directory.',
    'DM_VERITY_COLL_T_UPDATE_CRASH_BATCH_START': 'Being processing crashed batch file: epoch {0} batch {1}.',
    'DM_VERITY_COLL_T_UPDATE_BATCH_START': 'Begin Verity indexing: epoch {0} batch {1}.',
    'DM_VERITY_COLL_T_UPDATE_BATCH_END': 'End Verity indexing: successful docs: {0}, failed: {1}.',
    'DM_VERITY_COLL_T_UPDATE_BATCH_DESC': 'Batch collection dir {0}, size {1}.',
    'DM_VERITY_COLL_T_UPDATE_VERITY_INDEX_START': 'Begin Verity indexing.  Verity messages (if any) begin here.',
    'DM_VERITY_COLL_T_UPDATE_VERITY_INDEX_END': 'End Verity indexing.  Return value: {0}.',
    'DM_VERITY_COLL_T_UPDATE_DESC_FILE': 'Contents of descriptor file follow this message:',
    'DM_VERITY_COLL_T_UPDATE_VERITY_BATCH_FILE': 'Contents of Verity batch file follow this message:',
    'DM_VERITY_COLL_T_UPDATE_PHASEI_START': 'Begin phase 1 fulltext index update.',
    'DM_VERITY_COLL_T_UPDATE_PHASEI_END': 'End phase 1 fulltext index update. total good: {0} total bad: {1}.',
    'DM_VERITY_COLL_T_UPDATE_CRASH_BATCH_END': 'End processing crashed batch file: epoch {0} batch {1}.',
    'DM_VERITY_COLL_T_UPDATE_COLLECTION_START': 'Begin processing collection with object type {0} at position {1}.',
    'DM_VERITY_COLL_T_UPDATE_COLLECTION_END': 'End processing collection with object type {0} at position {1}.',
    'DM_VERITY_COLL_T_UPDATE_GET_CONTENT_START': 'Begin executing sql cursor to get pending content objects.',
    'DM_VERITY_COLL_T_UPDATE_GET_CONTENT_END': 'End executing sql cursor to get pending content objects.',
    'DM_VERITY_COLL_T_UPDATE_GET_BATCH_START': 'Begin processing batch {0} of pending contents.',
    'DM_VERITY_COLL_T_UPDATE_GET_BATCH_END': 'End processing batch {0} of pending contents.',
    'DM_VERITY_COLL_T_UPDATE_VERIFY_DOCS_START': 'Begin verifying contents in batch {0}.',
    'DM_VERITY_COLL_T_UPDATE_VERIFY_DOCS_END': 'End verifying contents in batch {0}.',
    'DM_VERITY_COLL_T_UPDATE_MAKE_BATCH_FILE_START': 'Begin making batch file for batch {0}.',
    'DM_VERITY_COLL_T_UPDATE_MAKE_BATCH_FILE_END': 'End making batch file for batch {0}.',
    'DM_VERITY_COLL_T_UPDATE_PHASEIII_START': 'Begin phase 3 (verification only) fulltext index update.',
    'DM_VERITY_COLL_T_UPDATE_PHASEIII_END': 'End phase 3 (verification only) fulltext index update. Total successful docs: {0}, total failed: {1}.',
    'DM_VERITY_COLL_T_UPDATE_CRASH_FOUND_RUNNING_BATCH': 'The UPDATE_FTINDEX method has found a running batch file (epoch={0} batch={1}) from a previous update run on fulltext index {2} and will examine if a previous failure occured. Please refer to the most recent status file in the fulltext working directory to see if any objects failed indexing from the previous run. If failed objects are reported and you wish to reindex these objects, use the MARK_FOR_RETRY method with update_count={3}.',
    'DM_VERITY_COLL_T_UPDATE_CANT_RENAME_BATCH_FILE': 'The UPDATE_FTINDEX method was unable to rename batch file {0} for fulltext index {1}. All contents in this batch will not be indexed and are marked as failed. Please refer to the most recent status file in the fulltext working directory to see the failed objects. If failed objects are reported and you wish to reindex these objects, use the MARK_FOR_RETRY method with update_count={2}.',
    'DM_VERITY_COLL_I_FTINDEX_IN_PROGRESS': 'Another fulltext operation is currently in progress on this fulltext index with epoch {0}.',
    'DM_VERITY_COLL_W_VERITY': 'verity error/warning.  message is: {0}',
    'DM_VERITY_COLL_W_BAD_CONTENT': 'Attempt to index content with id {0} failed -- Verity filter rejected content',
    'DM_VERITY_COLL_W_NO_CONTENT': 'Attempt to index content with non-existent id {0}',
    'DM_VERITY_COLL_W_CANT_CONVERT': 'Can\'t convert content {0} to format {1}',
    'DM_VERITY_COLL_W_CONTENT_OFFLINE': 'Attempt to index offline content with id {0}',
    'DM_VERITY_COLL_W_CANT_FIND_PHASE1_LOCKFILE': 'Can\'t find the lock file for update phase I.  Filename {0}.',
    'DM_VERITY_COLL_W_NO_CURRENT_STATUS_FILE_DURING_UPDATE': 'An update is in progress but there is no current status file.  The previous status file is returned.',
    'DM_VERITY_COLL_W_NO_TYPE': 'Can\'t process tdk collection because type {0} was not found.',
    'DM_VERITY_COLL_W_NO_VERITY_FILE': 'No Verity Full-Text Engine messages will be logged in the status file.',
    'DM_VERITY_COLL_W_CANNOT_PURGE_DIR': 'During crash recovery phase, attempt to purge {0} directory failed.',
    'DM_VERITY_COLL_W_NO_UPDATE_WORKDIR': 'Directory {0} does not exist. The fulltext index has probably never been updated before or does not exist.',
    'DM_VERITY_COLL_E_CANT_SET_DOC_HANDLE': 'Can\'t set the Verity document description for style {0}',
    'DM_VERITY_COLL_E_CANT_SET_PARSE_HANDLE': 'Can\'t set the Verity document parser for style {0}',
    'DM_VERITY_COLL_E_PART_UPDATE_FAIL': 'Attempt to update partition index {0} failed; trying to {1} partitions {2} and {3}',
    'DM_VERITY_COLL_E_MERGE_FAIL': 'Attempt to merge partitions {0} and {1} failed',
    'DM_VERITY_COLL_E_API_HANDLE_FAIL': 'Attempt to build Verity API handle failed.  Verity bin directory was {0}',
    'DM_VERITY_COLL_E_DOC_SET_CREATE': 'Attempt to create new Verity doc set failed while updating partition {0}',
    'DM_VERITY_COLL_E_DOC_INDEX_FAIL': 'Attempt to index new Verity doc set {0} failed while updating partition {1}',
    'DM_VERITY_COLL_E_VDB_OPEN': 'Attempt to open Verity VDB {0} failed while updating partition {1}',
    'DM_VERITY_COLL_E_VDB_UPDATE': 'Attempt to update Verity VDB {0} failed while updating partition {1}',
    'DM_VERITY_COLL_E_VDB_WRITE': 'Attempt to write Verity VDB {0} failed while updating partition {1}',
    'DM_VERITY_COLL_E_VDB_COMMIT': 'Attempt to commit changes to Verity VDB {0} failed while updating partition {1}',
    'DM_VERITY_COLL_E_CANT_MAKE_EMPTY_PARTITION': 'Can\'t build empty Verity partition with name {0}',
    'DM_VERITY_COLL_E_CANT_MAKE_ROOT': 'Can\'t build root partition copy',
    'DM_VERITY_COLL_E_NO_FILTER': 'No Verity filter for format {0}',
    'DM_VERITY_COLL_E_CANT_MAKE_FILES': 'Could not initialize Verity files for partition {0}',
    'DM_VERITY_COLL_E_BAD_CONTENT': 'Attempt to index content with id {0} failed -- Verity filter rejected content',
    'DM_VERITY_COLL_E_NO_CONTENT': 'Attempt to index content with non-existent id {0}',
    'DM_VERITY_COLL_E_CANT_CONVERT': 'Can\'t convert content {0} to format {1}',
    'DM_VERITY_COLL_E_BAD_BATCH': 'Failure attempting to index batch with format {0}',
    'DM_VERITY_COLL_E_NO_VERITY_DIR': 'Verity location directory not defined in server configuration',
    'DM_VERITY_COLL_E_EMPTY_CONTENT': 'Content object {0} has empty file identified by \'{1}\' path.',
    'DM_VERITY_COLL_E_CANT_STAT_CONTENT': 'Content object {0} identified by {1} path could not be accessed OS Error is {2}.',
    'DM_VERITY_COLL_E_TAR_FAILURE': 'Tar step failed during {0} operation -- OS error was {1}',
    'DM_VERITY_COLL_E_BAD_LOAD_FILE': 'Load failed because file {0} not found in index dump',
    'DM_VERITY_COLL_E_BAD_LOAD_HEADER': 'The verity_dump_header file had the wrong format -- load failed',
    'DM_VERITY_COLL_E_USE_FULL_PATHNAME': 'The dump file ({0}) must be specified by a full path name',
    'DM_VERITY_COLL_E_TRANSACTION_FAILURE': 'Could not {0} transaction for {1} operation',
    'DM_VERITY_COLL_E_NO_DIRECTORY': 'Directory {0} doesn\'t exist',
    'DM_VERITY_COLL_E_CANT_FETCH_PARENT': 'Error fetching dm_sysobject parent ({0}) of dmr_content object {1}; will contine to look for another valid parent.',
    'DM_VERITY_COLL_E_CANT_FETCH_CONTENT': 'Error: can\'t fetch dmr_content object {0} during fulltext index administration.',
    'DM_VERITY_COLL_E_CANT_ACCESS_CONTENT': 'The content identified by id ({0}) which references the file named ({1}) cannot be accessed.  Operating System error: {2}',
    'DM_VERITY_COLL_E_LAUNCH_FAIL': 'Failed to launch the command: {0}. Operating system error: {1}.',
    'DM_VERITY_COLL_E_WAIT_FAIL': 'Failed to wait for the command: {0}. Operating system error: {1}.',
    'DM_VERITY_COLL_E_EXEC_FAIL': 'Command execution failure: {0}. Operating system error: {1}.',
    'DM_VERITY_COLL_E_PART2_UPDATE_FAIL': 'Attempt to update partition index {0} failed; trying to {1} partition {2}.',
    'DM_VERITY_COLL_E_CANT_CHANGE_DIRECTORY': 'Failure in attempt to set working directory to {0}',
    'DM_VERITY_COLL_E_PATH_TOO_LONG': 'The directory path {0} is too long to be used by Verity',
    'DM_VERITY_COLL_E_TIMEOUT': 'Timeout after {0}d minutes attempting to index batch of size {1}d of format {2}',
    'DM_VERITY_COLL_E_CANT_OPEN_COLLECTION': 'Can\'t open collection for style {0}: Error code = {1}.',
    'DM_VERITY_COLL_E_CANT_OPEN_SESSION': 'Can\'t open Vdk Session: Error code = {0}.',
    'DM_VERITY_COLL_E_CANT_SET_COLLECTION': 'Can\'t set collection for style {0} on {1}: Error code = {2}.',
    'DM_VERITY_COLL_E_CANT_SUBMIT_BULK': 'Can\'t submit bulk update on {0} for {1}: Error code = {2}.',
    'DM_VERITY_COLL_E_CANT_SUBMIT_ADMIN_OPT': 'Can\'t submit admin optimization on {0}-th collection: Error code = {1}.',
    'DM_VERITY_COLL_E_CANT_ADD_STYLE': 'Can\'t add style files to collection due to database error: {0}. SQL statement: {1}',
    'DM_VERITY_COLL_E_CANT_FIND_TYPE_INFO': 'Can\'t determine ftindex attributes because internal type info not found for type: {0}.',
    'DM_VERITY_COLL_E_CANT_CREATE_PHASE2_LOCKFILE': 'Can\'t create the lock file for update phase II.  Filename {0}.',
    'DM_VERITY_COLL_E_CANT_ACQUIRE_PHASE2_LOCK': 'Can\'t acquire file lock for update phase II.  Filename {0}.',
    'DM_VERITY_COLL_E_BAD_PHASE2_FILENAME': 'Found badly formatted update file.  Filename {0}.',
    'DM_VERITY_COLL_E_LOST_PHASE2_FILE': 'Update file {0} has disappeared.',
    'DM_VERITY_COLL_E_BAD_DESC_FILE': 'Bad update descriptor file.  Can\'t read {0}.',
    'DM_VERITY_COLL_E_UPDATE_VERITY_INDEX_ERROR': 'Verity indexing returned error.  Code = {0}.',
    'DM_VERITY_COLL_E_VERITY_DELETE_ERROR': 'Verity index delete request returned error.  Code = {0}.',
    'DM_VERITY_COLL_E_DOC_NOT_INDEXED': 'Verity indexing failed for content {0} (key {1}).',
    'DM_VERITY_COLL_E_CANT_OPEN_COLLECTION_DIR': 'Can\'t open collection in directory {0}: Error code = {1}.',
    'DM_VERITY_COLL_E_PHASE2_TIMED_OUT': 'Phase 2 timed out after {0} seconds.  Killing it.',
    'DM_VERITY_COLL_E_CLEAR_PENDING_CANT_ACQUIRE_LOCK': 'The clear pending method can\'t acquire the file lock for modifiying the index.  Filename {0}.  Try again later.',
    'DM_VERITY_COLL_E_UPDATE_DIR_BAD': 'The update batch file is unreadable or missing.  Name: {0}.',
    'DM_VERITY_COLL_E_CANT_CREATE_UPDATE_STATUS_FILE': 'Can\'t create an update status file.  Filename {0}.',
    'DM_VERITY_COLL_E_NO_STATUS_FILES_DURING_UPDATE': 'An update seems to be in progress but there are no status files (either current or old).',
    'DM_VERITY_COLL_E_CANT_DESTROY_PHASE1_FILE': 'In update phase1, when attempting to erase file {0}, got os error:{1}',
    'DM_VERITY_COLL_E_CANT_DESTROY_PHASE2_FILE': 'In update phase2, when attempting to erase file {0}, got os error:{1}',
    'DM_VERITY_COLL_E_MKVDK_FAILURE': 'mkvdk failed -- OS error was {0}. Please check status.last file (for fulltext update operation) or status_optimize.last file (for fulltext clean operation) for more messages.',
    'DM_VERITY_COLL_E_CANT_DESTROY_LAST_STATUS_OPT_FILE': 'During cleaning, when attempting to erase file {0}, got os error:s',
    'DM_VERITY_COLL_E_FTINDEX_DEADLOCK': 'The database is in the deadlock state, so no fulltext operations will be performed. Check for errors in the server and session logs.',
    'DM_VERITY_COLL_E_FTINDEX_BAD_STATUS': 'The fulltext index object is in a bad status. Check for errors in the server and session logs.',
    'DM_VERITY_COLL_E_CANNOT_MARK_CONTENT_BAD': 'Content {0} with parent {1} failed to save after setting the update_count attr to {2}.',
    'DM_VERITY_COLL_E_COMMIT_FAILED': 'The fulltext update operation failed to commit the changes made to the database.',
    'DM_VERITY_COLL_E_COPY_ENC_STYLE_ARG_INVALID': 'Null arguments passed to function that adds decryption filters to style.uni file.',
    'DM_VERITY_COLL_E_SOURCE_STYLE_FILE_OPEN_FAILED': 'Could not open file {0} for read',
    'DM_VERITY_COLL_E_DEST_STYLE_FILE_OPEN_FAILED': 'Could not open file {0} for write',
    'DM_VERITY_COLL_E_STYLE_FILE_ERROR': 'The line {0} missing in {1}  file',
    'DM_VERITY_COLL_E_ATTRIBUTE_QUERY_FAILED': 'The query {0} to fetch indexed attribute values with batch size {1} failed. Check the server and database logs for any db errors.',
    'DM_VERITY_COLL_F_CANT_LAUNCH_UPDATE_PHASE2': 'Update phase 2 launch failed.',
    'DM_VERITY_COLL_F_DOC_CURSOR_PROBLEM': 'Problem reading document cursor.  Database: error {0}.',
    'DM_VERITY_COLL_F_STYLE_CURSOR_PROBLEM': 'Problem reading collection style cursor.  Database: error {0}.  Query: {1}',
    'DM_VERITY_COLL_F_UPDATE_SESSION_PROBLEM': 'Can\'t open vdk sessions or collections for this fulltext index.',
    'DM_VERITY_COLL_F_CANT_CREATE_PHASE1_LOCKFILE': 'Can\'t create the lock file for update phase I.  Filename {0}.',
    'DM_VERITY_COLL_F_CANT_ACQUIRE_PHASE1_LOCK': 'Can\'t acquire file lock for update phase I.  Filename {0}.',
    'DM_VERITY_COLL_F_CANT_CREATE_UPDATE_WORKDIR': 'Can\'t create an update work directory.  Filename {0}.',
    'DM_VERITY_COLL_F_CANT_FIND_UPDATE_WORKDIR': 'Can\'t find an update work directory.  Filename {0}.',
    'DM_VERITY_COLL_F_CANT_RENAME_BATCH_PREP_FILE': 'Rename of file {0} failed after {1} tries.  OS error: {2}',
    'DM_VERITY_COLL_F_CANT_CREATE_DUMMY_FILE': 'Can\'t create the dummy file for updating non-indexable or no-content sysobjects (update phase I).  Filename {0}.',
    'DM_DATA_PARTITION_W_APPLY_SCHME_MULTITIMES': 'Type or table {0} are already partitioned with scheme {1}.',
    'DM_DATA_PARTITION_W_MERGE_FIRST_PARTITION': 'The partition {0} you want to merge is the first partition in scheme object {1}.',
    'DM_DATA_PARTITION_E_UNKNOWN_OPERATION': 'Operation {0} is not recognized for GENERATE_PARTITION_SCHEME_SQL apply method.',
    'DM_DATA_PARTITION_E_INVALID_ARGUMENTS': 'You can not specify both {0} and {1} for GENERATE_PARTITION_SCHEME_SQL apply method.',
    'DM_DATA_PARTITION_E_INCORRECT_ARGUMENT': 'You cannot specify parameter {0} for operation {1} of GENERATE_PARTITION_SCHEME_SQL apply method.',
    'DM_DATA_PARTITION_E_NO_PARTITION_COLUMN_IN_REGTABLE': 'Table {0} does not have i_partition column.',
    'DM_DATA_PARTITION_E_TYPE_ALREADY_PARTITIONED': 'Type {0} is already partitioned.',
    'DM_DATA_PARTITION_E_REGTABLE_ALREADY_PARTITIONED': 'Table {0} is already partitioned.',
    'DM_DATA_PARTITION_E_TYPE_NOT_PARTITIONED': 'Type {0} is not partitioned.',
    'DM_DATA_PARTITION_E_REGTABLE_NOT_PARTITIONED': 'Table {0} is not partitioned.',
    'DM_DATA_PARTITION_E_MUST_BE_SUPERMOST_TYPE': 'Operation {0} for the GENERATE_PARTITION_SCHEME_SQL apply method can only be applied to super-most type, but type {1} is not one.',
    'DM_DATA_PARTITION_E_MISSING_TABLE_OR_TYPE': 'Operation {0} for the GENERATE_PARTITION_SCHEME_SQL apply method requires a table/type.',
    'DM_DATA_PARTITION_E_SUBTYPE_CANNT_ENABLE_PARTITION': 'You can only enable partition for a super type. Type {0} is not a super type.',
    'DM_DATA_PARTITION_E_DOCBASE_NOT_PARTITIONED': 'The docbase is not partitioned.',
    'DM_DATA_PARTITION_E_ACL_CANNOT_UPDATE_PARTITION': 'You cannot update i_partition internal attribute for external dm_acl object {0}.',
    'DM_DATA_PARTITION_E_MISSING_TABLESPACE': 'Value of TABLESPACE parameter cannot be empty for operation {0} of the GENERATE_PARTITION_SCHEME_SQL apply method.',
    'DM_DATA_PARTITION_E_ALL_PARTITIONED': 'All partitionable types are already partitioned.',
    'DM_DATA_PARTITION_E_CANT_PARTITION_TYPE_TABLE': 'Table {0} is an internal table for type {1}.',
    'DM_DATA_PARTITION_E_NO_OBJNAME_FOR_SCHEME': 'There is no object_name for the scheme object.',
    'DM_DATA_PARTITION_E_CANNOT_SET_SCHEME_OWNERNAME': 'dm_partition_scheme\'s owner_name cannot be set explicitly by you.',
    'DM_DATA_PARTITION_E_NOT_ENOUGH_PRIVILEDGE_FOR_CREATE_SCHEME': 'You do not have enough priviledge for creating dm_partition_scheme object, only SysAdmin/Superuser can do it.',
    'DM_DATA_PARTITION_E_CAN_ONLY_UPDATE_OBJECT_NAME_FOR_SCHEME': 'You can only update dm_partition_scheme object by changing its object_name.',
    'DM_DATA_PARTITION_E_SCHEME_PART_INFO_CNT_MISMATCH': 'You should provide same count of partition_up_range, partition_file_group, and partition_name.',
    'DM_DATA_PARTITION_E_SCHEME_OBJECT_HAS_UNSORTED_RANGES': 'The up ranges of dm_partition_scheme object is unsorted.',
    'DM_DATA_PARTITION_E_DUPLICATE_SCHEME_OBJECT': 'You are trying to create or update a dm_partition_scheme object with the same object_name of an existed ojbect.',
    'DM_DATA_PARTITION_E_DUPLICATE_PARTITION_NAME': 'Partition names should be unique for dm_partition_scheme object.',
    'DM_DATA_PARTITION_E_EMPTY_PARTITION_NAME': 'Partition names can not be empty.',
    'DM_DATA_PARTITION_E_NO_SCHEME': 'Partition scheme object is not found with object_name {0}.',
    'DM_DATA_PARTITION_E_NO_TYPE_AND_TABLE': 'There is no type or table arguments for DB_PARTITION process.',
    'DM_DATA_PARTITION_E_TABLE_NAME_OWNER_COUNT_MISMATCH': 'The counts of argument table_name and table_owner are not the same.',
    'DM_DATA_PARTITION_E_TYPE_ALREADY_PARTITIONED_EX': 'The type {0} is already partitioned with scheme object {1}.',
    'DM_DATA_PARTITION_E_TABLE_ALREADY_PARTITIONED': 'The table {0} is already partitioned with scheme object {1}.',
    'DM_DATA_PARTITION_E_INVALID_TABLE_NAME': 'the table name {0} is not valid',
    'DM_DATA_PARTITION_E_SCHEME_IS_NOT_VALIDATED': 'The Partition Scheme {0} is not validated',
    'DM_DATA_PARTITION_E_PARTITION_NOT_FOUND': 'The partition {0} is not found',
    'DM_DATA_PARTITION_E_PENDING_PARTITION_PROCESS': 'There is a pending off-line partition process registered with scheme object {0}, please run the generated sql script before any operation on this scheme object.',
    'DM_DATA_PARTITION_E_TYPE_NOT_FOUND': 'The type {0} is not found which is registered with partition scheme {1}.',
    'DM_DATA_PARTITION_E_ADD_PARTITION_RANGE': 'The range {0} you specified to ADD_PARTITION is smaller than the last range of the scheme object.',
    'DM_DATA_PARTITION_E_SPLIT_PARTITION_RANGE': 'The range {0} you specified to SPLIT_PARTITIOM is larger than the last range of the scheme object.',
    'DM_DATA_PARTITION_E_DELETE_PARTITION_WRONG': 'The partition {0} you want to delete is not the last partition in scheme object {1}.',
    'DM_DATA_PARTITION_E_MERGE_PARTITION_WRONG': 'The partition {0} you want to merge is not found or is the last partition in scheme object {1}.',
    'DM_DATA_PARTITION_E_EMPTY_TYPE_NAME': 'When applying DB_PARTITION to type, type name cannot be empty.',
    'DM_DATA_PARTITION_E_EMPTY_TABLE_NAME': 'When applying DB_PARTITION to registered table, table name cannot be empty.',
    'DM_DATA_PARTITION_E_MISSING_OWNER_NAME': 'When applying DB_PARTITION to registered table {0}, its owner_name is missing.',
    'DM_DATA_PARTITION_E_WRONG_ARGUMENT_COUNT': 'The counts of arguments: partition_name, range, tablespace are incorrect for operation {0}.',
    'DM_DATA_PARTITION_E_DEPRECATE_OPERATION': 'The apply method GENTERATE_PARTITION_SCHEME_SQL is deprecated, please use PARTITION_OPERATION instead.',
    'DM_DATA_PARTITION_E_MISSING_TEMP_TABLE_SUFFIX': 'Value of TEMP_TABLE_SUFFIX parameter cannot be empty.',
    'DM_DATA_PARTITION_E_SOURCE_NAME_INVALID': 'The source name argument: {0} is invalid.',
    'DM_DATA_PARTITION_E_MISSING_SOURCE_NAME': 'Value of SOURCE_NAME parameter cannot be empty.',
    'DM_DATA_PARTITION_E_FAIL_EXECUTE_SCRIPT': 'Fail to execute the script, may have not enough priviledge, please first run the command: Grant Create Any Table to {0}.',
    'DM_DATA_PARTITION_E_PARTITION_NOT_EMPTY': 'The partition to be switched into isn\'t empty',
    'DM_DATA_PARTITION_E_TABLE_NOT_EMPTY': 'The table to be switched into isn\'t empty',
    'DM_DATA_PARTITION_E_LAST_PARTITION_DEPRECATE': 'The parameter LAST_PARTITION was deprecated!',
    'DM_DATA_PARTITION_E_SWITCHIN_TABLE_NOT_EXIST': 'The table to be switched in doesn\'t exist',
    'DM_DATA_PARTITION_E_NO_SUCH_PARTITION': 'The partition {0} you specified is not found in the partition scheme {1}.',
    'DM_DATA_PARTITION_E_EMPTY_PARTITION_SCHEME': 'The operation {0} can not be applied on the empty partition scheme {1}.',
    'DM_PLATFORM_E_MEMORY_EXHAUSTED': 'Memory exhausted allocating {0} bytes',
    'DM_PLATFORM_E_SYSTEM_INFO': 'An error occured when calling the Operating System: {0}',
    'DM_PLATFORM_E_INTEGER_CONVERSION_ERROR': 'The server was unable to convert the following string ({0}) to an integer or long.',
    'DM_PLATFORM_E_STACK_OPERATION_INCONSISTENCE': 'Stack operation inconsistency found in File {0}, line {1}.',
    'DM_POLICY_I_ALREADY_VALIDATED': 'The policy identified by {0} is already in VALIDATED state.',
    'DM_POLICY_I_VALIDATE_INSTALLED': 'The policy identified by {0} is in INSTALLED state. No need to validate it.',
    'DM_POLICY_I_ALREADY_INSTALLED': 'The policy identified by {0} has already been installed. No need to install again.',
    'DM_POLICY_I_ALREADY_UNINSTALLED': 'The policy identified by {0} is not installed. No need to uninstall again.',
    'DM_POLICY_I_ALREADY_IN_EXCEP': 'No need to suspend the object since its current state {0} is an exception state.',
    'DM_POLICY_I_ALREADY_IN_NORMAL': 'No need to resume the object since its current state {0} is a normal state.',
    'DM_POLICY_W_WARN1': 'This is a warning {0}, {1}.',
    'DM_POLICY_W_EMPTY_RESULT_CONTENT': 'The dm_bp_transition returns an empty document ({0}) with status {1}.',
    'DM_POLICY_W_REMOVE_REF': 'State-related changes have applied to {0} (ID = {1}) when there exist referencing sysobjects.',
    'DM_POLICY_W_ERROR_1700': 'The User Post Processing Proc failed. Details:{0}',
    'DM_POLICY_E_NEED_PRIMARY_TYPE': 'You must set the primary type (i.e. included_type[0]) for this policy object.',
    'DM_POLICY_E_INVALID_ATCH_TYPE': 'The attached type {0} is not a valid docbase type.',
    'DM_POLICY_E_INVALID_ATCH_SUBTYPE': 'The attached type {0} is not a subtype of {1}.',
    'DM_POLICY_E_NOT_A_POLICY': 'The policy identified by {0} is not a dm_policy object.',
    'DM_POLICY_E_BAD_STATE_ATTRC': 'In policy named {0}, count of {1}: {2} does not match the count of state number: {3}.',
    'DM_POLICY_E_BAD_TYPE_ATTRC': 'In policy named {0}, count of {1}: {2} does not match the count of included_type: {3}.',
    'DM_POLICY_E_INVALID_STATE_NAME': 'Invalid state name {0} of policy {1} specified.',
    'DM_POLICY_E_NO_ATTACH_STATE': 'The policy identified by {0} does not have any attachable state.',
    'DM_POLICY_E_NO_NORMAL_STATE': 'The policy identified by {0} has no normal state.',
    'DM_POLICY_E_BAD_ENTRY': 'The policy identified by {0} has an invalid entry criteria id {1} specified for state {2}.',
    'DM_POLICY_E_BAD_ENTRY_TYPE': 'The policy identified by {0} has an invalid entry criteria {1}:{2} specified for state {3}.',
    'DM_POLICY_E_BAD_ACTION': 'The policy identified by {0} has an invalid action object id {1} specified for state {2}.',
    'DM_POLICY_E_BAD_ACTION_TYPE': 'The policy identified by {0} has an invalid action object {1}:{2} specified for state {3}.',
    'DM_POLICY_E_BAD_OVERRIDE': 'The policy identified by {0} has an invalid type_overwide {1} specified for state {2}.',
    'DM_POLICY_E_BAD_OVERRIDE_TYPE': 'The policy identified by {0} has an invalid type_overwide object {1}:{2} specified for state {3}.',
    'DM_POLICY_E_INVALID_EXCP_NAME': 'The state {0} defined for dm_policy {1} has an invalid exception state {2}.',
    'DM_POLICY_E_INVALID_EXCP_TYPE': 'The exception state {0} of {1} for dm_policy {2} is a normal state.',
    'DM_POLICY_E_UNIQUE_STATE_NAME': 'The state name {0} within dm_policy {1} must be unique.',
    'DM_POLICY_E_NO_INSTALLED_SAVE': 'You cannot save an INSTALLED policy object with changes related to policy definition.',
    'DM_POLICY_E_BAD_STATE_CHAIN': 'The policy object identified by {0} has loops.',
    'DM_POLICY_E_CANT_DESTROY': 'Cannot destroy policy identified by {0} since its state is installed or currently referenced by some sysobject.',
    'DM_POLICY_E_INVALID_STATE_INDEX': 'Invalid state index {0} of policy {1} specified.',
    'DM_POLICY_E_BAD_LABEL': 'There is no policy object with chronincle ID {0} and version label {1}.',
    'DM_POLICY_E_NOT_INCLUDED_TYPE': 'dm_policy object identified by {0} does not have {1} as one of its valid attachable type.',
    'DM_POLICY_E_LAUNCH_BAD_STATE': 'Cannot evaluate the entry_criteria/action of dm_policy {0} because the state {1} does not exist.',
    'DM_POLICY_E_NO_POLICY_METHOD': 'Cannot find the method {0}, which is needed to evaluate an entry criteria and/or to execute an action of a business policy.',
    'DM_POLICY_E_BAD_STATE': 'The dm_policy object identified by {0} does not have a state named {1}.',
    'DM_POLICY_E_NO_EXCP_STATE': 'The dm_policy object identified by {0} does not have an exception state defined for state {1}.',
    'DM_POLICY_E_GET_OVERR_BAD_STATE': 'You cannot get the type_override value due to that dm_policy {0} does not have a state named {1}.',
    'DM_POLICY_E_SET_OVERR_BAD_STATE': 'You cannot set the type_override attribute because dm_polict {0} does not have a state named {1}.',
    'DM_POLICY_E_BAD_USERENTRY': 'The policy identified by {0} has an invalid user-defined entry criteria id {1} specified for state {2}.',
    'DM_POLICY_E_BAD_USERENTRY_TYPE': 'The policy identified by {0} has an invalid user-defined entry criteria {1}:{2} specified for state {3}.',
    'DM_POLICY_E_BAD_USERACTION': 'The policy identified by {0} has an invalid user-defined action object id {1} specified for state {2}.',
    'DM_POLICY_E_BAD_USERACTION_TYPE': 'The policy identified by {0} has an invalid user-defined action object {1}:{2} specified for state {3}.',
    'DM_POLICY_E_NON_ATTACH_STATE': ' The state {0} you tried to attach is not an attachable state of policy {1}.',
    'DM_POLICY_E_NOT_VALIDATED': 'Cannot install a business {0} which is not validated.',
    'DM_POLICY_E_NO_ROUTER_BP': 'The attached type {0} can not be dm_router, dm_policy, or their subtypes.',
    'DM_POLICY_E_REMOVE_NO_STATE': 'Policy object {0} has no state to be removed.',
    'DM_POLICY_E_BAD_STATE_NAME': 'The specified state name \'{0}\' either is empty, or does not start with letter, or contains \':\', \'.\', or \',\'.',
    'DM_POLICY_E_INVALID_MOVE_POS': 'In movestate API, the old/new position ({0}/{1}) needs to be positive and less than (or equal to) the number of states ({2}).',
    'DM_POLICY_E_BAD_RESULT_ID': 'The dm_bp_transition returns an invalid ID {0}.',
    'DM_POLICY_E_BAD_RESULT_CONTENT': 'The dm_bp_transition returns a document (ID={0}) either without content or bad content ({1}).',
    'DM_POLICY_E_BAD_RESULT_STATUS': 'Document {0} has no content, but the status is bad ({1}).',
    'DM_POLICY_E_BAD_RESULT_ERROR': 'Document {0} has illegal error format ([ErrorCode]={1},[Parameter]={2},[Parameter]={3},[Parameter]={4},[ServerError]={5}.',
    'DM_POLICY_E_ERROR_1000': 'Unable to load the procedure:{0}. Details:{1}',
    'DM_POLICY_E_ERROR_1001': 'Unable to set attribute:{0} to value:{1}. Details:{2}',
    'DM_POLICY_E_ERROR_1002': 'Unable to set attribute:{0} to value:{1} at position {2}. Deatils:{3}',
    'DM_POLICY_E_ERROR_1003': 'Unable to remove value:{0} from attribute:{1}. Details:{2}',
    'DM_POLICY_E_ERROR_1004': 'Unable to remove all values from attribute:{0}. Details:{1}',
    'DM_POLICY_E_ERROR_1005': 'Unable to add value:{0} to attribute:{1} at position {2}. Details:{3}',
    'DM_POLICY_E_ERROR_1006': 'Unable to append value:{0} to attribute:{1}. Details:{2}',
    'DM_POLICY_E_ERROR_1007': 'Unable to add symbolic label:{0}. Details:{1}',
    'DM_POLICY_E_ERROR_1008': 'Unable to remove symbolic label:{0}. Details:{1}',
    'DM_POLICY_E_ERROR_1010': 'Unable to link object to location:{0}. Details:{1}',
    'DM_POLICY_E_ERROR_1011': 'Unable to unlink object from location:{0}. Details:{1}',
    'DM_POLICY_E_ERROR_1012': 'Unable to move object to location:{0}. Details:{1}',
    'DM_POLICY_E_ERROR_1013': 'Unable to set the objects ACL to {0}. Details:{1}',
    'DM_POLICY_E_ERROR_1014': 'Unable to set {0} as the owner of the object. Details:{1}',
    'DM_POLICY_E_ERROR_1500': 'The User Entry Criteria Proc failed. Details:{0}',
    'DM_POLICY_E_ERROR_1600': 'The User Actions Proc failed. Details:{0}',
    'DM_POLICY_E_INVALID_ALIAS_SET_INDEX': 'Invalid alias set index {0} of policy {1} specified.',
    'DM_POLICY_E_INVALID_ALIAS_SET_NAME': 'Invalid alias set name {0} of policy {1} specified.',
    'DM_POLICY_E_AS_INVALID_ID': 'Invalid alias set object ID {0} found for {1}.',
    'DM_POLICY_E_AS_INVALID_NAME': 'Cannot find {0} alias set for {1}.',
    'DM_POLICY_E_AS_PRIVILEGES': 'The current user ({0}) has insufficient privileges to save or destroy the {1} alias set object.',
    'DM_POLICY_E_AS_PRIVILEGES_OWNER': 'Cannot change the owner name of the {0} alias set.',
    'DM_POLICY_E_AS_EMPTY_NAME': 'The alias set has no name.',
    'DM_POLICY_E_AS_NAME_NOT_UNIQUE': 'Cannot create the {0} alias set since it already exists.',
    'DM_POLICY_E_AS_EMPTY_ALIAS_NAME': 'Cannot assign an empty alias name to alias set {0} at position {1}.',
    'DM_POLICY_E_AS_ALIAS_NAME_NOT_UNIQUE': 'The alias name {0} in alias set {1} is defined at positions {2} and {3}.',
    'DM_POLICY_E_AS_NO_ALIAS_SET': 'No value is found in alias set ({0}) for resolving alias {1}.',
    'DM_POLICY_E_AS_NO_DEFAULT_ALIAS_SET': 'No default alias set is allowed for resolving alias {0} since the sysobject is attached to a policy without alias set.',
    'DM_POLICY_E_AS_NAME_VALUE_NOT_MATCHED': 'The alias_name count ({0}) and alias_value count ({1}) of alias set {2} are not matched.',
    'DM_POLICY_E_AS_REF_INSTALLED_BP': 'The alias set {0} is referenced by {1} installed Business Policy objects.',
    'DM_POLICY_E_ERROR_1015': 'Unable to post a request to render the document in {0} format using Autorender for {1}. Details:{2}',
    'DM_POLICY_E_AS_NO_ALIAS_SET_POLICY': 'No default alias set found for user {0} under policy {1} (ID = {2}).',
    'DM_POLICY_E_AS_NO_ALIAS_SET_USER': 'No default alias set found for user {0}. The following alias sets were searched: sessionconfig, user, user\'s default group, server config, and policy (if applicable)',
    'DM_POLICY_E_ERROR_0001': 'Dmbasic error. Details:{0}',
    'DM_POLICY_E_ERROR_0010': 'BP transition script error. Details:{0}',
    'DM_POLICY_E_BAD_USERPOSTPROC': 'The policy identified by {0} has an invalid user-defined post-processing object id {1} specified for state {2}.',
    'DM_POLICY_E_BAD_USERPOSTPROC_TYPE': 'The policy identified by {0} has an invalid user-defined post-processing object {1}:{2} specified for state {3}.',
    'DM_POLICY_E_FAILED_TICKET': 'Failed to generate a ticket for {0} to execute {1} operation on object {2}',
    'DM_POLICY_E_AS_ILLEGAL_NAME': 'The alias set contains illegal symbols in the name ({0}).',
    'DM_POLICY_E_AS_ILLEGAL_CATEGORY': 'The alias set contains an illegal alias_category ({0}).',
    'DM_POLICY_E_PRIVILEGES': 'The current user ({0}) has insufficient privileges to save or destroy the {1} policy object.',
    'DM_POLICY_E_ERROR_1800': 'The Action failed. Details:{0}',
    'DM_POLICY_E_MUST_SAVE': 'Changes to the sysobject ({0}) must be saved or reverted first.',
    'DM_POLICY_E_ERROR_1400': 'The BP transition script failed due to deadlock. Details:{0}',
    'DM_POLICY_E_METHOD_TIMEOUT': 'The method ({0}) timeout before the action procedure could finish. The method timeout is currently set to {1}.',
    'DM_POLICY_E_CONNECTION_ERROR': 'Error connecting to docbase as user {0}.',
    'DM_POLICY_E_EXIST_NO_BP_LOG': 'BP Log ({0}) was not created.',
    'DM_POLICY_E_OPEN_LOG_FAILURE': 'Error opening file ({0}). Operating System error: ({1}).',
    'DM_POLICY_E_READ_LOG_FAILURE': 'Error reading file ({0}). Operating System error: ({1}).',
    'DM_POLICY_E_BAD_RESULT_ERROR_2': 'The BP Logfile ({0}) has illegal error format ([ErrorCode]={1},[Parameter]={2},[Parameter]={3},[Parameter]={4},[ServerError]={5}.',
    'DM_POLICY_E_OPER_FROM_EXCEPTION': 'It is not allowed to {0} on the document {1}({2}) from the exception state.',
    'DM_POLICY_E_ERROR_1900': 'Batch Promote failed. Details:{0}',
    'DM_POLICY_E_BP_OWNER_BATCH_PROMTE': 'It is not allowed to specify lifecycle_owner (in a_bpaction_run_as of docbase_config) to run the lifecycle actions.',
    'DM_POLICY_E_ERROR_2000': 'Unable to set application_code to \'dm_all_applications\'. Details: {0}',
    'DM_POLICY_E_CURSOR_ERROR': 'A database error has occurred during the creation of a cursor (\'{0}\').',
    'DM_POLICY_E_DEFAULT_POLICY_ID': 'The policy object with id \'{0}\' is the default_policy_id for type \'{1}\'. In order to destroy the policy, you must first modify the data dictionary for type and set the default_policy_id to another valid policy object or NULL.',
    'DM_POLICY_E_INVALID_ARG': 'The method \'{0}\' has invalid value ({1}) for argument \'{2}\'.',
    'DM_POLICY_E_ERROR_2100': 'Validation procedure detected error in the lifecycle. Details: {0}',
    'DM_POLICY_E_CANT_FIND_PROC_OBJ': 'Can\'t find the {0} procedure with id (\'{1}\') and version ({2})',
    'DM_POLICY_E_FAILED_CREATE_STATE_EXT_OBJ': 'Failed to create new dm_state_extension object for the document lifecycle (\'{0}\')',
    'DM_POLICY_E_CURSOR_FAIL': 'The following query {0} generated the following database {1} error',
    'DM_POLICY_E_BAD_USERENTRYSERVICE': 'The policy identified by {0} has an invalid user-defined entry criteria service {1} specified for state {2}.',
    'DM_POLICY_E_BAD_USERACTIONSERVICE': 'The policy identified by {0} has an invalid user-defined action service {1} specified for state {2}.',
    'DM_POLICY_E_BAD_USERPOSTPROCSERVICE': 'The policy identified by {0} has an invalid user-defined post-processing service {1} specified for state {2}.',
    'DM_POLICY_E_INCONSISTENT_JAVA_DOCBASIC': 'The policy identified by {0} cannot define a value for attribute {1} for state {2} when java_methods is set to {3}',
    'DM_POLICY_E_BAD_USERVALIDATIONSERVICE': 'The policy identified by {0} has an invalid user-defined validation service {1}.',
    'DM_POLICY_F_INIT1': 'The dm_policy type was found in the database without a version stamp.',
    'DM_POLICY_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_POLICY_F_INIT3': 'The type manager returned an error storing the dm_policy type.',
    'DM_POLICY_F_AS_INIT1': 'The dm_alias_set type was found in the database without a version stamp.',
    'DM_POLICY_F_AS_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_POLICY_F_AS_INIT3': 'The type manager returned an error storing the dm_alias_set type.',
    'DM_POLICY_F_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_POLICY_F_INT1': 'The following database query {0} could not be executed.',
    'DM_POLICY_F_TYPE_CONVERSION': 'Failed to convert type dm_policy to version {0}.',
    'DM_POLICY_F_TYPE_CONVERSION_QUERY_FAILURE': 'The following database error occurred:\'{0}.\' Attempt to upgrade dm_policy type to version {1} failed.',
    'DM_OBJ_MGR_W_ENUM_DATABASE_CLOSED': 'attempt to begin enumeration of type with closed database',
    'DM_OBJ_MGR_W_ENUM_TYPE_NULL': 'attempt to enumerate NULL type',
    'DM_OBJ_MGR_W_ENUM_TYPE_BOGUS': 'attempt to enumerate non-persistent type {0}',
    'DM_OBJ_MGR_W_ENUM_BAD_ATTR': 'order_by attribute {0} in enumeration is not part of type {1}',
    'DM_OBJ_MGR_W_ENUM_BAD_MATCH_TYPE': 'match_type {0} in enumeration is not subtype of type {1}',
    'DM_OBJ_MGR_W_MATCH_TYPE_NULL': 'attempt to perform match field with NULL type',
    'DM_OBJ_MGR_W_MATCH_TYPE_BOGUS': 'attempt to perform match field with non-persistent type {0}',
    'DM_OBJ_MGR_W_MATCH_BAD_MATCH_TYPE': 'match_type {0} in match field is not subtype of type {1}',
    'DM_OBJ_MGR_W_MATCH_BAD_ATTR': 'match field attribute {0} in type {1} is erroneous',
    'DM_OBJ_MGR_W_MATCH_BAD_POS': 'match position specification invalid',
    'DM_OBJ_MGR_W_MATCH_BAD_ORDER_BY': 'match field order_by attribute {0} is not attribute of type {1}',
    'DM_OBJ_MGR_W_UPDATE_NO_UPDATES': 'attempt to update with no updates',
    'DM_OBJ_MGR_W_UPDATE_TYPE_NULL': 'attempt to update NULL type',
    'DM_OBJ_MGR_W_UPDATE_TYPE_BOGUS': 'attempt to perform update with non-persistent type {0}',
    'DM_OBJ_MGR_W_UPDATE_OVERLAP_ATTR': 'attempt to use attribute {0} as both match field and update field of type {1}',
    'DM_OBJ_MGR_W_UPDATE_BAD_MATCH_TYPE': 'match_type {0} in update is not subtype of type {1}',
    'DM_OBJ_MGR_W_UPDATE_BAD_ATTR': 'attribute {0} of type {1} has undefined type in update',
    'DM_OBJ_MGR_W_VERSION_MISMATCH': 'save of object {0} of type {1} failed because of version mismatch: old version was {2}',
    'DM_OBJ_MGR_W_LOAD_PROPERTY_BAG': 'Could not deserialize property bag for {0}.',
    'DM_OBJ_MGR_E_FETCH_FAIL': 'attempt to fetch object with handle {0} failed',
    'DM_OBJ_MGR_E_FETCH_BAD_TYPE': 'attempt to create object of type {0} failed because type did not exist',
    'DM_OBJ_MGR_E_SET_NULL_TYPE': 'attempt to set persistent object type to NULL',
    'DM_OBJ_MGR_E_SET_BAD_TYPE': 'attempt to set persistent object type to non-persistent type {0}',
    'DM_OBJ_MGR_E_SAVE_FAIL': 'save failed for object with handle {0} of type {1}: table on which save failed was {2}; error from database system was {3}',
    'DM_OBJ_MGR_E_DELETE_FAIL': 'attempt to delete attributes of object {0} in table {1} failed: error from database system was {2}',
    'DM_OBJ_MGR_E_UPDATE_FAIL': 'attempt to update attributes of objects of type {0} in table {1} failed: error from database system was {2}',
    'DM_OBJ_MGR_E_DELETE_MISMATCH': 'version mismatch on delete of object {0}: version supplied was {1}',
    'DM_OBJ_MGR_E_DELETE_NOTFOUND': 'no entry for the object with identifier {0} could be found in the database table {1}',
    'DM_OBJ_MGR_E_CURSOR_FAIL': 'In operation {0} an attempt to create cursor failed; query was: \'{1}\'; error from database system was: {2}',
    'DM_OBJ_MGR_E_CURSOR_FETCH_FAIL': 'A failure occurred during a fetch through a cursor: database error message was {0}',
    'DM_OBJ_MGR_E_DB_CONN': 'A failure occurred during an attempt to establish a connection to the database.  The operation failed.',
    'DM_OBJ_MGR_E_VERSION_MISMATCH': 'save of object {0} of type {1} failed because of version mismatch: old version was {2}',
    'DM_OBJ_MGR_E_SAVE_FAILED_UNAVAILABLE_TYPE': 'Your client is older than your server, and you have attempted to create an object of a type ({0}) that is not available to your client version.',
    'DM_OBJ_MGR_E_CANT_DELETE_RELATION_EXISTS': 'Cannot delete object {0} since dm_relation object(s) {1} exists with integrity_kind set to 1.',
    'DM_OBJ_MGR_E_LOCK_INVALIDDB': 'lock of object {0} of type {1} failed because of invalid database connection.',
    'DM_OBJ_MGR_E_LOCK_NEWOBJ': 'lock of object {0} of type {1} failed because this object has not been created.',
    'DM_OBJ_MGR_E_LOCK_FAIL': 'lock failed for object with handle {0} of type {1}: table on which lock failed was {2}; error from database system was {3}',
    'DM_OBJ_MGR_E_DIRECT_SAVE_ASPECT_ATTRIBUTE_OBJECT_NOT_ALLOWED': 'Cannot save aspect attribute side object with handle ({0}) directly',
    'DM_OBJ_MGR_E_DIRECT_FETCH_ASPECT_ATTRIBUTE_OBJECT_NOT_ALLOWED': 'Cannot fetch aspect attribute side object with handle ({0}) directly',
    'DM_OBJ_MGR_E_DIRECT_EXPUNGE_ASPECT_ATTRIBUTE_OBJECT_NOT_ALLOWED': 'Cannot expunge aspect attribute side object with handle ({0}) directly',
    'DM_OBJ_MGR_E_INVALID_ASPECT_ATTR_TYPE': 'Attribute definition by aspect ({0}) is invalid. Internal type ({1}) is not found in the repository',
    'DM_OBJ_MGR_E_UNABLE_TO_VALIDATE_ASPECT_ATTRIBUTE_TYPE': 'A database error occured while attempting to validate attributes for aspect ({0}). Database error is ({1})',
    'DM_OBJ_MGR_E_DUPLICATE_ASPECTS_FOUND': 'Aspect ({0}) has been attached more than once for object ({1})',
    'DM_OBJ_MGR_E_INVALID_ASPECT_ATTRIBUTE_OBJECT': 'An error occured when instantiating a persistent object for aspect attributes for {0}, for aspect {1}',
    'DM_OBJ_MGR_E_UNABLE_TO_FETCH_ASPECT_ATTRS': 'Unable to fetch aspect attributes defined by aspect \'{0}\' for object \'{1}\'',
    'DM_OBJ_MGR_E_UNABLE_TO_APPLY_ASPECT_ATTR_CHANGES': 'Unable to apply aspect attribute changes defined by aspect \'{0}\' for object \'{1}\'',
    'DM_OBJ_MGR_E_UNABLE_TO_FETCH_CONSISTENT_OBJECT_SNAPSHOT': 'Unable to fetch object {0} alongwith its aspect attributes with consistency',
    'DM_OBJ_MGR_E_UNABLE_TO_CLONE_ASPECT_ATTRIBUTES': 'An error occured while cloning the aspect attributes from {0} to {1} for aspect {2}',
    'DM_OBJ_MGR_E_ASPECT_ATTR_EXISTS_CHECK_FAILED': 'A database error occured when checking if object {0} has attributes defined through aspect {1}: {2}',
    'DM_OBJ_MGR_E_SAVE_ASPECT_NQA': 'Could not save nonqualifiable aspect attribute to object {0} without property bag .',
    'DM_OBJ_MGR_E_UP_OUT_OF_RANGE': 'Unable to set attribute {0} because the value ({1}) being assigned is out of range',
    'DM_OBJ_MGR_E_CANNOT_EXPUNGE_OBJECT': 'Cannot destroy object {0} using the EXPUNGE RPC.',
    'DM_OBJ_MGR_E_INVALID_TYPE': 'Invalid type \'{0}\' for object \'{1}\'.',
    'DM_TYPE_MGR_W_SAVE_SUPER_FIRST': 'Before saving type {0} must save its supertype {1}.',
    'DM_TYPE_MGR_W_SAVE_SAME_NAME': 'Attempt to save type {0} while type with this name already exists.',
    'DM_TYPE_MGR_W_REMOVE_SUBTYPES': 'Attempt to remove type {0}, which has subtypes.',
    'DM_TYPE_MGR_W_TYPE_HAS_OBJECTS': 'Attempt to remove type {0}, which still has objects.',
    'DM_TYPE_MGR_W_DROP_FAILURE': 'Cannot remove table {0} for type {1}: error from database system is {2}',
    'DM_TYPE_MGR_W_NULL_TYPE_INDEX': 'Attempt to create an index on attributes of the NULL type.',
    'DM_TYPE_MGR_W_BAD_TYPE_INDEX': 'Attempt to create an index for non-persistent type {0}.',
    'DM_TYPE_MGR_W_MIXED_INDEX': 'Attempt to create index on type {0} with both repeating and single valued attributes.',
    'DM_TYPE_MGR_W_BAD_INDEX_ATTRIBUTE': 'Attempt to create index on type {0} using illegal attribute {1}',
    'DM_TYPE_MGR_W_NAME_TOO_LONG': 'attempt to save type {0} failed because attribute or type name {1} is too long',
    'DM_TYPE_MGR_W_ALTER_NOT_FOUND': 'the attributes being dropped for type {0} do not exist',
    'DM_TYPE_MGR_W_UNABLE_TO_REMOVE_COMPOSITE_TYPE': 'The type manager was unable to remove the dm_composite type.',
    'DM_TYPE_MGR_W_UNABLE_TO_REMOVE_COMPOSITE_SNAPSHOT_TABLE': 'The type manager was unable to remove the dmi_composite_snapshot table.',
    'DM_TYPE_MGR_W_UNABLE_TO_MOVE_INDEX': 'The type manager was unable to move the index with id {0}, for type {1}, at position {2} because the position is invalid. The database index has been dropped. The dmi_index object should be corrected manually and the MOVE_INDEX apply method should be used to recreate the database index.',
    'DM_TYPE_MGR_W_UNABLE_TO_CLEANUP_INDEX': 'The type manager was unable to remove the dmi_index object with id {0} on type {1}. This index needs to be removed since it references a table that no longer exists. Remove the dmi_index object and any references to it in the types dm_type table.',
    'DM_TYPE_MGR_W_INDEX_WITHOUT_TYPE_TABLE': 'The dmi_index object with id {0} on type {1}, refers to an attribute in a table that no longer exists in the database. The type manager will drop the dmi_index object and clean up.',
    'DM_TYPE_MGR_W_UNABLE_TO_PURGE_PENDING_PUBLISHES_FOR_TYPE': 'There was an error while trying to remove data dictionary entries relating to the {0} type. The type will still be dropped.',
    'DM_TYPE_MGR_W_RECREATE_INDEX': 'The {0} index {1} on type {2}({3}) has been dropped, you must re-create this index manually.',
    'DM_TYPE_MGR_E_CANT_CREATE_TABLE': 'Failure to create attribute table {0} for type {1}: error from database system is {2}',
    'DM_TYPE_MGR_E_CANT_DROP_TABLE': 'Failure to drop table {0} as part of creation or modification of type {1}: error from database system is {2}',
    'DM_TYPE_MGR_E_CANT_CREATE_INDEX': 'Failure to create index for table {0} as part of creation of type {1}: error from database system is {2}',
    'DM_TYPE_MGR_E_CANT_CREATE_VIEW': 'Failure to create view table {0} as part of creation of type {1}: error from database system is {2}',
    'DM_TYPE_MGR_E_CANT_FIND_TABLE': 'Failure to find table {0} as part of fetch of type {1}: error from database system is {2}',
    'DM_TYPE_MGR_E_CANT_SAVE_TYPE': 'Failure to insert row for type {0} in table {1}: error from database system is {2}',
    'DM_TYPE_MGR_E_CANT_FIND_TYPE': 'Failure to find type {0} in type table',
    'DM_TYPE_MGR_E_CANT_FIND_TYPE_HANDLE': 'Failure to find type with handle {0} in type table',
    'DM_TYPE_MGR_E_CANT_BUILD_OBJ_TABLE': 'Failure to construct new object table while constructing new database: error from database system is {0}',
    'DM_TYPE_MGR_E_CANT_BUILD_OBJ_INDEX': 'Failure to construct type index on object table: error from database system is {0}',
    'DM_TYPE_MGR_E_CANT_BUILD_NAME_INDEX': 'Failure to construct name index on type table: error from database system is {0}',
    'DM_TYPE_MGR_E_INITIAL_COMMIT_FAILED': 'Failure to commit version stamp change on initialization.',
    'DM_TYPE_MGR_E_VERSION_MISMATCH': 'Version of type manager code not consistent with database contents.',
    'DM_TYPE_MGR_E_CANT_REMOVE_TYPE_ON_SAVE': 'Failure to remove type named {0} before saving new type.',
    'DM_TYPE_MGR_E_CANT_ADD_VERSION_STAMP': 'Attempt to add (internal) version stamp attribute to type {0} before saving failed.',
    'DM_TYPE_MGR_E_SAVE_INSERT_FAILED': 'Failure to save new type {0} in object table: error from database system was {1}',
    'DM_TYPE_MGR_E_SAVE_COMMIT_FAILED': 'Failure to commit transaction when saving type {0}',
    'DM_TYPE_MGR_E_OBJECT_REMOVE_FAILED': 'Failure to remove objects of type {0} from object table before removing type: error from database system was {1}',
    'DM_TYPE_MGR_E_REMOVE_COMMIT_FAILED': 'Failure to commit changes to type tables when removing type {0}',
    'DM_TYPE_MGR_E_INDEX_FAILURE': 'Failure to create index named {0} for type {1}: error from database system is {2}',
    'DM_TYPE_MGR_E_INDEX_DROP_FAILURE': 'Failure to drop index named {0} for type {1}: error from database system is {2}',
    'DM_TYPE_MGR_E_CONNECTION_FAILURE': 'Cannot initialize type manager because of connection failure.',
    'DM_TYPE_MGR_E_CANT_DROP_COLUMN': 'Failed to drop column {0} from table {1}: error from database system is {2}',
    'DM_TYPE_MGR_E_DROP_UPDATE_FAIL': 'Failure to update type table dropping attributes for type {0}: error from database system is {1}',
    'DM_TYPE_MGR_E_ADD_UPDATE_FAIL': 'Failure to update type table adding attributes for type {0}: error from database system is {1}',
    'DM_TYPE_MGR_E_CANT_ADD_COLUMN': 'Failed to add column {0} from table {1}: error from database system is {2}',
    'DM_TYPE_MGR_E_ALTER_BAD_ARGS': 'Operation {0} failed on type {1} because {2}',
    'DM_TYPE_MGR_E_ALTER_DATABASE_FAILURE': 'Attempt to modify type {0} failed -- database error message was: {1}',
    'DM_TYPE_MGR_E_SAVE_SAME_NAME': 'Attempt to save type {0} while type with this name already exists.',
    'DM_TYPE_MGR_E_TYPE_HAS_OBJECTS': 'Attempt to remove type {0}, which still has objects.',
    'DM_TYPE_MGR_E_BAD_INDEX_SPACE': 'The index space {0} does not exist',
    'DM_TYPE_MGR_E_CANT_FETCH_ACL': 'Failed to fetch the ACL \'{0}\' in name space \'{1}\' for the type \'{2}\'. [{3}]',
    'DM_TYPE_MGR_E_CANT_DEREF_ACL': 'Failed to de-reference ACL \'{0}\' in name space \'{1}\' for type \'{2}\'.',
    'DM_TYPE_MGR_E_CANT_SAVE_ACL': 'Failed to save ACL \'{0}\' in name space \'{1}\' for type \'{2}\'.',
    'DM_TYPE_MGR_E_ACL_REVISE_GROUP': 'Failed to revise the group name of the ACL \'{0}\' in domain \'{1}\' for type \'{2}\'.',
    'DM_TYPE_MGR_E_ZERO_PERMIT': 'Failed to save ACL for type \'{0}\' because permits for owner, group and world, ({1},{2},{3}), need to be either all NULLs or not NULLs.',
    'DM_TYPE_MGR_E_ATTRIBUTE_TOO_LONG': 'The length of the {0} attribute of the type {1} is too long',
    'DM_TYPE_MGR_E_OLD_VERSION': 'Old version of type {0} -- version stamp is {1}; database version is {2}',
    'DM_TYPE_MGR_E_BAD_VSTAMP': 'Unexpected version stamp ({0}) is found for type {1}.',
    'DM_TYPE_MGR_E_ADD_UPDATE_FRESH_FAIL': 'Failure to batch update type table adding attributes for type {0}: error from database system is {1}',
    'DM_TYPE_MGR_E_CHECK_FTINDEX_FAIL': 'While checking for whether types already indexed, the following database query {0} could not be executed.',
    'DM_TYPE_MGR_E_TYPE_INFO_UPGRADE_FAILED': 'The type_info upgrade failed.',
    'DM_TYPE_MGR_E_ATTR_CHECK_FAILED': 'A database query to check upgrade status failed.  Message: {0}.',
    'DM_TYPE_MGR_E_CANT_ADD_ISREPLICA': 'Attempt to add (internal) i_is_replica attribute to type {0} before saving failed.',
    'DM_TYPE_MGR_E_DATABASE_INTERNAL_ERROR': 'An database error occured in while making object table. The database internal error is {0}',
    'DM_TYPE_MGR_E_LOAD_SYNONYM_CHECK': 'An Error occurred looking for a synonym for the type {0} during load processing of the dmi_type_info object.',
    'DM_TYPE_MGR_E_LOAD_TYPINFO_UPD': 'An Error occurred applying updates to the dmi_type_info object for new type {0} during load processing.',
    'DM_TYPE_MGR_E_LOAD_TYPINFO_FIX': 'An Error occurred applying updates to the dmi_type_info object for new type {0} during the second phase of load processing.',
    'DM_TYPE_MGR_E_NO_OLD_OBJ_TABLE': 'Unable to either find or construct old style object table: error from database system is {0}',
    'DM_TYPE_MGR_E_INIT_DBMS_ERR': 'Error from DBMS during initialization of the type manager.  Error was: {0}.',
    'DM_TYPE_MGR_E_EXISTING_TABLE': 'Cannot create type {0} because the table {1} unexpectedly already exists in the database and the server \'preserve_existing_types\' flag is enabled.  To complete this operation the table must first be manually dropped or the server flag disabled.',
    'DM_TYPE_MGR_E_EXISTING_TYPE': 'Cannot create type {0} because a type by that name already exists in the database and the server \'preserve_existing_types\' flag is enabled.  To complete this operation the type must be manually dropped or the server flag disabled.',
    'DM_TYPE_MGR_E_UNABLE_TO_ADJUST_INDEX_POSITIONS': 'The type manager was unable to modify the attribute positions in the dmi_index objects for the type {0} as a result of attribute changes to one or more of its supertypes. The following database error occurred: {1}',
    'DM_TYPE_MGR_E_CURSOR_ERROR': 'A database error has occurred during the creation of a cursor (\'{0}\').',
    'DM_TYPE_MGR_E_INDEX_WITHOUT_TYPE_TABLE': 'The dmi_index object with id {0} on type {1}, refers to an attribute in a table that no longer exists in the database. The type manager will drop the dmi_index object and clean up.',
    'DM_TYPE_MGR_E_INDEX_ALREADY_EXISTS': 'The index being created on type {0} already exists. The existing index is represented by dmi_index object with id {1}.',
    'DM_TYPE_MGR_E_UNABLE_TO_POPULATE_TABLE': 'Type Manager was unable to populate the table {0} for type {1}: error from database system is {2}',
    'DM_TYPE_MGR_E_QUERY_EXECUTION_FAILURE': 'The Type Manager encountered an error while trying to execute the following query: {0}. Database error was {1}.',
    'DM_TYPE_MGR_E_CANNOT_CREATE_ROOT_TYPES_TABLE': 'The Type Manager was unable to create the dm_dd_root_types table. More specific error messages should accompany this error.',
    'DM_TYPE_MGR_E_UNABLE_TO_LOCK_TYPE_CHAIN': 'The Type Manager was unable to lock the type chain for type {0}.',
    'DM_TYPE_MGR_E_CANNOT_ADD_ATTRIBUTE': 'Attempt to add attribute ({0}) to type ({1}) before saving failed.',
    'DM_TYPE_MGR_E_GET_ASPECT_INFO_UNABLE_TO_VERIFY': 'A database error occured while checking if aspect {0} has attributes defined (OR) if objects that have the aspect attached has attributes defined by the aspect. Database error is {1}',
    'DM_TYPE_MGR_E_GET_ASPECT_INFO_INVALID_ASPECT_NAME': 'There is no aspect in the repository with the name {0} OR the argument specified is either NULL or empty',
    'DM_TYPE_MGR_E_GET_ASPECT_INFO_TYPE_NOT_FOUND': 'There is no dmc_aspect_type in the repository',
    'DM_TYPE_MGR_E_GET_ASPECT_INFO_INCORRECT_ASPECT_TYPE': 'dmc_aspect_type does not have the i_attr_def attribute',
    'DM_TYPE_MGR_E_CANNOT_REMOVE_DEFAULT_ASPECT': 'Cannot remove default aspect \'{0}\' from type \'{1}\' because the aspect is not found in the type\'s type info.',
    'DM_TYPE_MGR_E_MAKE_INDEX_FAILED': 'MAKE_INDEX failed to create the requested index. Reason: {0}',
    'DM_TYPE_MGR_E_TOO_MANY_ATTRIBUTES': 'Cannot add attributes since {0} would have more than the maximum number of attributes ({1})',
    'DM_TYPE_MGR_E_UNABLE_TO_CREATE_SEQUENCE_OBJECT': 'The type manager was unable to create a sequence object for the type {0} as a result of attribute changes to one or more of its supertypes. The following database error occurred: {1}',
    'DM_TYPE_MGR_E_ILLEGAL_TYPE_CATEGORY': 'The type {0} has an illegal type_category value ({1}) when its super type {2} with type_category value ({3}) is not either a regular type or a shareable type.',
    'DM_QUERY_T_CONTAIN_BAD_TABLE': 'make_fulltext_temp:  Table creation failed for temporary table {0}.',
    'DM_QUERY_T_CONTAIN_TABLE': 'make_fulltext_temp:  Temporary fulltext table created: {0}.',
    'DM_QUERY_T_CONTAIN_TABLE_DROP': 'drop_temp_tables:  Temporary fulltext table dropped: {0}.',
    'DM_QUERY_T_SELECT_BEGIN': 'Begin SELECT statement.',
    'DM_QUERY_T_SELECT_COMPLETE': 'SELECT statement semantic checking and setup is complete.',
    'DM_QUERY_T_SQL_SELECT': 'SELECT statement generated by the query is: {0}.  Begin Database processing.',
    'DM_QUERY_T_SQL_PARTIAL': 'Partial SELECT statement generated by the query is: {0}.',
    'DM_QUERY_T_SUBSELECT': 'SQL select statement produced from the subselect or update or delete statement is: {0}.',
    'DM_QUERY_T_STMT_BEGIN': 'Begin {0} statement.',
    'DM_QUERY_T_STMT_COMPLETE': '{0} statement has completed.',
    'DM_QUERY_T_SYNTAX_BEGIN': 'Begin syntactic parse (call yacc).',
    'DM_QUERY_T_SYNTAX_COMPLETE': 'Syntactic parse is complete.',
    'DM_QUERY_T_CLOSE_BEGIN': 'Begin database cursor close ({0}).',
    'DM_QUERY_T_CLOSE_COMPLETE': 'Database cursor close is complete.',
    'DM_QUERY_T_DROP_BEGIN': 'Begin drop temporary fulltext table(s) ({0}).',
    'DM_QUERY_T_DROP_COMPLETE': 'Drop temporary fulltext table(s) is complete.',
    'DM_QUERY_T_SQL_DELETE': 'DELETE statement generated by the query is:  {0}.',
    'DM_QUERY_T_SQL_INSERT': 'INSERT statement generated by the query is:  {0}.',
    'DM_QUERY_T_SQL_UPDATE': 'UPDATE statement generated by the query is:  {0}.',
    'DM_QUERY_T_CYCLE': 'A compound document cycle has been found at object {0}.',
    'DM_QUERY_T_STMT': 'Your DQL statement is:  {0}.',
    'DM_QUERY_T_GROUP_BAD_VIEW': 'build_group_temp:  View creation failed for temporary view {0}.',
    'DM_QUERY_T_GROUP_VIEW': 'build_group_temp:  Temporary group view created: {0}.',
    'DM_QUERY_T_GROUP_VIEW_DROP': 'drop_temp_tables:  Temporary group view dropped: {0}.',
    'DM_QUERY_I_QUERY_CLOSED': 'A cursor was closed and the dmQueryResults object for it invalidated: {0}',
    'DM_QUERY_I_NUM_UPDATE': '{0} objects were affected by your {1} statement.',
    'DM_QUERY_I_UP_MAX_APPEND_EX': 'Your UPDATE statement exceeded the maximum append value ({0}) for attribute {1}.',
    'DM_QUERY_I_MODIFY_ATTR_NO': 'ALTER TYPE:  No action is required for attribute {0}.',
    'DM_QUERY_I_DISTINCT_COMPOUND': 'DISTINCT was ignored in this query.',
    'DM_QUERY_I_DEADLOCK_INFO': 'A database deadlock occurred.',
    'DM_QUERY_W_COMPOSITE_INTEGERS': 'You have specified an integer in the ORDER BY clause of a query containing ORDER in the select list.',
    'DM_QUERY_W_COMPOSITE_TWICE': 'You have specified the ORDER keyword more than once in your ORDER BY clause.',
    'DM_QUERY_W_NO_USERS': 'GRANT or REVOKE:  No users were returned by the subquery.  No privileges were affected.',
    'DM_QUERY_W_NO_USERS2': 'CREATE or ALTER GROUP:  No users were returned by the subquery.  No privileges were affected.',
    'DM_QUERY_W_NOT_FOLDER_ALL': 'You have specified a \'not folder(all)\' predicate.',
    'DM_QUERY_W_QUERIES_CLOSED': 'A transaction operation has caused a query or queries to be closed.',
    'DM_QUERY_W_RETRY_ALTER': 'ALTER TYPE is being re-tried.',
    'DM_QUERY_W_STAR_INTEGERS': 'You have specified an integer in the ORDER BY or NODESORT clause of a query containing * in the select list.',
    'DM_QUERY_W_NOT_A_FOLDER_PATH': 'You have specified a pathname ({0}) in a FOLDER or CABINET predicate that is not a valid pathname.',
    'DM_QUERY_W_NOT_A_FOLDER_ID': 'You have specified an ID ({0}) in a FOLDER or CABINET predicate that is not a valid ID value for a folder or cabinet.',
    'DM_QUERY_W_GROUPS_UNKNOWN': 'An error occurred processing your groups.',
    'DM_QUERY_W_COMPOUND_LATE': 'You have specified USING ASSEMBLIES and WITH in the same IN DOCUMENT clause.',
    'DM_QUERY_W_TRAN_ALREADY': 'BEGIN TRANSACTION:  There is already a transaction open.',
    'DM_QUERY_W_TRAN_NOT': '{0}:  There is no open transaction.',
    'DM_QUERY_W_ALTER_SOME': 'ALTER TYPE:  Your attempt to modify the lengths of attributes was only partially successful.',
    'DM_QUERY_W_UPNOTSUPP': 'Read-For-Update mode is not supported.',
    'DM_QUERY_W_BAD_DATE_FMT': 'The date format \'{0}\' is either un-recognizable or not supported on the RDBMS. Use default date format \'mm/dd/yyyy hh:mi:ss\'.',
    'DM_QUERY_W_ALTER_TYPE_OBSOLETE_SYNTAX': ' {0} is obsolete starting Release 5.3 of Content Server',
    'DM_QUERY_W_USE_DEF_FOR_CONTENT_ATT_WITH_LITE_TYPE': 'DQL does not support the content-related attribute, \'{0}\', with Lightweight Type ({1}). Hence, replace it with default value (i.e., 0 for integer, nullid for ID, etc).',
    'DM_QUERY_E_ALTER_BASE_TYPE': 'ALTER TYPE:  You have insufficient privilege to ADD or DROP attributes from a Documentum base type ({0}).',
    'DM_QUERY_E_ALTER_BASE_TYPE_DROP': 'ALTER TYPE:  You have attempted to drop or modify an attribute from a Documentum base type ({0}).',
    'DM_QUERY_E_ALTER_ERROR': 'ALTER TYPE:  statement failure.  Check the following messages for more information.',
    'DM_QUERY_E_ALTER_INTERNAL_ADD': 'ALTER TYPE:  You have attempted to ADD internal or readonly attribute.',
    'DM_QUERY_E_ALTER_INTERNAL_DROP': 'ALTER TYPE:  You have attempted to DROP an internal or readonly attribute.',
    'DM_QUERY_E_ALTER_TYPE_TOO': 'ALTER TYPE:  You have specified too many attributes.  The maximum allowed is {0}.',
    'DM_QUERY_E_ALTER_TYPE_TYPE': 'ALTER TYPE:  You have attempted to alter the dm_type type.',
    'DM_QUERY_E_BAD_ATTRIBUTE': 'The attribute name, {0}, is not an attribute of the queried type, {1}.',
    'DM_QUERY_E_BAD_GROUP_SAVE': 'CREATE or ALTER GROUP:  Unable to save the group.',
    'DM_QUERY_E_BAD_USER_SAVE': 'GRANT or REVOKE:  Unable to save the user ({0}).',
    'DM_QUERY_E_BAD_ID': 'The string specified for an ID value (\'{0}\') was not a valid Documentum dmID.',
    'DM_QUERY_E_BAD_QUAL': 'The attribute qualifier, {0}, for attribute {1}, is not a valid qualifier.',
    'DM_QUERY_E_BAD_SUBQUERY': '{0}:  An invalid attribute ({1}) was returned by the subquery.  Your statement was not executed.',
    'DM_QUERY_E_BAD_SUPERTYPE': 'CREATE TYPE:  A non-subtypeable type was specified as supertype.',
    'DM_QUERY_E_BAD_TYPE': '{0}: The datatype \'{1}\' is not valid in this statement.',
    'DM_QUERY_E_COLUMN_QUAL': 'The column or attribute name \'{0}\' must be qualified.',
    'DM_QUERY_E_COMPOSITE_1': 'ORDER keyword used in ORDER BY clause, but not in select list.',
    'DM_QUERY_E_COMPOSITE_2': 'ORDER keyword illegally used in SELECT statement.',
    'DM_QUERY_E_COMPOSITE_3': 'ORDER keyword used without IN COMPOSITE clause.',
    'DM_QUERY_E_COMPOSITE_4': 'IN COMPOSITE clause used without a dm_sysobject type.',
    'DM_QUERY_E_COMPOSITE_5': 'A correlated reference appears in a non-nested SELECT.',
    'DM_QUERY_E_COMPOSITE_6': 'A non-correlated column specification appears in an IN COMPOSITE clause.',
    'DM_QUERY_E_CREATE_BASE_TYPE': 'CREATE TYPE:  You must be a superuser to create a Documentum base type.',
    'DM_QUERY_E_CREATE_FAILED': 'CREATE TYPE statement failed for type: {0}.',
    'DM_QUERY_E_CREATE_FAILED2': 'CREATE TYPE statement failed because attribute {0} could not be added.',
    'DM_QUERY_E_CREATE_INTERNAL_ATT': 'CREATE TYPE:  You have attempted to create a type with internal or readonly attribute(s).',
    'DM_QUERY_E_CURSOR_ERROR': 'A database error has occurred during the creation of a cursor (\'{0}\').',
    'DM_QUERY_E_DATE_FORMAT': 'The specified date literal ({0}) is not in a recognized format, or is out of the valid date range.',
    'DM_QUERY_E_DOC_ALL': 'You have specified (ALL) in the FROM clause, but the type specified is not a dm_sysobject subtype.',
    'DM_QUERY_E_DOC_PRED': 'You have specified a SysObject predicate ({0}), but a dm_sysobject subtype was not specified as the first type in the FROM clause in this select or subselect.',
    'DM_QUERY_E_DOC_CLAUSE': 'You have specified a SEARCH clause or fulltext keyword, but a dm_sysobject type was not specified in this select or subselect.',
    'DM_QUERY_E_DROP_FAILED': 'DROP TYPE statement failed for type:  {0}.',
    'DM_QUERY_E_DROP_FAILED2': 'DROP GROUP statement failed for group: {0}.',
    'DM_QUERY_E_DROP_BASE_TYPE': 'DROP TYPE:  You have attempted to drop a Documentum base type, {0}.',
    'DM_QUERY_E_DROP_TYPE_TYPE': 'DROP TYPE:  You have attempted to drop the dm_type type.',
    'DM_QUERY_E_GROUP_BY_STAR': 'A star (*) may not be specified in the select list if GROUP BY is also specified for this query.',
    'DM_QUERY_E_ID_LENGTH': 'The identifier, {0}, exceeds the maximum identifier length allowed ({1}).',
    'DM_QUERY_E_ID_NOT_VALID': 'The ID datatype is not valid in REGISTER statements.',
    'DM_QUERY_E_IS_GROUP': 'CREATE GROUP:  The group specified ({0}) already exists.',
    'DM_QUERY_E_IS_GROUP2': 'GRANT or REVOKE:  The specified grantee or revokee ({0}) is a group.',
    'DM_QUERY_E_KEY_NO_MATCH': 'REGISTER: Column \'{0}\' specified in KEY clause has no match in column definitions.',
    'DM_QUERY_E_NO_CURSOR': 'GRANT, REVOKE, or CREATE GROUP:  An error occurred during the processing of the subquery.  Your statement was not executed.',
    'DM_QUERY_E_NO_CREATE_PRIV': 'CREATE TYPE:  You have insufficient privilege to create a type.',
    'DM_QUERY_E_NO_GROUP_PRIV': 'You have insufficient privilege to create, alter, or drop a group.',
    'DM_QUERY_E_NO_PRIV_PRIV': 'You have insufficient privilege to GRANT or REVOKE user privileges.',
    'DM_QUERY_E_NO_SUPER_PRIV': 'You have insufficient privilege to GRANT or REVOKE {0} privilege.',
    'DM_QUERY_E_NO_REPEAT': 'REGISTER:  The REPEATING column attribute is not supported in the register table statement.',
    'DM_QUERY_E_NO_SET_FUNC': 'Set Functions are not permitted in WHERE or WITH clauses.',
    'DM_QUERY_E_NO_SUPERTYPE': 'CREATE TYPE:  Supertype, {0}, not found.',
    'DM_QUERY_E_NO_SYSCAB': 'REGISTER:  Unable to link the table to the System cabinet.',
    'DM_QUERY_E_NULL_SUPERTYPE': 'CREATE TYPE:  You are not authorized to create a type with no supertype.',
    'DM_QUERY_E_NOT_CLASS': 'SELECT:  The type ({0}) specified in the FROM clause is either not a valid Documentum type, or not a queryable Documentum type.',
    'DM_QUERY_E_NOT_GROUP': '{0}:  The group specified ({1}) does not exist.',
    'DM_QUERY_E_NOT_OWNER': '{0}:  You have attempted to register or unregister a table that is not owned by you.',
    'DM_QUERY_E_NOT_REG': 'UNREGISTER:  The table, {0}.{1}, was not registered.',
    'DM_QUERY_E_NOT_SUPPORTED': '{0}:  The subquery form of this query is not supported in your environment, because your RDBMS ({1}) does not have the required functionality.',
    'DM_QUERY_E_NOT_USER': '{0}:  The username {1} is not a valid Documentum user.',
    'DM_QUERY_E_NOT_YET': '{0} is not supported at this time.',
    'DM_QUERY_E_OWNER_PERMIT': 'ALTER TYPE:  You may not set the default owner permit to a permit level less than VERSION.',
    'DM_QUERY_E_REG_ALREADY': 'REGISTER: Table \'{0}\' was already registered.',
    'DM_QUERY_E_REG_ATTR': 'REGISTER:  An error has occurred which caused your statement to fail.',
    'DM_QUERY_E_STAR_IN_SUBQUERY': 'Subquery:  You may not specify a * in the select list of non-\'exists\' subquery.',
    'DM_QUERY_E_STRING_LENGTH': 'CREATE or ALTER TYPE: Length specification ({0}) for attribute \'{1}\' exceeds allowable maximum ({2}).',
    'DM_QUERY_E_STRINGLIST_NOT_SUPPORTED': 'You have specified a string list in your SEARCH clause where only a single string is valid.',
    'DM_QUERY_E_SYNTAX': 'A Parser Error ({0}) has occurred in the vicinity of:  {1}',
    'DM_QUERY_E_TABLE_NO_ACCESS': 'The table, {0}.{1}, is not registered or you do not have access to it.',
    'DM_QUERY_E_TRAN_NOT_BEGUN': '{0}:  An attempt to begin a transaction failed.  This query must be run within a transaction.',
    'DM_QUERY_E_TWICE': 'ALTER TYPE:  You have attempted to set the {0} attribute more than once in this query.',
    'DM_QUERY_E_TYPE_NOT_FOUND': 'ALTER or DROP TYPE:  The type, {0}, was not found.  A type of this name does not exist.',
    'DM_QUERY_E_TYPE_NOT_OWNER': 'You have attempted to DROP or ALTER a type which does not belong to you.',
    'DM_QUERY_E_TYPE_PREDICATE': 'You have specified a type predicate ({0}), but no type was specified in the FROM clause of this query.',
    'DM_QUERY_E_WHITESPACE': 'You have specified a \'word\' ({0}) containing whitespace.',
    'DM_QUERY_E_WITHIN_NOT_SUPPORTED': 'You have specified a WITHIN predicate in your SEARCH clause.',
    'DM_QUERY_E_SEARCH_NEEDED': 'You have specified one of the special fulltext keywords without a SEARCH clause.',
    'DM_QUERY_E_KEYWORD_NEEDED': 'You have specified one of the special fulltext keywords ({0})in the ORDER BY clause.',
    'DM_QUERY_E_POSITION_USED': 'You have specified the POSITION keyword where it is not allowed.',
    'DM_QUERY_E_NOT_ATTRIBUTE': 'You have specified an invalid attribute name ({0}).',
    'DM_QUERY_E_NOT_REPEATING': 'You have specified a non-repeating attribute ({0}) in a repeating attribute predicate.',
    'DM_QUERY_E_MORE_REPEATING': 'You have specified too many repeating attributes.',
    'DM_QUERY_E_REPEATING_USED': 'You have specified a repeating attribute ({0}) where it is not allowed.',
    'DM_QUERY_E_REPEAT_POS': 'You have specified repeating attribute(s) and TAG or POSITION in the same select.',
    'DM_QUERY_E_REPEAT_ORDER': 'You have specified repeating attribute(s) and the composite ORDER keyword in the same select.',
    'DM_QUERY_E_STAR_WITHOUT_TYPE': 'You have incorrectly specified a star (*) in the select list of a select statement.',
    'DM_QUERY_E_TWO_TYPES': 'You have specified more than one type ({0} and {1}) in your FROM clause.',
    'DM_QUERY_E_NOT_CABINET_ID': 'You have specified an ID value ( \'{0}\' ) that is not a valid cabinet ID.',
    'DM_QUERY_E_NOT_CABINET_PATH': 'You have specified a path value ( \'{0}\' ) that is not a valid cabinet path.',
    'DM_QUERY_E_DEFAULT_NOT_CABINET': 'You have specified CABINET(DEFAULT) but your default folder is not a cabinet.',
    'DM_QUERY_E_SEARCH_NOT_AVAILABLE': 'You have specified a SEARCH clause, but no fulltext system is available.',
    'DM_QUERY_E_REPEAT_REG': 'You have specified repeating attribute(s) and columns from a registered table in the same select list.',
    'DM_QUERY_E_NULLDATE': 'NULLDATE is not valid in this context.',
    'DM_QUERY_E_UP_BAD_ATTR': 'The attribute {0} is not updateable.',
    'DM_QUERY_E_UP_BAD_ATTR_CORR': 'The correlation variable ({0}) for attribute {1} does not match the updated types correlation variable ({2}).',
    'DM_QUERY_E_UP_BAD_ATTR_SPEC': 'The attribute specification for attribute {0} is in error.',
    'DM_QUERY_E_UP_BAD_ATTR_TYPES': 'UPDATE:  The attributes {0} and {1} do not have the same datatype.',
    'DM_QUERY_E_UP_BOOL': 'UPDATE:  You have attempted to set a boolean attribute ({0}) with a non-boolean integer value ({1}).',
    'DM_QUERY_E_UP_CHAR': 'UPDATE:  You have attempted to set a non-string attribute ({0}) with a string value ({1}).',
    'DM_QUERY_E_UP_CURSOR': 'A database error has occurred during the creation of a cursor for \'{0}\'.',
    'DM_QUERY_E_UP_DOUBLE': 'UPDATE:  You have attempted to set a non-double attribute ({0}) with a floating point literal value ({1}{2}).',
    'DM_QUERY_E_UP_INDEX': 'You have specified a non-zero index for attribute {0}.',
    'DM_QUERY_E_UP_INT': 'UPDATE:  The attribute ({0}) cannot be updated with an integer value ({1}).',
    'DM_QUERY_E_UP_NOT_ATTR': 'The attribute {0} is not an attribute of the specified type.',
    'DM_QUERY_E_UP_NOT_TYPE': 'You have specified an invalid type name ({0}).',
    'DM_QUERY_E_UP_NOT_UPDATEABLE': 'You have specified a non updateable type name ({0}).',
    'DM_QUERY_E_UP_SINGLE': 'The attribute {0} is a single-valued attribute.',
    'DM_QUERY_E_UP_TYPES': 'You have specified a list of types or tables in your statement.',
    'DM_QUERY_E_UP_USER': 'You have attempted to assign the USER special value to a non-string attribute ({0}).',
    'DM_QUERY_E_UP_VALUE': 'You have specified an illegal value specification.',
    'DM_QUERY_E_UNION_NOT': 'UNION is not supported by your RDBMS ({0}).',
    'DM_QUERY_E_UNION_ORDER': 'You have specified a non-integer token in an ORDER BY clause with UNION.',
    'DM_QUERY_E_DELETE_ERROR': 'A database error has occurred during the execution of your delete statement (\'{0}\').',
    'DM_QUERY_E_INSERT_ERROR': 'A database error has occurred during the execution of your insert statement (\'{0}\').',
    'DM_QUERY_E_INSERT_BAD_VALUE': 'You have specified an invalid value in the VALUES clause of an INSERT statement.',
    'DM_QUERY_E_UPDATE_ERROR': 'A database error has occurred during the execution of your update statement (\'{0}\').',
    'DM_QUERY_E_UPDATE_SUB': 'UPDATE:  An error occurred during the processing of a subquery for attribute {0}.',
    'DM_QUERY_E_UPDATE_SUB_CONV1': 'UPDATE:  Your subquery returned an unconvertable value.',
    'DM_QUERY_E_UPDATE_SUB_CONV2': 'UPDATE:  Your subquery returned an unconvertable value.',
    'DM_QUERY_E_UPDATE_SUB_CONVB': 'UPDATE:  Your subquery returned an unconvertable value.',
    'DM_QUERY_E_UPDATE_SUB_DT': 'UPDATE:  Your subquery returned a value with an invalid datatype ({0}).',
    'DM_QUERY_E_UPDATE_SUB_EMPTY': 'UPDATE:  Your update subquery returned no values.',
    'DM_QUERY_E_BAD_STORAGE_CLASS': 'ALTER TYPE:  You have specified an invalid storage class ({0}).',
    'DM_QUERY_E_COMPOUND_COL_D': 'IN DOCUMENT clause has both a column specification and a DESCEND.',
    'DM_QUERY_E_COMPOUND_COL_S': 'IN DOCUMENT or IN ASSEMBLY clause has a column specification but is not in a subselect.',
    'DM_QUERY_E_COMPOUND_CURSOR': 'A database error has occurred during the creation of a cursor (\'{0}\').',
    'DM_QUERY_E_COMPOUND_CYCLE': 'IN DOCUMENT recursion has encountered a cycle at depth {0}.',
    'DM_QUERY_E_COMPOUND_FUNC': 'IN DOCUMENT clause and a set function appear in the same SELECT.',
    'DM_QUERY_E_COMPOUND_ID': 'IN DOCUMENT or IN ASSEMBLY clause has an invalid ID specification ({0}).',
    'DM_QUERY_E_COMPOUND_ID_NO': 'Compound document clause has an ID specification ({0}) that does not identify an existing SysObject.',
    'DM_QUERY_E_COMPOUND_DEPTH_ND': 'You have specified DEPTH in a query that does not have a DESCENDing IN DOCUMENT clause.',
    'DM_QUERY_E_COMPOUND_DEPTH_SL': 'You have specified DEPTH somewhere in your query besides the select list.',
    'DM_QUERY_E_COMPOUND_DEPTH_2': 'You have specified DEPTH more than once in a single select list.',
    'DM_QUERY_E_COMPOUND_ORDER': 'IN DOCUMENT or IN ASSEMBLY clause is combined with ORDER BY.',
    'DM_QUERY_E_COMPOUND_PARENT_ND': 'You have specified PARENT in a query that does not have an IN DOCUMENT or IN ASSEMBLY clause.',
    'DM_QUERY_E_COMPOUND_PARENT_SL': 'You have specified PARENT somewhere in your query besides the select list.',
    'DM_QUERY_E_COMPOUND_SUB': 'IN DOCUMENT clause appears within a subquery.',
    'DM_QUERY_E_COMPOUND_TYPE': 'IN DOCUMENT or IN ASSEMBLY clause was used without a dm_sysobject type.',
    'DM_QUERY_E_COMPOUND_UNION': 'IN DOCUMENT clause is combined with UNION.',
    'DM_QUERY_E_COMPOUND_VL': 'IN DOCUMENT or IN ASSEMBLY version label ({0}) does not have a match in the version branch containing {1}.',
    'DM_QUERY_E_UPDATE_INDEX': 'UPDATE:  Unable to {0} the attribute {1} at index {2}.',
    'DM_QUERY_E_REG_TABLE_GROUP': 'The registered table you are trying to access ({0}.{1}) has an invalid default group: {2}.',
    'DM_QUERY_E_REG_TABLE_PERMIT_I': 'You have attempted to set an invalid {0} table permission: {1}.',
    'DM_QUERY_E_REG_TABLE_PERMIT_IN': 'You have insufficient privilege to {0} the {1}.{2} table.',
    'DM_QUERY_E_REG_TABLE_PERMIT_U': 'You have attempted to set a table permission attribute of the registered table.',
    'DM_QUERY_E_COMPOUND_NCCS': 'A non-correlated column specification appears in an IN DOCUMENT or IN ASSEMBLY clause.',
    'DM_QUERY_E_UPDATE_GROUP_P': 'UPDATE:  You must have CREATE GROUP, SYSADMIN, or SUPERUSER privilege to update groups.',
    'DM_QUERY_E_UPDATE_USER_P': 'You must have SYSADMIN or SUPERUSER privilege to update or create users.',
    'DM_QUERY_E_COMPOUND_PARENT_2': 'You have specified PARENT more than once in a single select list.',
    'DM_QUERY_E_COMPOUND_UPD': 'IN ASSEMBLY clause with NODE appears in an UPDATE OBJECT statement.',
    'DM_QUERY_E_UP_SUB_MORE': 'UPDATE:  A subquery in your update statement has returned more than one row.',
    'DM_QUERY_E_COMPOUND_NS_SUB': 'IN DOCUMENT clause contains NODESORT within a subquery.',
    'DM_QUERY_E_COMPOUND_NS_NOT': 'IN DOCUMENT clause contains NODESORT within a non-select statement.',
    'DM_QUERY_E_COMPOUND_NS_KW': 'A NODESORT clause specifies an unsupported special keyword.',
    'DM_QUERY_E_COMPOUND_INS': 'IN DOCUMENT clause appears in an INSERT statement.',
    'DM_QUERY_E_FOLDERS_TOO_MANY': 'You have specified too many folders in a FOLDER predicate.',
    'DM_QUERY_E_COMPOUND_REPEATING': 'You have selected repeating attribute(s) in an IN DOCUMENT query.',
    'DM_QUERY_E_COMPOUND_UPDATE': 'You have specified an IN DOCUMENT clause in an UPDATE statement.',
    'DM_QUERY_E_UP_MAX_APPEND': 'You have specified an invalid maximum append value.',
    'DM_QUERY_E_UP_BAD_FOLDER': 'You have specified an invalid folder path, {0}, in your LINK or MOVE TO clause.',
    'DM_QUERY_E_UP_NOT_SYSOBJ': 'You have specified LINK or MOVE TO for a non-SysObject type.',
    'DM_QUERY_E_LIKE_INVALID_OP': 'You have specified an invalid operand to the LIKE predicate.',
    'DM_QUERY_E_COMPOUND_CONTID_SL': 'You have specified CONTAIN_ID somewhere in your query besides the select list.',
    'DM_QUERY_E_COMPOUND_CONTID_ND': 'You have specified CONTAIN_ID in a query that does not have an IN DOCUMENT or IN ASSEMBLY clause.',
    'DM_QUERY_E_COMPOUND_CONTID_2': 'You have specified CONTAIN_ID more than once in a single select list.',
    'DM_QUERY_E_UPDATE_LINK_CAB': 'You have specified {0} for a cabinet object.',
    'DM_QUERY_E_COMPOUND_NO_ASSEM': 'Your IN ASSEMBLY clause specifies a document with no assembly.',
    'DM_QUERY_E_COMPOUND_COL_N': 'Your IN ASSEMBLY clause has both a column specification and a NODE.',
    'DM_QUERY_E_COMPOUND_NODE_SUB': 'Your IN ASSEMBLY clause contains NODE phrase within a subquery.',
    'DM_QUERY_E_COMPOUND_NODE_ID': 'Your NODE phrase has an invalid ID specification ({0}).',
    'DM_QUERY_E_COMPOUND_NODE_ID_NO': 'Your NODE phrase has an ID specification ({0}) that does not identify an existing SysObject.',
    'DM_QUERY_E_ESCAPE_LENGTH': 'The ESCAPE character in your LIKE predicate is not one character long (\'{0}\').',
    'DM_QUERY_E_ESCAPE_NOT': 'The ESCAPE clause is not supported in your RDBMS.',
    'DM_QUERY_E_REPEATING_REQUIRED': 'You have specified a single-valued attribute ({0}) where a repeating attribute is required.',
    'DM_QUERY_E_COMPOUND_POS': 'You have specified POSITION or TAG in the select list of a query with an IN DOCUMENT clause.',
    'DM_QUERY_E_MODIFY_ATTR_TYPE': 'ALTER TYPE:  You have specified an invalid datatype in the MODIFY clause.',
    'DM_QUERY_E_MODIFY_ATTR_NOT': 'ALTER TYPE:  The attribute {0} is not an attribute of the type {1}.',
    'DM_QUERY_E_MODIFY_NOT_STR': 'ALTER TYPE:  The attribute {0} is not a string type.',
    'DM_QUERY_E_MODIFY_ATTR_LEN': 'ALTER TYPE:  The attribute {0} is longer ({1}) than the specified length {2}.',
    'DM_QUERY_E_EXEC_NOT_VALID': 'EXECUTE:  The function you are trying to execute ({0}) is not a valid function.',
    'DM_QUERY_E_EXEC_NO_REPEAT': 'EXECUTE:  You have specified an argument ({0}) twice, but it is not a repeatable argument.',
    'DM_QUERY_E_EXEC_NO_LIST': 'EXECUTE:  You have specified a value list for the argument {0}.',
    'DM_QUERY_E_EXEC_BAD_VALUE': 'EXECUTE:  You have specified a value that is not a valid datatype for argument {0}.',
    'DM_QUERY_E_EXEC_VALUE_LIST_MISMATCH': 'EXECUTE:  You have specified a value list with values of differing datatypes for argument {0}.',
    'DM_QUERY_E_EXEC_BAD_DATATYPE': 'EXECUTE:  You have specified a value that is not the same datatype as the argument {0} ({1})',
    'DM_QUERY_E_EXEC_BAD_BOOL': 'EXECUTE:  You have specified an integer value ({0}) for a boolean argument ({1}).',
    'DM_QUERY_E_EXEC_REQD': 'EXECUTE:  A required argument ({0}) was omitted.',
    'DM_QUERY_E_EXEC_NOID': 'EXECUTE:  The argument {0} is required unless an ID is specified.',
    'DM_QUERY_E_HITS_NOT_IN_SL': 'The special keyword HITS must appear in the select list.',
    'DM_QUERY_E_CHANGE_TYPES1': 'CHANGE:  You have specified two base types.',
    'DM_QUERY_E_CHANGE_TYPES2': 'CHANGE:  You have specified types that have a base type between them.',
    'DM_QUERY_E_CHANGE_TYPES3': 'CHANGE:  You have specified types that are not in a subtype/supertype relationship.',
    'DM_QUERY_E_MSCORE_USED': 'You have specified the MSCORE keyword where it is not allowed.',
    'DM_QUERY_E_MHITS_USED': 'You have specified the MHITS keyword where it is not allowed.',
    'DM_QUERY_E_MCONTENTID_USED': 'You have specified the MCONTENTID keyword where it is not allowed.',
    'DM_QUERY_E_STAR_EXPRESSIONS': 'You have specified an expression list along with * in the select list.',
    'DM_QUERY_E_UP_IMMUTABLE': 'Your UPDATE or CHANGE statement has tried to update an immutable object.',
    'DM_QUERY_E_MODIFY_ATTR_NO_MOD': 'ALTER TYPE:  The attribute {0} is not an accessible attribute of the type {1}.',
    'DM_QUERY_E_ATTR_NOT_ACC': 'The attribute {0} is not an accessible attribute.',
    'DM_QUERY_E_REG_TABLE_UPDATE': 'You have attempted to update the table_name or table_owner of a registered table.',
    'DM_QUERY_E_REG_NO_DB_NAME': 'You cannot register a table because your database login is not defined.',
    'DM_QUERY_E_REG_TABLE_QUAL': 'You must provide a table owner name qualification on your reference to table {0}.',
    'DM_QUERY_E_CHG_NOT_LINKABLE': 'You cannot move/link/unlink objects in a CHANGE statement.',
    'DM_QUERY_E_CHG_BAD_ATTR': 'The attribute {0} cannot be set in a CHANGE statement.',
    'DM_QUERY_E_NOT_ACL': '{0}:  The ACL specified ({1} {2}) does not exist.',
    'DM_QUERY_E_ACL_TRAN': 'ALTER TYPE: You cannot change the default acl when a multi-statement transaction is open.',
    'DM_QUERY_E_UP_PERMIT': 'UPDATE:  The permit ({0}) cannot be updated with an integer value ({1}) less than 1 or greater than 7.',
    'DM_QUERY_E_IS_REPLICA_SL': 'You have specified ISREPLICA somewhere in your query besides the select list.',
    'DM_QUERY_E_IS_REPLICA_SUB': 'You have specified ISREPLICA in a select list that is not the outermost select list.',
    'DM_QUERY_E_IS_REPLICA_2': 'You have specified ISREPLICA more than once in the select list.',
    'DM_QUERY_E_MIXED_UNION': 'UNION ALL clause is combined with UNION.',
    'DM_QUERY_E_CHANGE_NON_SYSOBJECT': 'The CHANGE OBJECT statement can only be used on dm_sysobject or its subtypes.',
    'DM_QUERY_E_INSERT_ORDER_BY': 'The ORDER BY clause in the INSERT statement is only supported for Sybase platform.',
    'DM_QUERY_E_POS_NOT_IN_SL': 'The special keyword POSITION must appear in the select list.',
    'DM_QUERY_E_CONT_ID_NOT_IN_SL': 'The special keyword CONTENTID must appear in the select list.',
    'DM_QUERY_E_SCORE_NOT_IN_SL': 'The special keyword SCORE must appear in the select list.',
    'DM_QUERY_E_TAG_NOT_IN_SL': 'The special keyword TAG must appear in the select list.',
    'DM_QUERY_E_SYS_ID_NOT_IN_SL': 'The special keyword SYSOBJ_ID must appear in the select list.',
    'DM_QUERY_E_PAGE_NO_NOT_IN_SL': 'The special keyword PAGE_NO must appear in the select list.',
    'DM_QUERY_E_PUBLIC_NOT_IN_SL': 'The special keyword ISPUBLIC must appear in the select list.',
    'DM_QUERY_E_CURRENT_NOT_IN_SL': 'The special keyword ISCURRENT must appear in the select list.',
    'DM_QUERY_E_TEXT_NOT_IN_SL': 'The special keyword TEXT must appear in the select list.',
    'DM_QUERY_E_SUMMARY_NOT_IN_SL': 'The special keyword SUMMARY must appear in the select list.',
    'DM_QUERY_E_INDEX_NOT_FOUND': 'The specified index, {0}, in the search clause is not found.',
    'DM_QUERY_E_INVALID_SETFILE_STMT': 'You have used an invalid setfile statement. Verify that you are using the correct form of the setfile statement.',
    'DM_QUERY_E_CHANGE_CANNOT_SETFILE': 'You can not use Setfile in a CHANGE OBJECT statement.',
    'DM_QUERY_E_OBJTYPE_NOT_IN_SL': 'The special keyword OBJTYPE must appear in the select list.',
    'DM_QUERY_E_ID_NOT_ALLOWED_IN_OUTER_SELECT': 'You cannot include the ID function in the selected values.',
    'DM_QUERY_E_CANT_ALTER_BASE_TYPE': 'ALTER TYPE:  You cannot ADD, DROP or MODIFY attributes from a Documentum base type ({0}).',
    'DM_QUERY_E_OFFSET_NOT_IN_SL': 'The special keyword OFFSET must appear in the select list.',
    'DM_QUERY_E_TEXTPAGE_NOT_IN_SL': 'The special keyword TEXTPAGE must appear in the select list.',
    'DM_QUERY_E_TH_URL_NOT_IN_SL': 'The special keyword THUMBNAIL_URL must appear in the outermost select list.',
    'DM_QUERY_E_NO_THUMBNAIL_STORE': 'There is no storage area whose media type is thumbnail (1).',
    'DM_QUERY_E_MFILE_URL_NOT_IN_SL': 'The special keyword MFILE_URL must appear in the outermost select list.',
    'DM_QUERY_E_NOT_VIEWABLE': 'You do not have enough privilege to view the specified type ({0}).',
    'DM_QUERY_E_ATTR_NOT_VIEWABLE': 'User ({0}) does not have enough privilege to view the column ({1}) in the type ({2}).',
    'DM_QUERY_E_QUERY_IS_NOT_FTDQL': 'You specified ENABLE(FTDQL) hint for a SELECT statement that does not conform to the rules of FTDQL',
    'DM_QUERY_E_NOT_RESTRICTED_FOLDER_ID': 'You have specified an ID value ( \'{0}\' ) that is not a folder (or subfolder of a folder) in the user\'s restricted_folder_ids.',
    'DM_QUERY_E_NOT_RESTRICTED_FOLDER_PATH': 'You have specified a folder path ( \'{0}\' ) that is not a folder (or subfolder of a folder) in the user\'s restricted_folder_ids.',
    'DM_QUERY_E_QUERY_HAS_OBSOLETE_KEYWORDS_IN_SELECT_LIST': 'The query statement contains the following obsolete keywords in the select list: \'{0}\'',
    'DM_QUERY_E_CONFLICT_HINTS': 'The DQL hints {0} and {1} are not compatible.',
    'DM_QUERY_E_TOO_MANY_FOLDERS_FOR_FTDQL': 'The folder predicate in the query exceeds the maximum number of supported folders ({0}). Conversion error message from the query plug-in: {1}',
    'DM_QUERY_E_CANT_USE_CONTENT_ATTS_WITH_LITE_OBJ': 'DQL does not support using the \'i_contents_id\', \'r_content_size\' or \'r_full_content_size\' attributes with Lightweight Objects',
    'DM_QUERY_E_DATE_FORMAT_EX': 'The specified date literal ({0}) is not in a recognized format, or the UTC of the specified date is out of the valid date range.',
    'DM_QUERY_E_MODIFY_SPACEOPTIMIZE_LOCAL_ONLY': 'ALTER TYPE:  The attribute {0} is not a local attribute of the type {1}.',
    'DM_QUERY_E_MODIFY_SPACEOPTIMIZE_MISMATCH_TYPE': 'ALTER TYPE:  The attribute {0} has a data type {1} different than the one ({2}) specified in the query.',
    'DM_QUERY_E_MODIFY_SPACEOPTIMIZE_WRONG_STRING_LENGTH': 'ALTER TYPE:  The string attribute {0} can not have a non-zero length ({1}) while enabling spaceoptimize.',
    'DM_QUERY_E_DATE_LOCAL_FUNCTION_NOT_SUPPORTED': 'The specified date arithmetic function {0} is not supported in the given context : {1} : {2}',
    'DM_QUERY_E_UP_INVALID_ATTR': 'The attribute {0} of a dm_group object cannot be updated directly. Please use the ALTER GROUP statement to change this attribute.',
    'DM_QUERY_E_UNABLE_TO_FETCH_CONFIG_TYPE': 'Cannot fetch message queue configuration type (\'{0}\').',
    'DM_QUERY_E_CANNOT_FIND_MQ_CONFIG_OBJECT': 'Cannot find configuration object for message queue (\'{0}\').',
    'DM_QUERY_E_MQ_ALREADY_EXISTS': 'CREATE MESSAGE_QUEUE: Message queue (\'{0}\') already exists.',
    'DM_QUERY_E_MQ_ADD_INTRINSIC_ATTR_FAILED': 'CREATE MESSAGE_QUEUE: Adding mesage queue intrinsic attributes failed in creating message queue (\'{0}\').',
    'DM_QUERY_E_INVALID_CHARS_IN_SQLHINT': 'Unexpected character(s) found in the hint. This could be a malformed query or a deliberate attempt for injecting SQL. User: {0} client: {1} query: {2} ',
    'DM_QUERY_E_INVALID_POSITION': 'The ORDER BY position number {0} is out of range of the number of items in the select list.',
    'DM_QUERY_F_ALTER_FAILED': 'ALTER TYPE statement failed.',
    'DM_QUERY_F_ALTER_STORE_FAILED': 'ALTER TYPE:  An unexpected error has occurred while storing the changes to the type {0}.',
    'DM_QUERY_F_COMMIT_FAILED': '{0}:  An attempt to commit your statement\'s changes to the database has failed, causing your statement to fail.',
    'DM_QUERY_F_CURSOR_CREATE': 'SELECT:  Unable to create the SQL cursor to represent this DQL query.',
    'DM_QUERY_F_DATABASE_ERROR': '{0}:  An unexpected database error has occurred (\'{1}\'), causing your statement to fail.',
    'DM_QUERY_F_INTERNAL': 'An internal inconsistency has occurred in function {0}. {1} {2}.',
    'DM_QUERY_F_INTERNAL_P': 'An internal problem has occurred in function {0}:  {1}.',
    'DM_QUERY_F_INVALID_GROUP': '{0}:  The group specified ({1}) was not properly fetched.',
    'DM_QUERY_F_NO_COLL': 'Unable to create the dmQueryResults collection.',
    'DM_QUERY_F_NO_CONNECTION': 'Unable to create a database connection.',
    'DM_QUERY_F_NO_CONTEXT': 'Unable to create a query context block.',
    'DM_QUERY_F_NO_INFO_OBJECT': 'Unable access the dmInfoObject.',
    'DM_QUERY_F_NO_OWNER': 'Unable retrieve the docbase owner from initialization file.',
    'DM_QUERY_F_NO_QUERY': 'The query string was not found.',
    'DM_QUERY_F_NO_REG': '{0}:  An unexpected error has occurred during a {1} operation, causing your statement to fail.',
    'DM_QUERY_F_NO_RESULT': 'Unable to create the `result object\' for the query results.',
    'DM_QUERY_F_NO_TYPE': 'Unable to create the `type\' of the query results object.',
    'DM_QUERY_F_ROLLBACK_FAILED': 'An attempt to rollback your statement\'s changes to the database has failed.',
    'DM_QUERY_F_SET_FAILED_I': '{0}:  Unable to set this attribute ({1}) with this value ({2}).',
    'DM_QUERY_F_SET_FAILED_S': '{0}:  Unable to set this attribute ({1}) with this value ({2}).',
    'DM_QUERY_F_TYPE_FAIL': 'An error occurred adding attribute {0} (with datatype, {1}) to the query results type.',
    'DM_QUERY_F_UP_SAVE': 'UPDATE:  An error has occurred during a save operation.',
    'DM_QUERY_F_UP_DESTROY': 'DELETE:  An error has occurred during a destroy operation.',
    'DM_QUERY_F_RESULT_NOT_SET_INT': 'Unable to set the integer return value for this query: {0}.',
    'DM_QUERY_F_RESULT_NOT_SET_ID': 'Unable to set the ID return value for this query: {0}.',
    'DM_QUERY_F_SYSOBJ_NOT_FOUND': 'Unable to find the SysObject matching ID {0}.',
    'DM_QUERY_F_COMPOUND_INT': 'An internal inconsistency has been encountered while recursively processing {0} for {1}.',
    'DM_QUERY_F_TRAN_ABORT_FAILED': 'ABORT:  Your abort transaction statement failed.',
    'DM_QUERY_F_TRAN_BEGIN_FAILED': 'BEGIN TRANSACTION:  Your begin transaction statement failed.',
    'DM_QUERY_F_TRAN_COMMIT_FAILED': 'COMMIT:  Your commit transaction statement failed.',
    'DM_QUERY_F_CHANGE_DESTROY': 'CHANGE:  An unexpected destroy error has occurred for object {0}.',
    'DM_QUERY_F_CHANGE_SAVE': 'CHANGE:  An unexpected save error has occurred for object {0}.',
    'DM_QUERY_F_CREATE_UNABLE': 'CREATE OBJECT:  An unexpected error has caused your creation of {0} object to fail.',
    'DM_QUERY_F_SET_FAILED_SS': '{0}:  Unable to set this attribute ({1}) with this value ({2} {3}).',
    'DM_QUERY_F_CHANGE_CONTENT_SAVE': 'CHANGE: An unexpected save error has occurred on content object ({0}). Please check for any accompanying error messages.',
    'DM_QUERY_F_CHANGE_CONTENT_BAD': 'CHANGE: The status for content object ({0}) is bad. Please check for any accompanying error messages and examine the file.',
    'DM_QUERY_F_THUMBNAIL_QUERY_ERROR': '{0}:  A database error has occurred (\'{1}\') causing the thumbnail URL query to fail. Query: (\'{2}\')',
    'DM_QUERY_F_MQ_CREATE_CONFIG_FAILED': 'CREATE MESSAGE_QUEUE: Cannot create configuration object for message queue (\'{0}\').',
    'DM_QUERY_F_MQ_CREATE_INDEX_FAILED': 'CREATE MESSAGE_QUEUE: Cannot create index for message queue (\'{0}\').',
    'DM_QUERY2_W_DROP_TYPE_CANNOT_FETCH_AGGR_DOMAIN': 'Cannot fetch the dm_aggr_domain object with ID \'{0}\' while dropping type {1}.  Proceeding with drop type operation.',
    'DM_QUERY2_W_NO_PRIMARY_KEY': 'No primary key exists to DROP.  DROP clause ignored.',
    'DM_QUERY2_W_NO_UNIQUE_KEY': 'No unique key matching the one specified exists to DROP.  DROP clause ignored.',
    'DM_QUERY2_W_NO_FOREIGN_KEY': 'No foreign key matching the one specified exists to DROP.  DROP clause ignored.',
    'DM_QUERY2_W_ATTRS_NOT_ALTERED_FTINDEX': 'String-valued attributes are not marked for fulltext indexing because index objects of type {0} already exist. Please see the documentation for more information.',
    'DM_QUERY2_W_DATA_DICTIONARY_PUBLISH_FAILURE_A_C': 'ALTER/CREATE for type {0}: The Data Dictionary encountered a failure while trying to publish Data Dictionary information. The ALTER/CREATE has succeeded, but the user should manually try to publish the Data Dictionary information for this type using the publish_dd API. More detailed error messages should follow.',
    'DM_QUERY2_W_CONVERSION_ERROR': 'Conversion error message from the query plug-in: {0}',
    'DM_QUERY2_E_PIPER_NOT_SUPPORTED_YET_TYPE_A_C': 'ALTER/CREATE for type {0}:  Feature ({1}) is not yet supported in Piper.',
    'DM_QUERY2_E_DD_NOT_YET_SUPPORTED_ATTR_A_C': 'ALTER/CREATE for type {0}, attribute {1}:  Feature ({2}) is not yet supported in Documentum 4i Server.',
    'DM_QUERY2_E_DATA_DICT_ERROR_FOR_TYPE_A_C': 'The following error(s) occurred processing an ALTER/CREATE statement for type {0}.',
    'DM_QUERY2_E_DATA_DICT_ERROR_FOR_ATTR_A_C': 'The following error(s) occurred processing an ALTER/CREATE statement for type {0}, attribute {1}.',
    'DM_QUERY2_E_NO_FUNCTION_LOCATION': 'User function {0} must specify a location by object id or folder path.',
    'DM_QUERY2_E_BAD_FUNCTION_LOCATION_ID': 'The location id for user function {0} is invalid ({1}).',
    'DM_QUERY2_E_UNSUPPORTED_DD_VALUE_SPECIFICATION': 'Only literals, NULL, USER, date(now), date(today), date(tomorrow), and date(yesterday) are allowed here.',
    'DM_QUERY2_E_UNSUPPORTED_DD_DATE_FUNCTION': 'Only date(now), date(today), date(tomorrow), and date(yesterday) are allowed here.',
    'DM_QUERY2_E_BAD_VALUE_LIST_ELEMENT': 'Only literal values are allowed in a value assistance list.',
    'DM_QUERY2_E_LITERAL_REQUIRED': 'Only literal values are allowed here.',
    'DM_QUERY2_E_VALUE_ASSIST_FOR_WHOLE_TYPE': 'Value assistance was specified for type {0}.  It is only allowed on individual attributes.',
    'DM_QUERY2_E_VALUE_LIST_WRONG_TYPE': 'A literal in the value assistance list for type {0}, attribute {1} is the wrong type.  Expected {2}, found {3}.',
    'DM_QUERY2_E_MAPPING_TABLE_FOR_WHOLE_TYPE': 'A mapping table was specified for type {0}.  It is only allowed on individual attributes.',
    'DM_QUERY2_E_MAPPING_TABLE_WRONG_TYPE': 'A literal in the mapping table value list for type {0}, attribute {1} is the wrong type.  Expected {2}, found {3}.',
    'DM_QUERY2_E_BAD_UPDATE_CLAUSE_IN_MODIFIER': 'The \'{0}\' form of the update clause is not allowed in a type/attribute modifier.',
    'DM_QUERY2_E_BAD_UPDATE_VALUE_IN_MODIFIER': 'Only literals are allowed in the update form of a type/attribute modifier.',
    'DM_QUERY2_E_DATE_LITERAL_IN_UPDATE_MODIFIER': 'Date literals are not supported in the update form of a type/attribute modifier.',
    'DM_QUERY2_E_SAVE_AGGR_DOMAIN_FAILED': 'Save of type/attribute modifiers failed for type {0}.',
    'DM_QUERY2_E_BAD_COMPONENT_ID': 'Bad object id \'{0}\' for component classifier {1}.',
    'DM_QUERY2_E_BAD_ATTR_FOR_TYPE': 'Attribute \'{0}\' does not exist for type \'{1}\'.',
    'DM_QUERY2_E_DUPLICATE_VALUE_ESTIMATE': 'Duplicate VALUE ESTIMATE clause for value assistance.',
    'DM_QUERY2_E_BAD_VALUE_ESTIMATE': 'VALUE ESTIMATE ({0}) must be greater than zero.',
    'DM_QUERY2_E_DUPLICATE_IS_COMPLETE': 'Duplicate IS COMPLETE clause for value assistance.',
    'DM_QUERY2_E_DUPLICATE_QRY_ATTR': 'Duplicate QRY ATTR clause for value assistance.',
    'DM_QUERY2_E_BAD_QRY_ATTR': 'The attribute \'{0}\' specified in the QRY ATTR clause does not exist in the type.',
    'DM_QUERY2_E_DUPLICATE_ALLOW_CACHING': 'Duplicate ALLOW CACHING clause for value assistance.',
    'DM_QUERY2_E_DUPLICATE_VALUE_SEPARATOR': 'Duplicate SEPARATOR clause for value assistance.',
    'DM_QUERY2_E_BAD_VALUE_SEPARATOR': 'The string \'{0}\' specified in the SEPARATOR clause is not length 1.',
    'DM_QUERY2_E_BAD_VA_FOR_QRY_ATTR': 'The QRY ATTR clause can only be specified for QRY value assistance.',
    'DM_QUERY2_E_BAD_VA_FOR_ALLOW_CACHING': 'The ALLOW CACHING clause can only be specified for QRY value assistance.',
    'DM_QUERY2_E_BAD_VA_FOR_VALUE_SEPARATOR': 'The SEPARATOR clause can only be specified for FUNCTION value assistance.',
    'DM_QUERY2_E_QUERY_VA_NOT_SELECT': 'The QRY form of value assistance must use a SELECT statement.',
    'DM_QUERY2_E_VA_QUERY_SYNTAX': 'For the query string used in QRY value assistance, a parser error ({0}) has occurred in the vicinity of:  {1}',
    'DM_QUERY2_E_BAD_UPDATE_WITH_NULL': 'NULL cannot be used with APPEND, INSERT, REMOVE, or TRUNCATE.',
    'DM_QUERY2_E_NULL_BUSINESS_POLICY_ID': 'The object id specified for the DEFAULT BUSINESS POLICY is NULL.',
    'DM_QUERY2_E_BAD_DEFAULT_FOR_REPEATING': 'Attribute {0} of type {1} is repeating, so the list form of the DEFAULT value clause must be used.',
    'DM_QUERY2_E_BAD_DEFAULT_FOR_NON_REPEATING': 'Attribute {0} of type {1} is not repeating, so the single value form of the DEFAULT value clause must be used.',
    'DM_QUERY2_E_DEFAULT_FOR_WHOLE_TYPE': 'A default value was specified for type {0}.  A default value is only allowed on individual attributes.',
    'DM_QUERY2_E_NO_ADD_FOREIGN_KEY_PRIV': 'You have insufficient privilege to add a foreign key.',
    'DM_QUERY2_E_NO_DROP_FOREIGN_KEY_PRIV': 'You have insufficient privilege to drop a foreign key.',
    'DM_QUERY2_E_NO_PRIMARY_KEY': 'No primary key exists to DROP.',
    'DM_QUERY2_E_NO_UNIQUE_KEY': 'No unique key matching the one specified exists to DROP.',
    'DM_QUERY2_E_NO_FOREIGN_KEY': 'No foreign key matching the one specified exists to DROP.',
    'DM_QUERY2_E_CANNOT_GENERATE_FOREIGN_KEY_NAME': 'Cannot generate a foreign key name for type {0} attribute {1}.',
    'DM_QUERY2_E_QUERY_VA_STAR_SELECT_LIST': 'The QRY form of value assistance cannot use \'*\' in the select list.',
    'DM_QUERY2_E_QUERY_VA_AS_NAME': 'The QRY form of value assistance cannot use an AS name ({0}) in the select list.',
    'DM_QUERY2_E_QUERY_VA_BAD_FIRST_VALUE': 'The first value in the select list for QRY value assistance is not a simple attribute name.',
    'DM_QUERY2_E_QUERY_VA_QUERY_ATTR_NOT_FOUND': 'The attribute specified in the QRY ATTR clause ({0}) was not found in the select list for the QRY value assistance query.',
    'DM_QUERY2_E_QUERY_VA_ATTR_NOT_FOUND': 'The query attribute from QRY value assistance ({0}) does not exist in type {1}.',
    'DM_QUERY2_E_QUERY_VA_ATTR_WRONG_TYPE': 'The type of the query attribute ({0}) from QRY value assistance does not match the type of attribute {1} in type {2}.  Expected {3}, found {4}.',
    'DM_QUERY2_E_ALTER_BAD_POLICY_ID': 'The business policy id ({0}) specified in ALTER TYPE is not valid.',
    'DM_QUERY2_E_ALTER_CANNOT_FETCH_POLICY': 'Could not fetch the business policy id ({0}) specified in ALTER TYPE.',
    'DM_QUERY2_E_ALTER_BAD_STATE_NAME': 'The business policy with object id {0} does not have a state named {1}.',
    'DM_QUERY2_E_DROP_TYPE_COMMIT_EXTERNAL_TRANSACTION': 'DROP TYPE for {0} is not allowed inside an explicit transaction if Data Dictionary information is present.',
    'DM_QUERY2_E_DUPLICATE_DEFAULT': 'Duplicate DEFAULT value clause.',
    'DM_QUERY2_E_DUPLICATE_DEFAULT_POLICY': 'Duplicate DEFAULT BUSINESS POLICY clause.',
    'DM_QUERY2_E_DUPLICATE_COMPONENTS': 'Duplicate COMPONENTS clause.',
    'DM_QUERY2_E_DUPLICATE_COMPUTED': 'Duplicate COMPUTED FROM clause.',
    'DM_QUERY2_E_DUPLICATE_VALUE_ASSIST': 'Duplicate VALUE ASSISTANCE clause.',
    'DM_QUERY2_E_DUPLICATE_MAPPING_TABLE': 'Duplicate MAPPING TABLE clause.',
    'DM_QUERY2_E_DUPLICATE_DROP_DEFAULT': 'Duplicate DROP DEFAULT clause.',
    'DM_QUERY2_E_DUPLICATE_DROP_NOT_NULL': 'Duplicate DROP NOT NULL clause.',
    'DM_QUERY2_E_DUPLICATE_DROP_CHECK': 'Duplicate DROP CHECK clause.',
    'DM_QUERY2_E_DUPLICATE_DROP_COMPUTED_FROM': 'Duplicate DROP COMPUTED FROM clause.',
    'DM_QUERY2_E_DUPLICATE_DROP_VALUE_ASSIST': 'Duplicate DROP VALUE ASSISTANCE clause.',
    'DM_QUERY2_E_DUPLICATE_DROP_MAPPING_TABLE': 'Duplicate DROP MAPPING TABLE clause.',
    'DM_QUERY2_E_DUPLICATE_DROP_COMPONENTS': 'Duplicate DROP COMPONENTS clause.',
    'DM_QUERY2_E_NO_COLUMNS_FOR_TYPE_LEVEL_PRIMARY_KEY': 'A Primary Key specified at the type level must contain an attribute list.',
    'DM_QUERY2_E_NO_COLUMNS_FOR_TYPE_LEVEL_UNIQUE_KEY': 'A Unique constraint specified at the type level must contain an attribute list.',
    'DM_QUERY2_E_NO_CHILD_COLUMNS_FOR_TYPE_LEVEL_FOREIGN_KEY': 'A Foreign Key specified at the type level must contain a child attribute list.',
    'DM_QUERY2_E_ALTER_NOT_PRIMARY_TYPE_FOR_POLICY': 'The type being altered ({0}) is not the primary type ({1}) for the busines policy with object id \'{2}\'.',
    'DM_QUERY2_E_NOT_ENOUGH_PRIVILEGE_FOR_USER_FUNCTION': 'To invoke code in a user-provided function ({0}) you must have at least sysadmin privilege.',
    'DM_QUERY2_E_DEFAULT_STORAGE_FOR_POLICY_OVERRIDE': 'You cannot specify a DEFAULT STORAGE clause for a business policy state.',
    'DM_QUERY2_E_DEFAULT_PERMIT_FOR_POLICY_OVERRIDE': 'You cannot specify a (default) PERMIT clause for a business policy state.',
    'DM_QUERY2_E_DEFAULT_GROUP_FOR_POLICY_OVERRIDE': 'You cannot specify a DEFAULT GROUP clause for a business policy state.',
    'DM_QUERY2_E_DEFAULT_ACL_FOR_POLICY_OVERRIDE': 'You cannot specify a DEFAULT ACL clause for a business policy state.',
    'DM_QUERY2_E_ADD_ATTRIBUTES_FOR_POLICY_OVERRIDE': 'You cannot ADD type attributes for a business policy state.',
    'DM_QUERY2_E_DROP_ATTRIBUTES_FOR_POLICY_OVERRIDE': 'You cannot DROP type attributes for a business policy state.',
    'DM_QUERY2_E_ADD_FULLTEXT_FOR_POLICY_OVERRIDE': 'You cannot specify an ADD_FTINDEX clause for a business policy state.',
    'DM_QUERY2_E_DROP_FULLTEXT_FOR_POLICY_OVERRIDE': 'You cannot specify a DROP_FTINDEX clause for a business policy state.',
    'DM_QUERY2_E_CHANGE_ATTRIBUTE_LENGTH_FOR_POLICY_OVERRIDE': 'You cannot modify the length of an attribute ({0}) for a business policy state.',
    'DM_QUERY2_E_NON_ACL': 'Non-ACL Permissions are no longer supported.',
    'DM_QUERY2_E_DUPLICATE_FOREIGN_KEY': 'You cannot supply two foreign keys with the same child attributes.',
    'DM_QUERY2_E_DUPLICATE_UNIQUE_KEY': 'You cannot supply two unique keys with the same attributes.',
    'DM_QUERY2_E_DUPLICATE_PRIMARY_KEY': 'You cannot supply two primary keys for the same type.',
    'DM_QUERY2_E_DEFAULT_FOR_ADDED_ATTRIBUTE': 'You cannot supply a DEFAULT value when adding an attribute.',
    'DM_QUERY2_E_LITERAL_EXPR_STRING_TOO_LONG': 'The the length of literal expression \'{0}\' ({1}) exceeds the maximum allowed for a literal ({2}).',
    'DM_QUERY2_E_LITERAL_VALUE_WRONG_TYPE': 'A literal supplied for type {0}, attribute {1} is the wrong type.  Expected {2}, found {3}.',
    'DM_QUERY2_E_ANY_PREDICATE_TYPES': 'You have specified attributes from more than one type in your ANY predicate.',
    'DM_QUERY2_E_TOO_MANY_TYPES_IN_JOIN': 'Your query has too many types in the FROM clause.',
    'DM_QUERY2_E_REPEAT_TYPE_JOIN': 'Your query is selecting repeating attributes and joining types.',
    'DM_QUERY2_E_OWNERNAME_QUAL': 'You have qualified a typename or correlation ({0}) name with an ownername qualifier.',
    'DM_QUERY2_E_JOIN_SEARCH': 'Your query specifies both a fulltext query and a multi-type join.',
    'DM_QUERY2_E_UPDATE_ATTRIBUTE_NOT_REPEATING': 'The Data Dictionary attribute {0} is not repeating.',
    'DM_QUERY2_E_ILLEGAL_ATTR_LEVEL_PRIMARY_KEY': 'The primary key specified at the attribute level for attribute {0} references another attribute ({1}).',
    'DM_QUERY2_E_ILLEGAL_ATTR_LEVEL_UNIQUE_KEY': 'The unique key specified at the attribute level for attribute {0} references another attribute ({1}).',
    'DM_QUERY2_E_COLLECTION_FAIL': 'Error executing query; the query collection terminated abnormally. Query was: {0}',
    'DM_QUERY2_E_DATA_DICTIONARY_PUBLISH_FAILURE': 'While trying to publish Data dictionary information (dmi_dd_common/type/attr info) for object defined by {0}, an error occured.',
    'DM_QUERY2_E_DATA_DICTIONARY_PUBLISH_SYNTAX': 'The alter/create statement should either have the word PUBLISH, or be left blank. {0} is an invalid argument.',
    'DM_QUERY2_E_DATA_DICTIONARY_LOGGING_FAILURE': 'While trying to log Data dictionary information (in dd_publish_log) for object defined by {0}, an error occured.',
    'DM_QUERY2_E_DD_FILE_NOT_FOUND_IN_DOCBASE': 'The object with the path {0} and version {1} is not found in the docbase.',
    'DM_QUERY2_E_DD_DO_NOT_HAVE_READ_PERMISSION': 'You do not have permission to read the sysobject with the path {0} and version {1}.',
    'DM_QUERY2_E_SYSOBJECT_FOR_FILE_NOT_FOUND_IN_DOCBASE': 'The sysobject with object id: {0} for the path {1} and version {2} is not found in the docbase.',
    'DM_QUERY2_E_DROP_FTATTRS_FAILED': 'An attempt to drop an indexed attribute(s) failed because there are existing indexed objects of type {0} in the docbase.',
    'DM_QUERY2_E_UP_OUT_OF_RANGE': 'Unable to set attribute {0} because the value being assigned is out of range',
    'DM_QUERY2_E_UNRECOGNIZED_HINT': '{0} is an unknown hint or is being used incorrectly.',
    'DM_QUERY2_E_INVALID_LOCALE_SETTING': 'ALTER/CREATE TYPE: The session_locale setting of \'{0}\' in the sessionconfig object is not a valid locale in the docbase. The ALTER/CREATE is disallowed because it contains locale sensitive information for an invalid locale. Please either set the session_locale to a valid dd_locales value ({1}), or add a new locale entry to dd_locales (dm_docbase_config).',
    'DM_QUERY2_E_TABLE_NOT_FOUND': 'The database table or view was not found in the database. Error from the database was: \'{0}\'',
    'DM_QUERY2_E_CREATE_ALTER_TYPE_FAILURE': 'An error was encountered during a CREATE/ALTER statement for type \'{0}\'. Failed query was: \'{1}\'',
    'DM_QUERY2_E_TOO_MANY_FOLDERS_FOR_FTDQL': 'The folder predicate in the query exceeds the maximum number of supported folders ({0}).',
    'DM_QUERY2_E_ALLOW_ASPECTS_MUST_BE_SUPERMOST_TYPE': 'ALTER TYPE statement to ALLOW ASPECTS can be executed on a type with no super types only. Type ({0}) has a super type ({1})',
    'DM_QUERY2_E_ALLOW_ASPECTS_SYSOBJECT_TYPE_NOT_ALLOWED': 'ALTER TYPE statement to ALLOW ASPECTS cannot be executed on a sysobject sub-type. Type ({0}) is a sysobject sub-type',
    'DM_QUERY2_E_ALLOW_ASPECTS_CANT_ALLOW': 'Type {0} cannot be altered to allow aspects because the type or a sub-type in the type hierarchy has an attribute named r_aspect_name',
    'DM_QUERY2_E_ALLOW_ASPECTS_NOT_SUPERUSER': 'You do not have super-user privileges to alter ({0}) type to allow aspects',
    'DM_QUERY2_E_ALTER_ASPECT_NOT_SUPER_USER': 'You must be a super user to execute an alter aspect statement',
    'DM_QUERY2_E_ALTER_ASPECT_UNABLE_TO_FETCH_TYPE': 'Unable to fetch type ({0})',
    'DM_QUERY2_E_ALTER_ASPECT_MISSING_ATTRIBUTE': 'Type ({0}) does not have the attribute ({1})',
    'DM_QUERY2_E_ALTER_ASPECT_ATTR_DEF_MISMATCH': 'Invalid data type or nature of i_attr_def attribute',
    'DM_QUERY2_E_ALTER_ASPECT_UNABLE_TO_FETCH_ASPECT': 'Unable to fetch the aspect with name ({0}) id ({1})',
    'DM_QUERY2_E_ALTER_ASPECT_MULTIPLE_ASPECTS_FOUND': 'Multiple aspects with the name ({0}) was found in the repository',
    'DM_QUERY2_E_ALTER_ASPECT_INVALID_ASPECT': 'Aspect ({0}) is invalid and is not found in the repository',
    'DM_QUERY2_E_ALTER_ASPECT_FAILED': 'Alter aspect statement failed.',
    'DM_QUERY2_E_ALTER_ASPECT_INVALID_OPERATION': 'Cannot perform ({0}) action on aspect ({1}) because {2}',
    'DM_QUERY2_E_ALTER_ASPECT_INVALID_TYPE_OBJECT': 'The internal type ({0}) referenced by aspect ({1}) for aspect attributes is invalid',
    'DM_QUERY2_E_ALTER_ASPECT_CANT_GET_TEMP_DATABASE_CONNECTION': 'Unable to get a temporary database connection to perform the alter aspect operation',
    'DM_QUERY2_E_ALTER_ASPECT_CANNOT_TOGGLE_OPTIMIZEFETCH': 'Optimization options for aspect attributes OPTIMIZEFETCH or NO OPTIMIZEFETCH specified does not match the current setting for aspect ({0})',
    'DM_QUERY2_E_TYPE_NOT_ASPECTS_ENABLED': 'Type ({0}) specified in the from clause is not enabled for aspects. Cannot reference aspect attribute(s) in the {1} of the query',
    'DM_QUERY2_E_AMBIGUOUS_ASPECT_ATTR_USAGE': 'Query has multiple types in the from clause. Could not resolve ambiguity of association of the aspect attribute {0} in the {1} of the query',
    'DM_QUERY2_E_INVALID_TYPE_CORRELATION_FOR_ASPECT_ATTR': 'Invalid type or correlation qualifier specified for aspect attribute {0}',
    'DM_QUERY2_E_INVALID_ASPECT_ATTRIBUTE': 'Aspect ({0}) does not have a attribute named ({1})',
    'DM_QUERY2_E_NOT_SHAREABLE_TYPE': 'Shared parent type ({0}) is not a shareable type.',
    'DM_QUERY2_E_': '',
    'DM_QUERY2_E_NOT_DMSYSOBJECT_TYPE': 'Type ({0}) is not dm_sysobject or a dm_sysobject subtype.',
    'DM_QUERY2_E_LITETYPE_NOT_SHAREABLE': 'Lightweight object types cannot be set to shareable',
    'DM_QUERY2_E_ALREADY_SHAREABLE': 'Type ({0}) is already a shareable type.',
    'DM_QUERY2_E_NOT_LITETYPE': '{0} is not a lightweight type.',
    'DM_QUERY2_E_MISS_LIGHTWEIGHT_OR_SHARES': 'lightweight and shares keywords must co-exist to create a lightweight type.',
    'DM_QUERY2_E_NO_ARCHIVE_SERVICE_LICENSE': 'An Archive Services license is required to create a lightweight or shareable type',
    'DM_QUERY2_E_MIXED_TYPE_REPEATING_ATTRS': 'Repeating attributes from shared parent type and repeating attributes from lightweight type, or repeating attribute and single attributes cannot be referenced in an expression in a select list item when querying a lightweight type.',
    'DM_QUERY2_E_INCORRECT_GROUPBY_FOR_LIGHTWEIGHT_AGGREGATE': 'The DQL statement has an aggregate function on a lightweight repeating attribute, the group by clause can only have r_object_id.',
    'DM_QUERY2_E_MISSING_OBJECTID_IN_SELECT_LIST': 'The DQL statement has non-qualifiable attribute(s) or repeating attribute(s) from lightweight type or repeating aspect attribute(s) in the select list, r_object_id is required in the select list.',
    'DM_QUERY2_E_LIGHTWEIGHT_REPEATING_IN_SUBQUERY': 'You cannot specify lightweight repeating attribute(s) in the select list of a subquery.',
    'DM_QUERY2_E_MIXED_TYPE_REPEATING_ASPECT_ATTRS': 'Repeating attributes from different aspects cannot be referenced in an expression in a select list item.',
    'DM_QUERY2_E_INCORRECT_GROUPBY_FOR_ASPECT_AGGREGATE': 'The DQL statement has an aggregate function on a repeating aspect attribute, the group by clause can only have r_object_id.',
    'DM_QUERY2_E_REPEATING_ASPECT_ATTR_IN_SUBQUERY': 'You cannot specify a repeating aspect attribute(s) in the select list of a subquery.',
    'DM_QUERY2_E_NQA_IN_WHERE_CLAUSE': 'You cannot specify nonqualifiable attributes ({0}) in where, order by and group by clause.',
    'DM_QUERY2_E_NQA_IN_FUNCTION': 'You cannot specify nonqualifiable attributes ({0}) in the functions or expressions.',
    'DM_QUERY2_E_NQA_IN_SUBQUERY': 'You cannot specify a nonqualifiable attribute in the select list of a subquery.',
    'DM_QUERY2_E_TYPE_ALREADY_PARTITIONED': 'Type ({0}) is already partitioned.',
    'DM_QUERY2_E_CANNOT_PARTITION': 'You need to run the data partitioning script generated by the GENERATE_PARTITION_SCHEME_SQL apply method against the database server before you can enable partitioning for any type.',
    'DM_QUERY2_E_PARTITION_NOT_SUPPORTED': 'Data partitioning is not supported.',
    'DM_QUERY2_E_PARTITION_API_INVALID_ARG': 'You specified arguments incorrectly for the GENERATE_PARTITION_SCHEME_SQL apply method.',
    'DM_QUERY2_E_PARTITION_API_INVALID_ARG2': 'DEFAULT_PARTITION and DEFAULT_TABLESPACE need to co-exist if you specify any of them in the GENERATE_PARTITION_SCHEME_SQL apply method.',
    'DM_QUERY2_E_DEFAULT_ASPECTS_NOT_SUPERUSER': 'You do not have Superuser privileges to alter the ({0}) type to set/add/remove default aspects',
    'DM_QUERY2_E_DEFAULT_ASPECTS_TYPE_NOT_ALLOWED': 'The type ({0}) specified in the ALTER TYPE statement is not enabled for default aspects.',
    'DM_QUERY2_E_NON_PARTITIONABLE_TYPE': 'Internal type {0} cannot be partitioned.',
    'DM_QUERY2_E_REPEATING_ASPECT_ATTR_IN_INVALID_CLAUSE': 'You cannot specify a repeating aspect attribute(s) in {0} clause.',
    'DM_QUERY2_E_INCONSISTENT_UNION': 'Incompatible select list items ({0}) and ({1}) have been specified in the union clauses.',
    'DM_QUERY2_E_ALREADY_LIGHTWEIGHT': 'Type ({0}) is already a lightweight type.',
    'DM_QUERY2_E_SHAREABLE_NOT_LITETYPE': 'Shareable object types cannot be set to lightweight',
    'DM_QUERY2_E_NO_SHAREABLE_SUBTYPES': 'Cannot make type {0} shareable as it has shareable subtypes',
    'DM_QUERY2_E_FTDQL_LITE_TYPE_FAIL': 'Cannot execute FTDQL for lightweight type {0} that does not have fulltext support.',
    'DM_QUERY2_E_OP_DISALLOW_DATATYPE': 'Operation {0} does not support datatype {1}',
    'DM_QUERY2_E_NO_HIGH_VOLUME_SERVER_LICENSE': 'A High-Volume Server license is required to create a lightweight or shareable type',
    'DM_QUERY2_E_UNKNOWN_XQUERY_TARGET': 'Unknown XQuery target: {0}',
    'DM_QUERY2_E_ALTER_TYPE_LIGHTWEIGHT_ONLY': 'The ALTER TYPE clause, {0}, can not be applied to type, {1}, because it is not a lightweight type',
    'DM_QUERY2_E_WRONG_PRIVILEGE_FOR_LITE_KEYWORD': 'The query with LITE keyword was issued by user without enough privilege, only superuser, or member of dm_read_all (or dm_browse_all) can issue such kind of query.',
    'DM_QUERY2_E_DATA_TYPE_NOT_SUPPORTED': 'The data type, {0}, declared for attribute, {1}, is not supported in {2} database platform.',
    'DM_QUERY2_E_BAD_THUMBNAIL_URL_CONFIGURATION': 'Validation of the custom settings for the thumbnail_url DQL query failed. Query: ({0}). Error: ({1}). Where clause extra: ({2}). Order by clause: ({3}).',
    'DM_QUERY2_E_FUNCTION_MISSING_PARAMETER': 'The function {0} is missing the value of a parameter {1}.',
    'DM_QUERY2_E_CONFLICT_ON_HINTS': 'The DQL hints {0} and {1} can not be used together.',
    'DM_QUERY2_F_CREATE_SET_OVERRIDE_FAILED': 'CREATE TYPE:  Unable to set the type_override attribute in the dmi_type_info object for type {0}.',
    'DM_QUERY2_F_CREATE_STORE_OVERRIDE_FAILED': 'CREATE TYPE:  Unable to store the updated type_override in the dmi_type_info object for type {0}.',
    'DM_QUERY2_F_BAD_MODIFIER_TYPE': 'ALTER/CREATE TYPE:  Unknown modifier type ({0}) for type {1}.',
    'DM_QUERY2_F_BAD_CONSTRAINT_TYPE': 'ALTER/CREATE TYPE:  Unknown constraint type ({0}) for type {1}.',
    'DM_QUERY2_F_BAD_KEY_TYPE': 'ALTER/CREATE TYPE:  Unknown key type ({0}) for type {1}.',
    'DM_QUERY2_F_BAD_EXPRESSION_TYPE': 'ALTER/CREATE TYPE:  Unknown expression type ({0}) for type {1}.',
    'DM_QUERY2_F_BAD_UPDATE_TYPE': 'ALTER/CREATE TYPE:  Unknown update type ({0}) for type {1}.',
    'DM_QUERY2_F_INTERNAL_ERROR_IN_MODIFIER': 'ALTER/CREATE TYPE:  An internal error occurred while processing a Data Dictionary modifier for type {0}: ({1}).',
    'DM_QUERY2_F_INTERNAL_ERROR_IN_ATTR_MODIFIER': 'ALTER/CREATE TYPE:  An internal error occurred while processing a Data Dictionary modifier for type {0}, attribute {1}: ({2}).',
    'DM_QUERY2_F_BAD_EXPRESSION_LANGUAGE': 'ALTER/CREATE TYPE:  Unknown expression language ({0}) for type {1}.',
    'DM_QUERY2_F_BAD_VALUE_ASSISTANCE_TYPE': 'ALTER/CREATE TYPE:  Unknown value assistance type ({0}) for type {1}.',
    'DM_QUERY2_F_BAD_LITERAL_TYPE': 'ALTER/CREATE TYPE:  Unknown literal type ({0}) for type {1}.',
    'DM_QUERY2_F_BAD_VA_OPTION_TYPE': 'ALTER/CREATE TYPE:  Unknown value assistance option ({0}).',
    'DM_QUERY2_F_BAD_UPDATE_MODIFIER_TYPE': 'Unknown update modifier ({0}).',
    'DM_QUERY2_F_BAD_BUSINESS_POLICY_MODIFIER_TYPE': 'Unknown business policy modifier type ({0}).',
    'DM_QUERY2_F_CANNOT_EXPUNGE_AGGR_DOMAIN': 'DROP TYPE could not expunge the dm_aggr_domain object with id \'{0}\' when dropping type {1}.',
    'DM_QUERY2_F_CANNOT_FETCH_AGGR_DOMAIN': 'DROP TYPE could not fetch the dm_aggr_domain object with id \'{0}\' when dropping type {1}.',
    'DM_QUERY2_F_ALTER_SET_OVERRIDE_FAILED': 'ALTER TYPE:  Unable to set the type_override attribute in the dmi_type_info object for type {0}.',
    'DM_QUERY2_F_ALTER_STORE_OVERRIDE_FAILED': 'ALTER TYPE:  Unable to store the updated type_override in the dmi_type_info object for type {0}.',
    'DM_QUERY2_F_INVALIDATE_DD_CACHE_FAILED': 'ALTER TYPE: Unable to flush the Data Dictionary cache for type {0}.',
    'DM_QUERY2_F_BAD_UPDATE_VALUE_TYPE': 'Unknown update value type ({0}).',
    'DM_QUERY2_F_BAD_DEFAULT_ELEMENT_TYPE': 'Unknown default element type ({0}).',
    'DM_QUERY2_F_DROP_TYPE_COMMIT_FAILURE': 'Commit failed for expunge of Data Dictionary information when dropping type {0}.',
    'DM_QUERY2_F_MARK_FOR_RESYNC_FAILED': 'Failure attempting to mark subtypes of type {0} for Data Dictionary re-synchronization.',
    'DM_QUERY2_F_DROP_DMI_DD_INFO_FOR_TYPE': 'Unable to drop Data dictionary information stored in the dmi_dd_common_info/dmi_dd_type_info/dmi_dd_attr_info tables about type {0} ',
    'DM_RECOVERY_E_NOT_SYS_ADMIN': 'Only the system administrator may run recovery procedures.',
    'DM_RECOVERY_E_ARG_WRONG_TYPE': 'The parameter to RUN_RECOVERY_PROCS was not a recovery object.',
    'DM_RECOVERY_E_BAD_ARG': 'The parameter to RUN_RECOVERY_PROCS was bad, may have been deleted.',
    'DM_RECOVERY_F_REG_TOOMANY': 'Too many recovery procedures have been registered.',
    'DM_RECOVERY_F_REG_DUPDEFN': 'The function ({0}) has already been registered as a recovery procedure.',
    'DM_RECOVERY_F_NOT_FOUND': 'A recovery procedure was requested but not found in the table.',
    'DM_RECOVERY_F_NO_CONNECTION': 'Unable to get a database connection to create a recovery object.',
    'DM_RECOVERY_F_SAVE_FAILED': 'Unable to save recovery object.',
    'DM_RECOVERY_F_CANT_COMMIT': 'Unable to commit save of recovery object.',
    'DM_RECOVERY_F_CANT_DESTROY': 'Unable to desrtoy recovery object {0}.',
    'DM_RELATION_E_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}',
    'DM_RELATION_E_NEED_PRIV': 'The current user {0} has insufficient privileges to  save or destroy {1} relation.',
    'DM_RELATION_E_CANT_DESTROY': 'Cannot destroy relation objects for {0} object {1}.',
    'DM_RELATION_E_INVALID_NAME': 'Invalid relation_name = {0}, Must be a valid dm_relation_type name.',
    'DM_RELATION_E_CANT_SAVE': 'Could not save the {0} relation object.',
    'DM_RELATION_E_BAD_LABEL': 'Non-existent {0} child_label associated {1} child of with relation.',
    'DM_RELATION_E_NO_RELATE_PERMIT': 'No relate permit for relation \'{0}\' since {1} \'{2}\' is protected.',
    'DM_RELATION_E_CANNOT_CREATE_RELATION_FOR_FOREIGN_KEY': 'You cannot create an explicit dm_relation object for a dm_foreign_key relation type ({0}).',
    'DM_RELATION_E_INCR_LENGTH_NONEXISTANT_ATTR': 'While upgrading to version {0}: Failed while trying to increase the length of a non-existant attribute in dm_relation.',
    'DM_RELATION_E_INCR_LENGTH_TOO_LONG': 'While upgrading to version {0}: Failed when trying to increase the length of a dm_relation attribute because the attribute is too long.',
    'DM_RELATION_E_INCR_LENGTH_FAILED': 'While upgrading to version {0}: The upgrade failed on widening dm_relation\'s attribute lengths.',
    'DM_RELATION_E_CANT_CASCADE_DESTROY_OBJECT': 'Cannot cascade delete related object {0} for object {1}.',
    'DM_RELATION_E_TYPE_FETCH_FAILED': 'Failed to fetch type ({0})',
    'DM_RELATION_E_NO_WRITE_PERMIT': 'No write permit for relation \'{0}\' since {1} \'{2}\' is protected.',
    'DM_RELATION_F_INT1': 'The following database query {0} could not be executed.',
    'DM_RELATION_F_INIT1': 'The dmRelation type was found in the database without a version stamp.',
    'DM_RELATION_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_RELATION_F_INIT3': 'The type manager returned an error storing the dmRelation type.',
    'DM_RELATION_F_TYPE_CONVERSION': 'Failed to convert type dm_relation_type to version {0}.',
    'DM_RELATION_F_RELATION_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_RELTYPE_E_CANT_FETCH': 'Cannot fetch - Invalid object ID {0}',
    'DM_RELTYPE_E_NEED_PRIVS': 'The current user {0} has insufficient privileges to  save or destroy {1} relation_type.',
    'DM_RELTYPE_E_INVALID_SECURITY': 'Invalid security {0} for relation.',
    'DM_RELTYPE_E_ALREADY_EXISTS': 'Relation_Type with {0} name already exists.',
    'DM_RELTYPE_E_MUST_HAVE_NAME': 'A new relation_type must have a name.',
    'DM_RELTYPE_E_CANT_CREATE_SYSTEM': 'Can not system defined create relation type {0}',
    'DM_RELTYPE_E_CANT_VALIDATE_SYSTEM': 'Server could not create server defined relation types.',
    'DM_RELTYPE_E_NOT_EMPTY': 'There are dm_relation object using {0} relation_type object.',
    'DM_RELTYPE_F_INIT1': 'The dmRelation_Type type was found in the database without a version stamp.',
    'DM_RELTYPE_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_RELTYPE_F_INIT3': 'The type manager returned an error storing the dmRelation_Type type.',
    'DM_RELTYPE_F_INT1': 'The following database query {0} could not be executed.',
    'DM_ROUTER_I_BAD_PACKAGE': 'Package identified by {0} and label <{1}> does not exist.',
    'DM_ROUTER_I_NO_EXTERNAL_METHODS': 'Can not find any external method for router named: \'{0}\' and operation: \'{1}\'',
    'DM_ROUTER_I_BAD_PACKAGE2': 'Package identified by {0} and label <{1}> does not have the relate permit because of {2} \'{3}\'.',
    'DM_ROUTER_W_ALREADY_ACQUIRED': 'Task Number {0} is already acquired.',
    'DM_ROUTER_E_CANT_DEQUEUE': 'Cannot dequeue task number {0} of router named \'{1}\' for user {2}.',
    'DM_ROUTER_E_CANT_DEQUEUER': 'Cannot dequeue router named \'{0}\' for user {1}.',
    'DM_ROUTER_E_CANT_DESTROY': 'Cannot destroy router named \'{0}\' since its state is active or halted.',
    'DM_ROUTER_E_CANT_QUEUE': 'Cannot queue task number {0} of router named \'{1}\' for user {2}.',
    'DM_ROUTER_E_CANT_QUEUER': 'Cannot queue router named \'{0}\' for user {1}.',
    'DM_ROUTER_E_CANT_SAVES': 'Cannot save router name \'{0}\' since its state is active.',
    'DM_ROUTER_E_MUSTBE_USER_OR_SUPER': 'Current user {0} must be the router supervisor or task user for {1} task to perform {2} operation on this router.',
    'DM_ROUTER_E_MUSTBE_TASK_USER': 'Current user {0} must be the task user for {1} task to perform {2} operation on this router.',
    'DM_ROUTER_E_MUSTBE_SUPERVISOR': 'Current user {0} must be the supervisor to perform {1} operation on this router.',
    'DM_ROUTER_E_INVALID_TASK_TYPE': 'Invalid {0} {1} for task number {2}.',
    'DM_ROUTER_E_INVALID_ROUTER_STATE': 'Current router state is {0}, expected to be {1}.',
    'DM_ROUTER_E_INVALID_ROUTER_TYPE': 'Invalid router type {0} specified.',
    'DM_ROUTER_E_INVALID_SUPERVISOR': 'Invalid user name {0} specified as supervisor.',
    'DM_ROUTER_E_INVALID_TASK_LIST1': 'Task list {0} for task number {1} should only have one task number, but the following were found:  {2}.',
    'DM_ROUTER_E_INVALID_TASK_LIST': 'Task list {0} for task number {1} has invalid task number {2}.',
    'DM_ROUTER_E_INVALID_TASK_NUM': 'Invalid task number {0} specified.',
    'DM_ROUTER_E_INVALID_TASK_STATE': 'State of task number {0} is \'{1}\', expected to be \'{2}\'.',
    'DM_ROUTER_E_INVALID_TASK_OWNER': 'Invalid task owner name \'{0}\' specified for task number {1}.',
    'DM_ROUTER_E_NEED_BEGIN': 'Router named \'{0}\' needs to have at least one begin task.',
    'DM_ROUTER_E_NEED_END': 'Router named \'{0}\' needs to have one end task.',
    'DM_ROUTER_E_NEED_TARGET': 'Need one or more target task to perform {0} operation on \'{1}\' task.',
    'DM_ROUTER_E_NOT_VALIDATED': 'Router named \'{0}\' must be validated before execution.',
    'DM_ROUTER_E_TARGET_NOT_REQUIRED': 'Target tasks not required.',
    'DM_ROUTER_E_TASKOWNER_NOT_REQUIRED': 'The task owner parameter is not allowed on the {0} operation unless you are the supervisor.',
    'DM_ROUTER_E_TASK_NOT_IN_LIST': 'Task Number {0} must be in {1} list: {2}',
    'DM_ROUTER_E_INVALID_TASK_INDEX': 'Invalid task index {0} specified.',
    'DM_ROUTER_E_MORE_END': 'Router named \'{0}\' has {1} end tasks. Only one end task is allowed in each router.',
    'DM_ROUTER_E_DUPLICATE_TASKNUM': 'Duplicate task number {0} is encountered in \'{1}\' router.',
    'DM_ROUTER_E_BAD_TASK_ATTRC': 'In router named \'{0}\', count of {1}: {2} does not match the count of task_num: {3}.',
    'DM_ROUTER_E_INVALID_TASK_LIST3': 'Task list {0} for task number {1} must be empty.',
    'DM_ROUTER_E_NOT_A_ROUTER': 'The object identified by {0} is not a router.',
    'DM_ROUTER_E_CANT_ACQUIRE': 'Could not acquire task number {0} of \'{1}\' router.',
    'DM_ROUTER_E_SIGN_OFF_REQUIRED': 'Task Number {0} must be signed off.',
    'DM_ROUTER_E_SIGN_OFF_FAILED': 'Task Number {0} could not be signed off.',
    'DM_ROUTER_E_CANT_PERFORM': 'Current user \'{0}\' must be the router supervisor or task owner(user) or sysadmin for {1} task to perform {2} operation on this router.',
    'DM_ROUTER_E_USER_NOT_IN_LIST': 'User \'{0}\' must be a task owner or user of {1} list of \'{2}\' task.',
    'DM_ROUTER_E_INVALID_TASK_STATE2': 'State of task \'{0}\' is \'{1}\', expected to be \'{2}\' or \'{3}\'.',
    'DM_ROUTER_E_INVALID_TASK_STATE3': 'State of task \'{0}\' is \'{1}\', expected to be \'{2}\' or \'{3}\' or \'{4}\'.',
    'DM_ROUTER_E_CANT_FIND_METHOD': 'Can not find the external method named: \'{0}\'',
    'DM_ROUTER_E_CANT_RUN_METHOD': 'Could not run external method named: \'{0}\', error return is {1}.',
    'DM_ROUTER_E_METHOD_FAILED': 'Method named: \'{0}\' failed with the following return value: {1}.',
    'DM_ROUTER_E_CANT_DELETE_REMOVED': 'Could not delete removed tasks for {0} router.',
    'DM_ROUTER_E_CANT_COPY_ROUTER': 'Router {0} is in use and can not be copied.',
    'DM_ROUTER_E_NO_STEP_ALLOWED': 'Router {0} is a broadcast router and can not have a step task.',
    'DM_ROUTER_E_BAD_PACKAGE': 'Package identified by {0} and label <{1}> does not exist.',
    'DM_ROUTER_E_BAD_PACKAGE2': 'Package identified by {0} and label <{1}> does not have the relate permit because of {2} \'{3}\'.',
    'DM_ROUTER_E_MAX_CURRENT_TASK_LIST': 'You have reached the maximum size of the current task list on router named \'{0}\'.',
    'DM_ROUTER_E_NEED_BROWSE': 'User \'{0}\' need to have browse permission on \'{1}\' document.',
    'DM_ROUTER_F_INIT1': 'The dm_router type was found in the database without a version stamp.',
    'DM_ROUTER_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_ROUTER_F_INIT3': 'The type manager returned an error storing the dm_router type.',
    'DM_ROUTER_F_INIT4': 'The type manager returned an error converting the dm_router type.',
    'DM_SERVER_I_START': '{0} {1}',
    'DM_SERVER_I_START_SERVER': 'Docbase {0} {1}',
    'DM_SERVER_I_START_ID': 'Docbase {0} was not successfully opened. Docbase id: ({1})',
    'DM_SERVER_I_CONNECT_STATUS': 'Connection {0} ({1})',
    'DM_SERVER_I_SHUTDOWN': '{0}.',
    'DM_SERVER_I_TRACE_CACHE': '{0}.',
    'DM_SERVER_I_REGISTERED': 'The server registered using service: ({0}) on port: ({1})',
    'DM_SERVER_I_LISTENING': 'The server is listening on network address ({0})',
    'DM_SERVER_I_MAX_SESSIONS': 'Max sessions ({0}) too large; only ({1}) sessions will be allowed',
    'DM_SERVER_I_SOCKET': '{0} {1}',
    'DM_SERVER_I_SERVER': '{0}',
    'DM_SERVER_I_SERVER_FORK': 'Attempt to fork failed with error ({0})',
    'DM_SERVER_I_NETWORK_REGISTER': 'Attempt to register with network failed.  A new TCP/IP service name will be used',
    'DM_SERVER_I_ACCEPT_FAILED': 'nl_accept failed, retry count = {0}',
    'DM_SERVER_I_TRACE_GETHOSTBYADDR': 'Trace gethostbyaddr(), {0}',
    'DM_SERVER_I_GETHOSTBYADDR_FAILED': 'gethostbyaddr() failed with error {0}.',
    'DM_SERVER_I_SKIPPING_GETHOSTBYADDR': 'server.ini parameter gethostbyaddr is set to F, skipping gethostbyaddr().',
    'DM_SERVER_I_LAUNCH_MTHDSVR': 'Launching Method Server {0}.',
    'DM_SERVER_I_USER_DEACTIVATED': 'User ({0}) has been deactivated due to unsuccessful authentication attempts.',
    'DM_SERVER_I_USER_SESSION_KILLED': '{0} sessions owned by user ({1}) have been killed because of the user account deactivation.',
    'DM_SERVER_I_INSTALL_OWNER_AUTH_FAILED': 'Server is shutdown because installation owner ({0}) has exceeded the limit ({1}) of unsuccessful authentication attempts.',
    'DM_SERVER_I_': '',
    'DM_SERVER_I_n': '',
    'DM_SERVER_I_INIT_LOGIN_TICKET_MGR': 'Initialization of login ticket manager failed.',
    'DM_SERVER_I_CONFIG_VALUE': 'Current value {0} of server configuration parameter {1} exceeded. Please consider increasing the limit. Minimum value: {2} Maximum value: {3}',
    'DM_SERVER_I_IPV6_DISABLED': 'The server can not listen on IPv6 address because {0}',
    'DM_SERVER_I_OPEN_FAILED': 'nl_open failed, retry count = {0}',
    'DM_SERVER_I_TRACING_ENABLED_GLOBAL': 'Tracing type: \'{0}\'',
    'DM_SERVER_I_TRACING_DISABLED_GLOBAL': 'Tracing type: \'{0}\'',
    'DM_SERVER_I_TRACING_ENABLED_USER': 'Tracing type: \'{0}\', user: \'{1}\'',
    'DM_SERVER_I_TRACING_DISABLED_USER': 'Tracing type: \'{0}\', user: \'{1}\'',
    'DM_SERVER_I_TRACING_ENABLED_SESSION': 'Tracing type: \'{0}\', Session ID: \'{1}\'',
    'DM_SERVER_I_TRACING_DISABLED_SESSION': 'Tracing type: \'{0}\', Session ID: \'{1}\'',
    'DM_SERVER_I_START_KEY_STORAGE_MODE': 'Docbase {0} is using {1} for cryptographic key storage',
    'DM_SERVER_W_DO_METHOD': 'Apply of DO_METHOD failed because of: {0}',
    'DM_SERVER_W_NONE_TO_ARCHIVE': 'No sysobject will be archived/restored as result of the specified request.',
    'DM_SERVER_W_NONE_TO_RESTORE': 'All of the objects specified by this restore request are currently online and available.  No restore action is necessary.',
    'DM_SERVER_W_DUMMY1_MESSAGE': 'This is here to keep the error numbers from shifting.',
    'DM_SERVER_W_CLIENT_SOCKET': 'Could not set desired TCP socket options on new client connection.  The Connection has been established but may suffer performance degradations.',
    'DM_SERVER_W_CANNOT_SECURE_MODE': 'Could not start server in secure or dual connect mode because server is not in trusted mode. Starting server in native connect mode.',
    'DM_SERVER_W_RESTART_MTHDSVR': 'The dmbasic method server program has stopped running.  It will be restarted.',
    'DM_SERVER_E_EXEC_SQL': 'The execsql method failed due to a database error: {0}',
    'DM_SERVER_E_SHUT_DOWN': 'The shutdown method has failed for the following reason: {0}',
    'DM_SERVER_E_INI_FILE_ACCESS': 'Error initializing process due to the inability to get startup parameters from the named init_file: {0}.  Error reason: {1}.',
    'DM_SERVER_E_NEED_ARCHIVE_DQL': 'Need a DQL predicate to perform archive/restore operation.',
    'DM_SERVER_E_RESTORE1': 'Need loadfile or DQL predicate to start restore operation.',
    'DM_SERVER_E_START_NETWISE': 'The server failed to start due to an error returned by the Netwise networking subsystem. Failed API: {0}. Error {1}.',
    'DM_SERVER_E_RUN_NETWISE': 'The server encountered an error returned by the Netwise networking subsystem. Failed API: {0}. Error {1}.',
    'DM_SERVER_E_REGISTER_FAIL': 'The server failed to register itself on port ({0}). Error {1}.',
    'DM_SERVER_E_REGISTER_IN_USE': 'The server failed to register itself as there is already a server on port ({0}). Error {1}.',
    'DM_SERVER_E_SOCKOPT': 'setsockopt failed for ({0}) with error ({1})',
    'DM_SERVER_E_PREDICATE_TOO_LONG': 'The predicate condition specified is too long for the archive/restore operation.  The predicate must be a legal value for the QUEUE method\'s \'message\' argument, which currently cannot exceed {0} bytes.',
    'DM_SERVER_E_INVALID_VSTAMP': 'The operation failed because an invalid version stamp ({0}) is found for \'{1}\'.',
    'DM_SERVER_E_LISTEN_FAIL': 'The server failed to register itself on network address ({0}). Error {1}.',
    'DM_SERVER_E_POOL_FULL': 'Unable to create connection because the internal connection data structure is full.  There are {0} elements',
    'DM_SERVER_E_LAUNCH_FAILED': 'Unable to create connection for process at machine {0} as user {1} because the creation of the execution context failed.  Operating system error: {2}',
    'DM_SERVER_E_SHARED_MEMORY': 'Unable to create shared memory segment of size {0}.  Operating system error: {1}',
    'DM_SERVER_E_LAUNCH_FAILED2': 'Unable to create connection for process because the creation of the execution context failed.  Operating system error: {0}',
    'DM_SERVER_E_START_NETWISE2': 'The server failed to start due to an error returned by the Netwise networking subsystem. Failed API: {0}. Error code {1}.',
    'DM_SERVER_E_RETRY_EXHAUSTED': 'The server failed to re-register on the network after exhausted the list of alternative TCP/IP service names',
    'DM_SERVER_E_CRT_SHM_OBJ_FAIL': '{0} : Failed to create shared memory object.',
    'DM_SERVER_E_CRT_SHM_REG_FAIL': '{0} : Failed to create shared memory region.',
    'DM_SERVER_E_MAKE_SHM_ARG_FAIL': '{0} : Failed to construct attach arguments.',
    'DM_SERVER_E_INIT_MEQ_FAIL': '{0} : Failed to initialize method execution queue.',
    'DM_SERVER_E_CRT_MTHDSVR_PROC_FAIL': '{0} : Creating method server process failed.',
    'DM_SERVER_E_NO_MTHDSVR_BINARY': '{0} : Method server binary is not accessible.',
    'DM_SERVER_E_NO_MTHD_BUF': '{0} failed to get free method execution request buffer.',
    'DM_SERVER_E_UPDATE_STATS': 'The UPDATE_STATISTICS method failed due to a database error: {0}',
    'DM_SERVER_E_REORG_TABLE': 'The REORGANIZE_TABLE method failed due to a database error: {0}',
    'DM_SERVER_E_UNABLE_TO_PROCESS_METHOD_RESULTS': 'Unable to process method results for method \'{0}\'',
    'DM_SERVER_E_SSL_HANDSHAKE_FAILED': 'Secure connection failed during handshake on connection ({0}). Netwise returns error code ({1}).',
    'DM_SERVER_E_VSTAMP_SETTING_FAIL': 'Failed to update version stamp for application: {0}',
    'DM_SERVER_E_CHANGE_TRACING_SETTINGS': 'Attempt to change tracing settings failed. Tracing type: \'{0}\'. Failed operation: {1} tracing for {2} {3}.',
    'DM_SERVER_E_BAD_ID': 'The string specified for an ID value (\'{0}\') was not a valid Documentum dmID.',
    'DM_SERVER_E_INVALID_TRACING_CONFIGURATION': 'Attempt to change tracing settings failed. Operation: {0}. Reason: {1}.',
    'DM_SERVER_F_INCR_LENGTH_FAILED': 'While upgrading {0} to version {1}: The upgrade failed to widen the {2} attribute to {3}.',
    'DM_SERVER_F_NOT_LISTENING': 'The server failed to initialize or reinitialize and is not listening for incoming connections on any port. The server will shutdown.',
    'DM_SERVER_F_CANT_CREATE_TICKET_MANAGER': 'Unable to create ticket manager on server startup. Likely reason is corrupted aek.key file or docbase config object. The server will shutdown.',
    'DM_SESSION_I_SESSION_START': 'Session {0} started for user {1}.',
    'DM_SESSION_I_SESSION_QUIT': 'Session {0} quit.',
    'DM_SESSION_I_SESSION_PAUSE': 'Session {0} paused.',
    'DM_SESSION_I_INITIALIZE_DB': 'Initializing document base {0}',
    'DM_SESSION_I_NEW_CONN': 'Established new connection.\nNew session identifier is {0}',
    'DM_SESSION_I_INIT_BEGIN': 'Initialize {0}.',
    'DM_SESSION_I_INIT_END': 'Initialized {0}.',
    'DM_SESSION_I_TRANSACTION_ABORT': 'Transaction aborted because of client timeout',
    'DM_SESSION_I_SESSION_AUTHENTICATED': 'Session {0} started and authenticated for user ({1}).',
    'DM_SESSION_I_OPERATION_STARTED': 'Operation {0} started.',
    'DM_SESSION_I_OPERATION_ENDED': 'Operation {0} completed.',
    'DM_SESSION_I_OPERATION_ARGUMENTS': '{0}',
    'DM_SESSION_I_OPERATION_RESULTS': '{0}',
    'DM_SESSION_I_RETRYING_DATABASE_CONNECTION': 'The following error was encountered trying to get a database connection:  {0} \nThe server will retry {1} more time(s) (every {2} seconds).',
    'DM_SESSION_I_KILL_SESSION': 'User \'{0}\' is attempting to kill session \'{1}\'{2}.',
    'DM_SESSION_I_DEADLOCK_RETRY': 'Retrying server operation following a DBMS Deadlock Error.',
    'DM_SESSION_I_DEADLOCK_INFO': 'A database deadlock occurred.',
    'DM_SESSION_I_ASSUME_USER': 'Session {0} is owned by user {1} now.',
    'DM_SESSION_I_TRACE_ENABLED': 'Trace enabled for client process {0} (thread {1}) on machine {2}.  Trace facility is {3}, level {4}.',
    'DM_SESSION_I_FIRST_ATTEMPT_FAIL': 'Attempt to make a {0} connection failed, trying to create a {1} connection instead.',
    'DM_SESSION_I_AUTH_PLUGIN_LOADED': 'Loaded Authentication Plugin with code \'{0}\' ({1}).',
    'DM_SESSION_I_AUTH_PLUGIN_LOAD_INIT': 'Authentication plugin ( \'{0}\' ) was {1}. {2}',
    'DM_SESSION_I_CONNECTED_TO_DATABASE': 'Successfully connected to database {0} on {1}',
    'DM_SESSION_I_PUSHING_OBJ_BY_CHUNKS': 'Operation {0} is pushing the object \'{1}\' by chunks now.',
    'DM_SESSION_I_DYNAMIC_ROLE_OPERATION': 'Session {0} {1} dynamic role {2}. Mode is {3}. RPC name is {4}, result of the operation is {5}',
    'DM_SESSION_I_CURRENT_DYNAMIC_GROUP_ENTRIES': '{0} dynamic groups for session [{1}] : [{2}]',
    'DM_SESSION_I_GENERIC_TRACE1': '{0}',
    'DM_SESSION_I_GENERIC_TRACE2': '{0} {1}',
    'DM_SESSION_I_GENERIC_TRACE3': '{0} {1} {2}',
    'DM_SESSION_I_FIX_OBJ_INCONSISTENCIES_TRACE': '{0}',
    'DM_SESSION_T_TYPE_DBLOAD_ATTEMPT': 'Attempting type load from database name={0}',
    'DM_SESSION_T_TYPE_DBLOAD': 'Loaded type from database ID={0}, name={1} type_cache_vstamp={2}',
    'DM_SESSION_T_TYPE_DROP': 'Dropping type from cache ID={0}, name={1}',
    'DM_SESSION_T_TYPE_DETACH': 'Detaching type from cache  ID={0}, name={1}',
    'DM_SESSION_T_TYPE_REFRESH': 'Checking for type changes (inline) server count={0} db count={1}',
    'DM_SESSION_T_TYPE_REFRESH_CHANGECHECK': 'Checking for changes (global) server count={0} db count={1}',
    'DM_SESSION_W_NO_CONNECTION': 'The connection with the server has been dropped.',
    'DM_SESSION_W_TRANSACTION_FAILURE': 'Transaction commit failed for session {0}; database error is: {1}',
    'DM_SESSION_W_ROLLBACK_FAILURE': 'Transaction rollback failed for session {0};  database error is: {1}',
    'DM_SESSION_W_CANT_BEGIN_TRANSACTION': 'Cannot begin a transaction since there is an active transaction for session {0}.',
    'DM_SESSION_W_CANT_MAKE_TYPE_MANAGER': 'Cannot make a type manager for user {0} in document base {1}.',
    'DM_SESSION_W_CANT_MAKE_OBJECT_MANAGER': 'Cannot make an object manager for user {0} in document base {1}.',
    'DM_SESSION_W_CANT_RESUME_SESSION': 'Cannot resume session {0} for user {1}.',
    'DM_SESSION_W_OBJECT_UPDATE_FAILED': 'Save of object of type {0} failed because attribute update to new values failed.',
    'DM_SESSION_W_SAVE_OF_NULL_OBJECT': 'Save of NULL object attempted.',
    'DM_SESSION_W_SAVE_OF_NONEXISTENT_OBJECT': 'Save of object with handle {0} failed because object does not exist.',
    'DM_SESSION_W_SAVE_COMMIT_FAILED': 'Save failed for object {0} because transaction could not be committed.\nDatabase system error message was: {1}',
    'DM_SESSION_W_FETCH_FAILED': 'Fetch of object with handle {0} and type {1} failed.',
    'DM_SESSION_W_ENUMERATE_OF_NULL': 'Attempt to enumerate objects of NULL type.',
    'DM_SESSION_W_ENUMERATE_TYPE_FAILURE': 'Enumeration of type {0} failed because type could not be found.',
    'DM_SESSION_W_MATCH_TYPE_NULL': 'Attempt to match objects of NULL type.',
    'DM_SESSION_W_MATCH_TYPE_FAILURE': 'Match of type {0} failed because type could not be found.',
    'DM_SESSION_W_MATCH_ATTRIBUTE_ERROR': 'Match failed because attribute {0} in type {1} is invalid.',
    'DM_SESSION_W_DESTROY_FAILED': 'Destroy of object {0} failed.',
    'DM_SESSION_W_DESTROY_ABORTED': 'Destroy of object {0} failed because transaction could not be committed.',
    'DM_SESSION_W_DB_PASSWORD_FILE_OWNER': 'The database password file, ({0}), is readable by other users.',
    'DM_SESSION_W_PASSWORD_STALE': 'The password for user ({0}) with user OS name ({1}) is stale',
    'DM_SESSION_W_CANT_SET_CONVERSION_IDENTIFIER': 'Failed to set the vtsamp identifier for docbase {0}.',
    'DM_SESSION_W_EXEC_POOL_FULL': 'Unable to launch process to perform deferred updates to objects, because the execution context pool is currently full. The updates will be performed later.',
    'DM_SESSION_W_LAUNCH_DEFER_UPDATE': 'Unable to launch process to perform deferred updates to objects due to the error: {0} The updates will be performed later.',
    'DM_SESSION_W_ZOMBIE_HOT_SESSION_FOUND': 'The session record for process/thread {0}d was marked active, but had not been used within the server timeout interval.  The session was moved to the inactive list.',
    'DM_SESSION_W_RESTART_AGENT_EXEC': 'The agent exec program has stopped running.  It will be restarted.',
    'DM_SESSION_W_LAUNCH_AGENT_EXEC': 'Unable to launch the agent exec process due to the error: {0}.',
    'DM_SESSION_W_LAUNCH_CHANGE_CHECK': 'Unable to launch the change check thread.  Operating system error: {0}.',
    'DM_SESSION_W_CHANGE_CHECK_ALIVE': 'Change check processing was not initiated.  The previously launched Change Check execution is still running.  Check your server log for additional messages.',
    'DM_SESSION_W_AGENT_EXEC_FAILURE_EXCEED': 'The failure limit of the agent exec program has exceeded. It will not be restarted again. Please correct the problem and restart the server.',
    'DM_SESSION_W_LIB_LOAD': 'The server failed to load the shared library \'{0}\'.  Operating System error: {1}.',
    'DM_SESSION_W_LDAP_NOCONFIG': 'The server cannot be set up for ldap services because the ldap config object does not exist.',
    'DM_SESSION_W_GENTICKET_FAIL': 'Failed to generate login ticket for user {0}.',
    'DM_SESSION_W_AUTH_PLUGIN_DUPL_CODE': 'Failed to load Authentication Plugin because it attempted to register with duplicate identifier \'{0}\' ({1}).',
    'DM_SESSION_W_SET_LDAP_OPT_PROTOCOL_VERSION_FAILED': 'Failed to set LDAP protocol version to Version-3. Proceeding with default V2 protocol version',
    'DM_SESSION_W_SUCCESS_WITH_INFO': '{0}',
    'DM_SESSION_E_BAD_INFO': 'Could not read dminfo.sys file for docbase.\nError message was: {0}',
    'DM_SESSION_E_INVALID_USER': 'User ({0}), with OS User name ({1}), has failed to connect to docbase ({2}) due to bad login.',
    'DM_SESSION_E_CANT_ESTABLISH_CONNECTION': 'Failure to establish database connection: document base {0}, database {1}, server {2}.',
    'DM_SESSION_E_CANT_FIND_DOCUMENT_BASE': 'Document base name {0} not in dminfo.sys.',
    'DM_SESSION_E_CANT_READ_DB_PASSWORD': 'The database password cannot be read for document base {0}.',
    'DM_SESSION_E_WRONG_DOCBASE_ID': 'The docbase identifier: {0} from the RDBMS does not match the DM_DBID: {1} for docbase: {2}.',
    'DM_SESSION_E_CANT_FIND_VERSION_STAMP_TABLE': 'Cannot find version stamp table for document base {0}.',
    'DM_SESSION_E_CANT_FIND_ID_TABLE': 'Cannot find id table for document base {0}.',
    'DM_SESSION_E_CANT_SET_DATABASE_IDENTIFIER': 'Cannot set database identifier for document base {0}.',
    'DM_SESSION_E_CANT_INITIALIZE_SESSION': 'Cannot initialize sessions for document base {0}.',
    'DM_SESSION_E_INIT_FAILURE': 'Failure on procedure number {0} in initialization procedure list.',
    'DM_SESSION_E_CANT_SET_SESSION_STAMP': 'Failure to set version stamp after creating session types.',
    'DM_SESSION_E_CANT_SAVE_TRANS_TYPE': 'Cannot save transaction type during session initialization.',
    'DM_SESSION_E_CANT_SAVE_SESSION_TYPE': 'Cannot save session type during session initialization.',
    'DM_SESSION_E_SESSION_STAMP_FAILURE': 'Version stamp mismatch between session code and database.',
    'DM_SESSION_E_CANT_BUILD_SESSION_TYPES': 'Cannot construct basic session types for user {0} in document base {1}.',
    'DM_SESSION_E_BOGUS_STAMP_TABLE': 'Internal version stamp table has wrong structure.',
    'DM_SESSION_E_CANT_INSERT_STAMP': 'Cannot insert version stamp in internal table.\nDatabase system error was:  {0}',
    'DM_SESSION_E_CANT_UPDATE_STAMP': 'Cannot update version stamp in internal table.\nDatabase system error was: {0}',
    'DM_SESSION_E_CANT_UPDATE_ID_TABLE': 'The internal id table cannot be updated.\nDatabase system error was: {0}',
    'DM_SESSION_E_RPC_ERROR': 'RPC error {0} occurred: {1}',
    'DM_SESSION_E_CANT_MAKE_TEMP_CONNECTION': 'Could not establish an internal, temporary database connection (database_name = {0}, docbase_owner = {1}, connection_string = {2}); database system error was: {3}',
    'DM_SESSION_E_CANT_MAKE_IDENTIFIER': 'Could not make new identifier value because of connection failure.',
    'DM_SESSION_E_CANT_BUILD_IDENTIFIER_TABLE': 'Could not build internal identifier table.',
    'DM_SESSION_E_CANT_FIND_IDENTIFIER_TABLE': 'Could not find internal identifier table.',
    'DM_SESSION_E_DATABASE_ID_NOT_FOUND': 'Database identifier not found in version stamp table',
    'DM_SESSION_E_START_FAIL': 'Server did not start session. Please see your system administrator or check the server log.\nError message from server was:\n{0}',
    'DM_SESSION_E_CANT_MAKE_TABLE': 'Unable to make the table \'{0}\'.\nDatabase error was: {1}',
    'DM_SESSION_E_INIT_FAILURE1': 'Failure to complete {0} initialization.',
    'DM_SESSION_E_ATTEMPT_TO_SAVE_TYPE': 'Attempt to save object of type dm_type.',
    'DM_SESSION_E_CANT_FIND_SERVICE': 'Could not connect to Docbase named ({0}) due to failure finding service to port mapping for service name name ({1}).',
    'DM_SESSION_E_CANT_CONNECT': 'Could not connect to docbase ({0}) at host ({1}) because ({2}).  Network address: ({3}).',
    'DM_SESSION_E_CONNECT_REJECT': 'Connection request rejected by docbase ({0}) at host ({1}) because ({2}).  Network address: ({3}).',
    'DM_SESSION_E_BAD_CLIENT_DIRS': 'Could not validate directories needed by client; errors were {0}',
    'DM_SESSION_E_CANT_MAKE_ID': 'Could not satisfy request to make {0} ids for the tag {1}',
    'DM_SESSION_E_NO_TRANSACTION': 'Transaction was not open; commit failed.',
    'DM_SESSION_E_CANT_COMMIT': 'Transaction could not be committed -- RPC to server failed',
    'DM_SESSION_E_PASSWORD_CHECK_1': 'Failure to validate existence and accessibility of External Password Checking program: ({0}).  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHECK_FORK': 'Operating System Failure during user validation using External Password Checking program: ({0}).  Operation: fork().  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHECK_WAITPID': 'Operating System Failure during user validation using External Password Checking program: ({0}).  Operation: waitpid().  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHECK_GETPWNAM': 'Operating System Failure during user validation.  Operation: getpwnam().  Operating System Error: ({0}).',
    'DM_SESSION_E_NO_TRANSLATOR': 'Unable to find character translator for client machine: ({0}) with client Locale: ({1})',
    'DM_SESSION_E_CONNECT_DOCBROKER': 'Unable to connect to docbase ({0}).  The Docbroker network addressing lookup failed',
    'DM_SESSION_E_DB_PASSWORD_FILE': 'Unable to access database password file: ({0}).  The operating system error was: ({1}).',
    'DM_SESSION_E_DB_PASSWORD_FILE_OPEN': 'Unable to open the database password file: ({0}).',
    'DM_SESSION_E_PASSWORD_CHECK_POPEN': 'Operating System Failure during user validation using External Password Checking program: ({0}).  Operation: popen().  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHECK_PCLOSE': 'Operating System Failure during user validation using External Password Checking program: ({0}).  Operation: pclose().  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHECK_SEU': 'Operating System Failure during user validation using External Password Checking program: ({0}). Operation: fprintf of user name.  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHECK_SE1': 'Operating System Failure during user validation using External Password Checking program: ({0}). Operation: fprintf of extra param 1.  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHECK_SE2': 'Operating System Failure during user validation using External Password Checking program: ({0}). Operation: fprintf of extra param 2.  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHECK_SEP': 'Operating System Failure during user validation using External Password Checking program: ({0}). Operation: fprintf of user password  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHANGE_FAILURE': 'The server was unable to change your password',
    'DM_SESSION_E_ELOC_NOT_CONFIGURED': 'The external location used to define the program used to change passwords is not configured.',
    'DM_SESSION_E_PASSWORD_CHANGE_SEU': 'Operating System Failure during change password using External Password Changing program: ({0}). Operation: fprintf of user name.  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHANGE_SENP': 'Operating System Failure during change password using External Password Changing program: ({0}). Operation: fprintf of new password.  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHANGE_SEOP': 'Operating System Failure during change password using External Password Changing program: ({0}). Operation: fprintf of old password.  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHANGE_1': 'Failure to validate existence and accessibility of External Password Changing program: ({0}).  Operating System Error: ({1}).',
    'DM_SESSION_E_DOWNREV_SERVER': 'Unable to connect to server due to software incompatibility.  The client library you are executing requires a server with at least a version of: ({0}).  The server version is ({1}). Your client library version is ({2}).',
    'DM_SESSION_E_PASSWORD_EXPIRED': 'The Operating System password for user ({0}) with user OS name ({1}) has expired',
    'DM_SESSION_E_ACCOUNT_EXPIRED': 'The Operating System account for user ({0}) with user OS name ({1}) has expired',
    'DM_SESSION_E_ACCOUNT_DROPPED': 'The Operating System account for user ({0}) with user OS name ({1}) has been dropped',
    'DM_SESSION_E_ACCOUNT_LOCKED': 'The Operating System account for user ({0}) with user OS name ({1}) has been locked',
    'DM_SESSION_E_UNEXPECTED_CHK_RES': 'The return value from the external password validation program ({0}) returned an unexpected value: ({1})',
    'DM_SESSION_E_CHK_PASS_OS_ERROR': 'There was an unexpected error during validation of your user credentials.  Please see your system administrator or check the server log',
    'DM_SESSION_E_RESTRICTED_ACCESS': 'The operation you attempted could not be completed because your user credentials are inadequate.  You are connected as user ({0}) with authentication level of ({1}).  Ensure you connected successfully.',
    'DM_SESSION_E_CHGPASS_CRITERIA': 'Unable to change the password because the new password provided did not meet the required criteria for the underlying Operating System.  Try again with another password',
    'DM_SESSION_E_CHGPASS_CRITERIA_V': 'The changepassword API failed with the following error: {0}',
    'DM_SESSION_E_CANT_ADVANCE_ID': 'Could not advance id generation beyond {0} for tag {1}',
    'DM_SESSION_E_BAD_PARTITION_SPEC': 'Illegal address partitioning specification -- partitions: {0}, start: {1}, end: {2}',
    'DM_SESSION_E_CANT_KILL_TICKET': 'User {0} does not have sufficient privilege to kill ticket \'{1}\'.',
    'DM_SESSION_E_BAD_TICKET': 'The following \'{0}\' is not a valid ticket definition.',
    'DM_SESSION_E_CHG_PASS_BAD_CRED': 'The password was unchanged for user ({0}) with user_login_name ({1}) due to invalid old user_login_name/password',
    'DM_SESSION_E_SEC_MODE_UNKNOWN': 'Failed to find out the docbase security mode, due to the sessionconfig doesn\'t exist.',
    'DM_SESSION_E_BAD_INFOID': 'Bad Info ID given: {0}',
    'DM_SESSION_E_DOCBASE_VSTAMP': 'The version stamp of the docbase is {0} and is lower than {1} required by the program. Please upgrade the docbase first and run the program again.',
    'DM_SESSION_E_HEAP_CREATION_FAILURE': 'Unable to create a session heap of size {0}.  Operating system error: {1}',
    'DM_SESSION_E_ASSUME_USER_FILE': 'Unable to access the assume user program file.  Error returned from Operating System: ({0}).  Program file: ({1}).',
    'DM_SESSION_E_DUMMY1_MESSAGE': 'This message is here to keep the error numbers from shifting.',
    'DM_SESSION_E_LAUNCH_VALIDATION': 'Unable to launch the external user validation program: {0}.  Operating System Error: {1}',
    'DM_SESSION_E_ACE_CREATE': 'An unexpected error occurred while creating an Operating System ACE.  Parameters: {0}, {1}.  Operating system error: {2}.',
    'DM_SESSION_E_SET_SECURITY': 'An unexpected error occurred while applying security the the file: {0}. Operating System Error: {1}',
    'DM_SESSION_E_NETWORK_TIMEOUT': 'The network request timed out; the network may be non-operational or the remote service may be temporarily unavailable',
    'DM_SESSION_E_NOT_SYSADMIN': 'The operation you requested, {0}, was not executed because the current user, {1}, is not sysadmin',
    'DM_SESSION_E_CHANGE_CHECKING_ABORTED': 'The root process change-checking step was aborted.',
    'DM_SESSION_E_STORESTAT_OVERFLOW': 'The shared memory segment for caching the ONLINE/OFFLINE status of the Documentum Storage areas has reached its maximum size ({0}).  Update access may be incorrectly given to Offline or ReadOnly or Worm enabled storage area ({1}).',
    'DM_SESSION_E_PASSWORD_CHANGE_LAUNCH': 'Operating System Failure during launch of the using External Password Change program: ({0}).  Operating System Error: ({1}).',
    'DM_SESSION_E_PASSWORD_CHECK_LAUNCH': 'Operating System Failure during launch of the using External Password Check program: ({0}).  Operating System Error: ({1}).',
    'DM_SESSION_E_NO_LOG_LOC_DEFINED': 'Your server configuration does not define a log location.',
    'DM_SESSION_E_LOG_DIR_ACCESS': 'The location defined in your server configuration for log, ({0}), specifies a directory, ({1}), which cannot be accessed.  The Operating System error returned was ({2}).',
    'DM_SESSION_E_MISSING_PARAMETERS': 'You must supply parameters to the apply method ({0})',
    'DM_SESSION_E_MAKE_DATABASE_CONN': 'An unexpected failure occurred during an attempt to create a database connection.  Please consult the server log for more details.',
    'DM_SESSION_E_MAX_HEAP_SIZE': 'Unable to set the session heap size to ({0}u).  Lower bound: ({1}u), upper bound: ({2}u).  You must use a value in the specified range.',
    'DM_SESSION_E_INVALID_SESSION_ID': 'The session referred to by ID \'{0}\' does not exist.',
    'DM_SESSION_E_INVALID_VENGEANCE': 'The vengeance level \'{0}\' is invalid.  Valid vengeance levels are: \'nice\', \'after current request\', and \'unsafe\'.',
    'DM_SESSION_E_KILL_FAIL': 'Attempt to kill the session referred to by ID \'{0}\' failed with operating system error \'{1}\'.  Attempting to clean up after this session.',
    'DM_SESSION_E_NT_UNIFIED_LOGON_FAILED': 'Unable to authenticate user ({0}) in domain ({1}) for docbase ({2}) using NT Unified Logon.  You may explicitly supply password and domain to connect again.',
    'DM_SESSION_E_SESSION_NOT_FOUND': 'The session that was requested to be killed \'{0}\' could not be found.',
    'DM_SESSION_E_UNEXPECTED_EXTERNAL': 'The external password validation program ({0}) returned an unexpected value: ({1}).  Error details: ({2}).',
    'DM_SESSION_E_NOT_SUPERUSER': 'The operation you requested, {0}, was not executed because the current user, {1}, is not superuser',
    'DM_SESSION_E_FILE_LIB': 'The server failed to set up the file I/O library.  Operating System error: {0}.',
    'DM_SESSION_E_DB_CONNECTION_FAILURE': '{0}',
    'DM_SESSION_E_LAUNCH_BP_TRANSITION': 'Unable to launch the BP transition evaluation process due to the error: {0}',
    'DM_SESSION_E_TRANSACTION_ABORTED': 'Transaction aborted by server due to client session timeout. Use abort API to re-establish connection to server.',
    'DM_SESSION_E_PASSWORD_CHECK_GETPWNAM2': 'Operating System Failure during user {0} validation. (User OS name = {1}, Domain = {2}, and session id = {3})',
    'DM_SESSION_E_DEADLOCK': 'Operation failed due to DBMS Deadlock error.',
    'DM_SESSION_E_LDAP_AUTHENTICATION_FAILED': 'Unable to authenticate user ({0}) for docbase ({1}) using LDAP.',
    'DM_SESSION_E_LDAP_DOWN': 'Unable to connect to Directory Server on machine ({0}) using port ({1}) for docbase ({2}).',
    'DM_SESSION_E_LDAP_SEARCH': 'The search in the Directory Server using searchbase ({0}) and filter ({1}) failed.',
    'DM_SESSION_E_LDAP_NOENTRY': 'The search in the Directory Server for user ({0}) didn\'t produce any results.',
    'DM_SESSION_E_LDAP_BIND': 'The bind call to the Directory Server failed.',
    'DM_SESSION_E_LDAP_MULTIPLE_UID': 'The uid ({0}) in the Directory Server is not unique.',
    'DM_SESSION_E_LDAP_INIT': 'The initialization of the ldap library failed.',
    'DM_SESSION_E_LDAP_OPT_RECONNECT': 'The setting of the reconnect option failed.',
    'DM_SESSION_E_LDAP_OPT_THREAD': 'The setting of the thread safety option failed.',
    'DM_SESSION_E_CHK_LDAP_NOSEARCHBASE': 'The searchbase couldn\'t be determined. The authentication for user ({0}) with user OS name ({1}) failed',
    'DM_SESSION_E_CHK_LDAP_DOWN': 'The LDAP server doesn\'t seem to run. The authentication for user ({0}) with user OS name ({1}) failed',
    'DM_SESSION_E_CHK_LDAP_SEARCH': 'The search for user ({0}) with user OS name ({1}) in the LDAP server failed. The authentication failed',
    'DM_SESSION_E_CHK_LDAP_MULTIPLE_UID': 'The search for user ({0}) with user OS name ({1}) found multiple entries in the LDAP server. The authentication failed',
    'DM_SESSION_E_CHK_LDAP_NOENTRY': 'The search for user ({0}) with user OS name ({1}) didn\'t find any entries in the LDAP server. The authentication failed',
    'DM_SESSION_E_CHK_LDAP_BIND': 'User ({0}) with user OS name ({1}) couldn\'t bind to the LDAP server. The authentication failed',
    'DM_SESSION_E_OPEN_TRANSACTION': 'Cannot execute {0} operation while in an open transaction.',
    'DM_SESSION_E_AUTH_FAIL': 'Authentication failed for user {0} with docbase {1}.',
    'DM_SESSION_E_LDAP_CHGPASS_USER': 'The changepassword API failed with the following error: {0}',
    'DM_SESSION_E_GETSVRCFG_FAIL': 'Getting server configuration object failed.',
    'DM_SESSION_E_CURSOR_ERROR': 'A database error has occurred during the execution of a cursor (\'{0}\').',
    'DM_SESSION_E_LOOKUP_DOCBASE_ID': 'Could not look up the docbase id for docbase {0}.  Error finding key value for \'doc_base_identifier\' in the type dmi_vstamp.',
    'DM_SESSION_E_TRANSACTION_ERROR': 'Transaction invalid due to errors, please abort transaction.',
    'DM_SESSION_E_UPGRADE_MAP_ERROR': 'Please shutdown your client session and reconnect to the docbase.',
    'DM_SESSION_E_CANT_ALLOCATE_NEXT_TICKET_BATCH': 'Could not allocate next ticket batch.',
    'DM_SESSION_E_OBJECT_FILE_OPEN': 'Unable to open the object stream file: ({0}).',
    'DM_SESSION_E_INVALID_APPLICATION_CODE': 'The application_code setting of \'{0}\' is invalid. Application codes may not contain whitespace. Valid codes may only contain alphanumeric characters or \'_\'.',
    'DM_SESSION_E_AUTH_PLUGIN_LOAD_ERROR': 'Failed to load Authentication Plugin {0}. Reason: {1}.',
    'DM_SESSION_E_AUTH_PLUGIN_LOAD_CHARTRANS_ERROR': 'Failed to load Authentication Plugin {0}. Plugin requested codepage \'{1}\' but server does not support translation from codepage \'{2}\'.',
    'DM_SESSION_E_AUTH_PLUGIN_LOAD_NO_ID_ERROR': 'Failed to load Authentication Plugin {0}. The plugin did not return an identifier.',
    'DM_SESSION_E_AUTH_PLUGIN_LOAD_INIT_ERROR': 'Failed to load Authentication Plugin {0}. Plugin initialization returned error: \'{1}\'.',
    'DM_SESSION_E_AUTH_PLUGIN_LOAD_EXCEPT_ERROR': 'Failed to load Authentication Plugin {0}. The following exception occured during initialization: {1}.',
    'DM_SESSION_E_AUTH_PLUGIN_AUTH_FAIL': 'Authentication failed for user {0} with docbase {1}. Plugin with ID \'{2}\' returned error: {3}',
    'DM_SESSION_E_AUTH_PLUGIN_CHGPASS_FAIL': 'The changepassword API using plugin with ID \'{0}\' failed with the following error: {1}',
    'DM_SESSION_E_INVALID_LDAPCERTDIR': 'Missing certificate database location object or Invalid LDAP certificate database directory.',
    'DM_SESSION_E_LDAPS_CLIENT_INIT': 'LDAP SSL Client initialization call failed.',
    'DM_SESSION_E_LDAPS_INIT': 'LDAP SSL initialization failed.',
    'DM_SESSION_E_MAX_LDAP_CONFIG_OBJECTS_EXCEEDED': 'Number of LDAP config objects enabled are ({0}) greater then default 100 or max_ldap_config_objects value in server.ini. LDAP user auth may not work successfully. Update server.ini file with appropriate value for max_ldap_config_objects and restart server',
    'DM_SESSION_E_PLUGIN_LOAD_FAILED': 'Failed to load {0} plugin. The following error occured: {1}.',
    'DM_SESSION_E_OUT_OF_TICKET': 'Cannot obtain a login ticket because all login ticket entries are in use.',
    'DM_SESSION_E_CANNOT_DECODE': 'Cannot decode {0} ({1}).',
    'DM_SESSION_E_CANNOT_VERIFY_SIGNATURE': 'Cannot verify the signature of {0} ({1}).',
    'DM_SESSION_E_TICKET_EXPIRED': 'The {0} ({1}) has expired.',
    'DM_SESSION_E_USED_TOKEN_ON_WRONG_MACHINE': 'Application access control token ({0}), created for use on machine ({1}) only, cannot be used on machine ({2}).',
    'DM_SESSION_E_INVALID_APPLICATION_ID': 'Application id ({0}) does not match application access control token ({1}).',
    'DM_SESSION_E_USE_TICKET_FOR_WRONG_USER': 'The {0} ({1}), created for user ({2}), cannot be used for user ({3}).',
    'DM_SESSION_E_USED_LOCAL_TICKET_OTHER_DOCBASE': 'Login ticket ({0}) is created for docbase ({1}), cannot be used in docbase ({2})',
    'DM_SESSION_E_SETUP_TICKET_ATTRIBUTES': 'Setting up {0} attributes for user ({1}) failed.',
    'DM_SESSION_E_SIGN_TICKET': 'Signing {0} ({1}) failed.',
    'DM_SESSION_E_CREATE_ENCODER': 'Creating encoder failed during generating {0} for ({1}).',
    'DM_SESSION_E_OUT_MEMORY': 'Running out of memory during creating a {0} for ({1}).',
    'DM_SESSION_E_INVALID_APPLICATION_TOKEN': 'Invalid application token ({0})',
    'DM_SESSION_E_RESET_TICKET_KEY': 'Reset login ticket key failed by user {0}.',
    'DM_SESSION_E_PASSWORD_REQUIRED': 'Password argument is required for executing method ({0}).',
    'DM_SESSION_E_NO_TICKET_KEY': 'Docbase ({0}) dose not have a login ticket key.',
    'DM_SESSION_E_ENCODE_KEY_FAILED': 'Encoding failed while exporting login ticket key from docbase ({0}).',
    'DM_SESSION_E_DECODE_KEY_FAILED': 'Decoding failed while importing login ticket key from docbase ({0}).',
    'DM_SESSION_E_ENCRYPT_KEY_FAILED': 'Encryption failed while exporting login ticket key from docbase ({0}).',
    'DM_SESSION_E_DECRYPT_KEY_FAILED': 'Decryption failed while importing login ticket key from docbase ({0}).',
    'DM_SESSION_E_DOCBASE_NOT_TRUSTED': 'The originating docbase ({0}) of login ticket ({1}) is not trusted.',
    'DM_SESSION_E_REUSE_ONE_TIME_TICKET': 'One-time login ticket ({0}) has already been used.',
    'DM_SESSION_E_ONE_TIME_TICKET_SCOPE': 'One-time login ticket ({0}) is valid for server ({1}) only.',
    'DM_SESSION_E_SUPERUSER_RESTRICTED': 'Super user ({0}) is not allowed to connect to docbase ({1}) using login ticket.',
    'DM_SESSION_E_TICKET_REVOKED': 'The {0} ({1}) has been revoked.',
    'DM_SESSION_E_INVALID_GROUP_NAME': 'Invalid group name ({0}).',
    'DM_SESSION_E_WRONG_GROUP': 'User ({0}) is not a member of of the group ({1}) that owns the application access control token ({2}).',
    'DM_SESSION_E_NULL_TICKET_KEY': 'A login ticket key must be provided.',
    'DM_SESSION_E_INVALID_TICKET_FORMAT': 'Invalid login ticket ({0}). A login ticket must have prefix \'DM_TOCKET=\'',
    'DM_SESSION_E_INLINE_AUTHENTICATION_FAILED': 'Unable to authenticate user ({0}) for docbase ({1}) using inline password.',
    'DM_SESSION_E_LDAP_BIND_FAILED': 'The bind call to the Directory Server ({0}) failed with error ({1}).',
    'DM_SESSION_E_MACHINE_ONLY': 'Token ({0}) can be used on machine identified by ({1}) only; you are using it on machine identifed by ({2}).',
    'DM_SESSION_E_LDAP_AUTH_FAILED': 'Unable to authenticate user ({0}) for docbase ({1}) using LDAP ({2}).',
    'DM_SESSION_E_EXCEPTION_OCCURRED': 'An exception occurred while {0}.',
    'DM_SESSION_E_EMPTY_CHUNKED_OBJ_STR': 'Either the chunked object string stored in session for the object \'{0}\' is empty or the ID doesn\'t match with \'{1}\'.',
    'DM_SESSION_E_CHUNKED_ID_NOT_MATCHED': 'The chunked object ID \'{0}\' passed in does not match with the one \'{1}\' stored in the session.',
    'DM_SESSION_E_CHUNKED_ID_IS_NULL': 'The passed-in chunked object ID via operation \'{0}\' is a null id.',
    'DM_SESSION_E_NON_EXIST_OBJ': 'The object identified by {0} does not exist.',
    'DM_SESSION_E_NON_LOCAL_SERVER_RUNNING': 'There are no running local content servers.',
    'DM_SESSION_E_NOID': 'No id given for command {0}.',
    'DM_SESSION_E_ILLEGAL_NUMBER_OF_ID_REQUESTED': 'The number ({0}) of IDs requested is either less than or equal to zero or exceeds the limit ({1}) set for type with tag ({2}).',
    'DM_SESSION_E_CANNOT_LOAD_LIGHTWEIGHT_TYPE_WITHOUT_PARENT': 'The lightweight type ({0}) could not be loaded because its parent type has not been cached yet',
    'DM_SESSION_E_LDAP_AUTH_EXPRESSION_SEARCHDN': 'Expression is not allowed when bind type is ({0}).',
    'DM_SESSION_E_LDAP_FAILOVER_DOWN': 'Unable to connect to Primary as well as Failover Directory Server on machine ({0}) for docbase ({1}).',
    'DM_SESSION_E_GET_GROUP_INFO_DB': 'Error processing database cursor for group {0}. ({1})',
    'DM_SESSION_E_PROCESS_GROUP_QUERY': 'Error executing query to process recursive group membership for group {0}.',
    'DM_SESSION_E_CLIENT_AUTHENTICATION_FAILURE': 'Failed to authenticate client.  Please check server log for more detail.',
    'DM_SESSION_E_ADD_DYNAMIC_ROLE': 'Error adding dynamic role {0}.',
    'DM_SESSION_E_SETUP_ROLES_FOR_RPC': 'Error initializing dynamic roles for RPC {0} ({1}).',
    'DM_SESSION_E_D6_FEATURE_NOT_SUPPORTED': 'You can not use the D6 feature, {0}, from a 5.3 client or below.',
    'DM_SESSION_E_FIX_OBJ_INCONSISTENCIES_ERROR': 'An internal error occurred while executing the fix object type table procedure for type {0}: {1}. Changes for all objects of this type will not be committed.',
    'DM_SESSION_E_GETJMSCONFIG_FAIL': 'Failed to get dm_jms_config objects from docbase.',
    'DM_SESSION_E_LOCK_OBJECT': 'Failed to lock object \'{0}\' of type {1}.',
    'DM_SESSION_E_INVALID_LOGIN_TICKET_TIMEOUT_VALUE': '({0}) is not a valid login ticket timeout value.',
    'DM_SESSION_E_INVALID_ARG_APPLY': 'Invalid value ({0}) for the {1} argument of {2} apply method.',
    'DM_SESSION_E_PRIVILEGE_REQUIRED': 'The operation ({0}) requires the current user ({1}) to have {2} privilege or be a member of the privilege group.',
    'DM_SESSION_E_OP_DISALLOWED_IN_STATE': 'The operation ({0}) is disallowed when the server is in {1} state.',
    'DM_SESSION_E_OP_DISALLOWED_IN_STATE_UNLESS_ENABLED': 'The operation ({0}) is disallowed when the server is in {1} state unless enabled by {2} on their sessions.',
    'DM_SESSION_E_OP_DISALLOWED_WHEN_DOCBASE_IS_DORMANT': 'The operation ({0}) is disallowed when the whole docbase is in dormant state.',
    'DM_SESSION_E_OP_DISALLOWED_IN_TRANS': 'The operation ({0}) is disallowed when there is an open transaction.',
    'DM_SESSION_E_OP_DISALLOWED_TO_MOVE_SERVER_STATE': 'The operation ({0}) is disallowed to move the server from state ({1}) to the state ({2}) via {3}.',
    'DM_SESSION_E_CANNOT_START_METRIC': 'The performance metric {0} can not be started because {1}',
    'DM_SESSION_E_CANNOT_STOP_METRIC': 'The performance metric {0} can not be stopped because {1}',
    'DM_SESSION_E_CANNOT_COLLECT_METRIC': 'The performance metric {0} can not be collected because {1}',
    'DM_SESSION_E_CANNOT_LIST_METRIC_STATE': 'The performance metric {0} can not be listed because {1}',
    'DM_SESSION_E_CANNOT_RESET_METRIC': 'The performance metric {0} can not be reset because {1}',
    'DM_SESSION_F_EXEC_TOOMANY': 'Too many procedures have been registered for EXECUTE.',
    'DM_SESSION_F_EXEC_DUPDEFN': 'The function ({0}) has already been registered for EXECUTE.',
    'DM_SESSION_F_EXEC_TOOMANYARGS': 'Too many arguments ({0}) have been specified for this function.\nThe maximum is {1}',
    'DM_SESSION_F_EXEC_NO_DATATYPE': 'No datatype specified in the argument description for {0} ({1}).',
    'DM_SESSION_F_EXEC_BAD_DATATYPE': 'An invalid datatype was specified in the argument description ({0}).',
    'DM_SESSION_F_TYPE_CONVERSION': 'The dmi_change_record type could not add the following attribute: {0}.',
    'DM_SESSION_F_AUDIT_CACHE_IS_FULL': 'The audit cache is full. The are {0} entries in the cache.',
    'DM_SESSION_F_INT1': 'The following database query {0} could not be executed. The database error is: {1}',
    'DM_SESSION_F_CRYPTOKEY_TYPE_CONVERSION': 'Failed to convert type {0} to version {1}.',
    'DM_SESSION_F_SETUP_DYNAMIC_ROLE_INTERNAL_ERROR': 'dmSession::SetupDynamicRoles invocation error',
    'DM_SCNFG_W_QRY_CACHE_DIR': 'An error has occurred creating or validating your query cache path.  Query caching is disabled for your session.',
    'DM_SCNFG_W_QRY_CACHE_QRY': 'An unexpected internal error has occurred while initializing your query cache.  Query caching is disabled for your session.',
    'DM_SCNFG_W_QRY_CACHE_USER': 'Query caching is disabled for your session.  User {0} is using your cache directory.',
    'DM_SCNFG_E_CANT_FIND': 'Cannot find {0} server_config object.',
    'DM_SCNFG_E_CANT_CREATE': 'Cannot create a server_config object.',
    'DM_SCNFG_E_CANT_FETCH_INVALID_ID': 'Cannot fetch a server_config - Invalid object ID {0}',
    'DM_SCNFG_E_CANT_SAVE': 'Cannot save {0} server_config.',
    'DM_SCNFG_E_INVALID_SESSC': 'Concurrent session count {0} must be positive.',
    'DM_SCNFG_E_NO_CONFIG_NAME': 'No configuration name is specified.',
    'DM_SCNFG_E_NEED_PRIV_FOR_CHANGE': 'The current user ({0}) needs to have superuser or sysadmin privilege to save or destroy {1} server_config object.',
    'DM_SCNFG_E_NEED_PRIV_FOR_REINIT': 'The current user ({0}) needs to have superuser or sysadmin privilege to reinit the server.',
    'DM_SCNFG_E_NEED_PRIV_FOR_GETLOGIN': 'The current user ({0}) needs to have superuser privilege to login as user {1}.',
    'DM_SCNFG_E_NEED_VALID_USER_FOR_GETLOGIN': 'The user ({0}) needs to be a valid user.',
    'DM_SCNFG_E_INVALID_DEFAULT_ACL': 'Invalid value {0} set for default_acl of the serverconfig \'{1}\'.',
    'DM_SCNFG_E_QRY_CACHE_FILE_NAME': 'A filename-generation error has occurred caching results of a cached query.',
    'DM_SCNFG_E_QRY_CACHE_FILE': 'A file error has occurred caching results of a cached query.',
    'DM_SCNFG_E_QRY_CACHE_FILE_WRITE': 'A file write error has occurred caching results of a cached query.',
    'DM_SCNFG_E_INCONSISTENT_TARGET_ATTRS': 'The value count of projection attributes (projection_targets,projection_proxval,projection_notes,projection_enable) are not consistent.',
    'DM_SCNFG_E_DUPLICATED_TARGET_VALUES': 'The projection attributes contain duplicated target \'{0}\' with port \'{1}\'.',
    'DM_SCNFG_E_INVALID_PROXVAL': 'The projection_proxval[{0}] contains invalid value {1}.',
    'DM_SCNFG_E_INVALID_PORT': 'The projection_port[{0}] contains invalid value {1}.',
    'DM_SCNFG_E_INCR_LENGTH_NONEXISTANT_ATTR': 'While upgrading to version {0}: Failed while trying to increase the length of a non-existant attribute in dm_server_config.',
    'DM_SCNFG_E_INCR_LENGTH_TOO_LONG': 'While upgrading to version {0}: Failed when trying to increase the length of a dm_server_config attribute because the attribute is too long.',
    'DM_SCNFG_E_INCR_LENGTH_FAILED': 'While upgrading to version {0}: The upgrade failed on widening dm_server_config\'s attribute lengths.',
    'DM_SCNFG_E_INCONSISTENT_APP_SERVER_ATTRS': 'The value count of app_server attributes (app_server_name, app_server_uri) is not consistent.',
    'DM_SCNFG_E_DUPLICATED_APP_SERVER_NAME': 'The repeating attribute app_server_name contains a duplicate for \'{0}\'.',
    'DM_SCNFG_E_NEED_PRIV_FOR_LOCK': 'The current user ({0}) needs to have sysadmin privilege to lock a non-sysobject (\'{1}\').',
    'DM_SCNFG_E_NEED_WRITE_PERMIT_FOR_LOCK': 'The current user ({0}) needs to have WRITE permit to lock the sysobject (\'{1}\').',
    'DM_SCNFG_E_INVALID_SECURE_MODE': 'Invalid value ({0}) specified for secure_connect_mode. Valid values are \'native\', \'secure\', and \'dual\'.',
    'DM_SCNFG_E_MAX_WF_THREADS': 'Invalid value ({0}) is specified for wf_agent_worker_threads. It must be between 1 and {1}.',
    'DM_SCNFG_E_TICKET_TIMEOUT_RANGE': 'Invalid value ({0}) is specified for login_ticket_timeout. It must be between {1} and {2}.',
    'DM_SCNFG_E_MAX_TICKET_TIMEOUT_RANGE': 'Invalid value ({0}) for max_login_ticket_timeout. It must be at least ({1}).',
    'DM_SCNFG_E_NEED_PRIV_FOR_GETTOKEN': 'Superuser privilege is required to execute command gettoken',
    'DM_SCNFG_E_NEED_VALID_USER_FOR_GETTOKEN': 'The user ({0}) must be a valid user or group.',
    'DM_SCNFG_E_MAX_TICKET_TIMEOUT_TOO_SMALL': 'Value ({0}) specififed for max_login_ticket_time is smaller than login_ticket_timeout ({1}). Please first reset login_ticket_timeout to a smaller value and then try again.',
    'DM_SCNFG_E_NEED_VERSION_PERMIT_FOR_LOCK': 'The current user ({0}) needs to have VERSION permit to lock the sysobject (\'{1}\').',
    'DM_SCNFG_E_INVALID_SRV_CONFIG': 'You have specified an invalid server config ({0}) for the {1} command.',
    'DM_SCNFG_F_INIT1': 'The server_config type was found in the database without a version stamp.',
    'DM_SCNFG_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_SCNFG_F_INIT3': 'The type manager returned an error storing the server_config type.',
    'DM_SCNFG_F_INT1': 'The following database query {0} could not be executed.',
    'DM_SCNFG_F_INIT4': 'The type manager returned an error converting the dm_server_config type.',
    'DM_SCNFG_F_SYBASE_INIT1': 'In-place conversion is not supported for the Sybase database with version stamp {0}.',
    'DM_SCNFG_F_TYPE_CONVERSION': 'Failed to convert type dm_serverconfig to version {0}.',
    'DM_STORAGE_W_NO_SYSOBJECT_DEFAULT': 'No default storage was set for type dm_sysobject',
    'DM_STORAGE_W_CHECK_PERMISSIONS': 'The directory {0} exists (for filestore {1}). All files should be {2}.',
    'DM_STORAGE_W_REMOVE_FILES': 'Filestore {0} deleted. Files in {1} can be removed.',
    'DM_STORAGE_W_NO_PATH_FOR_FAR_STORE': 'No path defined for location {0} for far filestore {1}.',
    'DM_STORAGE_W_CANT_CHANGE': 'Can\'t change {0} attribute for storage object {1}',
    'DM_STORAGE_W_REPLICA_EXISTS': 'A replica already exists in the store {0}',
    'DM_STORAGE_W_NOT_SUPPORTED': 'The {0} storage type is not supported on this platform ({1})',
    'DM_STORAGE_W_CANT_FETCH_FORMAT': 'Unable to fetch format object with id {0}',
    'DM_STORAGE_W_LINKSTORE_CLEANUP': 'Cleanup of Linked Storage areas being skipped due to errors.  Could not complete cleanup of links created by old getfile operations.',
    'DM_STORAGE_W_CANT_FETCH_FORMAT2': 'Unable to fetch format object with id \'{0}\'.',
    'DM_STORAGE_W_ACL_USER_MISMATCH': 'Your program may be unable to open the file because it will attempt the open as the user who is logged onto your computer ({0}), whereas file permissions are granted to the user connected to the docbase ({1}).',
    'DM_STORAGE_W_ACL_DOMAIN_MISMATCH': 'Your program may be unable to open the file because it will attempt the open as the domain who is logged onto your computer ({0}), but file security is granted to the domain connected to the docbase ({1}).',
    'DM_STORAGE_W_RENAME_MULTIPLE': 'During the scan for files matching the pattern ({0}) ({1}) files were found.  This is unexpected and should be investigated.',
    'DM_STORAGE_W_SUBCONTENT_SAVE_FAILED': 'Failed to save the turbostore content as subcontent object.',
    'DM_STORAGE_W_SIZE_MISMATCH': 'Actual content size of {0} is different from record content size of {1}.',
    'DM_STORAGE_W_CA_STORE_CONTENT_METADATA_FIELD_NOT_FOUND': 'Field {0} not found for object {1}.',
    'DM_STORAGE_W_CA_STORE_ORPHAN_CONTENT_ADDRESS': 'Content Address {0} is orphaned because of transaction rollback',
    'DM_STORAGE_W_CA_STORE_UNABLE_TO_READ_FULL_CONTENT': 'Unable to read full content for content address {0}. Size in the docbase is {1} bytes. Bytes read from the store is {2}',
    'DM_STORAGE_W_CA_STORE_TIME_MISMATCH': 'Local time in UTC and Storage time in UTC do not match. Storage Address: {0}, Local time in UTC: {1}, Storage time in UTC: {2}, Storage Object id: {3}',
    'DM_STORAGE_W_BLOB_INDEX_DB2_RULE': 'On DB2 platforms, blobstore names must be unique within the first 16 characters.  The index creation failure could have occurred because an index with the same name already exists, created for a different blobstore with a name similar to {0}.',
    'DM_STORAGE_W_STORE_PUSH_RETAINER_CHANGES_STOPPED': 'Retainer changes are not pushed to store for content object {0} because DM_NOT_PUSH_RETENTION flag is set to true.',
    'DM_STORAGE_E_BAD_TYPE': 'Can\'t make storage for type {0} -- type not registered',
    'DM_STORAGE_E_DUPLICATE_NAME': 'Attempt to make storage object with name {0} -- name already used',
    'DM_STORAGE_E_MKDIR_FAILED': 'Cannot create storage directory {0}',
    'DM_STORAGE_E_COPY_FAILED': 'Copy of file {0} to file {1} failed',
    'DM_STORAGE_E_CREATE_FAILED': 'Cannot create storage file {0}',
    'DM_STORAGE_E_CANT_MAKE_OTHER_FILE': 'Can\'t create file {0} for other content',
    'DM_STORAGE_E_NO_PROTOCOL': 'Attempt to store other file using invalid protocol specification',
    'DM_STORAGE_E_BAD_TICKET': 'Use of invalid ticket for storage object with name {0}; storage may be improperly configured.\nTicket was {1}.  Data Ticket was {2}.',
    'DM_STORAGE_E_WRONG_PROTOCOL': 'Protocol for server does not match stored protocol for storage object with name{0}.\nTicket was {1}.  Data Ticket was {2}.',
    'DM_STORAGE_E_LINK_SAVE_FAIL': 'Can\'t save link record while fetching ticket {0} from storage object {1}',
    'DM_STORAGE_E_CANT_LINK': 'Could not make link between {0} and {1}.',
    'DM_STORAGE_E_NO_CLOSE_REPLICA': 'Could not find close replica fetching ticket {0} from storage object {1}. \n Fetch or copy failed.',
    'DM_STORAGE_E_NOT_ONLINE': 'Could not update storage object {0}. Storage is not online',
    'DM_STORAGE_E_OFFLINE': 'Could not read from storage object {0}. Storage is offline',
    'DM_STORAGE_E_READONLY': 'Could not write to storage object {0}. Storage is marked Read-Only',
    'DM_STORAGE_E_NO_LOCAL_STORE': 'No local storage exists for distributed store {0}.',
    'DM_STORAGE_E_BAD_LINK_STORE': 'Linked storage object {0} has no component.',
    'DM_STORAGE_E_NO_STORE_FOR_NAME': 'There is no storage object with name {0}.',
    'DM_STORAGE_E_NO_STORE_FOR_ID': 'There is no storage object with id {0}.',
    'DM_STORAGE_E_BAD_DEFAULT_STORE': 'The default store ({0}) for type {1} does not exist.',
    'DM_STORAGE_E_NO_PATH': 'The location {0} for filestore {1} is not defined in the server configuration',
    'DM_STORAGE_E_CANT_DESTROY': 'Cannot destroy storage object {0} because {1}.',
    'DM_STORAGE_E_FAR_STORE_WRITE': 'Cannot write directly to far store {0}. This storage area is not accessible by the current server.',
    'DM_STORAGE_E_FAR_STORE_READ': 'Attempt to read from far store {0}',
    'DM_STORAGE_E_NO_NAME': 'Attempt to create new storage object without giving it a name',
    'DM_STORAGE_E_DUPLICATE_LOCATIONS': 'Storage object {0} already using location {1}',
    'DM_STORAGE_E_NOT_SYS_ADMIN': 'You must have sys admin privileges to perform a {0} operation',
    'DM_STORAGE_E_NO_FULLTEXT_INDEX': 'No fulltext index exists for storage {0} -- can\'t mark content {1} for indexing',
    'DM_STORAGE_E_BLOB_SAVE_FAILED': 'Attempt to save content in blob store {0} failed',
    'DM_STORAGE_E_LINK_LOCATION_UNDEFINED': 'Link location name {0} is not location object name',
    'DM_STORAGE_E_BLOB_INSERT_FAILED': 'Could not insert data in blob store {0}. {1}',
    'DM_STORAGE_E_BLOB_TABLE_CREATE': 'Could not create the table for blob store {0}. {1}',
    'DM_STORAGE_E_BLOB_COLUMN_ALLOCATE': 'Could not allocate columns in blob store {0}. {1}',
    'DM_STORAGE_E_BLOB_MEMORY': 'Out of memory for blob store {0}.',
    'DM_STORAGE_E_FILE_WRITE_FAILED': 'Error writing to content file {0}. File size {1} bytes.',
    'DM_STORAGE_E_MAX_BLOB_SIZE_EXCEEDED': 'Attempt to store into blob failed -- size ({0}) must be less than 65535 bytes',
    'DM_STORAGE_E_NOT_COMPONENT': 'Store {0} is not a component of the distributed store {1}',
    'DM_STORAGE_E_LAST_REPLICA': 'Can\'t delete last replica in storage {0}',
    'DM_STORAGE_E_NO_REPLICA': 'No replica exists in the component store {0}',
    'DM_STORAGE_E_NOT_DISTRIBUTED': 'The store {0} is not a distributed store',
    'DM_STORAGE_E_REPLICATE_BAD_TYPE': 'The type specified for replication ({0}) is not a sysobject subtype',
    'DM_STORAGE_E_BAD_COMPONENT': 'The store {0} cannot be used in as a component in a {1} store',
    'DM_STORAGE_E_NOT_FILESTORE': 'The store {0} is not a file store',
    'DM_STORAGE_E_NO_ROOT': 'Attempt to create filestore without specifying root location',
    'DM_STORAGE_E_SIZE_MISMATCH': 'Files sizes disagree when doing import -- expected {0} bytes, but file had {1} bytes',
    'DM_STORAGE_E_NOT_A_FILE': 'File {0} could not be opened for reading',
    'DM_STORAGE_E_COMPONENT_ALREADY_EXISTS': 'The component {0} already exists in store {1}',
    'DM_STORAGE_E_RESTORE_NO_FILE': 'The RESTORE method must include a file_path argument from which to restore the document content.',
    'DM_STORAGE_E_RESTORE_MISMATCH': 'The file specified in the RESTORE request has a size of {0} bytes which does not match the recorded content size ({1} bytes).',
    'DM_STORAGE_E_RESTORE_FAILED': 'Content restore failed because {0}.',
    'DM_STORAGE_E_NOT_ACCESSIBLE': 'Storage area {0} is not currently accessible.  Reason: {1}.',
    'DM_STORAGE_E_REPLICATE_NOACCESS': 'Cannot replicate to storage area {0} as it is not directly accessible by this server.',
    'DM_STORAGE_E_DELETEREP_NOACCESS': 'Cannot delete replica from storage area {0} as it is not directly accessible by this server.',
    'DM_STORAGE_E_BLOB_INDEX_CREATE': 'Could not create the index for blob store {0}. {1}.',
    'DM_STORAGE_E_LAUNCH_FAIL': 'Failed to launch the command: {0}. os_error: {1}.',
    'DM_STORAGE_E_WAIT_FAIL': 'Failed to wait for the command: {0}. os_error: {1}.',
    'DM_STORAGE_E_EXEC_FAIL': 'Command execution failure: {0}. os_error: {1}.',
    'DM_STORAGE_E_SECURITY_PRIVATE': 'Unable to change file system security on file {0}.  Operating System error: {1}',
    'DM_STORAGE_E_SECURITY_PUBLIC': 'Unable to change file system security on file {0}.  Operating System error: {1}',
    'DM_STORAGE_E_FILE_LINK': 'An unexpected failure occurred while attempting to link file {0} to file {1}.  Operating System error: {2}',
    'DM_STORAGE_E_RESET_FILE': 'An unexpected failure occurred while attempting to set file security on file {0}.  Operating System error: {1}',
    'DM_STORAGE_E_BAD_NAME': 'Illegal name {0} for storage object of type {1}',
    'DM_STORAGE_E_RENAME_EXT_SEARCH': 'Unable to rename a file matching ({0}) to ({1}).  Operating System error: {2}',
    'DM_STORAGE_E_RENAME_FAIL': 'Unable to rename a file ({0}) to ({1}).  Operating System error: {2}',
    'DM_STORAGE_E_NO_FULLTEXT_PARENT': 'Can\'t mark content {0} for indexing, because parent {1} is not an index_parent',
    'DM_STORAGE_E_INCORRECT_ATTR_COUNT': 'Attribute count for {0} and {1} should be equal',
    'DM_STORAGE_E_CANT_OPEN_PLUGIN': 'Could not open shared library {0} for external store object {1}, error : {2}',
    'DM_STORAGE_E_INVALID_PLUGIN': '{0} is not a valid shared library',
    'DM_STORAGE_E_CANT_INITIALIZE_PLUGIN': 'Could not initialize plugin ID: {0}, Path: {1}, Reason : {2}',
    'DM_STORAGE_E_SYMBOL_NOT_FOUND': 'Could not find API {0} in {1}',
    'DM_STORAGE_E_PLUGIN_INIT_FAILED': '{0} API in {1} returned a failure code of {2}',
    'DM_STORAGE_E_NO_PLUGIN_FOUND': 'No plugin found for external store object {0} for {1} execution mode',
    'DM_STORAGE_E_GETFILE_NOT_ALLOWED': 'getfile not allowed for sysobject {0}, because the storagetype for the object has not plugin configured',
    'DM_STORAGE_E_CANT_GET_PLUGIN_PATH': 'Could not obtain path of the plugin for {0} object',
    'DM_STORAGE_E_CANT_GET_CONTENT_TOKEN': 'Could not obtain content token for {0} object',
    'DM_STORAGE_E_CANT_CREATE_PLUGIN_READER': 'Could not open plugin reader {0} to read {1}',
    'DM_STORAGE_E_CANT_USE_EXTERNAL_STORE': 'Object {0} cannot be used as a plugin because it uses external storage',
    'DM_STORAGE_E_CANT_FETCH_PLUGIN': '{0} failed for plugin object {1}',
    'DM_STORAGE_E_EXTERNAL_STORE_CANT_CHANGE': 'Cannot update {0} because {1}',
    'DM_STORAGE_E_MOUNT_NOT_SUPPORTED': 'mount cannot be executed for {0} because it is not a dm_extern_file object',
    'DM_STORAGE_E_NOT_A_DIRECTORY': 'argument ({0}) specified for mount for ({1}) is not a valid directory on {2}',
    'DM_STORAGE_E_INVALID_OBJECT_NAME': '{0} is not a valid external store object name',
    'DM_STORAGE_E_INVALID_OBJECT_ID': '{0} is not a valid external store object id',
    'DM_STORAGE_E_MOUNT_FAILED': 'mount failed for {0} because {1} {2}',
    'DM_STORAGE_E_MOUNT_NOT_EXECUTED': 'You must execute mount for {0} before retrieving content',
    'DM_STORAGE_E_SYNTAX_ERROR': 'Incorrect syntax for mount command',
    'DM_STORAGE_E_INVALID_PLATFORM_INDICATOR': 'Invalid value for a_platform attribute : {0}. Should be between 1 and 5',
    'DM_STORAGE_E_DUPLICATE_PLATFORM_INDICATOR': 'Cannot specify duplicate platform indicator values for a_platform attribute: {0}',
    'DM_STORAGE_E_INVALID_PLUGIN_OBJECT_ID': '{0} is not a valid object id value for a_plugin_id attribute. Object does not exist in docbase',
    'DM_STORAGE_E_NO_PLUGIN_CONTENT': 'There is no content for plugin object {0}',
    'DM_STORAGE_E_NO_TEMP_LOCATION': 'No temp location specified in server config',
    'DM_STORAGE_E_NEED_LOCATION': 'Can\'t use temp location {0}, oserror: {1}',
    'DM_STORAGE_E_INVALID_URL': '{0} is not a valid URL',
    'DM_STORAGE_E_INVALID_LOCATION_NAME': '{0} is not a valid location object name',
    'DM_STORAGE_E_TURBO_SAVE_FAILED': 'Database and/or network error occured while saving turbo content',
    'DM_STORAGE_E_CURSOR_FETCH_FAIL': 'Database error occured while fetching sub content object(s). Error from database was {0}',
    'DM_STORAGE_E_CURSOR_EXEC_FAIL': 'Database error occured while executing a cursor. Error from database was {0}',
    'DM_STORAGE_E_INVALID_PLUGIN_OBJECT_TYPE': 'Plugin objects should be of dm_plugin type. {0} is of type {1}',
    'DM_STORAGE_E_DUMP_WITH_CONTENT_NOT_SUPPORTED': 'Dump with content is not supported for objects that use external storage',
    'DM_STORAGE_E_FULLTEXT_INDEX_NOT_SUPPORTED': 'Fulltext indexing not supported for content in external storage',
    'DM_STORAGE_E_SERVER_PLATFORM_INDICATOR': 'Unable to obtain server platform indicator',
    'DM_STORAGE_E_CANT_INITIALIZE_LOCALAREA': 'Unable to initialize localarea for plugin content',
    'DM_STORAGE_E_CANT_MAKE_LOCALDIR': 'Unable to make directory for downloading plugin content',
    'DM_STORAGE_E_CANT_DOWNLOAD_PLUGIN_CONTENT': 'Unable to download plugin library content',
    'DM_STORAGE_E_CANT_OBTAIN_PLUGIN_VERSION': 'Unable to obtain plugin protocol version. Plugin path: {0}',
    'DM_STORAGE_E_INCORRECT_PLUGIN_VERSION': 'Plugin protocol version {0}.{1} is not supported. Plugin path :{2}',
    'DM_STORAGE_E_INSUFFICIENT_BUFFER_SIZE': 'Turbo content retrieval requires a minimum buffer size of {0}. Supplied buffer size is {1}',
    'DM_STORAGE_E_NO_WORM_SUPPORT_FOR_STORE': 'There is no WORM support for store: {0}',
    'DM_STORAGE_E_REPLICA_FETCH': 'Error fetching replica record: {0}.',
    'DM_STORAGE_E_REPLICA_UPDATE': 'Error updating replica record: {0}.',
    'DM_STORAGE_E_SYNC_REP_RECORDS': 'Error performing SYNC_REPLICA_RECORDS operation.',
    'DM_STORAGE_E_WRONG_THUMB_KEY': 'Either the thumbnail key file is missing or the key length is less than 24 bytes for store (\'{0}\') that requires ticket.',
    'DM_STORAGE_E_TAR_FAILURE': 'Tar step failed during {0} operation -- OS error was {1}',
    'DM_STORAGE_E_CHANGE_NOT_ALLOWED': 'The attribute {0} is not allowed to be changed after the storage object is created.',
    'DM_STORAGE_E_NO_MORE_MEMORY': 'No more memory to perform an operation',
    'DM_STORAGE_E_MAKE_SOURCE_FAILED': 'Could not create source object while attempting to decrypt shared library - {0}.',
    'DM_STORAGE_E_COULD_NOT_OPEN_FILE_FOR_WRITE': ' The file- {0} could not be opened for writing',
    'DM_STORAGE_E_CA_STORE_PLUGIN_ERROR_DURING_READ': 'Plugin ID: {0} returned error: {1}, error code:{2}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_ERROR_DURING_WRITE': 'Plugin ID: {0} returned error: {1}, error code:{2}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_ERROR_DURING_SET_METADATA': 'Plugin ID: {0} returned error: {1}, error code:{2}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_ERROR_DURING_PREPARE_FOR_READ': 'Plugin ID: {0} returned error: {1}, error code:{2}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_ERROR_DURING_PREPARE_FOR_WRITE': 'Plugin ID: {0} returned error: {1}, error code:{2}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_ERROR_DURING_WRITE_CLOSE': 'Plugin ID: {0} returned error: {1}, error code:{2}',
    'DM_STORAGE_E_CANT_OPEN_CA_STORE_PLUGIN': 'Could not open plugin library {0} for content addressable store object {1}, error : {2}. Plugin ID: {3}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_CALLBACK_ATTR_NOT_FOUND': 'Requested attribute {0} not found in the dm_ca_store type.',
    'DM_STORAGE_E_CA_STORE_PLUGIN_CALLBACK_INVALID_POSITION': 'Incorrect argument value for position, for attribute {0}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_CALLBACK_INVALID_STORE_ID': 'Invalid storage object id {0}',
    'DM_STORAGE_E_CA_STORE_STORE_MISSING_RETENTION_FIELD': 'Field value ({0}) specified for a_retention_attr_name is missing in a_content_attr_name',
    'DM_STORAGE_E_CA_STORE_PLUGIN_WRITE_ERROR': 'dm_casplugin_write function in plugin {0} returned incorrect number of bytes written. Expected: {1}, Returned: {2}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_CONTENT_ADDRESS_SIZE_EXCEEDS_MAXIMUM': 'dm_casplugin_write_close() method in plugin {0} returned -1 because it requires {1} bytes for content address. The maximum is {2}.',
    'DM_STORAGE_E_CA_STORE_MISSING_RETENTION_FIELD_VALUE': 'No value was specified for attribute {0}. Value for this attribute is required because its value defines the retention period of the content',
    'DM_STORAGE_E_CA_STORE_RETENTION_FIELD_TYPE_INCORRECT': 'Type of value field {0} is not correct. Beause this field defines the retention period, it should be of DATE type.',
    'DM_STORAGE_E_CA_STORE_UNABLE_TO_OBTAIN_CONTENT_ADDRESS': 'Unable to obtain content address for content object {0}',
    'DM_STORAGE_E_CA_STORE_REMOVE_CONTENT_NOT_SUPPORTED': 'Removing content from a dm_ca_store type storage is not supported. Contact Documentum Technical Support.',
    'DM_STORAGE_E_CA_STORE_PLUGIN_UNABLE_TO_GET_RETENTION_PERIOD': 'Unable to obtain retention period for content address {0} through plugin {1}. Error code from dm_casplugin_get_retention_period is {2}. Storage id is {3}.',
    'DM_STORAGE_E_CA_STORE_NO_VALUE_FOR_ATTR': 'Value not specified for \'{0}\' attribute.',
    'DM_STORAGE_E_CA_STORE_CONTENT_CANNOT_BE_DESTROYED': 'Content object {0} cannot be destroyed because the retention period has not expired. Content Address is {1}. Storage area name is \'{2}\'.',
    'DM_STORAGE_E_CA_STORE_PLUGIN_ERROR_DURING_DELETE_CONTENT': 'An error occured while attempting to destroy content through plugin {0}, for storage {1}: Error Code: {2}. Error Message: {3}. Content Address is {4}.',
    'DM_STORAGE_E_CA_STORE_DUMP_WITH_CONTENT_NOT_SUPPORTED': 'Dump with content is not supported for objects using dm_ca_store type object for storing content.',
    'DM_STORAGE_E_CA_STORE_SETCONTENTATTRS_NOT_CALLED': 'setcontentattrs API must be called prior to saving the object. You must specify a DATE value for \'{0}\' using setcontentattrs API first. ',
    'DM_STORAGE_E_CA_STORE_PUSH_CONTENT_ATTRS_FAILED': 'PUSH_CONTENT_ATTRS failed because {0}',
    'DM_STORAGE_E_CA_STORE_UNABLE_TO_CHECK_CAN_DELETE': 'Unable to check if storage \'{0}\' allows deletes because dm_casplugin_can_delete() in plugin {1} returned error code {2}',
    'DM_STORAGE_E_CA_STORE_ERROR_DURING_WRITE': 'Error while attempting to write content to dm_ca_store object : {0}',
    'DM_STORAGE_E_CA_STORE_CONTENT_NOT_NEW': 'Page {0} of object {1} is not new.',
    'DM_STORAGE_E_CA_STORE_DUPLICATE_VALUE': 'Value {0} for attribute {1} is specified more than once.',
    'DM_STORAGE_E_CA_STORE_UNABLE_TO_GET_CONTENT_ATTRS': 'Unable to collect content attributes from content object {0} during load.',
    'DM_STORAGE_E_INVALID_COMPONENT': 'Store {0} is an invalid component for distributed store {1}',
    'DM_STORAGE_E_CA_STORE_UNABLE_TO_FETCH_CONTENT': 'Unable to fetch content for content address \'{0}\' in storage \'{1}\'',
    'DM_STORAGE_E_CA_STORE_LOCATION_NOT_FOUND_FOR_FETCH': 'A dm_location object with name \'{0}\' not found while attempting to fetch content for content address \'{1}\' in storage \'{2}\'',
    'DM_STORAGE_E_CA_STORE_FETCH_FAILURE': 'An Operating System error occured while attempting to write content to \'{0}\' : {1}. Content Address is \'{2}\', storage is \'{3}\'',
    'DM_STORAGE_E_CA_STORE_UNABLE_TO_SAVE_LOCATION_OBJECT': 'Unable to save \'{0}\' dm_location object.',
    'DM_STORAGE_E_CA_STORE_INVALID_CONTENT_ADDRESS': 'Content address is either empty or NULL',
    'DM_STORAGE_E_CA_STORE_INCORRECT_CLIENT_VERSION': 'Incorrect client version (\'{0}\') to store content in a dm_ca_store object.',
    'DM_STORAGE_E_CA_STORE_OTHERFILE_NOT_ALLOWED': 'Resource fork files cannot be saved in a CA Store',
    'DM_STORAGE_E_CA_STORE_FEATURE_NOT_ENABLED': 'Content Addressable Storage Services feature is not enabled for the server installation. Contact Documentum Technical Support.',
    'DM_STORAGE_E_CA_STORE_DELETE_NOT_ALLOWED_BY_STORAGE': 'Content object \'{0}\' cannot be destroyed because storage \'{1}\' does not allow deletes. Content Address is {2}',
    'DM_STORAGE_E_EXTERNAL_STORE_TYPE_UPGRADE_FAIL': 'Unable to upgrade {0} type, {1} attribute failed for {2}',
    'DM_STORAGE_E_CHECK_RETENTION_EXPIRED': 'Reason: {0}',
    'DM_STORAGE_E_CA_STORE_SETCONTENTATTRS_FAILED': 'Invalid storage to process content attributes',
    'DM_STORAGE_E_DIGITAL_SHREDDING_FAILURE': 'The file {0} in store {1} could not be shredded. OS/Other error: {2}.',
    'DM_STORAGE_E_INVALID_ARGUMENTS': 'Invalid arguments passed to {0}',
    'DM_STORAGE_E_FORCE_DELETE_FAILED': 'Error {0} ({1}) occured during force delete. Content Address {2}',
    'DM_STORAGE_E_FORCE_DELETE_NOT_SUPER_USER': 'You must be a super user or a retention manager to perform force delete operation',
    'DM_STORAGE_E_FORCE_DELETE_NOT_ALLOWED_IN_EXTERNAL_TRANSACTION': 'You cannot perform force delete after having initiated an explicit transaction',
    'DM_STORAGE_E_INVALID_STORE_TYPE_FOR_COMPRESSION': 'compression_mode can be set only for dm_filestore and dm_ca_store storage types.',
    'DM_STORAGE_E_INVALID_VALUE': 'Invalid value ({0}) specified for {1} attribute',
    'DM_STORAGE_E_FEATURE_NOT_SUPPORTED_FOR_STORAGE_TYPE': 'The \'{0}\' feature is not supported for \'{1}\' storage type',
    'DM_STORAGE_E_CASTORE_UNABLE_TO_WIDEN_ATTR': 'A database failure occured while widening the length of attribute {0}',
    'DM_STORAGE_E_CASTORE_UNABLE_TO_UPDATE_VERSION_STAMP': 'Unable to update the version stamp of ca_store_version to {0}',
    'DM_STORAGE_E_CASTORE_INVALID_ATTR_VALUE': '{0} is not a valid value for {1} as it\'s a value for {2} attribute',
    'DM_STORAGE_E_CASTORE_NOT_SUPPORTED': 'Content Addressable Storage type is not supported on {0} architecture',
    'DM_STORAGE_E_BLOB_READ_FAILED': 'Database error {0} occured when reading blob from blob store {1}',
    'DM_STORAGE_E_CASTORE_DUMP_CLIP': 'CASTORE_DUMP_CLIP error: {0}',
    'DM_STORAGE_E_UNABLE_TO_LOCK': 'Unable to lock storage object ({0}) for ticket allocation, object id is {1}, Lock statement: {2}, Error from database: {3}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_MISSING_ENTRY_POINT': 'Incorrect version of CA store Plugin with id {0}, path {1} , missing entry point {2}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_FILE_NOT_FOUND': 'Error accessing file ({0}) while migrating the content to CA store. Operating System error is {1}',
    'DM_STORAGE_E_OBSOLETE_CMD': 'Apply method {0} has been obsolete.',
    'DM_STORAGE_E_GFSMP_MISSING_PARAMETERS': 'Required parameters {0} are missing from GET_FILESTORE_METADATA_AND_PATH',
    'DM_STORAGE_E_GFSMP_INVALID_STORE_TYPE': 'Store {0} has storage type {1} not supported by GET_FILESTORE_METADATA_AND_PATH',
    'DM_STORAGE_E_GFSMP_DATA_TICKET_PATH': 'Cannot allocate data ticket and path for filestore {0}.',
    'DM_STORAGE_E_GFSMP_OTHER_TICKET_PATH': 'Cannot allocate other ticket and path for filestore {0}.',
    'DM_STORAGE_E_GET_STORAGE_INFO_ERROR': 'Unable to get the storage info for [{0}]: {1}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_UNABLE_TO_VERIFY_EBR': 'Unable to verify Event Based Retention. Error : {0}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_EBR_NOT_ENABLED': 'Unable to enable EBR for the clip, Error : {0}',
    'DM_STORAGE_E_CA_STORE_CLIP_DELETE_NOT_ALLOWED_AS_UNDER_EBR': 'The clip {0} is under Event Based Retention and cannot be deleted.',
    'DM_STORAGE_E_CA_STORE_PLUGIN_UNABLE_TO_GET_EBR': '{0}',
    'DM_STORAGE_E_CA_STORE_EBR_NOT_SUPPORTED': 'Event Based Retention is not supported on the centera cluster.',
    'DM_STORAGE_E_CA_STORE_PLUGIN_UNABLE_TO_TRIGGER_EBR': '{0}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_UNABLE_TO_VERIFY_TRIGGER': 'Unable to verify if the clip {0} is triggered or not. Error Code : {1}, Error message : {2}',
    'DM_STORAGE_E_CA_STORE_TRIGGER_EBR_WITH_PERIOD_FAILED': 'Unable to save the subcontent object with address {0}',
    'DM_STORAGE_E_CA_STORE_ENABLE_EBR_WITH_PERIOD_FAILED': 'Unable to save teh subcontent object with address {0}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_ERROR_DURING_PREPARE_FOR_EBR': 'Plugin Id: {0}, Error code: {1} , Error message {2}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_ERROR_DURING_CLIP_CLOSE': 'Error during closing the clip {0}, Error code {1}, Error message {2}',
    'DM_STORAGE_E_CA_STORE_TEMP_CONNECTION_NOT_VALID': 'Could not obtain TEMP_CONNECTION from the database',
    'DM_STORAGE_E_COMPONENT_PREFERENCE_MISMATCH': 'Setting of attribute {0} on store {1} does not match distributed store {2}.',
    'DM_STORAGE_E_COMPONENT_CHANGE_NOT_ALLOWED': 'The attribute {0} is not allowed to be changed on a component store {1}.',
    'DM_STORAGE_E_CANT_CHANGE': 'Can\'t change {0} attribute for storage object {1}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_ERROR_DURING_PREPARE_FOR_RH': 'Plugin Id: {0}, Error code: {1} , Error message {2}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_RH_NOT_ENABLED': 'Retention Hold is not supported on the centera cluster.',
    'DM_STORAGE_E_CA_STORE_PLUGIN_UNABLE_TO_VERIFY_RH': 'Unable to verify Retention Hold for content address {0}, Error Code: {1}, Error message: {2}.',
    'DM_STORAGE_E_CA_STORE_PLUGIN_UNABLE_TO_PROCESS_RH': '{0}.',
    'DM_STORAGE_E_GET_REPLICA_FAILED': 'Failed to get the replica record of content {0} during computing its other file size in distributed store.',
    'DM_STORAGE_E_EXTSTORE_PLUGIN_ERROR': 'Session: {0}, Store: {1}, message: {2}',
    'DM_STORAGE_E_EXTERNAL_STORE_OTHERFILE_NOT_ALLOWED': 'Resource fork files cannot be saved in an External Store',
    'DM_STORAGE_E_NO_ACS': 'ACS Content Transfer Connector cannot find ACS for server {0} to {1} content.',
    'DM_STORAGE_E_NO_ACS_BASE_URL': 'ACS Content Transfer Connector cannot find URL for ACS {0} using {1} protocol.',
    'DM_STORAGE_E_ACS_INTERNAL_ERROR': 'ACS Content Transfer Connector failed {0}.',
    'DM_STORAGE_E_ACS_HTTP_POST_FAILURE': 'ACS Content Transfer Connector failed to post the HTTP request to the ACS with status {0}.',
    'DM_STORAGE_E_CONTENT_ACCESSOR_MISSING': 'No Accessor defined for Store {0}.',
    'DM_STORAGE_E_CA_STORE_PLUGIN_ERROR_DURING_SETUP_FOR_MULTI_WRITE': 'Plugin Id : {0}, Plugin Error Code : {1}, Error Message : {2}',
    'DM_STORAGE_E_INTERNAL_ERROR_DURING_CONTENT_TRANSFER': '{0}',
    'DM_STORAGE_E_CA_STORE_PLUGIN_UNABLE_TO_GET_OTHER_FILE_SIZE': 'Plugin Id : {0}, Plugin Error Code : {1}, Error Message : {2}',
    'DM_STORAGE_E_EXTERNAL_STORE_INVALID_VALUE_FOR_ATTRIBUTE': 'Value {0} specified for attribute {1} is invalid',
    'DM_STORAGE_E_of': '',
    'DM_STORAGE_E_LOCK_FILE_LOCATION_NOT_UNIQUE': 'the file store {0} cannot be created because file store ({1}) is using location {2}',
    'DM_STORAGE_E_LOCK_FILE_OS_ERROR': 'Operating System Error Occur while {0} lock file. Error is: {1} ',
    'DM_STORAGE_E_REQUIRE_RETENTION_TO_SAVE': ' Required to attach Retainer object to sys object with object Id: {0}, inorder to store content inside store with storage name {1} ',
    'DM_STORAGE_E_FILESTORE_CONTENT_CANNOT_BE_DESTROYED': 'Content object {0} cannot be destroyed because the retention period has not expired. Storage area name is \'{1}\'.',
    'DM_STORAGE_F_TYPE_CONVERSION': 'Failed to convert type dm_store to version {0}.',
    'DM_STORAGE_F_VERSION_STAMPING': 'Failed to version stamp dm_store object to {0}.',
    'DM_STORAGE_F_MEMORY_ALLOCATION_FAILED': 'Unable to allocate memory for {0} object',
    'DM_STORAGE_F_NO_CONTENT_STORAGE_SERVICE_LICENSE': 'A Content Storage Services license is required to configure a storage object for content hash generation',
    'DM_STORAGE_F_NO_CONTENT_STORAGE_SERVICE_LICENSE_FOR_PM': 'A Content Storage Services license is required set the PARALLEL_DEGREE parameter for the CONTENT_MIGRATION method to a value greater than zero.',
    'DM_STORAGE_F_UNABLE_TO_COMPUTE_DATE_EPOCH': 'Unable to get epoch for the date {0}',
    'DM_STORAGE_F_NO_CONTENT_STORAGE_OR_ARCHIVE_SERVICE_LICENSE': 'A Content Storage or Archive Services license is required to configure a storage object for compression and content duplication prevention',
    'DM_STORAGE_F_NO_CONTENT_STORAGE_OR_HIGH_VOLUME_LICENSE': 'A Content Storage or High-Volume Server license is required to configure a storage object for compression and content duplication prevention',
    'DM_STORAGE_I_APPENDCONTENT_NOT_ALLOWED': 'appendcontent disallowed for {0}, because it uses external storage',
    'DM_STORAGE_I_INSERTCONTENT_NOT_ALLOWED': 'insertcontent disallowed for {0}, because it uses external storage',
    'DM_STORAGE_I_CANT_CHECKOUT': 'can\'t checkout {0}, because it uses external storage',
    'DM_STORAGE_I_OTHERFILE_NOT_ALLOWED': 'otherfile disallowed for {0}, because it uses external storage',
    'DM_STORAGE_I_SETCONTENT_NOT_ALLOWED': 'setcontent disallowed for {0}, because it uses external storage',
    'DM_STORAGE_I_STORAGE_NAME_REQUIRED': 'A valid storage name is required since {0} uses external storage',
    'DM_STORAGE_I_CANT_USE_EXTERNAL_STORE': 'Cannot use an external store for addrendition',
    'DM_STORAGE_I_DM_STORAGE_E_CHANGE_NOT_ALLOWED_CRYPTO_MODE': 'Changing crypto-mode attribute is not allowed.',
    'DM_STORAGE_T_FILESTORE_DUPLICATE_CONTENT_TRACE': '{0}',
    'DM_STORAGE_T_EXTSTORE_TRACE': 'Session: {0}, Store: {1}, message: {2}',
    'DM_STORAGE_T_FILESTORE_TRACE': '{0}',
    'DM_SYSOBJECT_T_MERGE_1': 'Checking local folder path for sysobject ID={0}, folder_path={1}, tgt_path={2}',
    'DM_SYSOBJECT_T_MERGE_2': 'Appending folder: folder_path={0}',
    'DM_SYSOBJECT_T_MERGE_3': 'Removing local folder: folder_path={0}',
    'DM_SYSOBJECT_T_ESIGN_CHECK_TCS_ENABLED': 'AddESignature: Verifying that Trusted Content Services are enabled.',
    'DM_SYSOBJECT_T_ESIGN_ARGUMENT_VALUE': 'AddESignature: Method argument \'{0}\' has value \'{1}\'.',
    'DM_SYSOBJECT_T_ESIGN_OBJECT_ID': 'AddESignature: Called for object \'{0}\'.',
    'DM_SYSOBJECT_T_ESIGN_AUTHENTICATE_USER': 'AddESignature: Authenticating user \'{0}\'.',
    'DM_SYSOBJECT_T_ESIGN_CHECK_PERMISSIONS': 'AddESignature: Checking user permissions.',
    'DM_SYSOBJECT_T_ESIGN_VERIFY_NOT_CHECKED_OUT': 'AddESignature: Verifying that the object is not checked out.',
    'DM_SYSOBJECT_T_ESIGN_CHECK_PRE_SIGNATURE_HASH': 'AddESignature: Verifying pre-signature hash.',
    'DM_SYSOBJECT_T_ESIGN_VERIFY_PREVIOUS_SIGNATURES': 'AddESignature: Verifying any previously existing signatures.',
    'DM_SYSOBJECT_T_ESIGN_SIGNATURE_NUMBER': 'AddESignature: This is signature number {0}.',
    'DM_SYSOBJECT_T_ESIGN_SAVE_ORIGINAL_CONTENT': 'AddESignature: Saving original (unsigned) content object with page modifier \'dm_sig_source\'.',
    'DM_SYSOBJECT_T_ESIGN_CREATE_TEMP_FILE': 'AddESignature: Creating temporary file \'{0}\' with content to be signed.',
    'DM_SYSOBJECT_T_ESIGN_CALL_METHOD': 'AddESignature: Calling method \'{0}\' with arguments \'{1}\'.',
    'DM_SYSOBJECT_T_ESIGN_NEW_CONTENT': 'AddESignature: Creating new content object \'{0}\'.',
    'DM_SYSOBJECT_T_ESIGN_SAVE_AUDIT': 'AddESignature: Saving dm_addesignature audit record.',
    'DM_SYSOBJECT_T_ESIGN_OPERATION_SUCCEEDED': 'AddESignature: Operation succeeded. New audit record ID is \'{0}\'.',
    'DM_SYSOBJECT_T_ESIGN_READ_USER_OS_NAME': 'AddESignature: Get user login name \'{0}\'.',
    'DM_SYSOBJECT_T_UPDATE_RETAIN_UNTIL_DATE': '{0}',
    'DM_SYSOBJECT_T_FULL_FETCH': 'Full Fetch of SysObj id={0} cache_vstamp={1}.',
    'DM_SYSOBJECT_T_SYSOBJ_SAVE_FAILED': 'Save of sysobject (id = {0}, name = {1}) failed during Phase {2}',
    'DM_SYSOBJECT_T_ESIGN_FAILED_SAVE_AUDIT': 'AddESignature: Saving dm_addesignature_failed audit record.',
    'DM_SYSOBJECT_W_FOLDER_DEFACL': 'Failed to inherit ACL for {0} \'{1}\', since it does not have a primary folder.',
    'DM_SYSOBJECT_W_RENDITION_NOT_REMOVED': 'Rendition page {0} is not removed for {1} because keep_flag is set to TRUE',
    'DM_SYSOBJECT_W_CANT_FETCH_ACL': 'Cannot fetch the ACL associated with sysobject {0}.',
    'DM_SYSOBJECT_W_ASSUMING_ACL_SECURITY_MODE': 'The server has dedected an unsupported security mode. ACL security is being assumed.',
    'DM_SYSOBJECT_W_ATTRS_NOT_ALTERED_FTINDEX': 'String-valued attributes have not been marked for fulltext indexing because index objects of type {0} already exist in the docbase. Please run the method dm_UpgradeFTSysObjAttrs.',
    'DM_SYSOBJECT_W_MERGE_PARENT_FETCH': 'Unable to fetch parent link {0} for folder {1}.  The load operation is unable to determine what to do with the link and will leave it in its current state.',
    'DM_SYSOBJECT_W_CANNOT_MODIFY_CONTROLLED_SYSOBJECT': 'An unauthorized application (User: \'{0}\') has attempted to modify the Controlled SysObject with id \'{1}\'. Only applications with an application_code of \'{2}\' can modify this SysObject.',
    'DM_SYSOBJECT_W_RETAINER_ALREADY_ATTACHED': 'Sysobject named \'{0}\' is already attached to {1} retainer object',
    'DM_SYSOBJECT_W_RETAINER_NOT_ATTACHED': 'Sysobject {0} is not attached to retainer {1}.',
    'DM_SYSOBJECT_W_NOT_CASCADE_DELETED_UNDER_RETENTION': 'Sysobject {0} is not cascade deleted because it is under retention.',
    'DM_SYSOBJECT_W_NOT_PRUNED': 'The object \'{0}\' was not pruned. The reason was \'{1}\'.',
    'DM_SYSOBJECT_W_RECURSIVE_DELETE': 'Recursive attempt to delete the sysobject \'{0}\' (ID: {1})',
    'DM_SYSOBJECT_E_ALREADY_LINKED': 'Sysobject named \'{0}\' is already linked to {1} folder',
    'DM_SYSOBJECT_E_BAD_ORDER': 'Invalid order number {0} specified. Must be positive and non-zero.',
    'DM_SYSOBJECT_E_CANT_ADD_NOTE': 'Cannot add note sysobject named \'{0}\'',
    'DM_SYSOBJECT_E_CANT_ADD_RENDITION': 'Cannot add rendition number {0} identified by {1} file, {2} format sysobject named \'{3}\'.',
    'DM_SYSOBJECT_E_CANT_CREATE': 'Cannot create a new sysobject',
    'DM_SYSOBJECT_E_CANT_LINKCOMPOSITE': 'Cannot link composite with ID {0} and version label {1}, version label {2} must exist in {3} sysobject.',
    'DM_SYSOBJECT_E_CANT_UNLINKCOMPOSITE': 'Cannot unlink composite with ID {0} at position {1} from {2} sysobject.',
    'DM_SYSOBJECT_E_CANT_CREATE_VERSION': 'Cannot create new version of sysobject named \'{0}\'.',
    'DM_SYSOBJECT_E_CANT_FETCH_INVALID_ID': 'Cannot fetch a sysobject - Invalid object ID {0}',
    'DM_SYSOBJECT_E_CANT_DESTROY': 'Cannot destroy {0} sysobject.',
    'DM_SYSOBJECT_E_CANT_FIND_LABEL': 'Cannot find {0} version label for {1} sysobject.',
    'DM_SYSOBJECT_E_CANT_LOCK': 'Cannot lock {0} sysobject, locked by {1}.',
    'DM_SYSOBJECT_E_CANT_GET_CONTENT': 'Cannot get {0} format for {1} content of {2} sysobject.',
    'DM_SYSOBJECT_E_CANT_READ_CONTENT': 'Cannot access content for ({0}) sysobject',
    'DM_SYSOBJECT_E_CANT_REMOVE_RENDITION': 'Cannot remove rendition number {0} identified by {1} format from {2} sysobject.',
    'DM_SYSOBJECT_E_CANT_SAVE': 'Cannot save {0} sysobject.',
    'DM_SYSOBJECT_E_CANT_SAVE_NO_LINK': 'Cannot save {0} sysobject without any link.',
    'DM_SYSOBJECT_E_CANT_STORE_CONTENT': 'Cannot store content pointed by file {0}',
    'DM_SYSOBJECT_E_FIXED_ILABELS': 'Version label {0} is internal and cannot be changed.',
    'DM_SYSOBJECT_E_INVALID_TYPE_FOR_OPERATION': 'Cannot perform {0} operation on {1} since it is of type {2}.',
    'DM_SYSOBJECT_E_INVALID_PAGE_NUM': 'Invalid page number = {0} for {1} sysobject.  Maximum page count is {2}.',
    'DM_SYSOBJECT_E_NO_DELETE_ACCESS': 'No delete permit on {0} sysobject.',
    'DM_SYSOBJECT_E_NO_CONTENT_TO_PRINT': 'Sysobject {0} has no content to print.',
    'DM_SYSOBJECT_E_NO_CONTENT_TYPE': 'No content type specified for {0} sysobject.',
    'DM_SYSOBJECT_E_NO_READ_ACCESS': 'No read access sysobject named \'{0}\'.',
    'DM_SYSOBJECT_E_NOT_LINKED': 'Sysobject {0} not linked to folder {1}.',
    'DM_SYSOBJECT_E_NOT_MULTI_PAGE': 'Cannot perform {0} operation since {1} sysobject is not a multi-page sysobject.',
    'DM_SYSOBJECT_E_NO_VERSION_ACCESS': 'No version access sysobject named \'{0}\'.',
    'DM_SYSOBJECT_E_NO_WRITE_ACCESS': 'No write access sysobject named \'{0}\'.',
    'DM_SYSOBJECT_E_LOCKED': 'The operation on {0} sysobject was unsuccessful because it is locked by user {1}.',
    'DM_SYSOBJECT_E_CANT_UNLOCK': 'Unsuccessful in removing the lock on {0} sysobject.',
    'DM_SYSOBJECT_E_INVALID_PERMIT': 'Invalid permit {0} specified for {1} sysobject.',
    'DM_SYSOBJECT_E_CANT_SAVE_IMMUTABLE': 'Cannot save {0} since it is immutable.',
    'DM_SYSOBJECT_E_CANT_MOVE_SYMBOLIC': 'Cannot move symbolic label {0} from {1} sysobject.',
    'DM_SYSOBJECT_E_CANT_DELETE_LOCKED': 'Cannot delete sysobject {0} since its locked by user {1}.',
    'DM_SYSOBJECT_E_CANT_VERSION_LOCKED': 'Cannot create a new version of sysobject {0} since its locked by user {1}.',
    'DM_SYSOBJECT_E_NOT_SINGLE_PAGE': 'Cannot perform this operation since {0} sysobject is not a single-page sysobject.',
    'DM_SYSOBJECT_E_CANT_FT_INDEX': 'The specified format ({0}) cannot be indexed by the full text engine.',
    'DM_SYSOBJECT_E_INVALID_FORMAT': 'The specified format ({0}) is invalid.',
    'DM_SYSOBJECT_E_CANT_NOTIFY': 'Could not send notification for {0} event for {1} sysobject.',
    'DM_SYSOBJECT_E_CANT_REGISTER': 'Could not register the specified {0} event for {1} sysobject.',
    'DM_SYSOBJECT_E_CANT_UNREGISTER': 'Could not unregister the specified {0} event for {1} sysobject.',
    'DM_SYSOBJECT_E_CANT_BINDFILE': 'Cannot bind page {0} of {1} sysobject to page {2} of {3} sysobject.',
    'DM_SYSOBJECT_E_CANT_PRUNE': 'Cannot prune {0} sysobject and its descendants.',
    'DM_SYSOBJECT_E_CANT_PRUNEI': 'Cannot prune {0} sysobject: {1}',
    'DM_SYSOBJECT_E_CANT_DESTROYC': 'Cannot destroy root of the {0} version tree.',
    'DM_SYSOBJECT_E_CANT_PRUNE_LOCKED': 'Cannot prune sysobject {0} version tree since one or more of its versions are locked.',
    'DM_SYSOBJECT_E_NOLABELS': 'Need one or more symbolic labels to mark/unmark {0} sysobject.',
    'DM_SYSOBJECT_E_FLABEL_INUSE': 'Cannot redefine an internal label {0} since it is in use.',
    'DM_SYSOBJECT_E_CANT_CHECKOUTNEW': 'Cannot checkout {0} sysobject, since it is not in the docbase.',
    'DM_SYSOBJECT_E_INVALID_TYPE': 'The {0} object identified by {1} is not a subtype of {2}.',
    'DM_SYSOBJECT_E_CANT_CHANGE_OWNER': 'Must be a superuser/owner or anyone with change_owner permit to change the owner_name to \'{0}\'.',
    'DM_SYSOBJECT_E_CANT_DROP_LABEL': 'Cannot drop {0} label.',
    'DM_SYSOBJECT_E_NONEXISTENT_LABEL': 'Label {0} does not exist in {1} sysobject.',
    'DM_SYSOBJECT_E_CANT_FETCH_RENDITION': 'Can not fetch prestored rendition for page {0} of {1} sysobject.',
    'DM_SYSOBJECT_E_CANT_CHANGE_PERMITS': 'Only the {0} sysobject owner, superuser, and anyone with the change_permit permit can change permits.',
    'DM_SYSOBJECT_E_RENDITION_FMT_SAMEAS': 'Rendition format {0} must be different than the original format {1} for {2} sysobject unless the page modifier is specified.',
    'DM_SYSOBJECT_E_CANT_FIND_CHRONICLE': '{0} chronicle identifier does not exist.',
    'DM_SYSOBJECT_E_INVALID_PART': 'Invalid part definition for {0} sysobject.',
    'DM_SYSOBJECT_E_NO_PARTS': 'No parts exists for {0} sysobjects.',
    'DM_SYSOBJECT_E_CIRC_LINK': '{0} sysobject can not be contained in itself.',
    'DM_SYSOBJECT_E_CANT_INSERTP': 'Cannot insert part before the self reference containment object for {0} sysobject.',
    'DM_SYSOBJECT_E_CANT_ASSEMBLE': 'Cannot build the assembly for {0} sysobject.',
    'DM_SYSOBJECT_E_INVALID_STORAGE': 'The specified storage ({0}) is invalid.',
    'DM_SYSOBJECT_E_NOT_CHECKEDOUT': 'The specified {0} sysobject is not checked out.',
    'DM_SYSOBJECT_E_CANT_DESTROYU': 'Cannot destroy sysobject named: \'{0}\' since it is referenced by another compound document or an assembly object.',
    'DM_SYSOBJECT_E_CANT_REPLACEP': 'Cannot replace the self reference containment object for {0} sysobject.',
    'DM_SYSOBJECT_E_NO_ASSEMBLY': 'No assembly object is attached sysobject named \'{0}\'.',
    'DM_SYSOBJECT_E_FROZEN': 'The {0} sysobject is frozen.',
    'DM_SYSOBJECT_E_NOCOMPS_TO_FREEZE': 'The {0} sysobject has no assembled components to be frozen.',
    'DM_SYSOBJECT_E_NOT_FROZEN': 'The {0} sysobject is not frozen.',
    'DM_SYSOBJECT_E_NOCOMPS_TO_THAW': 'The {0} sysobject has no assembled components to be thawed.',
    'DM_SYSOBJECT_E_CANT_UNFREEZE': 'The {0} sysobject can not be unfrozen.',
    'DM_SYSOBJECT_E_CANT_DO_ASSEMBLY_CHANGES': 'Both the thaw and freeze flags are turned on for {0} sysobject.',
    'DM_SYSOBJECT_E_CANT_ACCESS': 'Cannot access file ({0})',
    'DM_SYSOBJECT_E_CANT_ACCESS_FILE': 'Cannot access file \'{0}\' due to Operating System error: {1}',
    'DM_SYSOBJECT_E_NO_RELATE_ACCESS': 'No relate access sysobject named \'{0}\'.',
    'DM_SYSOBJECT_E_NAME_NOT_UNIQUE': 'The object_name of {0} must be unique for {1} type.',
    'DM_SYSOBJECT_E_NEED_NAME': 'The {0} objects must have an object_name.',
    'DM_SYSOBJECT_E_CONTENTS_SHARED': 'Can not change the content of {0} sysobject since it is shared.',
    'DM_SYSOBJECT_E_CANT_KEEP_RELATIONS': 'Can not keep user/system defined relations for {0} sysobject.',
    'DM_SYSOBJECT_E_CANT_MIGRATE': 'Can not migrate \'{0}\' sysobject to \'{1}\' storage area.',
    'DM_SYSOBJECT_E_REORDERING_FAILED': 'Could not recompute part order numbers for sysobject named \'{0}\'. (See your sysadmin)',
    'DM_SYSOBJECT_E_TOOMANY_INSERTP': 'You have inserted too many parts before {0} child for sysobject called \'{1}\', please save or checkin now to reorder parts.',
    'DM_SYSOBJECT_E_UNKNOWN_PERMIT': 'The permit of the sysobject \'{0}\' is unknown.',
    'DM_SYSOBJECT_E_IS_DELETED': 'The sysobject \'{0}\' has been deleted and can not be updated/deleted.',
    'DM_SYSOBJECT_E_PERMIT_ALLOWED': 'The permit requested should have been granted for sysobject {0}.',
    'DM_SYSOBJECT_E_BAD_CABINET': 'The sysobject \'{0}\' has a bad primary cabinet ID \'{1}\'.',
    'DM_SYSOBJECT_E_NO_DELETE_ACCESS2': 'No delete permit on sysobject \'{0}\' since {1} \'{2}\' is protected.',
    'DM_SYSOBJECT_E_NO_BROWSE_ACCESS2': 'No browse access to sysobject \'{0}\' since {1} \'{2}\' is protected.',
    'DM_SYSOBJECT_E_NO_READ_ACCESS2': 'No read access to sysobject \'{0}\' since {1} \'{2}\' is protected.',
    'DM_SYSOBJECT_E_NO_VRSN_ACCESS2': 'No version access for sysobject \'{0}\' since {1} \'{2}\' is protected.',
    'DM_SYSOBJECT_E_NO_WRITE_ACCESS2': 'No write access for sysobject \'{0}\' since {1} \'{2}\' is protected.',
    'DM_SYSOBJECT_E_NO_RELATE_ACCESS2': 'No relate access to sysobject \'{0}\', since {1} \'{2}\' is protected.',
    'DM_SYSOBJECT_E_NO_BROWSE_ACCESS': 'No browse access for sysobject with ID \'{0}\'.',
    'DM_SYSOBJECT_E_NEW_ACL': 'Failed to get the associated ACL object ({0}, {1}) for the sysobject \'{2}\'.',
    'DM_SYSOBJECT_E_ACL_NEED_NAME': 'Need an accessor name for operation \'{0}\' of {1} \'{2}\' to succeed.',
    'DM_SYSOBJECT_E_NOT_SUPPORTED': 'The operation \'{0}\' is not supported.',
    'DM_SYSOBJECT_E_ACL_CACHE': 'Error reported by the ACL cache of the sysobject \'{0}\'. The message is: {1}.',
    'DM_SYSOBJECT_E_INVALID_ACL_DOMAIN': 'The {0} \'{1}\' is given an invalid ACL domain \'{2}\'.',
    'DM_SYSOBJECT_E_CANT_FETCH_ACL': 'Failed to fetch the ACL \'{0}\' in domain \'{1}\' for {2} \'{3}\'. [{4}]',
    'DM_SYSOBJECT_E_CANT_SAVE_ACL': 'Failed to save the ACL \'{0}\' in domain \'{1}\' for the {2} \'{3}\'.',
    'DM_SYSOBJECT_E_DESTROY_ACL': 'Failed to destroy the ACL \'{0}\' in the domain \'{1}\' for {2} \'{3}\'.',
    'DM_SYSOBJECT_E_INVALID_SOURCE': 'The ACL source specified \'{0}\' for the sysobject \'{1}\' is invalid. The source could be either FOLDER, TYPE or USER.',
    'DM_SYSOBJECT_E_NO_ACL_SOURCE': 'The destinated ACL source is invalid.',
    'DM_SYSOBJECT_E_CANT_FIND_GROUP': 'The group \'{0}\' specified does not exist.',
    'DM_SYSOBJECT_E_CANT_FIND_USER': 'The user \'{0}\' specified does not exist.',
    'DM_SYSOBJECT_E_APPLY_ADHOC_ACL': 'Failed to {0} ACE (\'{1}\', \'{2}\', \'{3}\') to the ACL \'{4}\' in name space \'{5}\' for {6} \'{7}\'.',
    'DM_SYSOBJECT_E_BAD_ADHOC_OP': 'The operation ({0}) for an ad-hoc ACE of {1} \'{2}\' is neither \'grant\' (1) nor \'revoke\' (-1).',
    'DM_SYSOBJECT_E_CANT_DEREF_ACL': 'Failed to de-reference the ACL \'{0}\' in domain \'{1}\' for sysobject \'{2}\'.',
    'DM_SYSOBJECT_E_ACL_REVISE_GROUP': 'Failed to revise group name of the ACL \'{0}\' in domain \'{1}\' of {2} \'{3}\'.',
    'DM_SYSOBJECT_E_CANT_FETCH_FOLDER': 'Failed to fetch the folder \'{0}\'.',
    'DM_SYSOBJECT_E_LINK_PERMIT': 'Linking or unlinking to the folder \'{0}\' failed. WRITE permit is required on the folder.',
    'DM_SYSOBJECT_E_REVERT_ACL': 'Failed to revert the ACL \'{0}\' in domain \'{1}\' during reversion of {2} \'{3}\'.',
    'DM_SYSOBJECT_E_NO_NEW_ATOMIC': '{0} operation in atomic mode can not apply to a new sysobject named \'{1}\'.',
    'DM_SYSOBJECT_E_FOLDER_DEF_ACL': 'ACL inheritance failed, due to missing ACL in the folder \'{0}\'.',
    'DM_SYSOBJECT_E_TYPE_DEF_ACL': 'ACL inheritance failed, due to missing ACL in the type \'{0}\'.',
    'DM_SYSOBJECT_E_USER_DEF_ACL': 'ACL inheritance failed, due to missing ACL in the User \'{0}\'.',
    'DM_SYSOBJECT_E_OPEN_ACCESS': 'The file \'{0}\' cannot be opened because it is in use by another application.  (Operating System error: {1}).',
    'DM_SYSOBJECT_E_FILE_PERMISSION': 'The file \'{0}\' cannot be opened because the current user does not have sufficient permissions.  (Operating System error: {1}).',
    'DM_SYSOBJECT_E_LINK_PERMIT2': 'Linking or unlinking to the folder \'{0}\' failed on sysobject \'{1}\'. WRITE permit is required on the folder, when using folder security.',
    'DM_SYSOBJECT_E_LINK_ADJUST': 'Failed to adjust the link count of the sysobject \'{0}\'. The database error message was: {1}',
    'DM_SYSOBJECT_E_NO_PRIMARY_FOLDER': 'Failed to derive ACL from the primary folder, since cabinets have no primary folders.',
    'DM_SYSOBJECT_E_BINDFILE_SOURCE': 'Failed to bind file due to missing source sysobject object.',
    'DM_SYSOBJECT_E_NAME_MAPPING': 'Failed to the given name \'{0}\' to the object\'s handle due to database errors. The message from the database is: {1}',
    'DM_SYSOBJECT_E_UPDATE_VTREE': 'Failed to update the attributes used to maintain the version tree. The message from the database is: {0}',
    'DM_SYSOBJECT_E_SQL': 'Failed to execute the statement: {0}. The error message from the database was: {1}',
    'DM_SYSOBJECT_E_UPDATE_CABID': 'Failed to update the cabinet ID of the sysobjects. This change is necessary due to the change of the primary link of the folder \'{0}\'.',
    'DM_SYSOBJECT_E_SETTIME_MODIFY_FAIL': 'A failure occurred while trying to update set_time of content object: database error message was \'{0}\'',
    'DM_SYSOBJECT_E_NEW_SAVENEW': 'Cannot execute saveasnew operation on an object which has never been saved to the docbase.',
    'DM_SYSOBJECT_E_NO_POLICY': '{0} failed because the policy {1} does not exist.',
    'DM_SYSOBJECT_E_NO_STATE': '{0} failed because the state {1} is not in policy {2}.',
    'DM_SYSOBJECT_E_NOT_INSTALLED': '{0} failed because the associated policy \'{1}\' is not INSTALLED.',
    'DM_SYSOBJECT_E_BAD_CUR_STATE': '{0} failed since the current state \'{1}\' is not a valid state of the associated policy \'{2}\'.',
    'DM_SYSOBJECT_E_NO_PROM_TERMINAL': 'Promote failed since the sysobject\'s current state {0} is a terminal state of the associated policy {1}.',
    'DM_SYSOBJECT_E_NO_DEMOTE_BASE': 'Demote failed since the current state {0} is a base state of the associated policy {1}.',
    'DM_SYSOBJECT_E_NOT_ALLOW_DEMOTE': 'Demote failed since the sysobject\'s current state {0} of policy {1} is not allowed to demote.',
    'DM_SYSOBJECT_E_BAD_SCHED': 'The date {0} scheduled to promote the object {1} is a bad date.',
    'DM_SYSOBJECT_E_SCHED_PASSED': 'The date {0} scheduled to {1} the object {2} is smaller than the current time {3}.',
    'DM_SYSOBJECT_E_CHANGE_STATE_PERM': 'It requires the CHANGE_STATE and WRITE permits to perform {0} operation on object {1}.',
    'DM_SYSOBJECT_E_BAD_TARGET_STATE': 'Cannot {0} the sysobject {1} to the state {2}.',
    'DM_SYSOBJECT_E_RESUME_NOT_NORM': 'Cannot resume to state {0} which is not a normal state of policy {1}.',
    'DM_SYSOBJECT_E_OVERRIDE_ENTRY': 'Cannot override an entry criteria. User \'{0}\' must be the owner of the policy or a superuser.',
    'DM_SYSOBJECT_E_NOT_ATTACHABLE_TYPE': 'The object type \'{0}\' is not an acceptable type to policy \'{1}\'.',
    'DM_SYSOBJECT_E_MUST_BE_OWNER': 'You must be the owner (or superuser) to perform \'{0}\' operation\'.',
    'DM_SYSOBJECT_E_EXPUNGE_REPLICA': 'Cannot destroy a versioned replica or prune subset of its version tree. For replica, only deletion of all versions is allowed. (Reference \'prune\' command with object\'s chronicle_id and keepSLabel=F)',
    'DM_SYSOBJECT_E_INVALID_XPERMIT_NAME': 'There exists at least one invalid extended permission name in {0} for operation {1}.',
    'DM_SYSOBJECT_E_NO_PRIV_TO_CHG_LOC': 'The current user ({0}) does not have enough privilege to copy/move/link/unlink {1} sysobject.',
    'DM_SYSOBJECT_E_CANT_CHANGE_XPERMITS': 'Only the {0} sysobject owner and superuser can change extended permits.',
    'DM_SYSOBJECT_E_CANCEL_NO_JOB': 'The job {0} scheduled at {1} for object {2} does not exist.',
    'DM_SYSOBJECT_E_BAD_RESUME_STATE': 'Resume failed since the resume state \'{0}\' is not a valid state of the associated policy \'{1}\'.',
    'DM_SYSOBJECT_E_NOT_ALLOW_BP_SCHD': 'Scheduled {0} failed since the current state {1} of policy {2} is not schedulable.',
    'DM_SYSOBJECT_E_NO_TARGET_BP_SCHD': 'Scheduled {0} failed since no check state is specified.',
    'DM_SYSOBJECT_E_BAD_FROM_STATE': 'Cannot {0} the sysobject {1} from the state {2}.',
    'DM_SYSOBJECT_E_BP_SCHD_SAME_TIME': 'Scheduled {0} failed since there exists other event scheduled at the same time {1}.',
    'DM_SYSOBJECT_E_EXIST_CHECK_BP_SCHD': 'Scheduled {0} failed since check state {1} does not exist in policy {2}.',
    'DM_SYSOBJECT_E_BP_ON_OPENTRAN': 'A BP event {0} failed because this session has an open transaction.',
    'DM_SYSOBJECT_E_FAIL_ENTRY': '{0} failed because the document {1} does not satisfy the entry criteria ({2}) of state {3} in policy {4}.',
    'DM_SYSOBJECT_E_LENGTH_WIDEN_FAILED': 'The upgrade failed on widening sysobject\'s attribute lengths.',
    'DM_SYSOBJECT_E_NO_DEFAULT_POLICY': '{0} failed because the default policy {1} for type {2} does not exist.',
    'DM_SYSOBJECT_E_INSUFFICIENT_PRIVILEGE_FOR_PLUGIN': 'You must be a system administrator to create or destroy objects of dm_plugin type.',
    'DM_SYSOBJECT_E_SAVE_FAILED_UNAVAILABLE_SUBTYPE': 'Your client is older than your server, and you have attempted to create an object of a type ({0}) that is not available to your client\'s version.',
    'DM_SYSOBJECT_E_ALREADY_LOCKED': 'You already have document {0} checked out.',
    'DM_SYSOBJECT_E_FILE_AND_VERSION_MAPPING': 'Failed to find the sysobject r_object_id corresponding to the path \'{0}\' and version \'{1}\' due to database errors. The message from the database is: {2}',
    'DM_SYSOBJECT_E_SET_ATTR_SYNTAX_ERROR': 'The parameters, \'{0}\', specified in the SET_CONTENT_ATTRS call contains syntax error.',
    'DM_SYSOBJECT_E_MISSING_REQUIRED_PARA': 'Some required parameter is missing in the {0} call.',
    'DM_SYSOBJECT_E_CHANGE_STATE_PERM_2': 'It requires the CHANGE_STATE permit to perform {0} on the object {1}({2}).',
    'DM_SYSOBJECT_E_BAD_CUR_STATE_2': '{0} on the object {1}({2}) failed since the current state \'{3}\' is not a valid state of the associated policy \'{4}\'.',
    'DM_SYSOBJECT_E_NO_PROM_TERMINAL_2': 'Promote failed since the object, {0}({1}), is in the terminal state {2}.',
    'DM_SYSOBJECT_E_NOT_A_SYSOBJECT': '\'{0}\' is not a sysobject which is required for lifecycle operation.',
    'DM_SYSOBJECT_E_VERSION_MISMATCH': 'save of object failed because of version mismatch: old version was {0}',
    'DM_SYSOBJECT_E_CANT_DELETE_RELATION_EXISTS': 'Cannot delete object {0} since dm_relation object(s) {1} exists with integrity_kind set to 1.',
    'DM_SYSOBJECT_E_INVALID_A_CONTROLLING_APP_VALUE': 'The a_controlling_app value of \'{0}\' is invalid. Application codes can only contain alphanumeric characters or \'_\'.',
    'DM_SYSOBJECT_E_ILLEGAL_FLOATING_NUMBER': 'The floating number, \'{0}\', is either out of range, illegal, or specifies a zero other than \'0\' or \'0.0\'.',
    'DM_SYSOBJECT_E_CANT_ATTACH_REPLICA_POLICY': 'Attach of replica policy \'{0}\' is not supported.',
    'DM_SYSOBJECT_E_DM_PROCESS_OBJECT_COPY': 'Failed to copy \'{0}\' because copying workflow templates from one docbase to another is not supported.',
    'DM_SYSOBJECT_E_CANT_SET_FORK_WITHOUT_CONTENT': 'You cannot set the resource fork for the sysobject ({0}) before setting its content.',
    'DM_SYSOBJECT_E_CANT_SET_FORK_ON_EXISTING_CONTENT': 'You cannot set the resource fork for the sysobject ({0}) after the content has been saved.',
    'DM_SYSOBJECT_E_ESIGN_CONTENT_NOT_FOUND': 'Could not retrieve content for the object \'{0}\' in format \'{1}\' with page modifier \'{2}\'.',
    'DM_SYSOBJECT_E_ESIGN_PRIMARY_CONTENT_NOT_FOUND': 'Could not retrieve the primary content for the object {0}.',
    'DM_SYSOBJECT_E_ESIGN_CONTENT_HASH_FAILED': 'Could not generate a hash value for object {0} in format {1} with hashing algorithm {2}.',
    'DM_SYSOBJECT_E_ESIGN_OBJECT_UNSIGNED': 'The object {0} is unsigned',
    'DM_SYSOBJECT_E_ESIGN_AUDIT_RECORD_NULL_ID': 'Couldn\'t read object id of audit record.',
    'DM_SYSOBJECT_E_ESIGN_AUDIT_RECORD_UNSIGNED': 'Audit record {0} for the existing electronic signature is unsigned.',
    'DM_SYSOBJECT_E_ESIGN_CANT_VERIFY_AUDIT_RECORD': 'Audit record {0} for the previous electronic signature cannot be verified.',
    'DM_SYSOBJECT_E_ESIGN_CANT_GET_VERIFY_AUDIT_RESULTS': 'Audit record {0} for the previous electronic signature has no verification results.',
    'DM_SYSOBJECT_E_ESIGN_INVALID_AUDIT_RECORD': 'Audit record {0} for the existing electronic signature is invalid.',
    'DM_SYSOBJECT_E_ESIGN_INVALID_HASH_FORMAT_AUDIT': 'The format of hash attribute value \'{0}\' in audit record {1} is invalid.',
    'DM_SYSOBJECT_E_ESIGN_INVALID_PRE_SIGNATURE_HASH_FORMAT': 'The format of the preSignatureHash argument \'{0}\' is invalid.',
    'DM_SYSOBJECT_E_ESIGN_PRE_SIGNATURE_HASH_MISMATCH': 'Mismatch between object {0} with hash string \'{1}\' and preSignatureHash argument {2}.',
    'DM_SYSOBJECT_E_ESIGN_AUDIT_HASH_MISMATCH': 'Mismatch between object {0} with hash string \'{1}\' and audit record {2} with hash string \'{3}\'.',
    'DM_SYSOBJECT_E_ESIGN_CANT_DECRYPT_PASSWORD': 'Password decryption failed with error code {0}.',
    'DM_SYSOBJECT_E_ESIGN_CANT_AUTHENTICATE_USER': 'User {0} could not be authenticated.',
    'DM_SYSOBJECT_E_ESIGN_OBJECT_NOT_CHECKED_IN': 'Object {0} is checked out. Objects must be checked in to be signed.',
    'DM_SYSOBJECT_E_ESIGN_PREEXISTING_SIGNATURE_INVALID': 'The previous electronic signature for object {0} is invalid. New signatures may not be added.',
    'DM_SYSOBJECT_E_ESIGN_CANT_HASH_PRIMARY_CONTENT': 'The primary content for object {0} could not be hashed.',
    'DM_SYSOBJECT_E_ESIGN_CANT_HASH_RENDITION_CONTENT': 'The rendition to be signed for object {0} could not be hashed.',
    'DM_SYSOBJECT_E_ESIGN_AUDIT_CREATION_FAILED': 'An electronic signature audit record for object {0} could not be created.',
    'DM_SYSOBJECT_E_ESIGN_VERIFICATION_FAILED': 'The electronic signature for object {0} is invalid',
    'DM_SYSOBJECT_E_ESIGN_CANT_CREATE_TEMP_FILE': 'Unable to create temporary file \'{0}\'. Error: {1}.',
    'DM_SYSOBJECT_E_ESIGN_CANT_WRITE_TO_TEMP_FILE': 'Unable to write content to temporary file \'{0}\' at position \'{1}\'. Error: {2}.',
    'DM_SYSOBJECT_E_ESIGN_CANT_READ_DATA_SOURCE': 'Failed to read the data from content object \'{0}\'.',
    'DM_SYSOBJECT_E_ESIGN_CANT_CREATE_TEMP_DIRECTORY': 'Can\'t create the temporary directory \'{0}\'.',
    'DM_SYSOBJECT_E_ESIGN_CANT_WRITE_CONTENT_TO_FILE': 'Can\'t write content object {0} to file \'{1}\'.',
    'DM_SYSOBJECT_E_ESIGN_CANT_FIND_METHOD': 'Can\'t find method \'{0}\'.',
    'DM_SYSOBJECT_E_ESIGN_SIGNATURE_METHOD_FAILED': 'Method \'{0}\' failed. Arguments: {1}.',
    'DM_SYSOBJECT_E_ESIGN_CANT_UPDATE_CONTENT': 'Can\'t update the content for object \'{0}\'.',
    'DM_SYSOBJECT_E_ESIGN_CANT_DELETE_TEMPORARY_FILE': 'Can\'t delete the temporary file \'{0}\'.',
    'DM_SYSOBJECT_E_ESIGN_SIGNATURE_NUMBER_ERROR': 'Invalid electronic signature number for object \'{0}\'. Signature numbers must be consecutive and increase beginning with 1.',
    'DM_SYSOBJECT_E_ESIGN_SIGNATURE_METHOD_NOT_RUN': 'The signature method \'{0}\' did not execute.',
    'DM_SYSOBJECT_E_ESIGN_CANT_SAVE_ORIGINAL': 'The original content could not be saved.',
    'DM_SYSOBJECT_E_ESIGN_SIGNATURE_NUMBER_MISSING': 'Missing electronic signature number {0} for object \'{1}\'. Signature numbers must be consecutive and increase beginning with 1.',
    'DM_SYSOBJECT_E_ESIGN_SIGNATURE_SOURCE_ALREADY_EXISTS': 'Object \'{0}\' appears unsigned but a signature source content object \'{1}\' already exists for it.',
    'DM_SYSOBJECT_E_ESIGN_CURSOR_ERROR': 'A database error has occurred during the creation of a cursor needed for reading addesignature audit trail records (\'{0}\').',
    'DM_SYSOBJECT_E_ESIGN_USER_MISMATCH': 'The optional user name argument \'{0}\' if provided must match the name of the logged in user \'{1}\'.',
    'DM_SYSOBJECT_E_UPDATE_RETAIN_UNTIL_UNABLE_TO_SAVE': 'Unable to save {0} after updating i_retain_until attribute value',
    'DM_SYSOBJECT_E_UPDATE_RETAIN_UNTIL_UNABLE_TO_EXECUTE_QUERY': 'An error occured while executing a DQL statement to fetch objects to update the i_retain_until attribute: Query: {0}',
    'DM_SYSOBJECT_E_UPDATE_RETAIN_UNTIL_INVALID_OBJECT': '{0} is not a valid sysobject',
    'DM_SYSOBJECT_E_UPDATE_RETAIN_UNTIL_INVALID_ARGUMENTS': 'Invalid arguments specified for UPDATE_RETAIN_UNTIL_DATE apply method',
    'DM_SYSOBJECT_E_UPDATE_RETAIN_UNTIL_UNABLE_TO_COMMIT_BATCH': 'An error occured while attempting to commit changes made to {0} objects',
    'DM_SYSOBJECT_E_CANT_REMOVE_RENDITION2': 'Rendition page {0} is not removed for {1} because retention period has not expired',
    'DM_SYSOBJECT_E_SETSTORAGE_EXISTING_CONTENT_OBJECT': 'setstorage API cannot be executed on an existing dmr_content object.',
    'DM_SYSOBJECT_E_SETSTORAGE_INVALID_STORAGE': 'The storage name specified \'{0}\' is invalid.',
    'DM_SYSOBJECT_E_SETSTORAGE_UNABLE_TO_VALIDATE_STORAGE': 'Unable to validate the specified storage area name \'{0}\'',
    'DM_SYSOBJECT_E_NOT_IN_RESTRICTED_FOLDERS': 'The sysobject (\'{0}\') is not in any folder (or subfolder of the folder) specified in the user\'s restricted_folder_ids.',
    'DM_SYSOBJECT_E_OBJECT_NOT_CHECKEDOUT': 'Object {0} has not been checked out prior to calling {1} API',
    'DM_SYSOBJECT_E_INVALID_STORAGE_TYPE_CHANGE': 'Storage type for object {0} cannot be changed from {1} to {2}, because {3} is a retention enabled store and {4} is not',
    'DM_SYSOBJECT_E_CANT_FORCE_DELETE': 'Can\'t force delete object ({0}) because storage ({1}) does not allow the operation, for the specified authorization parameters ({2})',
    'DM_SYSOBJECT_E_FORCE_DELETE_CANT_EXPUNGE_CONTENT_OBJECT': 'force delete failed because an error occured during deletion of content object {0}. Sysobject is {1}',
    'DM_SYSOBJECT_E_FORCE_DELETE_CANT_EXPUNGE_SUBCONTENT_OBJECT': 'force delete failed because an error occured during deletion of a subcontent object ({0}), content object is {1}, Sysobject is {2}',
    'DM_SYSOBJECT_E_MUST_OWNED_BY_RET_MANAGER': 'The owner \'{0}\' needs to be a retention manager.',
    'DM_SYSOBJECT_E_CANT_VERSION_A_RETAINER': 'Cannot version {0} since it is a retainer object.',
    'DM_SYSOBJECT_E_CANT_DELETE_RETAINER': 'Cannot delete retainer object {0} since it is used by other objects.',
    'DM_SYSOBJECT_E_NEED_RETAINER_OBJ': 'The operation {0} applied to a sysobject requires the object \'{1}\' to be a retainer object.',
    'DM_SYSOBJECT_E_CANT_ACTIVATE_RETAINER': 'You cannot activate the retainer object {0} when it is inactive.',
    'DM_SYSOBJECT_E_CANT_ATTACH_RETAINER_TO_RETAINER': 'You cannot attach the retainer object {0} to sysobject {1} which is also a retainer.',
    'DM_SYSOBJECT_E_CANT_ATTACH_RETAINER_TO_DIST_COPY': 'You cannot attach the retainer object {0} to sysobject {1} which is either a reference or replica object.',
    'DM_SYSOBJECT_E_ONLY_ATTACH_ACTIVE_RETAINER': 'You cannot attach a locked or inactive retainer object {0} to sysobject {1}.',
    'DM_SYSOBJECT_E_ATTACH_NON_RET_MANAGER_OWNED_RETAINER': 'The retainer object {0} needs to be owned by retention managers in order to attach to a sysobject.',
    'DM_SYSOBJECT_E_NEED_READ_OR_RET_USER_MANAGER': 'The session user {0} needs to have READ permit on the sysobject {1} or a retention user/manager in order to call {2}.',
    'DM_SYSOBJECT_E_NEED_RELATE_OR_RET_MANAGER': 'The session user {0} needs to have relate permit on the sysobject {1} or a retention manager in order to call {2}.',
    'DM_SYSOBJECT_E_CANT_CHANGE_CONTENT_UNDER_RETENTION': 'You can not change/add any primary content to sysobject {0} when it is under retention unless you are a retention manager.',
    'DM_SYSOBJECT_E_CANT_CHANGE_RENDITION_UNDER_RETENTION': 'You can not change/delete any rendition from sysobject {0} when it is under retention.',
    'DM_SYSOBJECT_E_CANT_ATTACH_EXPIRED_RETENTION': 'You cannot attach the retainer object {0} to sysobject {1} because the retention is expired.',
    'DM_SYSOBJECT_E_CANT_DELETE_UNDER_RETENTION': 'Object {0} is under retention and cannot be deleted.',
    'DM_SYSOBJECT_E_NEED_ACTIVE_RETAINER_OBJ': 'The operation {0} applied to a sysobject requires the retainer \'{1}\' to be non-inactive.',
    'DM_SYSOBJECT_E_SAVEASNEW_KEEP_STORAGE_INVALID_STORAGE_ON_TARGET': 'Storage ({0}) does not exist in ({1}) respository',
    'DM_SYSOBJECT_E_SAVEASNEW_KEEP_STORAGE_INCOMPATIBLE_STORAGE_TYPE': 'Storage area ({0}) on source repository ({1}) is of type ({2}) and on target repository ({3}) it\'s of type ({4})',
    'DM_SYSOBJECT_E_CANT_CHANGE_CONTAINMENT_UNDER_RETENTION': 'You can not change/add/remove any containment to sysobject {0} when it is under retention unless you are a retention manager.',
    'DM_SYSOBJECT_E_ESIGN_UNSUPPORTED_HASH_ALGORITHM': '\'hash_algorithm\' \'{0}\' is not supported ',
    'DM_SYSOBJECT_E_ESIGN_FAILED_AUDIT_CREATION_FAILED': 'An esignature audit record for object {0} could not be created for the failed addesignature API Call',
    'DM_SYSOBJECT_E_ESIGN_METHOD_TIMED_OUT': 'eSignature Method Timed Out; Please increase the timeout_max and timeout_default values for (\'{0}\') method',
    'DM_SYSOBJECT_E_CANT_ASSEMBLE_WITH_OPEN_TRAN': 'Cannot build the assembly for {0} sysobject with frequency ({1}) greater than zero when there is an open transaction.',
    'DM_SYSOBJECT_E_LIGHTWEIGHT_CANNOT_CREATE': 'Cannot create a new lightweight sysobject',
    'DM_SYSOBJECT_E_LIGHTWEIGHT_NO_BROWSE_ACCESS': 'No Browse access to the lightweight sysobject named \'{0}\'.',
    'DM_SYSOBJECT_E_LIGHTWEIGHT_CANNOT_FETCH_INVALID_ID': 'Cannot fetch the lightweight sysobject; the object ID {0} is invalid',
    'DM_SYSOBJECT_E_LIGHTWEIGHT_CANNOT_SAVE': 'Cannot save a lightweight sysobject (\'{0}\')',
    'DM_SYSOBJECT_E_LIGHTWEIGHT_ILLEGAL_PARENT_ID': 'The parent id ({0}) is illegal',
    'DM_SYSOBJECT_E_CANT_DELETE_SHARED_BY_LIGHTWEIGHT': 'Cannot delete object {0} because it is shared by lightweight objects.',
    'DM_SYSOBJECT_E_CANT_CREATE_VERSION_WHEN_SHARED': 'Cannot create a new version of the sysobject named \'{0}\' when it is shared.',
    'DM_SYSOBJECT_E_CANNOT_MATERIALIZE': 'Cannot materialize the lightweight object ({0})',
    'DM_SYSOBJECT_E_DISALLOWED_OP_FOR_UNMATERIALIZED_OBJ': 'The operation {0} performed on object {1} is disallowed because the lightweight object is not materialized',
    'DM_SYSOBJECT_E_DISALLOWED_OP_FOR_NONSHAREABLE_TYPE': 'The operation {0} performed on object {1} is disallowed because its type {2} is not shareable',
    'DM_SYSOBJECT_E_CANNOT_CHANGE_RETENTION_ATTRS_WHEN_SHARED': 'Cannot change any retention-related attribute of {0} since it is shared by some lightweight object and its allow_propagating_changes flag is false.',
    'DM_SYSOBJECT_E_CANNOT_CHANGE_FT_ATTRS_WHEN_SHARED': 'Cannot change any ftindex attribute of {0} since it is shared by some lightweight object and its allow_propagating_changes flag is false.',
    'DM_SYSOBJECT_E_CANNOT_SHARE_PARENT_WITH_DIFF_LIGHTWEIGHT_TYPES': 'Cannot share object {0} with an instance of type {1} because it is already shared by instances of type {2}',
    'DM_SYSOBJECT_E_STORAGE_TYPE_CHANGE_DISALLOWED_PARKED_STATE': 'Cannot change a_storage_type of {0} because content for page {1} is in parked state',
    'DM_SYSOBJECT_E_CANNOT_ATTACH_CONDITIONAL_RETAINER': 'Cannot attach conditional retainer to sysobject {0} because it has triggered conditional retainers attached to it.',
    'DM_SYSOBJECT_E_NEED_TRIGGERED_CONDITIONAL_RETAINER': 'The Object {0} doesn not have any triggered conditional retainers attached.',
    'DM_SYSOBJECT_E_NEED_CONDITIONAL_RETAINER': 'The operation {0} requires the object {1} to have conditional retainers attached.',
    'DM_SYSOBJECT_E_FAILED_TO_TRIGGER_ONE_OR_MORE_CLIPS': 'One or more clips could not be triggered for sysobject {0}.',
    'DM_SYSOBJECT_E_FAILED_TO_CHECK_IF_CONTENT_TRIGGERED': 'Failed to check if the content objects for sysobject {0} were triggered.',
    'DM_SYSOBJECT_E_ESIGN_SIGNATURE_METHOD_FAILED_02': 'Method \'{0}\' failed :: Arguments \'{1}\' :: Method Returned \'{2}\'',
    'DM_SYSOBJECT_E_NEED_RET_MANAGER': 'The session user {0} needs to be a retention manager in order to call {1} on the sysobject with ID \'{2}\'.',
    'DM_SYSOBJECT_E_TRIGGER_COND_RET_DISALLOWED_PARKED_STATE': 'Cannot trigger Conditional Retainer of sysobject {0} because one of the contents with ID {1} is in Parked State',
    'DM_SYSOBJECT_E_FAILED_CHECK_FOR_PARKED_CONTENT': 'Failed to check if any content object for the sysobject {0} , ID : {1} is parked.',
    'DM_SYSOBJECT_E_CANNOT_CHECKOUT_IMMUTABLE_HOLD': 'Cannot checkout sysobject {0} because it is under an immutable retention hold.',
    'DM_SYSOBJECT_E_CANNOT_SAVECONTATTRS_ON_HOLD': 'Cannot apply SAVE_CONT_ATTRS on sysobject {0}.',
    'DM_SYSOBJECT_E_CANNOT_BRANCH_ON_HOLD': 'Cannot branch sysobject {0} because this sysobject is under retention hold.',
    'DM_SYSOBJECT_E_CANNOT_SAVE_ON_HOLD': 'Cannot save modifications on sysobject {0} because it was under retention hold.',
    'DM_SYSOBJECT_E_CANT_CHANGE_CONTENT': 'Content [{0}] cannot be changed for sysobject [{1}]. Reason: {2}.',
    'DM_SYSOBJECT_E_CANT_FORCE_DELETE_UNDER_HOLD': 'Can\'t force delete object ({0}) because it is under retention hold.',
    'DM_SYSOBJECT_E_CANT_CHANGE_RETAINER_TYPE': 'Can\'t change the value of aging_method attribute of an existing retainer object ({0}).',
    'DM_SYSOBJECT_E_ILLEGAL_PARAMETER_VALUE': 'You have specified a wrong value ({0}) for parameter ({1}) in the apply method ({2}). The legal values are ({3})',
    'DM_SYSOBJECT_E_CANT_CREATE_JOB_REQUEST_FOR_SHARED_PARENT': 'Can\'t Create Job Request for Shared Parent {0} after retention was pushed successfully.',
    'DM_SYSOBJECT_E_': '',
    'DM_SYSOBJECT_E_CANT_CREATE_JOB_REQUEST_FOR_OBJECT_TABLE': 'Can\'t Create Job Request for removing dmi_object_type reference in type.',
    'DM_SYSOBJECT_E_LIGHTWEIGHT_UTILITIES_FAILED': 'The server RPC LIGHTWEIGHT_UTILITIES failed for one or more Shared Parents in dm_job_request.The EXECUTION_MODE was {0}.',
    'DM_SYSOBJECT_E_INCONSISTENT_JMS_SERVLET_ATTRS': 'The number of jms servlet attributes (servlet_name, base_uri) is not consistent.',
    'DM_SYSOBJECT_E_DUPLICATED_JMS_SERVLET_NAME': 'The repeating attribute servlet_name contains a duplicate for \'{0}\'.',
    'DM_SYSOBJECT_E_RETAINERS_NOT_COMPATIBLE': 'The operation {0} applied to a sysobject requires the two retainer objects \'{1}\' and \'{2}\' to be compatible.',
    'DM_SYSOBJECT_E_MAT_OPTION_MISMATCH': 'Failed to materialize object {0} due to the materialization option mismatch',
    'DM_SYSOBJECT_E_INCONSISTENT_JMS_SERVLET_ATTRS2': 'The number of repeating attributes (servlet_name, base_uri, and supported_protocol) is not consistent.',
    'DM_SYSOBJECT_E_INVALID_SERVER_CONFIG_ID_IN_JMSCONFIG': '\'{0}\' is not a valid server_config id.',
    'DM_SYSOBJECT_E_INCONSISTENT_PROJECTION_ATTRS_IN_JMSCONFIG': 'The number of repeating attributes (server_config_id, projection_enable, projection_proximity_value, projection_targets, and projection_ports) is not consistent.',
    'DM_SYSOBJECT_E_INVALID_PROXVAL_IN_JMSCONFIG': 'Invalid projection_proximity_value value {0}.',
    'DM_SYSOBJECT_E_JMS_HOST_PORT_ALREADY_USED': 'An existing dm_jms_config object is already configured to use the same host name and port.',
    'DM_SYSOBJECT_E_CANT_CREATE_VERSION_LABEL': 'Cannot create new version label \'{0}\'.',
    'DM_SYSOBJECT_E_CANT_SAVE_TRANSPROC': 'Cannot save {0} during the execution of transaction proc of policy {1} for the state {2}, but the transaction is not rolled back.',
    'DM_SYSOBJECT_E_CANT_CHANGE_OWNER_NAME': 'Must have system admin privileges or superuser privileges to change the owner_name to \'{0}\'.',
    'DM_SYSOBJECT_E_CANT_WRITE_CONTENT': 'Cannot access content \'{0}\'.No write permission for current user',
    'DM_SYSOBJECT_E_CANT_TRANSFER_CONTENT': 'Cannot access content \'{0}\'.No read permission for current user',
    'DM_SYSOBJECT_F_INIT1': 'The dm_sysobject type was found in the database without a version stamp.',
    'DM_SYSOBJECT_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_SYSOBJECT_F_INIT3': 'The type manager returned an error storing the dm_sysobject type.',
    'DM_SYSOBJECT_F_INT1': 'The following database query {0} could not be executed.',
    'DM_SYSOBJECT_F_INIT4': 'The type manager returned an error converting the dm_sysobject type.',
    'DM_SYSOBJECT_F_TYPE_CONVERSION': 'Failed to convert type dm_sysobject to version {0}.',
    'DM_SYSOBJECT_F_INIT7': 'The default security mode is unknown. Verify that the parameter \'-security\' is specified in the server command line with a value of \'acl\' or \'none\'.',
    'DM_SYSOBJECT_F_INIT5': 'Failed to set the security version stamps.',
    'DM_SYSOBJECT_F_INIT6': 'The conversion vstamp object is missing.',
    'DM_SYSOBJECT_F_LIGHTWEIGHT_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_SYSOBJECT_F_ATTR_NOT_FOUND': 'Could not find attribute {0} on type {1}',
    'DM_UPGRADE_MGR_W_UNABLE_TO_VALIDATE_USER_INDEX': 'Unable to validate the dmi_index object with ID {0}. The index name is {1}. Verify that the index refers to the correct attribute(s).',
    'DM_UPGRADE_MGR_E_UNABLE_TO_VALIDATE_INDEX': 'Unable to validate dmi_index object with ID {0}. The index either could not be validated or does not exist.',
    'DM_UPGRADE_MGR_E_INDEXED_ATTRIBUTE_NOT_FOUND': 'The attribute {0} of type {1}, indexed by dmi_index object with ID {2} does not exist',
    'DM_UPGRADE_MGR_E_UNABLE_TO_CREATE_INDEX': 'The Upgrade Manager failed to create an index on table {0}. The error from the database was: {1}',
    'DM_UPGRADE_MGR_E_QUERY_EXECUTION_FAILURE': 'The Upgrade Manager failed to execute the following query: {0}. The database error is {1}.',
    'DM_UPGRADE_MGR_I_UPGRADE_INFO': '{0}.',
    'DM_UPGRADE_MGR_I_DOCBASE_UPGRADE_STARTED': 'The Upgrade Manager has started to upgrade the docbase to version {0}.',
    'DM_UPGRADE_MGR_I_DOCBASE_UPGRADE_COMPLETE': 'The Upgrade Manager has successfully upgraded the docbase to version {0}.',
    'DM_UPGRADE_MGR_I_DOCBASE_UPGRADE_FAILED': 'The Upgrade Manager was unable to upgrade the docbase to version {0}. Customers are encouraged to turn on sql tracing as well as upgrade tracing and restart the upgrade. The additional tracing information will be helpful in determining the cause of upgrade failure.',
    'DM_UPGRADE_MGR_I_PREVENTING_PRE_40_SERVER_FROM_STARTING': 'The Upgrade Manager has now reached a point where it cannot revert the docbase back to a pre-4.0 server.',
    'DM_UPGRADE_MGR_I_INDEX_VALIDATION_STARTED': 'The Upgrade Manager has started to validate Documentum indices. The Upgrade Manager will attempt to correct any incorrect indices',
    'DM_UPGRADE_MGR_I_INDEX_VALIDATION_COMPLETED': 'The Upgrade Manager has successfully completed validating Documentum indices.',
    'DM_UPGRADE_MGR_I_INDEX_VALIDATION_FAILED': 'The Upgrade Manager failed to validate Documentum indices.',
    'DM_UPGRADE_MGR_I_INDEX_CREATION_FOR_UPGRADE_STARTED': 'The Upgrade Manager has started to create the necessary indices for upgrade. This may take some time.',
    'DM_UPGRADE_MGR_I_INDEX_CREATION_FOR_UPGRADE_COMPLETED': 'The Upgrade Manager has created the necessary indices for upgrade.',
    'DM_UPGRADE_MGR_I_INDEX_CREATION_FOR_UPGRADE_FAILED': 'The Upgrade Manager was unable to create the necessary indices for upgrade.',
    'DM_UPGRADE_MGR_I_DROPPING_INDEX_ON_DMI_OBJECT_TYPE': 'The Upgrade Manager is dropping the index on the dmi_object_type table for enhanced upgrade performance',
    'DM_UPGRADE_MGR_I_OBJECT_TABLE_CONVERSION_STARTED': 'The Upgrade Manager has started the object table conversion.',
    'DM_UPGRADE_MGR_I_OBJECT_TABLE_CONVERSION_COMPLETED': 'The Upgrade Manager has completed the object table conversion.',
    'DM_UPGRADE_MGR_I_OBJECT_TABLE_CONVERSION_FAILED': 'The Upgrade Manager has encountered a failure during object table conversion.',
    'DM_UPGRADE_MGR_I_RECREATING_INDEX_ON_DMI_OBJECT_TYPE': 'The Upgrade Manager is re-creating the index on dmi_object_type table.',
    'DM_UPGRADE_MGR_I_VALIDATING_INDEX': 'The Upgrade Manager is validating index with ID {0}.',
    'DM_UPGRADE_MGR_I_SYBASE_ROW_LOCKING_STARTED': 'The Upgrade Manager has started verifying that row level locking is enabled for all tables.',
    'DM_UPGRADE_MGR_I_SYBASE_ROW_LOCKING_COMPLETED': 'The Upgrade Manager has completed verifying that row level locking is enabled for all tables.',
    'DM_UPGRADE_MGR_I_SYBASE_ROW_LOCKING_FAILED': 'The Upgrade Manager has failed to set row locking on existing tables',
    'DM_UPGRADE_MGR_F_INTERNAL_INDEX_VALIDATION_FAILURE': 'Unable to validate dmi_index object with ID {0} due to an internal error.',
    'DM_UPGRADE_MGR_F_INTERNAL_ERROR': 'The Upgrade Manager has encountered an internal error: {0}.',
    'DM_USER_W_LENGTH_WIDEN_FAILED': 'The upgrade failed on widening user\'s attribute ({0}) length from {1} to {2}.',
    'DM_USER_W_': '',
    'DM_USER_E_CANT_CREATE_EXISTING_USER': 'Cannot create user {0} since it already exists',
    'DM_USER_E_CANT_DROP_USER_FROM_GROUP': 'Cannot drop user {0} from group {1}.',
    'DM_USER_E_CANT_DESTROY_A_USER': 'Cannot destroy user {0}.',
    'DM_USER_E_CANT_FETCH_INVALID_ID': 'Cannot fetch a user - Invalid object ID {0}',
    'DM_USER_E_CANT_FIND_USER': 'Cannot find user {0}.',
    'DM_USER_E_NOT_DOCUMENTUM_USER': 'User {0} does not exist in the docbase',
    'DM_USER_E_CANT_SAVE_A_USER': 'Cannot save user {0}.',
    'DM_USER_E_INVALID_PRIVILEGE_VALUES': 'Specified privileges {0} are invalid, supported range is {1}:{2}',
    'DM_USER_E_MUST_HAVE_NAME': 'A user object must have a name',
    'DM_USER_E_MUST_HAVE_OSNAME': 'A new {0} user object must have an OS user name',
    'DM_USER_E_MUST_HAVE_EMAIL': 'A new {0} user object must have a EMail address',
    'DM_USER_E_NEED_SU_OR_SYS_PRIV': 'The current user ({0}) needs to have superuser or sysadmin privilege.',
    'DM_USER_E_NEED_SU_OR_SYS_FOR_CHANGE': 'The current user ({0}) needs to have superuser or sysadmin privilege to save or destroy {1} user object.',
    'DM_USER_E_NEED_SUPER_USER_PRIV': 'The current user ({0}) needs to have superuser privilege to save the object.',
    'DM_USER_E_INVALID_PERMIT': 'Invalid permit {0} specified for user {1}.',
    'DM_USER_E_EXISTING_USER_NAME': 'Cannot create user {0} since its user_name already exists',
    'DM_USER_E_EXISTING_USER_OSNAME': 'Cannot create user {0} since its user_os_name already exists',
    'DM_USER_E_CANT_FETCH_ACL': 'Failed to fetch the default ACL \'{0}\' in name space \'{1}\' of user \'{2}\'. [{3}]',
    'DM_USER_E_CANT_DEREF_ACL': 'Failed to fetch the default ACL \'{0}\' in name space \'{1}\' of user \'{2}\'.',
    'DM_USER_E_CANT_SAVE_ACL': 'Failed to save ACL \'{0}\' in name space \'{1}\' for user object \'{2}\'.',
    'DM_USER_E_ACL_REVISE_GROUP': 'Failed to revise the group name of the ACL \'{0}\' in domain \'{1}\' for user \'{2}\'.',
    'DM_USER_E_LOAD_OSNAME_CONFLICT': 'A dm_user object with user name {0} was encountered which has a user_os_name ({1}) which conflicts with an existing dm_user object.  The user_os_name of the object being loaded has been changed to {2}.',
    'DM_USER_E_MUST_HAVE_OSDOMAIN': 'A new {0} user object must have an OS domain name',
    'DM_USER_E_MUST_HAVE_LOGON_DOMAIN': 'You must specify the OS/LDAP domain to successfully logon to the docbase',
    'DM_USER_E_LOGON_DOM_NO_MATCH_USR': 'You cannot authenticate against \'{0}\' domain.',
    'DM_USER_E_LOGON_DOM_NO_MATCH_SVR': 'You cannot authenticate against {0} domain.',
    'DM_USER_E_NOT_DOCBASE_DOMAIN_USR': 'User {0} from domain \'{1}\' does not exist in the docbase -- session closed.',
    'DM_USER_E_DOCUMENTUM_USER_INACTIVE': 'User {0} is not activated in the docbase -- session closed.',
    'DM_USER_E_INVALID_STATE_VALUE': 'Specified state {0} is invalid, supported values are 0/1/2/3',
    'DM_USER_E_CANT_SET_SUPER_USER_STATE': 'A super user\'s state can not be set by any one other than a super user',
    'DM_USER_E_STATE_WORKFLOW_CONFLICT': 'You can not set user_state to inactive and workflow_ready to ready concurently',
    'DM_USER_E_INVALID_ACL_DOMAIN': 'The user \'{0}\' is given an invalid ACL domain \'{1}\'.',
    'DM_USER_E_RESERVED_NAME': 'The user name \'{0}\' is reserved.',
    'DM_USER_E_SPECIFY_ALTERNATE': 'A valid alternate performer for workflows must be specified, if workflow_disabled is set.',
    'DM_USER_E_INVALID_XPRIVILEGE_VALUES': 'Specified privileges {0} are invalid, supported values are {1}, {2}, {3} and their or\'d values.',
    'DM_USER_E_CANT_GRANT_PRIV_TO_SELF': 'You can\'t grant the specified privilege {0} to yourself ({1}).',
    'DM_USER_E_CANT_UNREGISTER': 'Could not unregister the specified {0} event for {1} object.',
    'DM_USER_E_CANT_REVOKE_PRIV_FROM_SELF': 'You can\'t revoke the specified privilege {0} from yourself ({1}).',
    'DM_USER_E_PASSWORD_ENCRYPTION_FAIL': 'Server failed to encrypt user password.',
    'DM_USER_E_ENCRYPTION_TOO_LONG': 'The internal gernerated encrypted password is too long ({0}). It cannot exceed the size of {1}.',
    'DM_USER_E_DIR_MAPPED_ATTR_CHANGED': 'Cannot save the directory user {0} because at least one directory-mapped attribute (\'{1}\') has been changed',
    'DM_USER_E_ILLEGAL_DIR_NAME': 'Cannot save a directory user {0} because its user_login_domain (\'{1}\') is not a legal LDAP config name',
    'DM_USER_E_NEED_SYS_OR_USER_ADMIN_OR_OWNER': 'The user ({0}) needs to have at least sysadmin privilege or be the user\'s user admin or owner to change the {1} user object.',
    'DM_USER_E_NEED_SYS_OR_USER_ADMIN_PRIV': 'The user ({0}) needs to have at least sysadmin privilege or be the user\'s user admin to change the {1} user object.',
    'DM_USER_E_MUST_HAVE_LOGINNAME': 'A new {0} user object must have a login name',
    'DM_USER_E_MUST_HAVE_LOGINDOMAIN': 'A new user object ({0}) must have a login domain name',
    'DM_USER_E_EXISTING_USER_LOGINNAME': 'Cannot create user {0} since its user_login_name already exists',
    'DM_USER_E_LOAD_LOGINNAME_CONFLICT': 'A dm_user object with user name {0} was encountered which has a user_login_name ({1}) which conflicts with an existing dm_user object.  The user_login_name of the object being loaded has been changed to {2}.',
    'DM_USER_E_NOT_IN_RESTRICTED_FOLDERS': 'The folder (\'{0}\') is not in the user\'s ({1}) restricted_folder_ids list.',
    'DM_USER_E_PASSWORD_DECRYPTION_FAIL': 'Server failed to decrypt user password.',
    'DM_USER_E_INVALID_XPRIVILEGES': 'Specified privileges {0} are invalid, supported values are {1} and their or\'d values.',
    'DM_USER_E_DOCUMENTUM_USER_LOCKED': 'User {0} is locked in the repository -- session closed.',
    'DM_USER_E_USER_LOCKED_AND_INACTIVE': 'User {0} is locked and inactive in the repository -- session closed.',
    'DM_USER_E_USER_YET_TO_BE_RENAMED': 'A job request to rename user (\'{0}\') is in progress or in pipeline to be processed.',
    'DM_USER_E_NEED_SU_OR_SYS_FOR_OBJECT_CHANGE': 'The current user ({0}) needs to have superuser or sysadmin privilege to create or save or destroy objects of type ({1}).',
    'DM_USER_F_INIT1': 'The dm_user type was found in the database without a version stamp.',
    'DM_USER_F_INIT2': 'Version stamp {0} was expected to be {1}.',
    'DM_USER_F_INIT3': 'The type manager returned an error storing the dm_user type.',
    'DM_USER_F_INT1': 'The following database query could not be executed: {0}.',
    'DM_USER_F_INIT4': 'Cannot create or retrieve the superuser {0} dmUser object during initialization.',
    'DM_USER_F_CVT1': 'Could not update the new user_db_name attribute.  Database error was: {0}',
    'DM_USER_F_CVT2': 'Could not convert the dm_user type.',
    'DM_USER_F_TYPE_CONVERSION': 'Failed to convert the dm_user to version {0}.',
    'DM_USER_F_UNKNOWN_AUTH_PROTOCOL': 'The docbase auth_protocol is not of any value known to server.',
    'DM_VERSION_E_MEMORY_EXHAUSTED': 'Memory allocation of {0} bytes failed',
    'DM_VERSION_E_PARSE_NO_HEADER': 'Format string is not parsable: expecting numeric value for version.  Format string: {0}',
    'DM_VERSION_E_MAJOR_SCALE_BOUNDS_EXCEEDED': 'The maximum bounds for a Major revision has been exceeded.  Major ={0}, Maximum ={1}',
    'DM_VERSION_E_MINOR_SCALE_BOUNDS_EXCEEDED': 'The maximum bounds for a Minor revision has been exceeded.  Minor ={0}, Maximum ={1}',
    'DM_VERSION_E_MAINT_SCALE_BOUNDS_EXCEEDED': 'The maximum bounds for a Maintenence revision has been exceeded.  Maintenence ={0}, Maximum ={1}',
    'DM_VERSION_E_PATCH_SCALE_BOUNDS_EXCEEDED': 'The maximum bounds for a Patch revision has been exceeded.  Patch ={0}, Maximum ={1}',
    'DM_WORKFLOW_I_AGENT_START': 'Workflow agent {0} ({1} : {2}, session {3}) is started sucessfully.',
    'DM_WORKFLOW_I_AGENT_TERMINATE': 'Workflow agent {0} ({1} : {2}, session {3}) has terminated sucessfully.{4}',
    'DM_WORKFLOW_I_SHUTDOWN_TIMEDOUT': 'Workflow agent shutdown has timed out. System Administrator should execute the RECOVER_AUTO_TASKS administrative method to recover the workitems.',
    'DM_WORKFLOW_I_AGENT_SHUTDOWN': 'Workflow agent has been successfully shutdown',
    'DM_WORKFLOW_I_AGENT_STATUS_CHANGE': 'The workflow agent status has changed because {0}. The workflow agent is currently {1}.',
    'DM_WORKFLOW_I_AGENT_CHECKING_SUBSYSTEM': 'The worker threads will start after a healthy {0} is found.',
    'DM_WORKFLOW_F_TYPE_INIT': 'Failed to initialize type {0}.',
    'DM_WORKFLOW_F_BAD_VSTAMP': 'Type {0} has a bad vstamp {1}. The vstamp is supposed to be {2}.',
    'DM_WORKFLOW_F_VIEW_INIT': 'Failed to create view {0}: database error was: {1}.',
    'DM_WORKFLOW_F_TYPE_CONVERSION': 'Failed to convert type {0} to version {1}.',
    'DM_WORKFLOW_W_PORT_INCOMPAT_DOWN_CASTING': 'Down casting occurs between {0}th packages from source activity {1} source port {2} and destination activity {3} destination port {4}',
    'DM_WORKFLOW_W_CANT_REACH': 'Activity {0} can not be reached from any start activity.',
    'DM_WORKFLOW_W_DANGLING_PORT': 'Output port \'{0}\' of activity \'{1}\' within process definition \'{2}\' ({3}) is a dangling port.',
    'DM_WORKFLOW_W_EXEC_POOL_FULL': 'Failed to launch {0} due to no vacancy in the execution context pool.',
    'DM_WORKFLOW_W_NO_DELEGATION': 'User, {0}, does not have any one to delegate to.',
    'DM_WORKFLOW_W_NO_MESSAGE_SENT': 'An event notification could not be sent to user \'{0}\'',
    'DM_WORKFLOW_W_PERFORMER_CATEGORY': 'Invalid alias category for resolved performer \'{0}\' of activity \'{1}\' of workflow ({2}):  the category of the alias was not user or group',
    'DM_WORKFLOW_W_PERFORMER_UNRESOLVED': 'A user/group could not be found for performer \'{0}\' of activity \'{1}\' of workflow (\'{2}\').  The activity has been assigned to the workflow supervisor, \'{3}\'.',
    'DM_WORKFLOW_W_BINDING_PACKAGE': 'Package binding failed because no object could be identified by package ID ({0}) with package label \'{1}\'.',
    'DM_WORKFLOW_W_AGENT_DIED': 'Server detected that workflow agent master has died, and is restarting it ......',
    'DM_WORKFLOW_W_TASKSUBJECT_UNRESOLVED': 'Resolving task subject failed for workitem (\'{0}\'), \'task_subject\' attribute of its inbox item is not set.',
    'DM_WORKFLOW_W_PEFORMER_OF_PREVIOUS_ACT': 'Activity \'{0}\' is set to use performer(s) of activity \'{1}\'. But the source activity has not been triggered or has not finished. Therefore the task is assigned to the workflow supervisor.',
    'DM_WORKFLOW_W_DYNAMIC_PERFORMER': 'Failed to resolve dynamic performer \'{0}\' based on process data. {1}',
    'DM_WORKFLOW_W_RESOLVE_PROCESS_PARAMETER': 'Failed to resolve process parameter \'{0}\'. {1}',
    'DM_WORKFLOW_W_TASKINSTRUCTION_UNRESOLVED': 'Resolving task instruction failed for workitem (\'{0}\'), \'message\' attribute of its inbox item is not set.',
    'DM_WORKFLOW_W_UNABLE_TO_DELETE_INTERNAL_GROUP': 'Unable to delete the internal group {0}.',
    'DM_WORKFLOW_E_CANT_FETCH': 'The {0} object ({1}) does not exist.',
    'DM_WORKFLOW_E_INTERNAL_STATE': 'The {0} object ({1}) is in a bad state.',
    'DM_WORKFLOW_E_CANT_CREATE': 'Cannot create a {0} object.',
    'DM_WORKFLOW_E_BAD_TYPE': 'The package ({0}) contains a component ({1}) that is not of type \'{2}\' or its sub-type.',
    'DM_WORKFLOW_E_MISSING_VALUE': 'The attribute {0} of {1} \'{2}\' ({3}) has to be set for this operation to succeed.',
    'DM_WORKFLOW_E_ACTIVITY_RUNTIME': 'The sequence number of an activity run-time instance has an invalid value \'{0}\'.',
    'DM_WORKFLOW_E_ACTION_NOT_ALLOWED': 'This operation is not allowed when the state is \'{0}\' for {1} \'{2}\'.',
    'DM_WORKFLOW_E_VALUE_NOT_ALLOWED': 'The value set to the attribute {0} of {1} \'{2}\' is illegal.',
    'DM_WORKFLOW_E_NO_WRITE_ACCESS': 'The operation requires at least WRITE permit or can be performed by a user with SYSADMIN or SUPERUSER privileges.',
    'DM_WORKFLOW_E_OUT_OF_RANGE': 'The value of the attribute {0} should be between {1} and {2} for {3} \'{4}\'.',
    'DM_WORKFLOW_E_NAME_INDEX': 'The internal index for attribute {0} of the {1} object ({2}) is corrupted for key value \'{3}\',',
    'DM_WORKFLOW_E_NO_VALUE': 'The attribute {0} of the {1} object ({2}) contains no value at position {3}.',
    'DM_WORKFLOW_E_CONFLICT_PACKAGE_TYPE': 'The package definition by the name \'{0}\' has conflicting types: {1} and {2} on activity \'{3}\'.',
    'DM_WORKFLOW_E_PACKAGE_TYPE': 'The package definition by name \'{0}\' contains a non-existing type \'{1}\'.',
    'DM_WORKFLOW_E_CONFLICT_PORT_TYPE': 'The port of name \'{0}\' is used in multiple port types on activity \'{1}\'.',
    'DM_WORKFLOW_E_FOREIGN_ID': 'The foreign object ({0}) is not allowed in the attribute {1} of type {2}.',
    'DM_WORKFLOW_E_MISSING_PARAMETERS': 'The API command {0} has missing parameters.',
    'DM_WORKFLOW_E_PORT_EXIST': 'The specified port \'{0}\' already exists.',
    'DM_WORKFLOW_E_ILLEGAL_PORT_TYPE': 'The specified port type \'{0}\' is illegal.',
    'DM_WORKFLOW_E_ACTIVITY_TYPE': 'The specified object ({0}) is not an activity definition object.',
    'DM_WORKFLOW_E_ACTIVITY_NAME': 'The activity name \'{0}\' is invalid.',
    'DM_WORKFLOW_E_ACTIVITY_INUSE': 'The activity \'{0}\' is referenced by link \'{1}\'.',
    'DM_WORKFLOW_E_PORT_TABLE': 'The following attributes should have had same number of values: {0}, {1}, {2}, {3}, {4}, {5} and {6}.',
    'DM_WORKFLOW_E_ROUTE_TABLE': 'The following attributes should have had same number of values: {0} and {1}.',
    'DM_WORKFLOW_E_PORT_NOT_FOUND': 'The specified port \'{0}\' does not exist.',
    'DM_WORKFLOW_E_METHOD_NOT_APPLICABLE': 'The method {0} is not applicable, before the object is saved.',
    'DM_WORKFLOW_E_DESTROY_INUSE': 'The operation fails, because the {0} object ({1}) is in use.',
    'DM_WORKFLOW_E_CURSOR': 'The cursor \'{0}\' fails. The error message from the database server is: {1}.',
    'DM_WORKFLOW_E_CANT_DESTROY': 'Can not destroy process definition due to being referenced by workflow ({0}).',
    'DM_WORKFLOW_E_DESTROY_STATE': 'Can not destroy an installed process definition.',
    'DM_WORKFLOW_E_INSTALL_ACTIVITY': 'One of the paramter provided to install an activity definition is invalid.',
    'DM_WORKFLOW_E_RESTART': 'One of the paramters provided for restart is invalid.',
    'DM_WORKFLOW_E_ACTIVITY_NOT_INSTALLED': 'One of the referring activities ({0}) has not yet been installed.',
    'DM_WORKFLOW_E_PORT_INCOMPAT_PKGCNT': 'Source activity {0} source port {1} has different package count than destination activity {2} destination port {3}.',
    'DM_WORKFLOW_E_PORT_INCOMPAT_TYPE': 'Type incompatibility occurs between the {0}th packages of the source activity \'{1}\' port \'{2}\' and destination activity \'{3}\' port \'{4}\'',
    'DM_WORKFLOW_E_END_ACTIVITY': 'More than one end activities are specified.',
    'DM_WORKFLOW_E_ACTIVITY_DUPLICATE': 'Activity \'{0}\' has already existed.',
    'DM_WORKFLOW_E_SRC_LINK_DUPLICATE': 'Source activity \'{0}\' port \'{1}\' has two outgoing links.',
    'DM_WORKFLOW_E_DEST_LINK_DUPLICATE': 'Destination activity \'{0}\' port \'{1}\' has two incoming links.',
    'DM_WORKFLOW_E_LINK_ACTIVITY_NAME': 'Activity \'{0}\' does not exist for linking.',
    'DM_WORKFLOW_E_ACTDEFID_STATE': 'Activity definition ({0}) has not been validated or installed.',
    'DM_WORKFLOW_E_DEST_LINK_START_ACTIVITY': 'Start activity \'{0}\' has an incoming link \'{1}\'.',
    'DM_WORKFLOW_E_SRC_LINK_END_ACTIVITY': 'End activity \'{0}\' has an outgoing link \'{1}\'.',
    'DM_WORKFLOW_E_PORT_NAME': 'Port \'{0}\' does not exist in the activity definition \'{1}\'.',
    'DM_WORKFLOW_E_PORT_TYPE': 'An input (or output) activity \'{0}\' port \'{1}\' is specified as source (or destination) port in a link.',
    'DM_WORKFLOW_E_PACKAGE_NOT_FOUND': 'There is no package definition by the given name \'{0}\' in port \'{1}\'.',
    'DM_WORKFLOW_E_ROUTECASE_NOT_FOUND': 'The route case can not be found give the name \'{0}\'.',
    'DM_WORKFLOW_E_PACKAGE_EXIST': 'The given package name \'{0}\' already exists in port \'{1}\'.',
    'DM_WORKFLOW_E_PACKAGE_ID': 'The package ID ({0}) given in the package definition \'{1}\' is not of the declared package type \'{2}\' or its sub-type.',
    'DM_WORKFLOW_E_PERFORMER_TYPE_PRIV': 'The setting of {0} ({1}) for automatic activity \'{2}\' requires SUPERUSER privileges.',
    'DM_WORKFLOW_E_FEATURE_NOT_SUPPORTED': 'The feature indicated by the value in attribute {0} is not currently supported.',
    'DM_WORKFLOW_E_UNIQUE_PORT_PACKAGE': 'The package definition by the name \'{0}\' has duplicated entries in port \'{1}\' of activity \'{2}\'.',
    'DM_WORKFLOW_E_DISCONNECTED_GRAPH': 'Activity {0} does not have an incoming or outgoing link.',
    'DM_WORKFLOW_E_NAME_NOT_EXIST': 'The {0} object by the name \'{1}\' specified in attribute {2} does not exist.',
    'DM_WORKFLOW_E_CANT_START': 'The workflow \'{0}\' can only start, when its referenced process ({1}) is installed.',
    'DM_WORKFLOW_E_FROZEN_ATTR': 'The attribute {0} can not be changed, when the {1} object is at state ({2}).',
    'DM_WORKFLOW_E_CHECK_ACTIVITY': 'The parameter checkactivity is invalid.',
    'DM_WORKFLOW_E_LINK_NAME': 'The link {0} does not exist.',
    'DM_WORKFLOW_E_BAD_PARAM': 'The parameter {0} specified is invalid.',
    'DM_WORKFLOW_E_CANT_END': 'The activity {0} does not reach the end activity.',
    'DM_WORKFLOW_E_LINK_DUPLICATE': 'Link name {0} is a duplicate.',
    'DM_WORKFLOW_E_ACTIVITY_ATTR_COUNT': 'No of elements in activity_type/activity_priority/activity_def_id does not match that of activity_name.',
    'DM_WORKFLOW_E_LINK_ATTR_COUNT': 'No of elements in link_src_activity/link_src_port/link_dest_activity/link_dest_port does not match that of link_name.',
    'DM_WORKFLOW_E_ACTIVITY_SEQNO': 'No activity run-time instance can be identified by the sequence no ({0}) in workflow ({1}).',
    'DM_WORKFLOW_E_ACTIVITY_RUNTIME_CREATION': 'Failed to create run-time instances for activities defined in the process definition ({0}).',
    'DM_WORKFLOW_E_COMPUTE_PERFORMER': 'Failed to compute performers for activity \'{0}\' ({1}) of the workflow ({2}).',
    'DM_WORKFLOW_E_ACCEPT_PACKAGE': 'Failed to accept packages arriving at port \'{0}\' of activity \'{1}\' ({2}) of the workflow ({3}).',
    'DM_WORKFLOW_E_INCOMING_PORT': 'The given port name \'{0}\' is neither an input nor a revert port.',
    'DM_WORKFLOW_E_INCOMING_PACKAGE': 'The number of packages ({0}) does not match what is expected ({1}) as defined in port \'{2}\' of the activity definition ({3}).',
    'DM_WORKFLOW_E_PACKAGE_TYPE_NOT_FOUND': 'The type \'{0}\' of the package \'{1}\' does not exist.',
    'DM_WORKFLOW_E_PACKAGE_TYPE_INCOMPAT': 'The type \'{0}\' of the incoming package \'{1}\' is not compatible with type \'{2}\' as defined in package name \'{3}\' of port \'{4}\' of the activity definition ({5}).',
    'DM_WORKFLOW_E_ACT_STATE_TRANS': 'The workflow engine fails to make necessary state transition for activity \'{0}\' ({1}) within the workflow ({2}).',
    'DM_WORKFLOW_E_PACKAGE_CONSOLIDATION': 'Package consolidation fails on activity \'{0}\' ({1}) of the workflow ({2}).',
    'DM_WORKFLOW_E_PACKAGE_MERGE': 'Package merge fails, because one package ({0}) is of type \'{1}\' and the other ({2}) is of type \'{3}\'.',
    'DM_WORKFLOW_E_CREATE_WORKITEM': 'Failed to create a workitem for user \'{0}\' within activity \'{1}\' ({2}) of workflow ({3}).',
    'DM_WORKFLOW_E_COMPUTE_TRANS_COND': 'Failed to compute transition condition for activity \'{0}\' ({1}) of workflow ({2}).',
    'DM_WORKFLOW_E_MANU_PACKAGE': 'Failed to manufacture packages for activity \'{0}\' ({1}) of workflow ({2}).',
    'DM_WORKFLOW_E_OUTGOING_LINK': 'Failed to find the outgoing link from output port \'{0}\' of activity \'{1}\'.',
    'DM_WORKFLOW_E_MISSING_PACKAGE': 'A package \'{0}\' is missing, but is required to satisfy definition of output port \'{1}\'.',
    'DM_WORKFLOW_E_EMPTY_PACKAGE': 'The package ({0}) contains no bound component.',
    'DM_WORKFLOW_E_BINDING_PACKAGE': 'Package binding failed because no object could be identified by package ID ({0}) with package label \'{1}\'.',
    'DM_WORKFLOW_E_AGENT_LAUNCH': 'Failed to launch {0} due to an operating system error: {1}.',
    'DM_WORKFLOW_E_NO_ACCESS': 'This user does not have the permission to perform the current operation on object, {0}.',
    'DM_WORKFLOW_E_NO_START_END_ACTIVITY': 'There is no start or end activity.',
    'DM_WORKFLOW_E_NO_PACKAGE': 'There is no package in the activity definition.',
    'DM_WORKFLOW_E_INVALID_PACKAGE_NAME': 'The package name, {0}, is not valid.',
    'DM_WORKFLOW_E_INVALID_PACKAGE_TYPE': 'The package type, {0}, is not valid.',
    'DM_WORKFLOW_E_PACKAGE_EXISTS': 'The package already exists.',
    'DM_WORKFLOW_E_PACKAGE_NOT_EXISTS': 'The package does not exist.',
    'DM_WORKFLOW_E_NOT_PERFORMER': 'The current user is not the activity performer.',
    'DM_WORKFLOW_E_NO_NOTE': 'The specified note, {0}, has not been added to the package.',
    'DM_WORKFLOW_E_DUPLICATE_ROUTE_ID': 'The route case identifier, {0}, already exists.',
    'DM_WORKFLOW_E_INVALID_PORT': 'The port name \'{0}\' is not defined on activity \'{1}\'.',
    'DM_WORKFLOW_E_INVALID_ROUTE_ID': 'The route case identifier, {0}, specified does not exist.',
    'DM_WORKFLOW_E_INVALID_ROUTE_ALIASE': 'The route aliase \'{0}\' used in activity \'{1}\' is invalid.',
    'DM_WORKFLOW_E_NO_RUNTIME_PACKAGE': 'The package, {0}, does not exist for the activity, {1}.',
    'DM_WORKFLOW_E_CLEAN_NOTE': 'Failed to clean up old notes attached to a package ({0}).',
    'DM_WORKFLOW_E_COLLECT_PACKAGES': 'The workflow ({0}) fails to collect all available packages.',
    'DM_WORKFLOW_E_NO_EXECUTE_ACCESS': 'User \'{0}\' has no EXECUTE permit on process ({1}).',
    'DM_WORKFLOW_E_CHANGE_NOT_ALLOWED': 'Workflow ({0}) can only be modified by its creator \'{1}\' or users with SUPERUSER privilege.',
    'DM_WORKFLOW_E_INVALID_USER': 'The specified user \'{0}\' is not a valid user.',
    'DM_WORKFLOW_E_WORKITEM_TRANSITION': 'Workitem ({0}) fails to make the state transition.',
    'DM_WORKFLOW_E_UNINSTALLED_PROCESS': 'Process definition ({0}) is not installed.',
    'DM_WORKFLOW_E_INACTIVE_ACTIVITY': 'The activity run-time \'{0}\' ({1}) of workflow ({2}) is not active.',
    'DM_WORKFLOW_E_CREATE_ACTIVITY_RUNTIME': 'Fails to instantiate a new activity run-time for \'{0}\'.',
    'DM_WORKFLOW_E_DELIVER_PACKAGES': 'The activity run-time \'{0}\' fails to deliver packages from the source port \'{1}\' to the destination port \'{2}\' of activity \'{3}\'.',
    'DM_WORKFLOW_E_CLEANUP_ACTIVITY': 'Fails to clean up activity run-time list of workflow ({0}).',
    'DM_WORKFLOW_E_PACKAGE_COMPONENT_TYPE': 'The component, {0}, is not the specified type.',
    'DM_WORKFLOW_E_INVALID_ACTIVITY_NAME': 'The activity name, {0}, is invalid.',
    'DM_WORKFLOW_E_INVALID_ACTIVITY_TYPE': 'The activity, {0}, is not a start activity.',
    'DM_WORKFLOW_E_INVALID_PACKAGE_INPUT_PORT': 'The package \'{0}\' is not in the specified input port \'{1}\' of activity \'{2}\'.',
    'DM_WORKFLOW_E_OUTPUT_PORT': 'The specified output port \'{0}\' does not exist in the activity definition ({1}).',
    'DM_WORKFLOW_E_COLLECT_OUTPORT': 'The activity \'{0}\' ({1}) of workflow ({2}) fails to collect manually specified output ports for transition.',
    'DM_WORKFLOW_E_SEND_WF_EVENT': 'The workflow engine fails to send an event \'{0}\' for workflow ({1}).',
    'DM_WORKFLOW_E_SEND_WI_EVENT': 'The workflow engine fails to send an event \'{0}\' for workitem ({1}).',
    'DM_WORKFLOW_E_SEND_WA_EVENT': 'The workflow engine fails to send an event \'{0}\' for activity \'{1}\' ({2}) of workflow ({3}).',
    'DM_WORKFLOW_E_COLLECT_EVENTS': 'The workflow engine fails to collect events for processing.',
    'DM_WORKFLOW_E_BOGUS_EVENT': 'The workflow ({0}) is not able to process event ({1}).',
    'DM_WORKFLOW_E_PROCESS_EVENT': 'The workflow engine fails to process \'{0}\' event on behalf of activity \'{1}\' ({2}) of workflow ({3}).',
    'DM_WORKFLOW_E_CHECK_EVENT': 'The workflow engine fails to check for event \'{0}\' for workflow ({1}).',
    'DM_WORKFLOW_E_TRANSITION_PRIVILEGE': 'The operation can only be performed by the workflow supervisor \'{0}\' or users with SYSADMIN privilege.',
    'DM_WORKFLOW_E_DESTROY_PRIVILEGE': 'The operation can only be performed by the workflow creator \'{0}\', the supervisor \'{1}\' or users with SYSADMIN privilege.',
    'DM_WORKFLOW_E_DESTROY_WORKFLOW': 'The workflow \'{0}\' ({1}) can not be destroyed, unless it is in DORMANT, FINISHED or TERMINATED state.',
    'DM_WORKFLOW_E_HALT_AUTOMATIC': 'The workflow ({0}) can not be halted, because an automatic activity (represented by a workitem ({1})) is being executed.',
    'DM_WORKFLOW_E_INVALID_ACTIVITY_STATE': 'The activity, {0}, is not in dormant state.',
    'DM_WORKFLOW_E_INVALID_WORKITEM_STATE': 'The workitem, {0}, is not in acquired state.',
    'DM_WORKFLOW_E_ENGINE_PROCESSING_ERROR': 'Internal error during processing of workflow, {0}.',
    'DM_WORKFLOW_E_NOT_RUNNING': 'The workflow, {0}, is not running.',
    'DM_WORKFLOW_E_NO_PACKAGE_COMPONENT': 'The package, {0}, for the activity, {1}, does not have a component.',
    'DM_WORKFLOW_E_ACTIVITY_NOT_ACTIVE': 'The activity, {0}, of workflow, {1}, is not active.',
    'DM_WORKFLOW_E_PORT_NO_PACKAGE': 'The port \'{0}\' of activity \'{1}\' does not have any package.',
    'DM_WORKFLOW_E_NO_CONDITION': 'The activity definition, {0}, does not have any route case.',
    'DM_WORKFLOW_E_ITEM_NEED_SIGNOFF': 'It is required to sign off workitem \'{0}\' before complete.',
    'DM_WORKFLOW_E_REFERENCING_PROCESS': 'This operation is not allowed where there is referencing validated process.',
    'DM_WORKFLOW_E_WORKFLOW_NOT_RUNNING': 'This operation is not allowed when the workflow is halted.',
    'DM_WORKFLOW_E_CANT_RESUME': 'The workflow \'{0}\' can only resume, when its referenced process ({1}) is installed.',
    'DM_WORKFLOW_E_NO_RELATE_ACCESS': 'The operation requires at least RELATE permit on object({0}) or can be performed by a user with SYSADMIN or SUPERUSER privileges.',
    'DM_WORKFLOW_E_CANT_SAVE': 'Saving the object, {0}, is not allowed.',
    'DM_WORKFLOW_E_SAVE_ONCE': 'The workflow, {0}, can be saved only once.',
    'DM_WORKFLOW_E_INVALID_NOTE': 'The dm_note object identified as \'{0}\' is not a valid object.',
    'DM_WORKFLOW_E_NO_SUPERVISOR_ACCESS': 'The supervisor \'{0}\', designated in workflow \'{1}\', does not have at least RELATE permit on the referenced process.',
    'DM_WORKFLOW_E_': '',
    'DM_WORKFLOW_E_CANT_REPEAT': 'The referenced activity \'{0}\' ({1}) does not allow extension.',
    'DM_WORKFLOW_E_DUPLICATE_REPEAT': 'Workitem {0} is a repeated workitem; it cannot be further repeated.',
    'DM_WORKFLOW_E_INPUT_BINDING': 'Cannot add packageinfo to input port \'{0}\'; package ID and label binding are not allowed for input ports',
    'DM_WORKFLOW_E_PACKAGE_REQUIRED': 'Package \'{0}\' is required for performer resolution, but is not defined on an input port of activity \'{1}\'.',
    'DM_WORKFLOW_E_PERFORMER_CATEGORY': 'Invalid alias category for resolved performer \'{0}\' of activity \'{1}\' of workflow ({2}):  the category of the alias was not user or group',
    'DM_WORKFLOW_E_MULTIPLE_PERFORMERS': 'Only a single performer is allowed for performer type {0} in activity ({1}).',
    'DM_WORKFLOW_E_PERFORMER_REQUIRED': 'A performer is required for activity \'{0}\' ({1}), or a designation of which activity\'s performer will choose this performer.',
    'DM_WORKFLOW_E_CHOOSE_ATTR_COUNT': 'Number of elements in act_choose_name/act_choose_by/act_choose_for do not match.',
    'DM_WORKFLOW_E_SETSUPERVISOR_WORKFLOW': 'The workflow \'{0}\' ({1}) can not be changed supervisor, unless it is in DORMANT, RUNNING or HALTED state.',
    'DM_WORKFLOW_E_AUTO_TASK': 'Launch of {0} failed: the method was launched successfully but the method did not acquire/complete the workitem.',
    'DM_WORKFLOW_E_CANT_REACH': 'Activity \'{0}\' can not be reached from any start activity.',
    'DM_WORKFLOW_E_SELFLINK_NOT_ALLOWED': 'Activity \'{0}\' has a link to itself.  This is not allowed for activities with performer_type {1} and transition_type {2}.',
    'DM_WORKFLOW_E_ASSIGN_TASK_FAIL': 'Workflow agent master failed to assign work item \'{0}\' to worker threads.',
    'DM_WORKFLOW_E_WAIT_FOR_TASK_FAIL': 'Workflow agent master failed in waiting for new tasks.',
    'DM_WORKFLOW_E_CREATE_WF_CONTEXT': 'Creating Workflow agent execution context failed.',
    'DM_WORKFLOW_E_CONTEXT_INIT': 'Initializing {0} of workflow agent execution context failed.',
    'DM_WORKFLOW_E_SET_PRIORITY_AUTO_TASK_EXECUTING': 'Setpriority failed on automatic workitem \'{0}\' because this workitem is being executed by workflow agent.',
    'DM_WORKFLOW_E_TRANS_MAX_OUTPUT_CNT_EXCEEDED': 'A maximum of {0} output ports can be selected. (The maximum is defined in the activity\'s transition_max_output_cnt attribute.)',
    'DM_WORKFLOW_E_CANT_REMOVE_ATTACHMENT': 'Cannot remove the attachment \'{0}\' because this attachment is not attached to workflow \'{1}\'.',
    'DM_WORKFLOW_E_OPERATION_NOT_SUPPORTED': 'The activity object \'{0}\' cannot be saved because the package definitions cannot be correctly saved.',
    'DM_WORKFLOW_E_ADD_PORT_TABLE': 'The attributes that define a package must have the same number of values.',
    'DM_WORKFLOW_E_INVALID_ARG': 'The \'{0}\' method has an invalid value ({1}) for argument \'{2}\'.',
    'DM_WORKFLOW_E_SAVE_TRANSITION': 'The r_conidtion_id and r_predicate_id attributes of the activity cannot be set concurrently.',
    'DM_WORKFLOW_E_ATTR_COUNT': 'The number of values in the {0} attributes of {1} \'{2}\' do not match.',
    'DM_WORKFLOW_E_NO_TRANSITION_METHOD': 'Cannot find the method {0}, which is needed to evaluate the automatic transition condition.',
    'DM_WORKFLOW_E_TRANSITION_TIMEOUT': 'The transition evaluation method {0} timed out. The method timeout is currently set to {1}.',
    'DM_WORKFLOW_E_LAUNCH_TRANSITION': 'Failed to launch the transition evaluation method {0}.',
    'DM_WORKFLOW_E_ATTACHMENT_SAVE_DESTROY': 'You cannot use save or destroy methods to create or destroy a workflow attachment object. You must use addAttachment or removeAttachment methods (in IDfWorkflow and IDfWorkitem interfaces) to create or destroy a workflow attachment object.',
    'DM_WORKFLOW_E_SET_PACKAGE_SKILL_LEVEL': 'Attempt to set user skill level for package \'{0}\' of workflow \'{1}\' failed.',
    'DM_WORKFLOW_E_AGENT_LOCK_OBJ_MISSING': 'The SysObject \'{0}\' is missing from the repository.',
    'DM_WORKFLOW_E_COLLECT_SD_ELEMENTS': 'The workflow ({0}) fails to collect instances of Structured Data Elements.',
    'DM_WORKFLOW_E_NO_SD_ELEMENT_INSTANCE': 'The instance of the Structured Data Element, {0}, does not exist for the workflow, {1}.',
    'DM_WORKFLOW_E_LENGTH_WIDEN_FAILED': 'The upgrade failed on widening attribute lengths for type {0}.',
    'DM_WORKFLOW_E_SRC_LINK_EXCEPTION_ACTIVITY': 'EXCEPTION activity \'{0}\' can not have an outgoing link \'{1}\'.',
    'DM_WORKFLOW_E_INVOKE_FAULT_HANDLER': 'Failed to invoke fault-handler for activity \'{0}\' ({1}) of workflow ({2}).',
    'DM_WORKFLOW_E_SD_REPORT_NO_ACCESS': 'User lacks the required privilege to access the Structured Data Report table ({0}).',
    'DM_WORKFLOW_E_SD_REPORT': 'Failed to generate a report for the SD element \'{0}\' at activity \'{1}\' ({2}) of workflow ({3}).',
    'DM_WORKFLOW_E_INSTALL_PROCESS_HANDLE_WORKFLOW': 'Failed to resume or abort the workflows when installing process \'{0}\' ({1}). If the process has been installed, un-install the process, fix the problem, then re-install the process.',
    'DM_WORKFLOW_E_UNINSTALL_PROCESS_HANDLE_WORKFLOW': 'Failed to halt the workflows when un-installing process \'{0}\' ({1}).',
    'DM_WORKFLOW_E_COLLECT_ACTGROUP_INSTANCES': 'The workflow ({0}) fails to collect activity group instances with query ({1}).',
    'DM_WORKFLOW_E_EMPTY_ACTGROUP': 'Activity group ({0}) defined on process ({1}) does not contain any activity.',
    'DM_WORKFLOW_E_UPDATE_TIMER': 'Failed to update timer ({0}) of workflow instance ({1}) as {2}.',
    'DM_WORKFLOW_E_PROCESS_AUTO_TASK': 'Workflow Agent failed to process task {0} of workflow {1}. The task is using method \'{2}\'. {3}.',
    'DM_WORKFLOW_E_UNABLE_TO_CREATE_INTERNAL_GROUP': 'Unable to create internal group.',
    'DM_WORKFLOW_E_NEED_SU_OR_SYS_PRIVS': 'State change of workflow agent failed because user ({0}) does not have superuser or sys admin privileges.',
    'DM_WORKFLOW_E_WAIT_FOR_COMPLETE_TASK_FAIL': 'Workflow agent master failed in waiting for completion of currently processed task.',
    'DM_WORKFLOW_E_WFLOW_AGENT_STATE': 'Workflow agent is unable to {0}. Workflow agent is currently {1} .',
    'DM_WORKFLOW_E_WFLOW_AGENT_METHOD': 'The dm_method named {0} is not defined. Please restart the content server for the method to be defined.',
    'DM_WORKFLOW_E_INCOMPATIBLE_CLIENT': 'The {0} RPC failed as it depends on the latest version of the following. {1}.',
    'DM_XFRM_W_NO_CONVERT_LOC_DEFINED': 'Your server configuration does not define a conversion location -- no conversions can be performed.',
    'DM_XFRM_E_ATTR_EXCEED': 'List has > {0} attributes: {1}...{2}',
    'DM_XFRM_E_BAD_ATTR': 'Bad conversion attribute: {0}',
    'DM_XFRM_E_MEMORY': 'Unable to allocate memory for file: {0}',
    'DM_XFRM_E_CANT_OPEN': 'Unable to open file: ({0}).  Operating System Error: ({1})',
    'DM_XFRM_E_TOO_MANY_CVRT': 'More than {0} conversions',
    'DM_XFRM_E_ATTR_FAIL': 'Conversion {0} failed to read attributes',
    'DM_XFRM_E_CVRT_FAIL': 'Conversion {0} failed for attribute {1}',
    'DM_XFRM_E_NO_CVRT': 'Unable to find a conversion from {0} to {1}',
    'DM_XFRM_E_NO_FMT_AVAIL': 'Unable to find a rendition for {0} with format {1} on page {2}',
    'DM_XFRM_E_NO_ORIG': 'Unable to find the original for {0} on page {1}',
    'DM_XFRM_E_CANT_CONV': 'Could not transform document {0} to format {1} on page {2}',
    'DM_XFRM_E_CANT_CONV_EXT': 'External converter {0} could not transform document {1} to format {2} on page {3}, status returned {4}',
    'DM_XFRM_E_CONVERT_DIRECTORY_ACCESS': 'The location defined in your server configuration for conversions, ({0}), specifies a directory, ({1}), which cannot be accessed.  The Operating System error returned was ({2}).',
    'DM_XFRM_E_CONVERT_TABLE': 'The location defined in your server configuration for conversions, ({0}), specifies a file, ({1}), which cannot be accessed.  The Operating System error returned was ({2}).',
    'DM_XFRM_E_NEED_TEMP': 'Need to define a temp_location to perform convesions.',
    'DM_XFRM_E_NEED_LOC': 'Could not locate {0} temp_location os_error: {1}',
    'DM_XFRM_E_INVALID_CONV': 'Invalid {0} server_converter_location defined.',
    'DM_XFRM_E_NO_BACKING_STORE': 'No backing store to make copy of blob/turbo content',
    'DM_XFRM_E_NO_BACKING_STORE2': 'No backing store to make copy of external content',
    'DM_XFRM_E_LAUNCH_FAIL': 'Failed to launch the command: {0}. Operating system error: {1}.',
    'DM_XFRM_E_WAIT_FAIL': 'Failed to wait for the command: {0}. Operating system error: {1}.',
    'DM_XFRM_E_CURSOR_FETCH_FAIL': 'A failure occurred during a fetch through a cursor: database error message was {0}'

}


def get_message(message):
    name = message['NAME']
    severity = message['SEVERITY']
    if not name in MESSAGES:
        return None
    return "[%s] %s: %s" % (name, SEVERITIES[severity], MESSAGES[name])
